{$P}
{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UObject.inc1.p }
{ Copyright  1984-1990 by Apple Computer, Inc.  All rights reserved. }

{$IFC UNDEFINED qMacApp}
{$SETC qMacApp := FALSE}
{$ENDC}

{$Push} {$IFC NOT qDebugTheDebugger}
{$W+}
{$R-}
{$Init-}
{$OV-}
{$ENDC}

{$%+  Enable '%' in identifiers}

{=====
 NOTE:
 The optimizer redirects the following procedure names
 We call the optimized names here since non-optimized dispatch
 is not supported.

%_INITOBJ  becomes %_OPTINITOBJ
%_INOBJ  becomes   %_OPTINOBJ
%_SETCLASSINDEX   becomes %_OPTSETCI
%_METHOD becomes   %_JMPTOTRAP
}

{--------------------------------------------------------------------------------------------------}

CONST
	kJTSkipOver 		= 2;							{ size of jmp (or loadseg) instruction that
														 must be skipped in the JT Entry in order
														 to get to the target address }

TYPE

	{= = = SuperClassTable format = = =}
	SuperClassTableSize = ObjClassID;					{ in 32 B-E is a longint else int}
	SuperClassTable 	= RECORD
		itsSize:			SuperClassTableSize;
		itsTable:			ARRAY [1..1] OF ObjClassID; { Actually, a variable size array where each
														 entry's byte offset corresponds to its
														 ClassID and the entry's value is the
														 ClassID of the immediate superclass }
		END;
	SuperClassTablePtr	= ^SuperClassTable;
	SuperClassTableHandle = ^SuperClassTablePtr;

	{= = = ClassInfoProc format = = =}
	ClassInfoProc		= RECORD
		itsClassID: 		ObjClassID;
		itsInstanceSize:	INTEGER;
		itsName:			MAName;
		END;
	ClassInfoProcPtr	= ^ClassInfoProc;
	ClassInfoProcHandle = ^ClassInfoProcPtr;

	{= = = ClassTable format = = =}
	ClassTableSize		= ObjClassID;					{ in 32 B-E is a longint else int}
{$IFC qModelFarCode}
	ClassTableEntry 	= Ptr;							{ Ptr to the JT Entry of the ClassInfoProc.
														 Add kJTSkipOver and you get a
														 ClassInfoProcPtr. }
{$ELSEC}
	ClassTableEntry 	= INTEGER;						{ JT Offset of ClassInfoProc }
{$EndC}
	ClassTableEntryPtr	= ^ClassTableEntry;
	ClassTableEntryHandle = ^ClassTableEntryPtr;
	ClassTable			= RECORD
		itsSize:			ClassTableSize;
		itsTable:			ARRAY [1..1] OF ClassTableEntry; { Actually, a variable size array where
															  each entry's byte offset corresponds
															  to its ClassID and the entry's value
															  is used to locate its ClassInfoProc.
															  }
		END;
	ClassTablePtr		= ^ClassTable;
	ClassTableHandle	= ^ClassTablePtr;

	ClassIdTable		= ARRAY [1..16000] OF ObjClassId; { Actually variable size }
	ClassIdTablePtr 	= ^ClassIdTable;
	ClassIdTableHandle	= ^ClassIdTablePtr;

{--------------------------------------------------------------------------------------------------}

VAR
	pMethDispAddr:		ProcPtr;						{address of method dispatcher}
	pNoOfOrderedClasses: INTEGER;
	pOrderedClassIds:	ClassIdTableHandle;
	pTObjectClassID:	ObjClassId; 					{ClassID of the Root class}

	pAddNewObjectsToInspector: BOOLEAN;
	{$Push} {$Z+}
	pDisciplineMethodCalls: BOOLEAN;					{ Discipline method calls }
	pSuperClassTable:	SuperClassTablePtr; 			{ ptr to superclass table }
	pClassTable:		ClassTablePtr;					{ ptr to superclass table }
	pDispatchErrorProc: ProcPtr;						{Routine to handle dispatching failures}
	{$Pop}
	pInspectLinePos:	INTEGER;						{ Used to do line breaks when inspecting
														 fields. }
	pODFail:			ProcPtr;						{address OD Failure Handler}
	pAllocateObjectsFromPerm: BOOLEAN;					{ Used to track whether to allocate objects
														 from permanent memory or not. }

{--------------------------------------------------------------------------------------------------}

PROCEDURE OrderClassIdsByName;
	FORWARD;

FUNCTION IsClassIDMemberClass(testClass: ObjClassId;
							  superClass: ObjClassId): BOOLEAN;
	EXTERNAL;

PROCEDURE %_NewMethod;
	EXTERNAL;
{ Defined in UObject.a }

PROCEDURE %_SUPERCLASSTABLE;
	EXTERNAL;
{ Created by linker -Model Far and -opt }

PROCEDURE %_CLASSTABLE;
	EXTERNAL;
{ Created by linker for -Model Far and -opt }

PROCEDURE %_SELECTORPROCTABLE;
	EXTERNAL;
{ Created by linker for -Model Far and -opt }

PROCEDURE %_CLASSINFO;
	EXTERNAL;
{ Created by linker except for -Model Far and -opt}

PROCEDURE %_JMPTOTRAP;
	EXTERNAL;
{ Defined in UObject.a }

PROCEDURE %_DISCIPLINEDISPATCH;
	EXTERNAL;
{ Defined in UObject.a }

PROCEDURE %_DISCIPLINEDISPATCH_PATCHPOINT;
	EXTERNAL;
{ Defined in UObject.a }

PROCEDURE AddObjectToInspector(theObject: TObject);
	EXTERNAL;
{ Defined in UInspector.p }

PROCEDURE RemoveObjectFromInspector(theObject: TObject);
	EXTERNAL;
{ Defined in UInspector.p }

PROCEDURE %_ObjError;
	FORWARD;

PROCEDURE InstallDispatcher;
	FORWARD;
{--------------------------------------------------------------------------------------------------}
{$S MAObjectRes}
{$Push} {$IFC qTrace} {$D++} {$ENDC}

FUNCTION AddNewObjectsToInspector(add: BOOLEAN): BOOLEAN;

	BEGIN
	AddNewObjectsToInspector := pAddNewObjectsToInspector;
	pAddNewObjectsToInspector := add;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$S MAObjectRes}

FUNCTION AllocateObjectsFromPerm(allocateFromPerm: BOOLEAN): BOOLEAN;

	BEGIN
	AllocateObjectsFromPerm := pAllocateObjectsFromPerm;
	pAllocateObjectsFromPerm := allocateFromPerm;
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAObjectRes}

FUNCTION DisciplineMethodCalls(discipline: BOOLEAN): BOOLEAN;

	BEGIN
	DisciplineMethodCalls := pDisciplineMethodCalls;
	pDisciplineMethodCalls := discipline;
	END;

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE EachClassDo(PROCEDURE DoToClass(theClass: ObjClassId));

	VAR
		aClassID:			ObjClassID;
		maxID:				ObjClassID;

	BEGIN
	{ Manufacture classIDs for all classes from the root to the largest }
	maxID := pSuperClassTable^.itsSize;
	aClassID := sizeof(ObjClassID);

	{ NOTE: Since maxID is obtained from the size of the super class table, maxID serves as a
	maximum bound on the possible range of class IDs. So, in the loop below, we only call DoToClass
	while aClassID is less than maxID. This is because the size (in bytes) of the
	super class table includes the bytes required to enter the size at the head of the
	super class table.

	Incidentally, since the class table follows the super class table, this gives us the
	following identity:
		superclass table ptr + size of super class table = class table ptr

	So, in 16-bit worlds, for a two class system, the superclass table could look like:
		$0006 $0000 $0002	<= super class table with class IDs 2 and 4, followed by
		$0006 $4ADA $4ADC	<= class table with offsets into jump table
	this structure gives us a maxID of 6 and the following while loop looks like:

		WHILE aClassID < 6 DO
			
			aClassID := aClassID + 2
	}

	WHILE (aClassID < maxID) DO
		BEGIN
		DoToClass(aClassID);
		aClassID := aClassID + sizeof(ObjClassID);
		END;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE EachSubClassDo(testClass: ObjClassId;
						 PROCEDURE DoToClass(theClass: ObjClassId));

	PROCEDURE DoToCandidateClass(theClass: ObjClassId);

		BEGIN
		IF (theClass <> testClass) & IsClassIDMemberClass(theClass, testClass) THEN
			DoToClass(theClass);
		END;

	BEGIN
	EachClassDo(DoToCandidateClass);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE EachSuperClassDo(testClass: ObjClassId;
						   PROCEDURE DoToClass(theClass: ObjClassId));

	VAR
		theSuperClass:		ObjClassId;

	BEGIN
	theSuperClass := GetSuperClassID(testClass);
	WHILE theSuperClass <> kNilClass DO
		BEGIN
		DoToClass(theSuperClass);
		theSuperClass := GetSuperClassID(theSuperClass);
		END;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE FailNonObject(obj: UNIV TObject);

	BEGIN
	IF NOT IsObject(obj) THEN
		BEGIN
		{$IFC qDebug}
		IF VerboseIsObject(obj) THEN;					{ show why }
		WrLblHexLongint('Object that failed discipline', ord(obj));
		WriteLn;
		ProgramBreak('');
		{$ENDC}
		Failure(minErr, 0); 							{ ??? need to assign a message }
		END;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$S MAObjectRes}
{$Push} {$IFC qTrace} {$D++} {$ENDC}

PROCEDURE FreeIfObject(obj: TObject);

	BEGIN
	IF obj <> NIL THEN
		BEGIN
		{$IFC qDebug}
		IF NOT VerboseIsObject(obj) THEN
			ProgramBreak('In FreeIfObject: Not handed a valid object.');
		{$ENDC}
		obj.Free;
		END;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$S MAObjectRes}
{$Push} {$IFC qTrace} {$D++} {$ENDC}

PROCEDURE FreeObject(obj: TObject);

	BEGIN
	FreeIfObject(obj);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

FUNCTION GetClassID(obj: TObject): ObjClassId;

	BEGIN
	{$Ifc qDebug}
	FailNonObject(obj);
	{$Endc}
	GetClassID := ObjClassIDHandle(obj)^^;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

FUNCTION GetClassIDFromName(clName: MAName): ObjClassId;

	VAR
		high, low, index:	INTEGER;
		nameFromTable:		MAName;
		compareResult:		INTEGER;
		id: 				ObjClassID;

	BEGIN
	UprMAName(clName);
	IF pNoOfOrderedClasses > 0 THEN
		BEGIN
		low := 1;
		high := pNoOfOrderedClasses;
		REPEAT
			index := BSR(low + high, 1);				{ (low + high) DIV 2 }
			id := pOrderedClassIds^^[index];
			GetClassNameFromID(id, nameFromTable);
			compareResult := CompareStrings(clName, nameFromTable);
			IF compareResult = 0 THEN
				BEGIN
				GetClassIDFromName := id;
				EXIT(GetClassIDFromName);
				END;
			IF compareResult < 0 THEN
				high := index - 1
			ELSE
				low := index + 1;
		UNTIL low > high;
		END;

	{$IFC qDebug}
	ProgramBreak(Concat('Can''t find class name ', clName));
	{$ENDC qDebug}
	GetClassIDFromName := kNilClass;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

PROCEDURE GetClassNameFromID(classID: ObjClassId;
							 VAR clName: MAName);

	CONST
		kClasInfoPrefix 	= 'CLASINFO.';				{ 'CLASINFO.' prepended to class name }

	VAR
		namePtr:			Ptr;
		discard:			StringPtr;
		nameLength: 		INTEGER;
		clNamePtr:			Ptr;
		i:					INTEGER;
		aClassInfoProcHandle: ClassInfoProcHandle;

	BEGIN
	IF (classID = kNilClass) | ODD(classID) THEN
		clName := kInvalidObj
	ELSE
		BEGIN
		IF qModelFarCode THEN
			aClassInfoProcHandle := ClassInfoProcHandle(ord(ClassTableEntryPtr(ord(pClassTable) +
															classID)^) + kJTSkipOver)
		ELSE
			aClassInfoProcHandle := ClassInfoProcHandle(ord(ClassTableEntryPtr(ord(pClassTable) +
															classID)^) + ord(GetA5) + kJTSkipOver);

		namePtr := @aClassInfoProcHandle^^.itsName; 	{ Stinking compiler (3.2A1) }

		{ discard := validMacsBugSymbol(namePtr, ord(namePtr) + 256, @clName); }
		{ delete(clName, 1, 9); }						{ 'CLASINFO.' }
	{!!! the above function call could conceivably return a null terminated pascal string
	that would exceed a Str255 by one byte.  If that happens we're HOSED.  The workaround
	is to have the validMacsBugSymbol call put the returned string on the stack with room
	for that last null byte.  The cost is yet another copy of the string on the stack. So
	anticipating that no identifier names will ever ACTUALLY be 255 chars we take the simple
	path and return the name directly into the var parameter. }

		{ We need all the speed we can get here, so forego the use of validMacsBugSymbol
		  (it did make a difference) and do it ourselves.  This routine would be a good
		  candidate for assembly }

		IF namePtr^ = $FF80 THEN						{ $FF80 instead of $80 as compile word
														 extends }
			BEGIN
			namePtr := Ptr(ord(namePtr) + 1);
			nameLength := namePtr^ - Length(kClasInfoPrefix);
			END
		ELSE
			nameLength := BAND(namePtr^, $7F) - Length(kClasInfoPrefix);
		clName[0] := CHR(Min(kMANameSize, nameLength));
		clNamePtr := Ptr(ord(@clName) + 1);
		namePtr := Ptr(ord(namePtr) + Length(kClasInfoPrefix) + 1);
		FOR i := 1 TO Min(ord(clName[0]), sizeof(MAName) - 1) DO { Be polite. Don't copy more bytes
																  than the caller has reserved room
																  for. }
			BEGIN
			clNamePtr^ := namePtr^;
			clNamePtr := Ptr(ord(clNamePtr) + 1);
			namePtr := Ptr(ord(namePtr) + 1);
			END;

		END;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

FUNCTION GetClassSizeFromId(classID: ObjClassID): Size;

	BEGIN
	IF qModelFarCode THEN
		GetClassSizeFromId := ClassInfoProcHandle(ord(ClassTableEntryPtr(ord(pClassTable) +
																		 classID)^) +
							  kJTSkipOver)^^.itsInstanceSize
	ELSE
		GetClassSizeFromId := ClassInfoProcHandle(ord(ClassTableEntryPtr(ord(pClassTable) +
																		 classID)^) +
												  ord(GetA5) + kJTSkipOver)^^.itsInstanceSize;

	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

FUNCTION GetSuperClassID(objID: ObjClassID): ObjClassID;

	BEGIN
	IF objID <> kNilClass THEN
		GetSuperClassID := ObjClassIDPtr(ord(pSuperClassTable) + objID)^
	ELSE
		GetSuperClassID := kNilClass;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MADebug}

PROCEDURE IDUobject;

	BEGIN
	WRITELN('Uobject of 14 Feb 90 (Valentine''s Day), Compiled on ', COMPDATE, ' @ ', COMPTIME);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

FUNCTION GetSuperClassTablePtr: SuperClassTablePtr;

	BEGIN
{$Push} {$B-}											{ Force Jump Table relative }
	IF qModelFarCode THEN
		GetSuperClassTablePtr := SuperClassTableHandle(ord(@%_SUPERCLASSTABLE) + kJTSkipOver)^
	ELSE
		GetSuperClassTablePtr := SuperClassTableHandle(ord(@%_CLASSINFO) + kJTSkipOver)^;
{$Pop}
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

FUNCTION GetClassTablePtr: ClassTablePtr;

	BEGIN
{$Push} {$B-}											{ Force Jump Table relative }
	IF qModelFarCode THEN
		GetClassTablePtr := ClassTableHandle(ord(@%_CLASSTABLE) + kJTSkipOver)^ { make PHONY handle
												 and dereference to make pointer }
	ELSE
	{ Old style. Table is past end of superclass table }
		GetClassTablePtr := ClassTablePtr(ord(GetSuperClassTablePtr) + GetSuperClassTablePtr^.
										  itsSize);

{$Pop}
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

FUNCTION GetSelectorProcTablePtr: Ptr;

	BEGIN
	IF qModelFarCode THEN
		GetSelectorProcTablePtr := @%_SELECTORPROCTABLE;

	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$S MAInit}

PROCEDURE InitUObject;

	BEGIN
	{$IFC qInspector}
	pAddNewObjectsToInspector := TRUE;
	{$EndC}
	{$IFC qDebug}
	pDisciplineMethodCalls := TRUE;
	{$ENDC qDebug}

	pAllocateObjectsFromPerm := TRUE;

	InstallDispatcher;

	OrderClassIdsByName;
	pTObjectClassID := SizeOf(ObjClassId);
	END;

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MADebug}

PROCEDURE InspectField(fieldName: Str255;
					   fieldAddr: Ptr;
					   fieldType: INTEGER);

	VAR
		s:					Str255;
		x:					INTEGER;

	BEGIN
	IF fieldType <> bClass THEN
		BEGIN
		FieldToString(fieldAddr, fieldType, s);
		x := Length(fieldName) + 1 + Length(s);
		{??? maybe a better solution would be to let the transcript do it's own word breaks}
		{$IFC qDebug}
		IF pInspectLinePos + x + 2 >= DebugTranscriptWidth THEN
			BEGIN
			WriteLn;
			pInspectLinePos := 0;
			END
		ELSE IF pInspectLinePos <> 0 THEN				{ If not at the start of a line }
			BEGIN
			WRITE('  ');
			pInspectLinePos := pInspectLinePos + 2;
			END;
		{$EndC}
		WRITE(fieldName, '=', s);
		pInspectLinePos := pInspectLinePos + x;
		END;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MADebug}

PROCEDURE InspectObject(obj: TObject);

	VAR
		oldState:			BOOLEAN;

	BEGIN
	IF VerboseIsObject(obj) THEN
		BEGIN
		oldState := obj.Lock(TRUE);
		obj.Inspect;
		WriteLn;
		oldState := obj.Lock(oldState);
		END
	ELSE
		BEGIN
		WritePtr(obj);
		WriteLn(' is not a TObject!');
		END;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}

FUNCTION IsObject(obj: UNIV TObject): BOOLEAN;
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

	BEGIN
	IF IsHandle(obj)
	{ Test for handle not purged since we don't allow purgeable objects (??? yet?, ever?) }
	   & (Handle(obj)^ <> NIL)
	{ Test objecthood }
	   & IsClassIDMemberClass(ObjClassIdHandle(obj)^^, pTObjectClassID) &
	   (GetHandleSize(Handle(obj)) >= GetClassSizeFromId(ObjClassIdHandle(obj)^^)) THEN
		IsObject := TRUE
	ELSE
		IsObject := FALSE;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

FUNCTION IsMemberClassID(obj: TObject;
						 objID: ObjClassId): BOOLEAN;

	BEGIN
	{$IFC qDebug}
	FailNonObject(obj);
	{$ENDC}
	IF IsObject(obj) THEN
		IsMemberClassID := IsClassIDMemberClass(ObjClassIDHandle(obj)^^, objID)
	ELSE
		IsMemberClassID := FALSE;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$S MAObjectRes}
{$Push} {$IFC qTrace} {$D+} {$ENDC}

FUNCTION MakeNewInstance(classID: ObjClassId): TObject;
{ makes objects for "new" calls.  Internal use only. }

{$IFC qDebug}

	CONST
		initVal 			= $F1F1;					{ guaranteed to be odd at all byte
														 boundaries }
		{$ENDC}

	VAR
		{$IFC qDebug}
		i:					Size;
		p:					IntegerPtr;
		{$ENDC}

		itsSize:			Size;
		obj:				TObject;

	BEGIN
	IF classID <> kNilClass THEN
		BEGIN
		itsSize := GetClassSizeFromId(classID);
		IF qMacApp & pAllocateObjectsFromPerm THEN
			Handle(obj) := NewPermHandle(itsSize)
		ELSE
			Handle(obj) := NewHandle(itsSize);

		IF obj <> NIL THEN
			BEGIN

			{$IFC qDebug}
			{Initialize the object to $F1F1F1F1...}
			p := IntegerPtr(Handle(obj)^);
			FOR i := 1 TO itsSize DIV 2 DO
				BEGIN
				p^ := initVal;
				p := IntegerPtr(ord(p) + 2);
				END;
			{$ENDC}

			{ Install class ID into object }
			ObjClassIDHandle(obj)^^ := classID;

			{$IFC qInspector}
			IF pAddNewObjectsToInspector THEN
				AddObjectToInspector(obj);
			{$ENDC}
			END;
		MakeNewInstance := obj;
		END
	ELSE
		MakeNewInstance := NIL;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

FUNCTION NewObjectByClassId(classID: ObjClassId): TObject;

{$IFC qDebug}

	VAR
		s:					MAName;
		className:			MAName;
		{$ENDC}

	BEGIN
	{$IFC qDebug}
	IF gAskAboutAlloc & CanReadLn THEN
		BEGIN

		GetCallersMethodName(s);
		GetClassNameFromID(classID, className);
		WriteLn('Within ', s, ', trying to make a ''', className, '''.');

		IF ReadYesNo('     Return NIL (Y or N) [N]? ') THEN
			BEGIN
			NewObjectByClassId := NIL;
			EXIT(NewObjectByClassId);
			END;
		END;
	{$ENDC qDebug}

	NewObjectByClassId := MakeNewInstance(classID);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

FUNCTION NewObjectByClassName(className: MAName): TObject;

	VAR
		classID:			ObjClassId;
		{$IFC qDebug}
		s:					MAName;
		{$ENDC}

	BEGIN
	{$IFC qDebug}
	IF gAskAboutAlloc & CanReadLn THEN
		BEGIN

		GetCallersMethodName(s);
		WriteLn('Within ', s, ', trying to make a ''', className, '''.');

		IF ReadYesNo('     Return NIL (Y or N) [N]? ') THEN
			BEGIN
			NewObjectByClassName := NIL;
			EXIT(NewObjectByClassName);
			END;
		END;
	{$ENDC qDebug}

	classID := GetClassIDFromName(className);
	IF (classID <> kNilClass) THEN
		NewObjectByClassName := MakeNewInstance(classID);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE OBJFail(error: INTEGER);

	BEGIN
	{$IFC qDebug}

	CASE error OF
		kFailCoercion:
			ProgramBreak('Object type coercion error.');
		kFailMethNotFound:
			ProgramBreak('Method not found');
		OTHERWISE
			BEGIN
			WriteLn('Failure code: ', error);
			ProgramBreak('Object runtime failure. See UObject.p.');
			END;
	END;
	{$ENDC}
	{$IFC qMacApp}
	Failure(minErr, 0); 								{ ??? need to assign a message }
	{$ELSEC}
	{ ??? Should we do anything if not for MacApp? }
	{$ENDC}
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$W+}
{$R-}
{$OV-}
{$S MAObjectRes}

PROCEDURE OrderClassIdsByName;

	VAR
		high, low, index: INTEGER;

	PROCEDURE DoToClass(theClass: ObjClassId);

	VAR
		nameFromTable: MAName;
		aClassName: MAName;

		BEGIN
		{$Push} {$R-}
		{$IFC qModelFarCode}
		IF pClassTable^.itsTable[theClass DIV sizeof(ObjClassId)] <> NIL THEN
		{$ELSEC}
		IF pClassTable^.itsTable[theClass DIV sizeof(ObjClassId)] <> 0 THEN
		{$EndC}
		{$Pop}
			BEGIN
			GetClassNameFromID(theClass, aClassName);

			IF pNoOfOrderedClasses = 0 THEN
				index := 1
			ELSE
				BEGIN
				low := 1;
				high := pNoOfOrderedClasses;
				REPEAT
					index := BSR(low + high, 1); { (low + high) DIV 2 }
					GetClassNameFromID(pOrderedClassIds^^[index], nameFromTable);
					IF aClassName < nameFromTable THEN
						high := index - 1
					ELSE
						BEGIN
						low := index + 1;
						index := index + 1;
						END;
				UNTIL low > high;
				END;
			IF index <= pNoOfOrderedClasses THEN
				BlockMove(@pOrderedClassIds^^[index], @pOrderedClassIds^^[index + 1],
						  (pNoOfOrderedClasses - index + 1) * sizeof(ObjClassId));
			pOrderedClassIds^^[index] := theClass;
			pNoOfOrderedClasses := pNoOfOrderedClasses + 1;
			END;
		END;

	BEGIN
	pNoOfOrderedClasses := 0;

	{$IFC qMacApp} {We can't call failure if not for MacApp }
	pOrderedClassIds := ClassIdTableHandle(NewPermHandle(pClassTable^.itsSize));
	FailNIL(pOrderedClassIds);
	{$ELSEC}
	pOrderedClassIds := ClassTableHandle(NewHandle(pClassTable^.itsSize));
	IF pOrderedClassIds = NIL THEN
		EXIT(OrderClassIdsByName); { Caller should check for NIL }
	{$ENDC}

	EachClassDo(DoToClass);

	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$S MADebug}

FUNCTION VerboseIsObject(obj: UNIV TObject): BOOLEAN;

	VAR
		className:			MAName;
		classSize:			Size;
		instSize:			Size;

	BEGIN
	VerboseIsObject := FALSE;
	IF VerboseIsHandle(obj) THEN
	{ Test for handle not purged since we don't allow purgeable objects (??? yet?, ever?) }
		IF (Handle(obj)^ = NIL) THEN
			WriteLn('  That handle appears to be purged.')
		ELSE IF NOT IsClassIDMemberClass(ObjClassIdHandle(obj)^^, pTObjectClassID) THEN
			WriteLn('  That handle is not a subclass of TObject.')
		ELSE IF (GetHandleSize(Handle(obj)) < GetClassSizeFromId(GetClassID(obj))) THEN
			BEGIN
			GetClassNameFromID(GetClassID(obj), className);
			classSize := GetClassSizeFromId(GetClassID(obj));
			instSize := GetHandleSize(Handle(obj));
			WriteLn('  That handle at: ', instSize: 1, ' bytes is smaller than a ', className,
					' is supposed to be at: ', classSize: 1, ' bytes.');
			END
		ELSE
			VerboseIsObject := TRUE;
	END;

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MADebug}

PROCEDURE WrLblField(fieldName: Str255;
					 fieldAddr: Ptr;
					 fieldType: INTEGER);

	BEGIN
	pInspectLinePos := 0;
	InspectField(fieldName, fieldAddr, fieldType);
	pInspectLinePos := 0;
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S %_MethTables}

PROCEDURE InstallDispatcher;
{ LOW LEVEL one time initialization. Must be in same segment as dispatcher. }

	TYPE
		JmpToTrapPatchPtr	= ^JmpToTrapPatch;
		JmpToTrapPatch		= RECORD
			Jmp:				INTEGER;				{ jmp instruction }
			Routine:			ProcPtr;				{ address to jump to }
			END;

	VAR
		aJmpToTrapPatchPtr: JmpToTrapPatchPtr;

	BEGIN
	{ The new method dispatcher provided with MacApp is enough faster that it is even worth using
	instead of the ROM based dispatcher. }

	pMethDispAddr := @%_NewMethod;
	{$IFC qDebug}
	pODFail := @FailNonObject;
	{$ENDC}

{ NOTE =================================================
 the following is a real slimedog trick but since we are
 after performance in this bottleneck we'll do it anyway.
 since it saves a memory fetch for each dispatch.
 Don't need to flush the cache here.
 }
	aJmpToTrapPatchPtr := @%_JMPTOTRAP;
	WITH aJmpToTrapPatchPtr^ DO
		BEGIN
		Jmp := $4EF9;									{ JMP #Routine }
		{$IFC qDebug}
		Routine := @%_DISCIPLINEDISPATCH;
		{$ELSEC}
		Routine := pMethDispAddr;
		{$ENDC}
		END;

	{$IFC qDebug}
	aJmpToTrapPatchPtr := @%_DISCIPLINEDISPATCH_PATCHPOINT;
	WITH aJmpToTrapPatchPtr^ DO
		BEGIN
		Jmp := $4EF9;									{ JMP #Routine }
		Routine := pMethDispAddr;
		END;
{$ENDC}

	{ Don't forget the class and superclass tables and the error handler }
	pSuperClassTable := GetSuperClassTablePtr;
	pClassTable := GetClassTablePtr;
	IF GetSelectorProcTablePtr <> NIL THEN; 			{!!! suppress dead strip of table. Fix b4
														 final }
	pDispatchErrorProc := @%_ObjError;

	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE %_INITOBJ;
{ LOW LEVEL required to satisfy fussy linker.  Even though the optimizer
 redirects these entry points they must at least be present. }

	BEGIN
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE %_INOBJ;
{ LOW LEVEL required to satisfy fussy linker.  Even though the optimizer
 redirects these entry points they must at least be present. }

	BEGIN
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

FUNCTION %_OBCHK(obj: TObject;
				 jumpTablePtr: Ptr): TObject;

{ LOW LEVEL routine called at run time verify object coercions.  It returns its obj
parameter if the parameter is nil or passes the membership test.  Otherwise it calls
ObjFail.  }

	BEGIN
	{$IFC qDebug}
	IF (obj <> NIL) THEN
		FailNonObject(obj);
	{$ENDC}
	%_OBCHK := obj;
	IF (obj <> NIL) & (NOT IsClassIDMemberClass(ObjClassIDHandle(obj)^^,
												ObjClassIDHandle(jumpTablePtr)^^)) THEN
		OBJFail(kFailCoercion);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D++} {$ENDC}
{$S MAObjectRes}

PROCEDURE %_OBDISP(obj: TObject);
{ LOW LEVEL routine called by DISPOSE(<object>); }

	BEGIN
	{$Ifc qDebug}
	FailNonObject(obj);
	{$Endc}

	{$IFC qInspector}
	RemoveObjectFromInspector(obj);
	{$ENDC}

	Handle(obj) := DisposeIfHandle(obj);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}

{$Push} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE %_ObjError;
{ LOW LEVEL Error routine that ROM method dispatch routine jumps to if method not found
  Address of this routine is stuffed at lomem location MAErrProc at startup }

	BEGIN
	OBJFail(kFailMethNotFound); 						{ Method Not Found }
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D++} {$ENDC}

{$S MAObjectRes}

PROCEDURE %_OBNEW(VAR obj: TObject;
				  jumpTablePtr: Ptr;
				  itsSize: INTEGER);					{ !!! itsSize is unused }
{ LOW LEVEL routine called by NEW(<object>); }

	VAR
		{$IFC qDebug}
		n:					MAName;
		s:					MAName;
		{$ENDC}
		classID:			ObjClassId;

	BEGIN
	classID := ClassInfoProcHandle(jumpTablePtr)^^.itsClassID;
{$IFC qDebug}
	IF gAskAboutAlloc & CanReadLn THEN
		BEGIN

		GetCallersMethodName(s);
		GetClassNameFromID(classID, n);
		WriteLn('Within ', s, ', trying to make a ''', n, '''.');

		IF ReadYesNo('     Return NIL (Y or N) [N]? ') THEN
			BEGIN
			obj := NIL;
			EXIT(%_OBNEW);
			END;
		END;
	{$ENDC qDebug}

	obj := MakeNewInstance(classID);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}

{$S MAObjectRes}

FUNCTION %_OPTINOBJ(obj: TObject;
					jumpTablePtr: Ptr): BOOLEAN;
{ LOW LEVEL called to perform MEMBER function }

	BEGIN
	{$IFC qDebug}
	IF (obj <> NIL) THEN
		FailNonObject(obj);
{$ENDC}
	%_OPTINOBJ := (obj <> NIL) & IsClassIDMemberClass(ObjClassIdHandle(obj)^^,
													  ClassInfoProcHandle(jumpTablePtr)^^.
													  itsClassID);
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE %_OptInitObj;
{ LOW LEVEL Not Used.  Must be present however to satisfy linker }

	BEGIN
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE %_OptSetCI;
{ LOW LEVEL Not Used.  Must be present however to satisfy linker }

	BEGIN
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}
{$S MAObjectRes}

PROCEDURE %_METHOD;
{ LOW LEVEL required to satisfy fussy linker.  Even though the optimizer
 redirects these entry points they must at least be present. }

	BEGIN
	END;
{$Pop}

{--------------------------------------------------------------------------------------------------}
{$Push} {$Z+} {$IFC qTrace} {$D+} {$ENDC}
{$S Main}					{ Must actually be in "Main" since it is called in UNIT setup by Pascal }

PROCEDURE %_PGM1;
{ LOW LEVEL The Pascal compiler generates code to call this procedure automatically, before
initializing the units and starting the application's main program.  This function must always
work on 64K ROMs. }

	BEGIN
	END;
{$Pop}

{$Pop}
