{	This file has been processed by The THINK Pascal Source Converter, v1.03.	}
{	This file has then been modified to support floaters with MacApp 2.0. }

{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ UMacApp.p }
{ Copyright  1984-1989  Apple Computer, Inc.  All rights reserved. }

{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := FALSE}
{$ENDC}

unit UMacAppTApplication;

interface

	uses
		SysEqu, Traps, ULoMem, UMacAppUtilities, UPatch, UObject, UList, UViewCoords, UMemory, UFailure, UMenuSetup, 
{$SETC __UMacApp__ := TRUE}
{  MacApp }







		UAssociation,
{  Implementation use }

		UBusyCursor, 

		UDebug, 
{$IFC qInspector}
		UInspector, 
{$ENDC}
		FixMath, Script, PasLibIntf,
{RMS 8/22/89 added USES of UMacApp}
		UMacApp;

implementation


{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UMacApp.TApplication.p }
{ Copyright  1984-1990 by Apple Computer Inc. All rights reserved. }

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TCommandList.Compare (item1, item2: TObject): integer;

	begin
		if TCommand(item1).fPriority > TCommand(item2).fPriority then
			Compare := kItem1GreaterThanItem2
		else if TCommand(item1).fPriority < TCommand(item2).fPriority then
			Compare := kItem1LessThanItem2
		else
			Compare := kItem1EqualItem2
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInit}

	procedure TCommandList.ICommandList;

	begin
		ISortedList;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TCommandList.Insert (item: TObject);
		OVERRIDE;

		var
			oldObjectPerm: BOOLEAN;
			anEqualItem: ArrayIndex;
			lastEqualItem: ArrayIndex;
			i: ArrayIndex;

	begin
	{ Guarantee that the insertion can take place }
		oldObjectPerm := AllocateObjectsFromPerm(FALSE);

	{ !!! the search alg. should support this.  Performance will degrade here for}
{	big queues (shouldn't happen often, but come back and fix the general case anyways)}

		anEqualItem := GetEqualItemNo(item);

	{ If any equal items were found then find the _last_ equal item }
		if anEqualItem <> kEmptyIndex then
			begin
				lastEqualItem := anEqualItem; { Tentative value }
				for i := (anEqualItem + 1) to GetSize do	{ ??? what about kMaxArrayIndex? }
					if Compare(At(i), item) = kItem1EqualItem2 then
						lastEqualItem := i
					else
						LEAVE;

				InsertBefore(lastEqualItem + 1, item);
			end
		else
			inherited Insert(item);

		if AllocateObjectsFromPerm(oldObjectPerm) then
			;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TCommandList.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TCommandList', nil, bClass);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$IFC qDebug}
{$S MADebugger}

	procedure TDebugCommand.DoIt;

	begin
		EnterMacAppDebugger;
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$IFC qDebug}
{$S MASelCommand}

	procedure TDebugCommand.IDebugCommand (itsCmdNumber: CmdNumber);

	begin
		INoChangesCommand(itsCmdNumber, nil, nil, nil);
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$IFC qDebug}
{$S MAFields}

	procedure TDebugCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TDebugCommand', nil, bClass);
		inherited Fields(DoToField);
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$IFC qInspector}
{$S MAInspector}

	procedure TInspectorCommand.DoIt;

	begin
		MakeInspectorWindow;
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$IFC qInspector}
{$S MASelCommand}

	procedure TInspectorCommand.IInspectorCommand (itsCmdNumber: CmdNumber);

	begin
		INoChangesCommand(itsCmdNumber, nil, nil, nil);
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$IFC qInspector}
{$S MAFields}

	procedure TInspectorCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TInspectorCommand', nil, bClass);
		inherited Fields(DoToField);
	end;
{$ENDC}

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TQuitCommand.DoIt;

		var
			fi: FailInfo;

		procedure HdlQuit (error: OSErr; message: LONGINT);

		begin
			gAppDone := FALSE;
		end;

	begin
		CatchFailures(fi, HdlQuit);
		gAppDone := TRUE;
		gApplication.Close;
		Success(fi);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInit}

	procedure TQuitCommand.IQuitCommand (itsCmdNumber: CmdNumber);

	begin
		INoChangesCommand(itsCmdNumber, nil, nil, nil);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TQuitCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TQuitCommand', nil, bClass);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TUndoRedoCommand.DoIt;

		var
			deltaCount: integer;
			lastCommand: TCommand;

	begin
		lastCommand := gTarget.GetLastCommand;
		if lastCommand.fChangesClipboard then
			gApplication.SwapClipViews;

		if lastCommand.fCmdDone then
			begin
				lastCommand.UndoIt;
				deltaCount := -1;
			end
		else
			begin
				lastCommand.RedoIt;
				deltaCount := 1;
			end;

		lastCommand.fCmdDone := not lastCommand.fCmdDone;

		if lastCommand.fCausesChange then					{ put this after .UndoIt/.RedoIt, so they}
{														 can change the flag}
			with lastCommand do
				if fChangedDocument <> nil then
					with fChangedDocument do
						begin
							SetChangeCount(GetChangeCount + deltaCount);
					{$IFC qDebug}
							if GetChangeCount < 0 then
								ProgramBreak('GetChangeCount < 0');
					{$ENDC}
						end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInit}

	procedure TUndoRedoCommand.IUndoRedoCommand (itsCmdNumber: CmdNumber);

	begin
		INoChangesCommand(itsCmdNumber, nil, nil, nil);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TUndoRedoCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TUndoRedoCommand', nil, bClass);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TNewDocCommand.DoIt;

	begin
		gApplication.OpenNew(fCmdNumber);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	procedure TNewDocCommand.INewDocCommand (itsCmdNumber: CmdNumber);

	begin
		INoChangesCommand(itsCmdNumber, nil, nil, nil);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TNewDocCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TNewDocCommand', nil, bClass);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TOldDocCommand.DoIt;

		var
			anAppFile: AppFile;

	begin
		if gApplication.ChooseDocument(fCmdNumber, anAppFile) then
			gApplication.OpenOld(fCmdNumber, anAppFile);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	procedure TOldDocCommand.IOldDocCommand (itsCmdNumber: CmdNumber);

	begin
		INoChangesCommand(itsCmdNumber, nil, nil, nil);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TOldDocCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TOldDocCommand', nil, bClass);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	procedure TAboutAppCommand.IAboutAppCommand (itsCmdNumber: CmdNumber);

	begin
		INoChangesCommand(itsCmdNumber, nil, nil, nil);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAAboutApp}

	procedure TAboutAppCommand.DoIt;

	begin
		gApplication.DoShowAboutApp;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TAboutAppCommand.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TAboutAppCommand', nil, bClass);
		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInit}

	procedure TApplication.IApplication (itsMainFileType: OSType);

		const
			kParamText1 = '^0';

		type
			MenuBarHandle = ^MenuBarPtr;
			MenuBarPtr = ^MenuBarRecord;
			MenuBarRecord = record
					nMenus: integer;
					menuID: array[1..1000] of integer;
				end;

		var
			menuID: integer;
			aMenu: MenuHandle;
			mbar: Handle;
			hmbar: MenuBarHandle;
			i: integer;
			s: Str255;
			aCommandList: TCommandList;
			apName: Str255;
			apRefnum: integer;
			apParam: Handle;

	begin
		gApplication := SELF;
		gAppDone := FALSE;
		gSysWindowActive := FALSE;
		gTarget := SELF;
		fTicksOfLastIdle := 0;
		fTicksTilNextIdle := 0;
		fCommandQueue := nil;
		fLastCommand := nil;

		with gOldScrapStuff do
			begin
				scrapSize := 0;
				scrapHandle := nil;
				scrapCount := 0;
				scrapState := 0;
				scrapName := nil;
			end;
		gNewScrapStuff := gOldScrapStuff;

		IEvtHandler(nil);

	{$IFC qInspector}
		MakeInspector;
		AddObjectToInspector(SELF);
		AddObjectToInspector(gNullPrintHandler);
		AddObjectToInspector(gPrintHandler);
		AddObjectToInspector(gFreeWindowList);
	{$ENDC}

		New(aCommandList);
		FailNil(aCommandList);
		aCommandList.ICommandList;
		fCommandQueue := aCommandList;
	{$IFC qDebug}
		fCommandQueue.SetEltType('TCommand');
	{$ENDC}

		fLaunchWithNewDocument := TRUE;

		gDocList := NewList;
	{$IFC qDebug}
		gDocList.SetEltType('TDocument');
	{$ENDC}

		gMainFileType := itsMainFileType;

		gVarClipPicSize := FALSE;							{ temporary }

		if not gFinderPrinting then
			begin
				mbar := MAGetNewMBar(gMBarDisplayed);
				if mbar <> nil then
					begin
						SetMenuBar(mbar);
						ReleaseResource(Handle(mbar));
					end
				else
					begin
			{$IFC qDebug}
						Writeln('The MBAR ', gMBarDisplayed : 1, ' resource was not specified.');
						ProgramBreak('You will not have any menus!');
			{$ENDC}
					end;

		{$IFC qDebug OR qInspector}
				aMenu := GetMenu(mDebug);
				if aMenu <> nil then
					InsertMenu(aMenu, 0);
		{$ENDC}

				aMenu := MAGetMenu(mApple);
				if aMenu <> nil then
					AddResMenu(aMenu, 'DRVR');

		{ If the "About" item contains the paramtext keystring (^0) then substitute the}
{		Application's name}
				CmdToName(cAboutApp, s);
				i := Pos(kParamText1, s);
				if i <> 0 then
					begin
						GetAppParms(apName, apRefnum, apParam);
						Delete(s, i, length(kParamText1));
						Insert(apName, s, i);
						SetCmdName(cAboutApp, s);
					end;

				mbar := MAGetNewMBar(gMBarNotDisplayed);		{ reads in and initializes these menus. }
				if mbar <> nil then
					ReleaseResource(Handle(mbar));

				if qNeedsHierarchicalMenus | gConfiguration.hasHierarchicalMenus then
					begin
			{ Add all the hierarchical menus in the 'hierarchical' menu bar to the applications}
{			menus.	Note that hierarchical must be treated differently from regular menus in that}
{			they are added with InsertMenu(, -1).	We can't use GetNewMBar here because we want}
{			to call GetMenu for each menu in the MBAR, and GetNewMBar would do that for us.}
						hmbar := MenuBarHandle(GetResource('MBAR', gMBarHierarchical));
						if hmbar <> nil then
							begin
								for i := 1 to hmbar^^.nMenus do
									begin
										aMenu := GetMenu(hmbar^^.menuID[i]);
										if aMenu <> nil then
											InsertMenu(aMenu, -1);
									end;
								ReleaseResource(Handle(hmbar));
							end;
					end;

				gClipWindow := MakeClipboardWindow;
				gClipOrphanage := gClipWindow.FindSubView(KIDClipView);
				FailNILResource(gClipOrphanage);

			end;

	{}
{	| Finally finish up with the debugger;}
{}
	{$IFC qDebug}
		InitUDebugAfterIApplication;
	{$ENDC}

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClipboard}

	procedure TApplication.AbandonUndoClipboard;

	begin
		if gClipUndoView <> nil then
			begin
		{$IFC qDebug}
				if gClipUndoView = gClipView then
					ProgramBreak('About to Free view both in clip and undo Clip!');
		{$ENDC}
				gClipUndoView.FreeFromClipboard;
				gClipUndoView := nil;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAActivate}

	procedure TApplication.AboutToLoseControl (convertClipboard: BOOLEAN);

		label
			1000;

		var
			err: LONGINT;
			fi: FailInfo;
			lastCommand: TCommand;

		procedure PublicizeFailed (error: integer; message: LONGINT);		{ ??? ERROR ??? }

		begin
		{$IFC qDebug}
			Writeln('Can''t use clipboard data outside this app');
		{$ENDC}
			if message = 0 then
				message := msgExportClipFailed;
			ShowError(error, message);
			goto 1000;
		end;

	begin
 { Remember when we last started a desk accessory. UPrinting uses this}
{  to know whether the Chooser may have been run.}
		gLastDeskAcc := TickCount;

		ActivateBusyCursor(FALSE);							{ Don't want busy cursor while in desk acc.}

		if convertClipboard then
			begin
				lastCommand := GetLastCommand;
				if (lastCommand <> nil) & lastCommand.fChangesClipboard then
					CommitLastCommand;

				if (gClipView <> nil) & (not gClipWrittenToDeskScrap) then
					begin
						err := ZeroScrap;
						CatchFailures(fi, PublicizeFailed);
						gClipView.WriteToDeskScrap;
						Success(fi);
						gClipWrittenToDeskScrap := TRUE;
1000:
						AbsorbScrapStuff;							{ ??? correct post-error reentry point? }
					end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.AbsorbScrapStuff;

	begin
		gOldScrapStuff := gNewScrapStuff;					{ stash previous version, for later}
{														 change-checkage}
		gNewScrapStuff := InfoScrap^;						{ Copy over from low memory to our private}
{														 global record}
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.ActivateBusyCursor (entering: BOOLEAN);

	begin
		BusyActivate(entering);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TApplication.AddDocument (aNewDocument: TDocument);

	begin
		gDocList.Insert(aNewDocument);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TApplication.AddFreeWindow (aWindow: TWindow);

	begin
		gFreeWindowList.Insert(aWindow);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFile}

	function TApplication.AlreadyOpen (fileName: Str255; volRefnum: integer): TDocument;

		const
			ignoreCase = FALSE;
			diacritSens = TRUE;

		var
			parmDirID: LONGINT;
			parmVRefnum: integer;
			result: TDocument;
			err: OSErr;

		procedure TestDoc (doc: TDocument);

			var
				err: OSErr;
				docVRefnum: integer;
				docDirID: LONGINT;

		begin
			if (result = nil) & doc.fSaveExists then
				begin
					docVRefnum := doc.fVolRefnum;
					err := GetDirID(docVRefnum, docDirID);
					if (err = noErr) & (docVRefnum = parmVRefnum) & (docDirID = parmDirID) then
						begin
				{$Push}
 							{ EqualString does not move memory }
							if EqualString(fileName, doc.fTitle^^, ignoreCase, diacritSens) then
								result := doc;
				{$Pop}
						end;
				end;
		end;

	begin
		result := nil;

		parmVRefnum := volRefnum;
		err := GetDirID(parmVRefnum, parmDirID);

		if err = noErr then
			ForAllDocumentsDo(TestDoc);

		AlreadyOpen := result;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.Beep (duration: integer);

	begin
		SysBeep(duration);
	end;

{--------------------------------------------------------------------------------------------------}

	function CallFileFilter (paramBlock: HParmBlkPtr; routine: ProcPtr): BOOLEAN;
	inline
		$205F,										{ MOVEA.L (A7)+,A0 }
		$4E90;										{ JSR (A0) }

 { This is called only when opening/printing from the finder; it simulates the}
{  filtering done by Std File.}

{--------------------------------------------------------------------------------------------------}
{$S MAFinder}

	function TApplication.CanOpenDocument (itsCmdNumber: CmdNumber; var anAppFile: AppFile): BOOLEAN;

		var
			dlgID: integer;
			where: Point;
			fileFilter: ProcPtr;
			dlgHook: ProcPtr;
			filterProc: ProcPtr;
			typeList: TypeListHandle;
			i: integer;
			paramBlock: HParamBlockRec;
			numTypes: integer;

	begin
		CanOpenDocument := FALSE;

  { First check that file type is in the list of allowed file types. See SFGetParms}
{   below for more info.}
		typeList := TypeListHandle(NewHandle(0));
		FailNil(typeList);

		SFGetParms(itsCmdNumber, dlgID, where, fileFilter, dlgHook, filterProc, typeList);

		numTypes := GetHandleSize(Handle(typeList)) div SIZEOF(ResType);
		if numTypes = 0 then
			CanOpenDocument := TRUE 						{ if 0 then want all types }
		else
			for i := 1 to numTypes do
 { do coercions because the compiler generates lousy code for comparing 2}
{  packed arrays of characters}
				if LONGINT(anAppFile.fType) = LONGINT(typeList^^[i]) then
					begin
						if fileFilter = nil then
							CanOpenDocument := TRUE
						else if GetFileInfo(anAppFile.fName, anAppFile.vRefnum, paramBlock) = noErr then
							CanOpenDocument := not CallFileFilter(@paramBlock, fileFilter)
						else
							CanOpenDocument := FALSE;
						LEAVE;
					end;

		Handle(typeList) := DisposeIfHandle(typeList);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.CheckDeskScrap;

		var
			err: OSErr;
			lastCommand: TCommand;

	begin
		AbsorbScrapStuff;

		if (gOldScrapStuff.scrapCount <> gNewScrapStuff.scrapCount) then
			begin
				lastCommand := GetLastCommand;
				if (lastCommand <> nil) & lastCommand.fChangesClipboard then
					CommitLastCommand;
				gClipView.FreeFromClipboard;					{ AbandonCurrentClipboard }
				gClipView := nil;								{ no reason to have an Undo clipboard }

		{ If the scrap is in memory and we are low on memory, then write the scrap to disk.}
				if (gNewScrapStuff.scrapState > 0) & MemSpaceIsLow then
					err := UnloadScrap; 						{ Write the scrap to disk. How should we}
{														 handle the error???}
				ReadFromDeskScrap;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	function TApplication.ChooseDocument (itsCmdNumber: CmdNumber; var anAppFile: AppFile): BOOLEAN;

		type
			SFTypeListHandle = ^SFTypeListPtr;
			SFTypeListPtr = ^SFTypeList;

		var
			dlgID: integer;
			where: Point;
			fileFilter: ProcPtr;
			dlgHook: ProcPtr;
			filterProc: ProcPtr;
			typeList: TypeListHandle;
			pTypeList: SFTypeListPtr;
			numTypes: integer;
			reply: SFReply;

	begin
		typeList := TypeListHandle(NewHandle(0));
		FailNil(typeList);

		SFGetParms(itsCmdNumber, dlgID, where, fileFilter, dlgHook, filterProc, typeList);
		numTypes := GetHandleSize(Handle(typeList)) div SIZEOF(ResType);

		if numTypes = 0 then
			begin
				numTypes := -1;								{ Tell Std File to display all types.}
				pTypeList := @pTypeList;						{ arbitrary, as long as it points to 4 bytes}
{														 of valid memory}
			end
		else
			begin
				LockHandleHigh(Handle(typeList));				{ in case Std File does allocations }
				pTypeList := SFTypeListHandle(typeList)^;
			end;

	{$IFC qDebug}
	{ Causes TApplication.GetEvent to call CheckRsrcUsage. }
		gRsrcCheck := 0;
	{$ENDC}

		UpdateAllWindows;									{ needed to work around bug in SF; if all}
{														 windows are not updated you wont be able}
{														 to mount a disk correctly}

		SFPGetFile(where, '', fileFilter, numTypes, pTypeList^, dlgHook, reply, dlgID, filterProc);

		Handle(typeList) := DisposeIfHandle(typeList);

		ChooseDocument := reply.good;
		if reply.good then
			begin
				anAppFile.vRefnum := reply.vRefnum;
				anAppFile.fType := reply.fType;
				anAppFile.versNum := reply.version;
				anAppFile.fName := reply.fName;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClipboard}

	procedure TApplication.ClaimClipboard (clipView: TView);

	begin
		AbandonUndoClipboard;								{ free up any old UNDO stuff }
		gClipUndoView := gClipView; 						{ Copy current clipboard contents to the}
{														 Undo side}
		if clipView <> nil then
			SetClipView(clipView)							{ Will install it as gClipView }
		else
			begin
		{$IFC qDebug}
				ProgramBreak('Claiming clipboard with null view');
		{$ENDC}
			end;

		gClipClaimed := TRUE;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MATerminate}

	procedure TApplication.Close;

		var
			WMgrWindow: WindowPtr;

		procedure FreeIt (anEvtHandler: TEvtHandler);

		begin
			FreeIfObject(anEvtHandler); 					{ ??? also call Terminate ??? }
			anEvtHandler := nil;
		end;

		procedure CloseADocument (aDocument: TDocument);

		begin
			aDocument.Close;
		end;

	begin
	{ Close all of the visible non-floater windows }
		repeat
			WMgrWindow := MAFrontWindow;
			if WMgrWindow <> nil then
				CloseWMgrWindow(WMgrWindow);
		until WMgrWindow = nil;

	{ Close all of the windows }
		repeat
			WMgrWindow := FrontWindow;
			if WMgrWindow <> nil then
				CloseWMgrWindow(WMgrWindow);
		until WMgrWindow = nil;

	{ Close any windowless documents }
		ForAllDocumentsDo(CloseADocument);

		gPrintHandler.Terminate;
		if gHeadCoHandler <> nil then
			gHeadCoHandler.EachHandler(FreeIt);
		if LoadScrap <> noErr then
			; 						{ ??? }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClose}

	procedure TApplication.CloseWMgrWindow (aWMgrWindow: WindowPtr);

		var
			aWindow: TWindow;

	begin
		if IsDeskAccessory(aWMgrWindow) then
			CloseDeskAcc(WindowPeek(aWMgrWindow)^.windowKind)
		else
			begin
				aWindow := WMgrToWindow(aWMgrWindow);
				if aWindow <> nil then
					aWindow.CloseByUser
				else
					HideWindow(aWMgrWindow);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.CommitLastCommand;

	begin
		AbandonUndoClipboard;

		if fLastCommand <> nil then
			begin
				if fLastCommand.fCmdDone then
					fLastCommand.Commit;
				if fLastCommand.fFreeOnCompletion then
					FreeIfObject(fLastCommand);
				fLastCommand := nil;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.CountClicks (aPDownEvent: EventRecordPtr; whereMouseDown: integer): integer;

		var
			clickCount: integer;

	begin
		clickCount := 1;

		with aPDownEvent^ do
			begin
		{ This series of IF's generates less code than short-circuit booleans }
				if whereMouseDown = gLastClickPart then
					if gClickCount > 0 then 					{ not the first click and ... }
						if when - gLastUpTime < GetDblTime then { ... close enough in time and ... }
							if gTarget.DoMultiClick(gLastMsePt, where) then { ... close enough in space }
								clickCount := gClickCount + 1;

				gLastMsePt := where;
			end;

		gLastClickPart := whereMouseDown;
		gClickCount := clickCount;
		CountClicks := clickCount;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClose}

	procedure TApplication.DeleteDocument (docToDelete: TDocument);

	begin
		gDocList.Delete(docToDelete);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.DeleteFreeWindow (windowToDelete: TWindow);

	begin
		gFreeWindowList.Delete(windowToDelete);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.DispatchEvent (var theEventInfo: EventInfo; var commandToPerform: TCommand);

	begin
		commandToPerform := nil;

		with theEventInfo.thePEvent^ do
			begin

				case what of
					mouseUp: 
						commandToPerform := HandleMouseUp(theEventInfo);

					mouseDown: 
						commandToPerform := HandleMouseDown(theEventInfo);

					activateEvt: 
						commandToPerform := HandleActivateEvent(theEventInfo);

					updateEvt: 
						commandToPerform := HandleUpdateEvent(theEventInfo);

					keyDown, autoKey: 
						commandToPerform := HandleKeyDownEvent(theEventInfo);

					keyUp: 
						;
				{ !!! We'd like to have a chain for keyUp but a MultiFinder bug}
{				(at least up to 6.0) keep us from reliably getting keyUp events}
{				after minor context switches (background updates, etc.).  It replaces}
{				the global event mask (which we would have had to change to get keyups}
{				in the first place) with the wrong mask.  Oh well, we had such good intentions!}

					diskEvt: 
						commandToPerform := HandleDiskEvent(theEventInfo);

					app4Evt:
			{ All app4Evt's are owned by the system }
						commandToPerform := HandleSystemEvent(theEventInfo);

					otherwise
						commandToPerform := HandleAlienEvent(theEventInfo);

				end;

			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.DoCommandKey (ch: CHAR; var info: EventInfo): TCommand;
		OVERRIDE;

	begin
		DoCommandKey := nil;
		if (not info.theAutoKey) & (not InModalMenuState) then
			begin
				SetupTheMenus;
		{ If you want to have case sensitive command keys use the following line because}
{		KeyEventToComponents returns the correct character for shifted keys when the command}
{		key is down.  That lets us test for things like command-period correctly.  So in order}
{		to be backward compatible (sigh) we now have to ignore the _correct_ char that is passed}
{		in (and is in info.theCharacter) and use the old ToolBox supplied unPasteurized character that}
{		is left in the actual EventRecord at info.thePEvent^}

		{ DoCommandKey := MenuEvent(MenuKey(ch)); }

				DoCommandKey := MenuEvent(MenuKey(chr(BAND(info.thePEvent^.message, charCodeMask))));

			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.DoKeyCommand (ch: CHAR; aKeyCode: integer; var info: EventInfo): TCommand;
		OVERRIDE;

		procedure HandleFunctionKey (cmd: CmdNumber);

		begin
			SetupTheMenus;
			if CmdEnabled(cmd) then
				DoKeyCommand := gTarget.DoMenuCommand(cmd);
		end;

	begin
		DoKeyCommand := nil;
		case aKeyCode of
			kF1VirtualCode: 
				HandleFunctionKey(cUndo);
			kF2VirtualCode: 
				HandleFunctionKey(cCut);
			kF3VirtualCode: 
				HandleFunctionKey(cCopy);
			kF4VirtualCode: 
				HandleFunctionKey(cPaste);
			kClearVirtualCode: 
				HandleFunctionKey(cClear);
			otherwise
				DoKeyCommand := inherited DoKeyCommand(ch, aKeyCode, info);
		end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	function TApplication.DoMakeDocument (itsCmdNumber: CmdNumber): TDocument;
{ E X A M P L E}
{	VAR aYOURDocument: TDocument;}
{}
{	BEGIN}
{	New(aYOURDocument);}
{	aYOURDocument.IYOURDocument(itsDocKind, ...);}
{	DoMakeDocument := aYOURDocument;}
{	END;}
{}

		var
			aDocument: TDocument;

	begin
	{ Allocate and initialize the document}
		aDocument := nil;

		if qTemplateViews then
			aDocument := TDocument(NewStdObject(kStdDocument))
		else
			New(aDocument);

		FailNil(aDocument);

		aDocument.IDocument(gMainFileType, '????', kUsesDataFork, not kUsesRsrcFork, not kDataOpen, not kRsrcOpen);
		DoMakeDocument := aDocument;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	function TApplication.DoMenuCommand (aCmdNumber: CmdNumber): TCommand;

		var
			succeeded: BOOLEAN;
			aDocument: TDocument;
			aWindow: TWindow;
			aNewDocCommand: TNewDocCommand;
			aOldDocCommand: TOldDocCommand;
			aAboutAppCommand: TAboutAppCommand;
			aQuitCommand: TQuitCommand;
			aUndoRedoCommand: TUndoRedoCommand;

			oldObjectPerm: BOOLEAN;
			just: INTEGER;

		{$IFC qDebug}
			aDebugCommand: TDebugCommand;
			oldState: BOOLEAN;
		{$ENDC}

		{$IFC qInspector}
			aInspectorCommand: TInspectorCommand;
			oldIState: BOOLEAN;
		{$ENDC}

	begin
	{ ==================================================================================}
{	Some commands will be returned to perform actions that must _ALWAYS_ be available.}
{	The allocation cannot be allowed to fail.  So we do a temp allocation which by}
{	definition cannot be allowed to fail.  This strategy is used wherever we want to use}
{	command objects but don't want to leave the user twisting in the breeze.}
{	NOTE: Don't forget to allow for this memory in your mem! resource if you copy this}
{	style in your own code.}
{	==================================================================================}

		aWindow := GetActiveWindow;
		DoMenuCommand := nil;

		case aCmdNumber of
			cQuit: 
				begin

					oldObjectPerm := AllocateObjectsFromPerm(FALSE);
					New(aQuitCommand);
					if AllocateObjectsFromPerm(oldObjectPerm) then
						;

					FailNil(aQuitCommand);						{ just in case }
					aQuitCommand.IQuitCommand(aCmdNumber);
					DoMenuCommand := aQuitCommand;
				end;

			cNew..cNewLast, cFinderNew: 
				begin
					New(aNewDocCommand);
					FailNil(aNewDocCommand);
					aNewDocCommand.INewDocCommand(aCmdNumber);
					DoMenuCommand := aNewDocCommand;
				end;

			cOpen..cOpenLast: 
				begin
					New(aOldDocCommand);
					FailNil(aOldDocCommand);
					aOldDocCommand.IOldDocCommand(aCmdNumber);
					DoMenuCommand := aOldDocCommand;
				end;

			cClose: 
				begin
					if qDebug & (WMgrToWindow(FrontWindow) <> nil) then
						ProgramBreak('The frontmost window is a window object but didn''t handle the cClose CmdNumber, your TWindow subclass probably forgot to call INHERITED DoMenuCommand!');

					CloseWMgrWindow(FrontWindow);				{ TWindow would have handled the command}
{														 before we get here so the window is}
{														 probably a DA or something}
				end;

			cShowClipboard: 
				if gClipWindow = aWindow then
					gClipWindow.Close						{ Hide the clipboard }
				else
					begin
						gClipWindow.Open;
						gClipWindow.Select;
					end;

			cAboutApp: 
				begin
					New(aAboutAppCommand);
					FailNil(aAboutAppCommand);
					aAboutAppCommand.IAboutAppCommand(aCmdNumber);
					DoMenuCommand := aAboutAppCommand;
				end;

		{$IFC qDebug}
			cDebugWind: 
				DebugShowTranscriptWindow;
			cExperimenting: 
				gExperimenting := not gExperimenting;
			cReportEvt: 
				gReportEvt := not gReportEvt;
			cDebugPrinting: 
				gDebugPrinting := not gDebugPrinting;
			cReportMenuChoices: 
				gReportMenuChoices := not gReportMenuChoices;
			cIntenseDebugging: 
				gIntenseDebugging := not gIntenseDebugging;
			cIdentifySoftware: 
				begin
					Writeln;
					Writeln('===== Software Version(s): =====');
					Writeln(kCopyright);
					gTarget.IdentifySoftware;
				end;
			cRefreshFrontWindow: 
				if aWindow <> nil then
					aWindow.ForceRedraw;
			cModalToggle: 
				if aWindow <> nil then
					aWindow.fIsModal := not aWindow.fIsModal;
			cDoFirstClick: 
				if aWindow <> nil then
					aWindow.fDoFirstClick := not aWindow.fDoFirstClick;
			cSetSysJust: 
				begin
			{ swap the current setting }
					if GetActualJustification(teJustSystem) = teJustLeft then
						just := teJustRight
					else
						just := teJustLeft;

			{ stuff the new setting }
					if qNeedsScriptManager | gConfiguration.hasScriptManager then
						SetSysJust(just)
					else if qNeedsROM128k | gConfiguration.hasROM128k then
						IntegerPtr(kLMTESysJust)^ := just;
				end;

			cEnterMacAppDebugger: 
				begin
					oldObjectPerm := AllocateObjectsFromPerm(FALSE);
					oldState := AddNewObjectsToInspector(FALSE);
					New(aDebugCommand);
					if AddNewObjectsToInspector(oldState) then
						;
					if AllocateObjectsFromPerm(oldObjectPerm) then
						;

					FailNil(aDebugCommand); 					{ just in case }
					aDebugCommand.IDebugCommand(aCmdNumber);
					DoMenuCommand := aDebugCommand;
				end;
		{$ENDC}

		{$IFC qDebug}
			cTraceSetupMenus: 
				gTraceSetupMenus := not gTraceSetupMenus;
			cTraceIdle: 
				gTraceIdle := not gTraceIdle;
		{$ENDC}

		{$IFC qInspector}
			cNewInspectorWindow: 
				begin
					oldIState := AddNewObjectsToInspector(FALSE);
					New(aInspectorCommand);
					if AddNewObjectsToInspector(oldIState) then
						;
					FailNil(aInspectorCommand);
					aInspectorCommand.IInspectorCommand(aCmdNumber);
					DoMenuCommand := aInspectorCommand;
				end;
		{$ENDC}

			cUndo											{ , cRedo }
			: 
				begin
					oldObjectPerm := AllocateObjectsFromPerm(FALSE);
					New(aUndoRedoCommand);
					if AllocateObjectsFromPerm(oldObjectPerm) then
						;

					FailNil(aUndoRedoCommand);					{ just in case }
					aUndoRedoCommand.IUndoRedoCommand(aCmdNumber);
					DoMenuCommand := aUndoRedoCommand;
				end;

			otherwise
				DoMenuCommand := inherited DoMenuCommand(aCmdNumber);
		end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.DoSetupMenus;

		var
			lowSpace: BOOLEAN;
			aWindowPtr: WindowPtr;

	begin
		inherited DoSetupMenus;

		lowSpace := MemSpaceIsLow;

		Enable(cAboutApp, TRUE);

		Enable(cQuit, gEventLevel <= 1);					{ Can't enable Quit if in nested event}
{														 handling}
		Enable(cShowClipboard, TRUE);
		SetMenuState(cShowClipboard, kIDBuzzString, bzShowClip, bzHideClip, gClipWindow = GetActiveWindow);

		Enable(cNew, not lowSpace);
		Enable(cOpen, not lowSpace);

		aWindowPtr := FrontWindow;
		if (aWindowPtr <> nil) & (WMgrToWindow(aWindowPtr) = nil) then
			Enable(cClose, WindowPeek(aWindowPtr)^.goAwayFlag <> FALSE); { window objects will take care}
{																	  of themselves, but we take}
{																	  care of the indigent.}
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAAboutApp}

	var
		hadCreditsStringList: BOOLEAN;						{ does the rsrc 'STR#' = kDefaultCredits}
{														 exist ?}
		lastCreditsStringIndex: integer;					{ the last string in the STR# to be}
{														 displayed}
		lastCreditsShownTicks: LONGINT; 					{ the tickcount when the last Credit was}
{														 Shown}
		originalText: StringHandle;					{ the about box's original text (prior to}
{														 credits)}
		waitTicks: integer;						{ how long to wait between credits }

	function DoShowAboutAppFilter (theDialog: DialogPtr; var theEvent: EventRecord; var itemHit: integer): BOOLEAN;

		var
			s: Str255;
			originalStr: Str255;
			item: Handle;

		function GetFirstStaticText (theDialog: DialogPtr): Handle;

			var
				itemType: integer;
				item: Handle;
				itemNo: integer;
				box: Rect;

		begin
			GetFirstStaticText := nil;
			itemNo := 1;
			repeat
				item := nil;
				GetDItem(theDialog, itemNo, itemType, item, box);
				if BAND(itemType, $7F) = statText then		{ we don't care if its enabled or not }
					begin
						GetFirstStaticText := item;
						LEAVE;
					end
				else
					itemNo := succ(itemNo);
			until item = nil;
		end;

		procedure DoKeyDown (itemNo: integer);
	{ Handle a keypress that has been mapped to the OK button. }

			var
				itemType: integer;
				item: Handle;
				finalTicks: LONGINT;
				box: Rect;

		begin
			DoShowAboutAppFilter := TRUE;
			itemHit := itemNo;
			GetDItem(theDialog, itemNo, itemType, item, box);
			if itemType = (ctrlItem + btnCtrl) then
				begin										{ this code gives visual feedback }
					HiliteControl(ControlHandle(item), inButton); { hilite the button }
					Delay(8, finalTicks);						{ delay for 8 ticks }
					HiliteControl(ControlHandle(item), 0);		{ stop hiliting the button }
				end;
		end;

	begin
		DoShowAboutAppFilter := FALSE;

		case theEvent.what of
			keyDown: 
				case chr(BAND(theEvent.message, charCodeMask)) of
					chEnter, chReturn: 
						DoKeyDown(ok);
				end;
			nullEvent: 
				if (TickCount - lastCreditsShownTicks) > waitTicks then
					begin
						item := GetFirstStaticText(theDialog);
						GetIndString(s, kDefaultCredits, lastCreditsStringIndex);
						if s <> '' then
							begin
					{ save the original text }
								if (lastCreditsStringIndex = 1) & (originalText^^ = '') & (item <> nil) then
									begin
										GetIText(item, originalStr);
										SetString(originalText, originalStr);
									end;
								lastCreditsStringIndex := succ(lastCreditsStringIndex);
								lastCreditsShownTicks := TickCount;
								if item <> nil then
									SetIText(item, s);
								waitTicks := Min((length(s) * 6), 60);
							end
						else									{ no more items }
							begin
								lastCreditsStringIndex := 1;
								lastCreditsShownTicks := TickCount;
								if item <> nil then
									begin
										BlockMove(Ptr(originalText^), @originalStr, length(originalText^^) + 1);
										SetIText(item, originalStr);
									end;
								waitTicks := 6 * 60;
							end;
					end;
		end;

	{ Forward on to the standard filter }
		if gMacAppAlertFilter <> nil then
			DoShowAboutAppFilter := CallAlertFilter(theDialog, theEvent, itemHit, gMacAppAlertFilter);

	end;

	procedure TApplication.DoShowAboutApp;
{ Method to display the "About" box for your application.  Override to do interesting things.}
{Since it is normally called from a command; the app usually has the maximum free space available.}

		var
			apName: Str255;
			apRefnum: integer;
			apParam: Handle;

	begin
		FailSpaceIsLow;
		GetAppParms(apName, apRefnum, apParam);
		ParamText(apName, '', '', '');						{ Put Application name in the about box }
		hadCreditsStringList := (GetResource('STR#', kDefaultCredits) <> nil);
		if hadCreditsStringList then
			begin
				lastCreditsStringIndex := 1;
				lastCreditsShownTicks := TickCount;
				waitTicks := 5 * 60;
				originalText := NewString('');
				if MacAppAlert(phAboutApp, @DoShowAboutAppFilter) <> 0 then
					;
				Handle(originalText) := DisposeIfHandle(originalText);
			end
		else
			StdAlert(phAboutApp);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.EachFreeWindow (procedure DoToWindow (aWindow: TWindow));

	begin
		gFreeWindowList.Each(DoToWindow);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

	procedure TApplication.Fields (procedure DoToField (fieldName: Str255; fieldAddr: Ptr; fieldType: integer));
		OVERRIDE;

	begin
		DoToField('TApplication', nil, bClass);
		DoToField('fCommandQueue', @fCommandQueue, bObject);
		DoToField('fLastCommand', @fLastCommand, bObject);
		DoToField('fLaunchWithNewDocument', @fLaunchWithNewDocument, bBoolean);

		DoToField('fTicksOfLastIdle', @fTicksOfLastIdle, bLongint);
		DoToField('fTicksTilNextIdle', @fTicksTilNextIdle, bLongint);

		DoToField('gAppDone', @gAppDone, bBoolean);
		DoToField('gApplication', @gApplication, bObject);

		TextStyleFields('gApplicationStyle', gApplicationStyle, DoToField);

	{$IFC qDebug}
		DoToField('gBusyTempRgn', @gBusyTempRgn, bBoolean);
	{$EndC}
		DoToField('gChooserOK', @gChooserOK, bBoolean);
		DoToField('gClickCount', @gClickCount, bInteger);
		DoToField('gClipClaimed', @gClipClaimed, bBoolean);
		DoToField('gClipOrphanage', @gClipOrphanage, bObject);
		DoToField('gClipUndoView', @gClipUndoView, bObject);
		DoToField('gClipView', @gClipView, bObject);
		DoToField('gClipWindow', @gClipWindow, bObject);
		DoToField('gClipWrittenToDeskScrap', @gClipWrittenToDeskScrap, bBoolean);

		ConfigRecFields('gConfiguration', gConfiguration, DoToField);

		DoToField('gCouldPrint', @gCouldPrint, bBoolean);
		DoToField('gCurrPrintHandler', @gCurrPrintHandler, bObject);
		DoToField('gCursorRgn', @gCursorRgn, bRgnHandle);
	{$IFC qDebug}
		DoToField('gDebugPrinting', @gDebugPrinting, bBoolean);
	{$EndC}
		DoToField('gDocList', @gDocList, bObject);
		DoToField('gDrawingPictScrap', @gDrawingPictScrap, bBoolean);
		DoToField('gDrawingPictScrapView', @gDrawingPictScrapView, bObject);
		DoToField('gErrorParm3', @gErrorParm3, bString);
		DoToField('gEventLevel', @gEventLevel, bInteger);
	{$IFC qDebug}
		DoToField('gExperimenting', @gExperimenting, bBoolean);
	{$EndC}
		DoToField('gFileCount', @gFileCount, bInteger);
		DoToField('gFinderPrinting', @gFinderPrinting, bBoolean);
		DoToField('gFocusedView', @gFocusedView, bObject);
		DoToField('gFreeWindowList', @gFreeWindowList, bObject);
		DoToField('gGotClipType', @gGotClipType, bBoolean);
		DoToField('gHeadCohandler', @gHeadCoHandler, bObject);
		DoToField('gIdlePhase', @gIdlePhase, bByte);
		DoToField('gInBackground', @gInBackground, bBoolean);
		DoToField('gInitialized', @gInitialized, bBoolean);
	{$IFC qDebug}
		DoToField('gIntenseDebugging', @gIntenseDebugging, bBoolean);
	{$EndC}
		DoToField('gLastClickPart', @gLastClickPart, bInteger);
		DoToField('gLastDeskAcc', @gLastDeskAcc, bLongint);
		DoToField('gLastMsePt', @gLastMsePt, bPoint);
		DoToField('gLastUpTime', @gLastUpTime, bLongint);
		DoToField('gLongOffset', @gLongOffset, bVPoint);
		DoToField('gLowSpaceInterval', @gLowSpaceInterval, bLongint);
		DoToField('gMainEventMask', @gMainEventMask, bHexInteger);
		DoToField('gMainFileType', @gMainFileType, bOSType);
		DoToField('gMBarDisplayed', @gMBarDisplayed, bInteger);
		DoToField('gMBarHeight', @gMBarHeight, bInteger);
		DoToField('gMBarHierarchical', @gMBarHierarchical, bInteger);
		DoToField('gMBarNotDisplayed', @gMBarNotDisplayed, bInteger);
		DoToField('gMenusAreSetup', @gMenusAreSetup, bBoolean);
		ScrapStuffFields('gNewScrapStuff', gNewScrapStuff, DoToField);
		DoToField('gNextSpaceMsg', @gNextSpaceMsg, bLongint);
		DoToField('gNoChanges', @gNoChanges, bObject);
		DoToField('gNullPrintHandler', @gNullPrintHandler, bObject);
		DoToField('gNumUntitled', @gNumUntitled, bInteger);
		DoToField('gOldChooserFlag', @gOldChooserFlag, bBoolean);
		ScrapStuffFields('gOldScrapStuff', gOldScrapStuff, DoToField);
		DoToField('gOrthogonal[h]', @gOrthogonal[h], bByte);
		DoToField('gOrthogonal[v]', @gOrthogonal[v], bByte);
		DoToField('gPageOffset', @gPageOffset, bVPoint);
		DoToField('gPrefClipType', @gPrefClipType, bOSType);
		DoToField('gPrintHandler', @gPrintHandler, bObject);
		DoToField('gPrinting', @gPrinting, bBoolean);
		DoToField('gRedrawMenuBar', @gRedrawMenuBar, bBoolean);
	{$IFC qDebug}
		DoToField('gReportEvt', @gReportEvt, bBoolean);
	{$EndC}
	{$IFC qDebug}
		DoToField('gReportMenuChoices', @gReportMenuChoices, bBoolean);
	{$EndC}
	{$IFC qDebug}
		DoToField('gRsrcCheck', @gRsrcCheck, bBoolean);
	{$EndC}
		DoToField('gSaveFocusRec', nil, bTitle);
		DoToField('  isValid', @gSaveFocusRec.isValid, bBoolean);
		DoToField('  clip', @gSaveFocusRec.clip, bRgnHandle);
		DoToField('  drawingPictScrap', @gSaveFocusRec.drawingPictScrap, bBoolean);
		DoToField('  drawingPictScrapView', @gSaveFocusRec.drawingPictScrapView, bObject);
		DoToField('  focusedView', @gSaveFocusRec.focusedView, bObject);
		DoToField('  longOffset', @gSaveFocusRec.longOffset, bVPoint);
		DoToField('  org', @gSaveFocusRec.org, bPoint);
		DoToField('  port', @gSaveFocusRec.port, bWindowPtr);
		DoToField('  printing', @gSaveFocusRec.printing, bBoolean);
		DoToField('gSignatureCount', @gSignatureCount, bInteger);
		DoToField('gStdHysteresis', @gStdHysteresis, bPoint);
		DoToField('gStdStaggerCount', @gStdStaggerCount, bInteger);
		DoToField('gStdWMoveBounds', @gStdWMoveBounds, bRect);
		DoToField('gStdWSizeRect', @gStdWSizeRect, bRect);
		DoToField('gStdWScreenRect', @gStdWScreenRect, bRect);
		DoToField('gSysWindowActive', @gSysWindowActive, bBoolean);

		TextStyleFields('gSystemStyle', gSystemStyle, DoToField);

		DoToField('gTarget', @gTarget, bObject);
		DoToField('gTempRgn', @gTempRgn, bRgnHandle);
	{$IFC qDebug}
		DoToField('gTraceIdle', @gTraceIdle, bBoolean);
	{$EndC}
		DoToField('gUndoState', @gUndoState, bBoolean);
		DoToField('gUndoCmd', @gUndoCmd, bInteger);
	{$IFC qDebug}
		DoToField('gUsedBy', @gUsedBy, bString);
	{$EndC}
		DoToField('gVarClipPicSize', @gVarClipPicSize, bBoolean);
		DoToField('gWorkPort', @gWorkPort, bGrafPtr);
		DoToField('gWResSignature', @gWResSignature, bIDType);
		DoToField('gWResType', @gWResType, bString);
		DoToField('gZeroPt', @gZeroPt, bPoint);
		DoToField('gZeroRect', @gZeroRect, bRect);
		DoToField('gZeroVPt', @gZeroVPt, bVPoint);
		DoToField('gZeroVRect', @gZeroVRect, bVRect);

		inherited Fields(DoToField);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.ForAllDocumentsDo (procedure DoToDoc (aDocument: TDocument));

	begin
		gDocList.Each(DoToDoc);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.ForAllWindowsDo (procedure DoToWind (aWindow: TWindow));

		procedure DoToYourWindows (aDocument: TDocument);

		begin
			aDocument.ForAllWindowsDo(DoToWind);
		end;

	begin
		ForAllDocumentsDo(DoToYourWindows);
		EachFreeWindow(DoToWind);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInspector}

	procedure TApplication.GetInspectorName (var inspectorName: Str255);

	begin
		if SELF = gApplication then
			inspectorName := 'gApplication';
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClipboard}

	function TApplication.GetDataToPaste (aDataHandle: Handle; var dataType: ResType): LONGINT;

		var
			err: LONGINT;
			myType: ResType;

	begin
		if gGotClipType then
			begin
				dataType := gPrefClipType;

				err := gClipView.GivePasteData(aDataHandle, dataType);

				if err < 0 then
					Failure(err, 0);
			end
		else
			begin
		{$IFC qDebug}
				ProgramBreak('GetDataToPaste called when gGotClipType was FALSE');
		{$ENDC}
			end;

		GetDataToPaste := err;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.GetEvent (eventMask: integer; sleep: LONGINT; cursorRgn: RgnHandle; var anEvent: EventRecord): BOOLEAN;

		const
			kMaxSleep = 60;						{ max sleep in foreground so MultiFinder}
{														 gives time to non-desk accessory drivers}

		var
			haveEvent: BOOLEAN;


	begin

	{$IFC qDebug}
		gRsrcCheck := gRsrcCheck - 1;
		if gRsrcCheck <= 0 then
			begin
				CheckRsrcUsage;
				gRsrcCheck := kRsrcCheckInterval;
			end;
	{$ENDC qDebug}

		if qNeedsWaitNextEvent | gConfiguration.hasWaitNextEvent then
			begin
		{$IFC qDebug}
				if gIntenseDebugging & gReportEvt then
					begin
						WRITE('WaitNextEvent: sleep=', sleep : 0);
			{ faceless driver bug fixed in MF 7.0 }
						if (gConfiguration.systemVersion < $700) & not gInBackground then
							WRITE(', MaxSleep=', kMaxSleep : 0);

						if cursorRgn = nil then
							WRITE(', cursor region=NIL')
						else
							WrLblRect(', cursor', cursorRgn^^.rgnBBox);
						Writeln;
					end;
		{$ENDC}
				ActivateBusyCursor(FALSE);						{ Turn off busy cursor while we're away.}



		{ faceless driver bug fixed in MF 7.0 }
				if (gConfiguration.systemVersion < $700) & not gInBackground then
					sleep := Min(sleep, kMaxSleep);

				haveEvent := WaitNextEvent(eventMask, anEvent, sleep, cursorRgn);



				if not gInBackground then						{ If we're not in the background, then }
					ActivateBusyCursor(TRUE);					{ enable the busy cursor mechanism. }
			end
		else
			begin


				SystemTask;
				haveEvent := GetNextEvent(eventMask, anEvent);


			end;

		GetEvent := haveEvent;

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.GetFrontWindow: TWindow;

		procedure DoToWMgrWindow (theWMgrWindow: WindowPtr);

			var
				aWindow: TWindow;

		begin
			aWindow := WMgrToWindow(theWMgrWindow);
			if (aWindow <> nil) & aWindow.IsShown & (not aWindow.fFloats) then
				begin
					GetFrontWindow := aWindow;
					EXIT(GetFrontWindow)
				end;
		end;

	begin
		GetFrontWindow := nil;
		if not IsDeskAccessory(FrontWindow) then
			EachWMgrWindowDo(DoToWMgrWindow);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.GetActiveWindow: TWindow;

		procedure DoToWMgrWindow (theWMgrWindow: WindowPtr);

			var
				aWindow: TWindow;

		begin
			aWindow := WMgrToWindow(theWMgrWindow);
			if (aWindow <> nil) & aWindow.IsShown & aWindow.fIsActive & (not aWindow.fFloats) then
				begin
					GetActiveWindow := aWindow;
					EXIT(GetActiveWindow)
				end;
		end;

	begin
		GetActiveWindow := nil;
		if not IsDeskAccessory(FrontWindow) then
			EachWMgrWindowDo(DoToWMgrWindow);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.GetLastCommand: TCommand;

	begin
		GetLastCommand := fLastCommand;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.GetNextCommand: TCommand;

		var
			aCommand: TCommand;

		function IsReadyToGo (command: TCommand): BOOLEAN;

		begin
			IsReadyToGo := command.IsReadyToExecute;
		end;

	begin
		if not fCommandQueue.IsEmpty then
			begin
				aCommand := TCommand(fCommandQueue.FirstThat(IsReadyToGo));
				if (aCommand <> nil) & not aCommand.fRecurring then
					fCommandQueue.Delete(aCommand);
				GetNextCommand := aCommand;
			end
		else
			GetNextCommand := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}
 { ??? We should not muck with the window template; the extra code isn't worth it}
{  since programmer can easily change the resource file ???}

	function TApplication.GetRsrcWindow (storage: Ptr; rsrcId: integer; var isResizable, isClosable: BOOLEAN): WindowPtr;
{ We force INVISIBLE in the WIND definition so the screen won't flash. }

		type
			WINDTemplate = record
					bounds: Rect;
					procID: integer;
					visible, filler1: BOOLEAN;
					goAway, filler2: BOOLEAN;
					refcon: LONGINT;
					itemsID: integer;				{ only for DLOG resource }
				end;
			WINDTemplatePtr = ^WINDTemplate;
			WINDTemplateHandle = ^WINDTemplatePtr;

		var
			aWMgrWindow: WindowPtr;
			templateHandle: WINDTemplateHandle;
			rsrcType: ResType;
			ditl: Handle;
			oldPerm: BOOLEAN;
			fi: FailInfo;

		procedure HdlFailure (error: integer; message: LONGINT); 			{ ??? ERROR ??? }

		begin
		{ Make sure the perm allocation flag is set back to what it was}
{		  when we entered GetRsrcWindow.}
			oldPerm := PermAllocation(oldPerm);
		end;

	begin
		oldPerm := PermAllocation(FALSE);
   { Even though the window is permanent, we allocate it}
{ under a temporary flag so that the maximum memory}
{ is available. Quickdraw can blow up if it can't}
{ allocate a grafPort.}

		CatchFailures(fi, HdlFailure);

		templateHandle := WINDTemplateHandle(GetResource('WIND', rsrcId));
		FailNILResource(templateHandle);
		MoveHHi(Handle(templateHandle));					{ in case it is locked by the ROM }

		with templateHandle^^ do
			begin
		{ ignore request for zoomDocProc if not 128K ROM, because}
{		the user might be running pre-3.0 System, which can't}
{		handle zoomDocProc}
				if not qNeedsROM128K & not gConfiguration.hasROM128K then
					procID := BAND(procID, $FFF7);

				visible := FALSE;
				isClosable := goAway;
				isResizable := (procID = documentProc) | (procID = zoomDocProc);
   { If your own defProc is resizable, too, then after}
{   the call on GetRsrcWindow, set isResizable TRUE}
			end;

		if qNeedsColorQD | gConfiguration.hasColorQD then
			aWMgrWindow := WindowPtr(GetNewCWindow(rsrcId, Pointer(storage), Pointer(-1)))
		else
			aWMgrWindow := GetNewWindow(rsrcId, Pointer(storage), Pointer(-1));

		FailNil(aWMgrWindow);
		oldPerm := PermAllocation(oldPerm);
		Success(fi);										{ Don't need the failure handler since we've}
{														 set the perm allocation flag back.}

	{ Now we must make sure that the code reserve is still intact.}
		if not CheckReserve then
			begin
				aWMgrWindow := FreeIfWMgrWindow(aWMgrWindow, storage = nil);

				Failure(memFullErr, 0);
			end;

		GetRsrcWindow := aWMgrWindow;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.HandleActivateEvent (var theEventInfo: EventInfo): TCommand;

		var
			aWindow: TWindow;

	begin
		with theEventInfo, thePEvent^ do
			begin
				aWindow := WMgrToWindow(WindowPtr(message));
				if aWindow <> nil then
					aWindow.Activate(Odd(modifiers));
			end;

		HandleActivateEvent := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.HandleAlienEvent (var theEventInfo: EventInfo): TCommand;

		var
			aCommand: TCommand;
			anEvtHandler: TEvtHandler;

		function TakeEvent (anEvtHandler: TEvtHandler): BOOLEAN;

		begin
			TakeEvent := anEvtHandler.DoHandleEvent(theEventInfo.thePEvent, aCommand);
		end;

	begin
		aCommand := nil;
		if gHeadCoHandler <> nil then
			anEvtHandler := gHeadCoHandler.FirstHandlerThat(TakeEvent);
		HandleAlienEvent := aCommand;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MADoCommand}

	function TApplication.HandleDiskEvent (var theEventInfo: EventInfo): TCommand;

		const
			topLeft = $00500070;

		var
			err: integer;

	begin
		with theEventInfo.thePEvent^ do
			if HiWrd(message) <> noErr then
				begin
					err := DIBadMount(Point(topLeft), message); { ??? do something with the error ??? }
			{$IFC qDebug}
					if err <> noErr then
						Writeln('error from DIBadMount is ', err : 1);
			{$ENDC}
				end;

		HandleDiskEvent := nil;

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.HandleEvent (var theEvent: EventRecord);

		var
			fi: FailInfo;
			commandToPerform: TCommand;
			theEventInfo: EventInfo;
		{$IFC qDebug}
			aMAName: MAName;
		{$ENDC}

		procedure HandleFailure (error: OSErr; message: LONGINT);

		begin
			PostHandleEvent(theEventInfo);
		end;

	begin
	{$IFC qDebug}
		if gReportEvt then
			ReportEvent(theEvent);
	{$ENDC}

		with theEventInfo, theEvent do
			begin
				thePEvent := @theEvent;
				theBtnState := BAND(modifiers, btnState) <> 0;
				theCmdKey := BAND(modifiers, cmdKey) <> 0;
				theShiftKey := BAND(modifiers, shiftKey) <> 0;
				theAlphaLock := BAND(modifiers, alphaLock) <> 0;
				theOptionKey := BAND(modifiers, optionKey) <> 0;
				theControlKey := BAND(modifiers, controlKey) <> 0;
				theAutoKey := what = autoKey;
				theClickCount := gClickCount;
				theCharacter := chr(0); 						{ Default, we don't know if this is a}
{														 keystroke yet}
				theKeyCode := 0;								{ Default, we don't know if this is a}
{														 keystroke yet}
				affectsMenus := TRUE;							{ assume going in that this event affects}
{														 the menus}
			end;

		CatchFailures(fi, HandleFailure);

		DispatchEvent(theEventInfo, commandToPerform);

		if (commandToPerform <> nil) then					{ Send the command out to be executed }
			PostCommand(commandToPerform);

		Success(fi);

		PostHandleEvent(theEventInfo);

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function OptionKeyIsDown: BOOLEAN;

		const
			kOptionKey = 58;

		var
			theKeys: KeyMap;

	begin
		GetKeys(theKeys);
		OptionKeyIsDown := theKeys[kOptionKey];
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFinder}

	procedure TApplication.HandleFinderRequest;

		label
			1, 2;

		var
			i: integer;
			anAppFile: AppFile;
			continuePrinting: BOOLEAN;
			cmd: CmdNumber;
			fi: FailInfo;
			aCommand: TCommand;

		{ ??? need better error messages here ??? }

		procedure HdlORequest (error: OSErr; message: LONGINT);

		begin
			if error <> noErr then
				begin
					if message = 0 then
						begin
							gErrorParm3 := anAppFile.fName;
							if cmd = cFinderPrint then
								message := msgPrintFailed
							else
								message := msgOpenFailed;
						end;
					ShowError(error, message);
				end;
			goto 1; 										{ continue the loop }
		end;

		procedure HdlNRequest (error: OSErr; message: LONGINT);

		begin
			if error <> noErr then
				ShowError(error, message);					{ PollEvent's error handler not in place yet}
{}
			goto 2; 										{ exit the method }
		end;

	begin
	{$IFC qDebug}
		if gExperimenting then
			Writeln('File count: ', gFileCount : 1);
	{$ENDC}

		if gFileCount = 0 then
			begin
				aCommand := nil;
				CatchFailures(fi, HdlNRequest);

				if OptionKeyIsDown then
					aCommand := DoMenuCommand(cOpen)
				else if fLaunchWithNewDocument then
					aCommand := DoMenuCommand(cFinderNew);

				if aCommand <> nil then
					PostCommand(aCommand);
				Success(fi);

			end
		else												{ it's an OPEN or PRINT of 1 or more}
{														 existing files}
			begin
				continuePrinting := TRUE;

				if gFinderPrinting then
					cmd := cFinderPrint
				else
					cmd := cFinderOpen;

				for i := 1 to gFileCount do
					begin
						CatchFailures(fi, HdlORequest);

						GetAppFiles(i, anAppFile);

						if CanOpenDocument(cmd, anAppFile) then
							begin
								ClrAppFiles(i);

								if gFinderPrinting then
									begin
										if continuePrinting then
											continuePrinting := PrintDocument(anAppFile);
									end
								else
									OpenOld(cFinderOpen, anAppFile);
							end
						else
							Failure(errNotMyType, 0);

						Success(fi);
1:												{ continue the loop }
					end;
			end;
2:														{ exit the method }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.HandleKeyDownEvent (var theEventInfo: EventInfo): TCommand;

	begin
		with theEventInfo, thePEvent^ do
			begin
				gTarget.KeyEventToComponents(theEventInfo); 	{ Find out what keys were _REALLY_ pressed }

				if theCmdKey then
					HandleKeyDownEvent := gTarget.DoCommandKey(theCharacter, theEventInfo)
				else
					HandleKeyDownEvent := gTarget.DoKeyCommand(theCharacter, theKeyCode, theEventInfo);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.HandleMouseDown (var theEventInfo: EventInfo): TCommand;

		var
			doClick: BOOLEAN;
			aWindow: TWindow;
			aWMgrWindow: WindowPtr;
			whereMouseDown: integer;
			sysWindowAct: BOOLEAN;
			aCommand: TCommand;
			theMouse: Point;
			theVMouse: VPoint;
			hysteresis: Point;

	begin
		HandleMouseDown := nil;

		with theEventInfo, thePEvent^ do
			begin
				whereMouseDown := FindWindow(where, aWMgrWindow);
				theClickCount := CountClicks(thePEvent, whereMouseDown);

				aWindow := WMgrToWindow(aWMgrWindow);

				if ((whereMouseDown = inMenuBar) & InModalMenuState) | ((whereMouseDown <> inMenuBar) & InModalState & (aWindow <> GetActiveWindow)) then
					begin
						Beep(2);
						EXIT(HandleMouseDown);
					end;

			end;

		if whereMouseDown <> inContent then
			SetCursor(arrow);

		with theEventInfo, thePEvent^ do
			case whereMouseDown of
				inMenuBar: 
					begin
						SetupTheMenus;							{ gives application a chance to setup}
{														 individual menu items}
						HandleMouseDown := MenuEvent(MenuSelect(where));
					end;

				inSysWindow: 
					SystemClick(thePEvent^, aWMgrWindow);

				otherwise
					{ if a MacApp window was associated with the WindowPtr then let the window object}
{					decide what to do with the mouse click}
					if (aWindow <> nil) & aWindow.Focus then { if we can't focus, we're in trouble }
						begin
							theMouse := where;
							GlobalToLocal(theMouse);
							aWindow.QDToViewPt(theMouse, theVMouse);
							hysteresis := gStdHysteresis;		{ don't want std changed by var }
							if aWindow.HandleMouseDown(theVMouse, theEventInfo, hysteresis, aCommand) & (aCommand <> nil) then
								begin
									aCommand.fTracksMouse := TRUE;	{??? someday this won't be forced }
									aCommand.fInitialPt := where;	{??? someday this won't be forced }
									HandleMouseDown := aCommand;
								end;
						end
					else if qDebug then
						begin
							if aWindow <> nil then
								ProgramBreak('In TApplication.HandleMouseDown: couldn''t focus on a window object!')
							else if gIntenseDebugging then
								Writeln('Got a mouse event for a non-MacApp, non-system window');
						end;

			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.HandleMouseUp (var theEventInfo: EventInfo): TCommand;

	begin
	{ Remember time of last mouse up, in order to detect double clicks }
		gLastUpTime := theEventInfo.thePEvent^.when;
		HandleMouseUp := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	var
		pHiddenWindowsToShow: TDynamicArray;

	procedure TApplication.ShowHideHiddenWindows (showFlag: BOOLEAN; floatersOnly: BOOLEAN);

		label
			999;				{ end of ShowHideHiddenWindows }

		var
			fi: FailInfo;
			aHiddenWindowsToShow: TDynamicArray;
			activeWindow: WindowPtr;

		procedure DoHideHiddenWindows (theWMgrWindow: WindowPtr);

			var
				aWindow: TWindow;

		begin
			aWindow := WMgrToWindow(theWMgrWindow);
			if (aWindow <> nil) & aWindow.IsShown & aWindow.IsHidOnSuspend then
				begin
					aHiddenWindowsToShow.InsertElementsBefore(1, @theWMgrWindow, 1);
					ShowHide(theWMgrWindow, FALSE);
					aWindow.Activate(FALSE);
				end;
		end;

		function IsBehind (behindWindow, targetWindow: WindowPtr): Boolean;
	{ returns TRUE if behindWindow is, in fact, behind targetWindow}
	{returns FALSE if behindWindow=targetWindow }
			var
				wPeek: WindowPeek;
		begin
			IsBehind := FALSE;
			wPeek := WindowPeek(targetWindow);
			while (wPeek <> nil) do
				begin
					if wPeek^.nextWindow = WindowPeek(behindWindow) then
						begin
							IsBehind := TRUE;
							Exit(IsBehind);
						end;
					wPeek := wPeek^.nextWindow;
				end;
		end;

		function DoShowHiddenWindows (elementIndex: ArrayIndex): Boolean;

			var
				aWindow: TWindow;
				localWindowPtr: WindowPtr;

		begin
			DoShowHiddenWindows := FALSE;								{ iterate over the whole array }
			pHiddenWindowsToShow.GetElementsAt(elementIndex, @localWindowPtr, 1);
			if localWindowPtr <> nil then
				begin
		{ if the window we're about to show is a document window that is NOT behind the active window, then send it there }
					if not IsFloatWindow(localWindowPtr) & (activeWindow <> nil) & not IsBehind(localWindowPtr, activeWindow) then
						SendBehind(localWindowPtr, activeWindow);
					ShowHide(localWindowPtr, TRUE);
				end;
		end;

		procedure GoToEnd (error: OSErr; message: LONGINT);

		begin
			if aHiddenWindowsToShow <> nil then
				begin
			{ since we can't create an array to hold all floating windows, let's show the ones we've}
{			tried to hide this far and then free the array before proceeding }
					if aHiddenWindowsToShow.EachElementDoTil(DoShowHiddenWindows, kIterateForward) = 0 then
						;
					aHiddenWindowsToShow.Free;								{ delete all elements & free }
					aHiddenWindowsToShow := nil;
					pHiddenWindowsToShow := nil;
				end;
			goto 999;
		end;

	begin
		activeWindow := MAGetActiveWindow;
		if showFlag then
			begin
				if pHiddenWindowsToShow <> nil then
					begin
						if pHiddenWindowsToShow.EachElementDoTil(DoShowHiddenWindows, kIterateForward) = 0 then
							;
						pHiddenWindowsToShow.Free;								{ delete all elements & free }
						pHiddenWindowsToShow := nil;
					end;
			end
		else
			begin
				CatchFailures(fi, GoToEnd);
				NEW(aHiddenWindowsToShow);
				FailNIL(aHiddenWindowsToShow);								{ if this fails, we escape to end }
				aHiddenWindowsToShow.IDynamicArray(0, SizeOf(WindowPtr));
				EachWMgrWindowDo(DoHideHiddenWindows);						{ if this fails, we escape to end }
				Success(fi);

				if aHiddenWindowsToShow.GetSize = 0 then
					begin
						pHiddenWindowsToShow := nil;
						aHiddenWindowsToShow.Free;
						aHiddenWindowsToShow := nil;
					end
				else
					pHiddenWindowsToShow := aHiddenWindowsToShow;
			end;
999:
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.HandleSystemEvent (var theEventInfo: EventInfo): TCommand;

		const
			kOsEvtMessageMask = $FF000000;

		var
			switchingIn: BOOLEAN;
			convertClipboard: BOOLEAN;
			aWindow: TWindow;

	begin
		with theEventInfo.thePEvent^ do
			case BSR(BAND(message, kOsEvtMessageMask), 24) of
				kSuspendOrResume: 
					begin
						switchingIn := Odd(message);
						convertClipboard := BAND(message, $00000002) <> 0;

						if switchingIn then
							RegainControl(convertClipboard)
						else
							AboutToLoseControl(convertClipboard);

						if switchingIn then
							begin
								aWindow := GetFrontWindow;
								if aWindow <> nil then
									aWindow.Activate(TRUE);			{ activate the front window }
								ShowHideHiddenWindows(TRUE, FALSE);				{ show the floaters }
							end
						else
							begin
								ShowHideHiddenWindows(FALSE, FALSE);			{ hide the floaters }
								aWindow := GetActiveWindow;
								if aWindow <> nil then
									aWindow.Activate(FALSE);		{ deactivate the active window }
							end;

						gInBackground := not switchingIn;
						InvalidateCursorRgn;
					end;
				kMouseMovedMessage: 
					begin
						theEventInfo.affectsMenus := FALSE; 	{ We don't think mouse tracking usually}
{														 bothers the menus. }
						if TrackCursor then
							;					{ Recalculate the cursor region. After all}
{														 that's why we got a mouse moved event }
					end;
				otherwise
					if gIntenseDebugging then
						Writeln('in TApplication.HandleSystemEvent: got unrecognized event');
			end;

		HandleSystemEvent := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.HandleUpdateEvent (var theEventInfo: EventInfo): TCommand;

		var
			aWindow: TWindow;

	begin
		with theEventInfo.thePEvent^ do
			begin
				aWindow := WMgrToWindow(WindowPtr(message));
				if aWindow <> nil then
					aWindow.Update;
			end;
		HandleUpdateEvent := nil;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MADebug}

	procedure TApplication.IdentifySoftware;

	begin
		WRITELN('UMacApp of 14 Feb 90 (Valentine''s Day), Compiled on ', COMPDATE, ' @ ', COMPTIME);

		IDUObject;
	{$IFC qDebug}
		IDUDebug;
	{$EndC}
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.Idle (phase: IdlePhase);

		var
			currTick: LONGINT;
			fi: FailInfo;

		procedure HdlIdle (error: OSErr; message: LONGINT);

		begin
			gInhibitNestedHandling := TRUE; 				{ Don't want to come back into Idle From}
{														 alert filters or other strange places}

		end;

		procedure DoIdleAction (anEvtHandler: TEvtHandler);

			var
				didFree: BOOLEAN;
				ticksTilNextIdle: LONGINT;

		begin
	  { If this handler needs idling, and enough ticks have elapsed}
{	   since the last time it was idled, call its DoIdle. (This was not}
{	   made a TEvtHandler method in order to optimize idling speed.)}
			with anEvtHandler do
				begin
					didFree := FALSE;
					if fIdleFreq <> kMaxIdleTime then			{ Does it idle at all? }
						begin
							if (phase <> idleContinue) | (currTick - fLastIdle >= fIdleFreq) then
								begin
									didFree := anEvtHandler.DoIdle(phase);
									if not didFree then
										fLastIdle := currTick;
								end;
							if not didFree & (fIdleFreq <> kMaxIdleTime) then
								begin
									if fLastIdle = 0 then
										ticksTilNextIdle := fIdleFreq
									else
										ticksTilNextIdle := Max(fLastIdle + fIdleFreq - currTick, 0); { accounts for}
{						overdue}
									fTicksTilNextIdle := Min(ticksTilNextIdle, fTicksTilNextIdle); { update the}
{						composite}
								end;
						end;
				end;
		end;

	begin
		CatchFailures(fi, HdlIdle);

		currTick := TickCount;

		if phase = idleBegin then
			begin
		{$IFC qDebug}
				gWasTrcEnable := TRCEnable(gTraceIdle); 		{ Trace during idle only if user wants to. }
		{$ENDC}
				if not gInFilter & MemSpaceIsLow then
					SpaceIsLow
				else
					gNextSpaceMsg := currTick;

				SetupTheMenus;									{ To get the menu bar redrawn if necessary.}
				fTicksTilNextIdle := 0; 						{ Force idling event handlers &}
{														 co-handlers.}
			end;

		if (phase <> idleContinue) | (currTick - fTicksOfLastIdle >= fTicksTilNextIdle) then
			begin
				fTicksTilNextIdle := kMaxIdleTime;
				if gHeadCoHandler <> nil then
					gHeadCoHandler.EachHandler(DoIdleAction);
				if qDebug then
					Assertion(gTarget <> nil, AtStr('gTarget <> nil'));
				gTarget.EachHandler(DoIdleAction);
				fTicksOfLastIdle := currTick;
			end;

	{ If we have WaitNextEvent then the cursor will be tracked via MouseMoved events. }
		if (not (qNeedsWaitNextEvent | gConfiguration.hasWaitNextEvent) | gAlwaysTrackCursor) & (phase <> idleEnd) then
			begin
				if TrackCursor then
					;							{ Recompute the cursor region if necessary.}
{}
			end
		else
			begin
 {$IFC qDebug}
				if TRCEnable(gWasTrcEnable) then
					;
    {$ENDC}
			end;
		Success(fi);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.InModalState: BOOLEAN;

		var
			aWindow: TWindow;
			aWindowPtr: WindowPtr;

	begin
		aWindowPtr := FrontWindow;
		InModalState := FALSE;

	{ in case the front window is an alert or something }

		if (WMgrToWindow(aWindowPtr) = nil) & (aWindowPtr <> nil) then
			case WindowPeek(aWindowPtr)^.windowKind of
				dBoxProc, plainDBox, altDBoxProc: 
					InModalState := TRUE;
			end
		else
			begin
				aWindow := GetActiveWindow;
				InModalState := (aWindow <> nil) & (aWindow.fIsModal);
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.InModalMenuState: BOOLEAN;

		var
			aWindow: TWindow;
			aWindowPtr: WindowPtr;

	begin
		aWindowPtr := FrontWindow;
		InModalMenuState := FALSE;

	{ in case the front window is an alert or something }

		if (WMgrToWindow(aWindowPtr) = nil) & (aWindowPtr <> nil) then
			case WindowPeek(aWindowPtr)^.windowKind of
				dBoxProc, plainDBox, altDBoxProc: 
					InModalMenuState := TRUE;
			end
		else
			begin
				aWindow := GetActiveWindow;
				InModalMenuState := (aWindow <> nil) & not aWindow.AllowsMenuAccess;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

	procedure TApplication.InstallCohandler (aCohandler: TEvtHandler; addIt: BOOLEAN);

	begin
		fTicksTilNextIdle := 0; 							{ Force idling event handlers &}
{														 co-handlers.}
		if addIt then
			gHeadCoHandler := aCohandler.AddHandler(gHeadCoHandler)
		else
			gHeadCoHandler := aCohandler.RemoveHandler(gHeadCoHandler);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.IsDeskAccessory (aWMgrWindow: WindowPtr): BOOLEAN;

	begin
		IsDeskAccessory := (aWMgrWindow <> nil) & (WindowPeek(aWMgrWindow)^.windowKind < 0);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.InvalidateCursorRgn;

	begin
		if gCursorRgn <> nil then
			SetEmptyRgn(gCursorRgn);						{ Make sure it gets changed back }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.InvalidateFocus;

	begin
		if gFocusedView <> nil then
			gFocusedView.InvalidateFocus;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.KeyEventToComponents (var info: EventInfo);
{ See Tech Note #263 for the reason for this abomination }

		const
			kMaskModifier = $FE00;					{ need to strip command key from Modifiers }
			kMaskASCII1 = $000000FF;				{ get key from KeyTrans return }
			kMaskASCII2 = $00FF0000;				{ get key from KeyTrans return }
			kPeriod = ord('.');
			kUpKeyMask = $0080;
			kMAsmKeyCache = 38;						{!!! Replace with system supplied constant}
{														when sys 7.0 headers ship}

		type
		{ !!! Delete this record for 7.0 only operation.}
{		This is really a private record so _DON'T_ use any other fields!}
			MAExpandMemRec = record
					emVersion: integer;				{ version of expanded memory }
					emSize: LONGINT;				{ length of em }
					emIntlGlobals: LONGINT;				{ international globals pointer }
					emKeyDeadState: LONGINT;				{ Key1Trans, Key2Trans dead state }
					emKeyCache: Ptr;					{ KCHR keyboard cache }
					emIntlDef: LONGINT;				{ Reserved for Intl }
					emFirstKeyboard: BOOLEAN;				{ flag byte }
					emAlign: BOOLEAN;				{ long-align until we need this storage }
					emItlCache: array[0..3] of LONGINT; { bytes in cache }
					emItlNeedUnlock: BOOLEAN;				{ for pack6 }
					emItlDirectGetIntl: BOOLEAN;				{ for pack6 }
					emFiller: array[1..22] of CHAR;	{ Reserved room }
				end;
			MAExpandMemRecPtr = ^MAExpandMemRec;
			MAExpandMemRecHandle = ^MAExpandMemRecPtr;

		var
			keyCodeParameter: integer;					{ See IM-V pp. 195 }
			virtualKey: LONGINT;
			keyInfo: LONGINT;
			theChar: LONGINT;
			state: LONGINT;
			keyTransTable: Ptr;

	begin
		inherited KeyEventToComponents(info);				{ Get default translation, if any }

		if qNeedsScriptManager | gConfiguration.hasScriptManager then
			begin
				with info, thePEvent^ do
					if (what = keyDown) | (what = autoKey) then
						begin
				{ Now see if the command key is down.  If it is, get the correct ASCII translation}
{				by masking the command key out and re-translating because the command key will mask}
{				the shift modifier.}

							if theCmdKey then
								begin
					{ set the upkey bit so KeyTrans doesn't do special deadkey processing }
									keyCodeParameter := BOR(BOR(BAND(modifiers, kMaskModifier), theKeyCode), kUpKeyMask);

									state := 0;

					{ Get the correct keytable pointer.  We don't want to grope the system unnecessarily}
{					so use the script managers improvements if they're there.}
									if gConfiguration.systemVersion >= $700 then
										keyTransTable := Ptr(GetEnvirons(kMAsmKeyCache))
									else
					{ Fake handle.  the lomem address is a pointer to the table }
										keyTransTable := Ptr(MAExpandMemRecHandle(ExpandMem)^^.emKeyCache);

									keyInfo := KeyTrans(keyTransTable, keyCodeParameter, state);

									theCharacter := chr(BAND(keyInfo, kMaskASCII1));
									if theCharacter = chr(0) then
										theCharacter := chr(BSR(BAND(keyInfo, kMaskASCII2), 16));
								end;
						end;

			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	function TApplication.KindOfDocument (itsCmdNumber: CmdNumber; itsAppFilePtr: AppFilePtr): CmdNumber;

	begin
		KindOfDocument := itsCmdNumber;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInit}

	procedure TApplication.LaunchClipboard;

	begin
		AbsorbScrapStuff;									{ Get current scrapCount as a baseline }
		ReadFromDeskScrap;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}
									{ must be in the main segment }

	procedure TApplication.MainEventLoop;

	begin
		gIdlePhase := idleBegin;
		repeat
			if gIdlePhase = idleBegin then
				UnloadAllSegments;							{ don't unload segs after idle has begun }

		{ ??? should we}
{		(1) unload segs after completing idle but before doing the event?}
{		(2) unload segs while processing event during background printing?}

			PollEvent(kAllowApplicationToSleep);
		until gAppDone; 									{ gAppDone is a global BOOLEAN; that we set}
{														 TRUE when the user chooses 'Quit'}
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAInit}

	function TApplication.MakeClipboardWindow: TWindow;

		var
			aWindow: TWindow;
			aDeskScrapView: TDeskScrapView;

	begin
		aWindow := nil;
		if qTemplateViews then
			aWindow := NewTemplateWindow(kIDClipWindow, nil)
		else
			begin
				New(aDeskScrapView);
				FailNil(aDeskScrapView);
				aDeskScrapView.IDeskScrapView;
				aDeskScrapView.fIdentifier := KIDClipView;
				aWindow := NewSimpleWindow(kIDClipWindow, TRUE, TRUE, nil, aDeskScrapView);
			end;
		if aWindow <> nil then
			aWindow.fHideOnSuspend := TRUE;
		MakeClipboardWindow := aWindow;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClipboard}

	function TApplication.MakeViewForAlienClipboard: TView;

	begin
 { If the application doesn't override this then we just set the}
{  clipboard view to the orphanage, which handles TEXT and PICT}
{  scraps in a standard way.}
		MakeViewForAlienClipboard := gClipOrphanage;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	function TApplication.MenuEvent (menuItem: LONGINT): TCommand;

		var
			fi: FailInfo;
			cmd: CmdNumber;
			deskAccName: Str255;
			theMenuNumber: integer;
			theItemNumber: integer;

		procedure HdlMenuEvt (error: OSErr; message: LONGINT);

		begin
			if gSysWindowActive then
				ActivateBusyCursor(FALSE);

			FailNewMessage(error, message, BuildMessage(cmd, msgCmdErr));
		end;

	begin
		MenuEvent := nil;

		theMenuNumber := HiWrd(menuItem);
		theItemNumber := LoWrd(menuItem);

		if theMenuNumber <> 0 then
			begin

				cmd := CmdFromMenuItem(theMenuNumber, theItemNumber);

		{$IFC qDebug}
				if cmd = cCantUndo then
					begin
						Writeln('Command number ', cCantUndo : 1, ' is reserved for MacApp.');
						ProgramBreak('Use of reserved command number.');
					end;

				if gReportMenuChoices & (cmd > 0) then
					Writeln('Menu Choice Command Number = ', cmd : 1);
		{$ENDC qDebug}

				if (cmd < 0) & (theMenuNumber = mApple) then
					begin
						GetItem(MAGetMenu(mApple), theItemNumber, deskAccName);
						OpenDeskAccessory(deskAccName);
					end
				else if (cmd < cEditBase) | (cmd > cEditLast) | (not SystemEdit(cmd - cEditBase)) then
					begin
						CatchFailures(fi, HdlMenuEvt);

						if gSysWindowActive then
							ActivateBusyCursor(TRUE);

						MenuEvent := gTarget.DoMenuCommand(cmd);

						if gSysWindowActive then
							ActivateBusyCursor(FALSE);

						Success(fi);
					end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MASelCommand}

	procedure TApplication.OpenDeskAccessory (deskAccName: Str255);

		var
			aRefNum: integer;
			drvrH: Handle;
			theID: integer;
			theType: ResType;
			theName: Str255;
			oldPerm: BOOLEAN;
			ourHeap: BOOLEAN;
			fi: FailInfo;
			err: OSErr;
			savedPort: GrafPtr;

		procedure HdlOpenDeskAcc (error: OSErr; message: LONGINT);

		begin
			if aRefNum <> 0 then
				CloseDeskAcc(aRefNum);

			if message = 0 then
				begin
					gErrorParm3 := deskAccName;
			{ Get rid of leading null character }
					if ord(gErrorParm3[1]) = 0 then
						Delete(gErrorParm3, 1, 1);
				end;

			FailNewMessage(error, message, msgOpenFailed);
		end;

		function IsOpen (itsID: integer): BOOLEAN;

			var
				dceHnd: DCtlhandle;

		begin
			IsOpen := FALSE;
			if (itsID >= 0) & (itsID < GetUnitNtryCnt) then
				begin
					dceHnd := GetUTableBase^[itsID];
					if (dceHnd <> nil) & BTst(dceHnd^^.dCtlFlags, 5) then
						IsOpen := TRUE;
				end;
		end;

	begin
		CatchFailures(fi, HdlOpenDeskAcc);
		aRefNum := 0;										{ Make sure failure handler works. }

	{ Attempt to load the DA into memory.  If 'deskAccName' refers to another app }
	{ rather than a real desk acc, then GetNamedResource returns a faked up handle }
	{ courtesy of MultiFinder. We open the DA with permanent allocation so as to }
	{ ensure that we don't take space from our code segments.                       }

		oldPerm := PermAllocation(TRUE);
		drvrH := GetNamedResource('DRVR', deskAccName);
		if PermAllocation(oldPerm) then
			;					{ discard result }
		FailNILResource(drvrH); 							{ Either there wasn't enough memory }
	{ to load the DA, or something is }
	{ seriously wrong. }

	{ At this point if we are really opening a DA we know it fits in memory.  }

		GetResInfo(drvrH, theID, theType, theName); 		{ If it's a not a real DA then this }
	{ will generate a ResError.   }
		ourHeap := (HandleZone(drvrH) = ApplicZone) | OptionKeyIsDown;	{ Find out which zone it }
{														lives in, or if option key is down.}

		if (ResError <> noErr) | IsOpen(theID) | (not ourHeap) then							{ If it's a MultiFinder fake DA, }
									{ or if the DA is already open, }
								{ or it's not going in our heap }
			begin
				oldPerm := PermAllocation(TRUE);				{ In case we guess wrong }
				GetPort(savedPort);
				aRefNum := OpenDeskAcc(deskAccName);			{ then go ahead and open it. }
				SetPort(savedPort);
				if PermAllocation(oldPerm) then
					;				{ discard result }
			end

		else

			begin
		{ If we get this far, we know we have a real DA and it's going into our     }
		{ heap.  Open it, but them make sure we have enough memory to continue }
		{ running.	}

				FailSpaceIsLow; 								{ In case we're already low on mem. }

				oldPerm := PermAllocation(TRUE);				{ If the pig wants to wallow }
				GetPort(savedPort);
				aRefNum := OpenDeskAcc(deskAccName);			{ Use temporary allocation. }
				SetPort(savedPort);
				if PermAllocation(oldPerm) then
					;				{ discard result }

				FailSpaceIsLow; 								{ Fail if not enough memory left. }
				FailNil(drvrH^);								{ or if the driver was purged to }
		{ satisfy a code space requirement.}
			end;

		Success(fi);

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TApplication.OpenNew (itsCmdNumber: CmdNumber);

		var
			aDocument: TDocument;
			fi: FailInfo;
			newTitle: Str255;
			aWindow: TWindow;

		procedure HdlOpenNew (error: integer; message: LONGINT);

		begin
			FreeIfObject(aDocument);
			aDocument := nil;

			FailNewMessage(error, message, msgNewFailed);
		end;

	begin
		aDocument := nil;
		CatchFailures(fi, HdlOpenNew);

		aDocument := DoMakeDocument(KindOfDocument(itsCmdNumber, nil));
		aDocument.DoInitialState;
		aDocument.DoMakeViews(kForDisplay);
		aDocument.DoMakeWindows;

		aDocument.UntitledName(newTitle);
	{ For MacApp 1.1, newTitle should be always <> '' }
		if newTitle <> '' then
			aDocument.SetTitle(newTitle)
		else if (aDocument.fWindowList <> nil) & (aDocument.fWindowList.GetSize > 0) then
	{ Grope, grope, grope }
			begin											{ must set fTitle field anyways }
				aWindow := TWindow(aDocument.fWindowList.First);

				aWindow.GetTitle(newTitle);
				Handle(aDocument.fTitle) := DisposeIfHandle(aDocument.fTitle);
				aDocument.fTitle := NewString(Copy(newTitle, aWindow.fPreDocname, length(newTitle) - aWindow.fConstTitle));
				FailNil(aDocument.fTitle);
			end;

		AddDocument(aDocument);

		FailSpaceIsLow; 									{ Fail if document leaves us with no room }

	{ Don't attempt to show the windows until we're sure we won't fail }
		aDocument.ShowWindows;

		Success(fi);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TApplication.OpenOld (itsOpenCmd: CmdNumber; anAppFile: AppFile);
{ Called for opening a document, given its name }

		var
			aDocument: TDocument;
			otherDoc: TDocument;
			oldCodeReserve, oldMemReserve: Size;
			fi: FailInfo;

		procedure HdlOpenOld (error: integer; message: LONGINT);

		begin
			FreeIfObject(aDocument);
			aDocument := nil;

			if message = 0 then
				gErrorParm3 := anAppFile.fName;
		{ Set the reserve back to where it was }
			SetReserveSize(oldCodeReserve, oldMemReserve);
			FailNewMessage(error, message, msgOpenFailed);
		end;

	begin
		aDocument := nil;

		CatchFailures(fi, HdlOpenOld);

	{ Set reserve down a little to ensure that we can open existing documents }
		GetReserveSize(oldCodeReserve, oldMemReserve);
		SetReserveSize(oldCodeReserve, oldMemReserve div 2);

		otherDoc := AlreadyOpen(anAppFile.fName, anAppFile.vRefnum);
		if otherDoc <> nil then
			otherDoc.OpenAgain(itsOpenCmd, aDocument);

		aDocument := DoMakeDocument(KindOfDocument(itsOpenCmd, @anAppFile));

		aDocument.ReadFromFile(anAppFile, kForDisplay);
		aDocument.DoMakeViews(kForDisplay);
		aDocument.DoMakeWindows;

		AddDocument(aDocument);

		FailSpaceIsLow; 									{ Fail if the document leaves us with no}
{														 memory}
	{ Set the reserve back to where it was }
		SetReserveSize(oldCodeReserve, oldMemReserve);

	{ Don't attempt to show the windows until we're sure we won't fail }
		aDocument.ShowWindows;

		Success(fi);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.PerformCommand (command: TCommand);

		var
			fi: FailInfo;
			saveCmd: BOOLEAN;
		{$IFC qDebug}
			aMAName: MAName;
		{$ENDC}

		procedure HdlDoit (error: integer; message: LONGINT);

			var
				aCmdNumber: integer;

		begin
			if gClipClaimed then
				begin
					SetClipView(gClipUndoView);
					gClipUndoView := nil;
			{ The newly-installed view needs to be freed also }
			{ SwapClipViews;}
							{ Get original back there !!! would be nice}
{														 but doesn't do right thing yet}
				end;

			aCmdNumber := command.fCmdNumber;
			if command.fFreeOnCompletion then
				FreeIfObject(command);

			if command = fLastCommand then
				fLastCommand := nil;						{ make sure we clear our reference }

			FailNewMessage(error, message, BuildMessage(aCmdNumber, msgCmdErr));
		end;

	begin
		if qDebug & (command = nil) then
			ProgramBreak('NIL passed to TApplication.PerformCommand')
		else if qDebug & (not IsObject(command)) then		{ since it's possible to have passed in a}
{														 freed undoable command allocated in a}
{														 global variable (due to pilot error)}
			begin
				if VerboseIsobject(command) then
					;
				ProgramBreak('bogus object passed to TApplication.PerformCommand');
			end
		else
			begin
		{$IFC qDebug}
				if gIntenseDebugging then
					begin
						command.GetClassName(aMAName);
						Writeln('The Command to perform: ', aMAName);

					end;
		{$ENDC}

				if command.fTracksMouse then
					begin
			{$IFC qDebug}
						if gIntenseDebugging then
							if (command <> nil) then
								begin
									command.GetClassName(aMAName);
									Writeln('Tracking Command: ', aMAName);

								end;
			{$ENDC}
						if gEventLevel = 1 then 					{ Don't unload segs if in nested event}
{														 handling}
							UnloadAllSegments;

						command := TrackMouse(command.fInitialPt, gStdHysteresis, command);
					end;

				if (command <> nil) then
					begin

						saveCmd := command.fCausesChange | command.fCanUndo;

						if saveCmd then
							begin
								CommitLastCommand;						{ it frees fLastCommand. If the last}
{														 (fCausesChange or fCanUndo) command sets}
{														 fFreeOnCompletion to FALSE then we can}
{														 execute the same undoable command any}
{														 number of times. Non-Undoable commands}
{														 don't get FREEd here but immediately after}
{														 they're executed (that's performed not}
{														 shot)}

								if qDebug & not IsObject(command) then
									begin
										if VerboseIsobject(command) then
											;
										ProgramBreak('You may not want to continue with a command that''s been _FREED_!');
									end;
							end;

						CatchFailures(fi, HdlDoit);
						if gEventLevel = 1 then 					{ Don't unload segs if in nested event}
{														 handling}
							UnloadAllSegments;

						gClipClaimed := FALSE;

						command.DoIt;
						Success(fi);

						if saveCmd then
							begin
								fLastCommand := command;
								command.fCmdDone := TRUE;
							end;

						with command do
							if fCausesChange then					{ put this after .DoIt, so .DoIt can change}
{														 this flag}
								begin
									if fChangedDocument <> nil then
										with fChangedDocument do
											SetChangeCount(Max(GetChangeCount + 1, 1)); { protect from rollover (it}
{																		 goes negative). If your}
{																		 document has this many}
{																		 changes (over 2 billion}
{																		 you are truly sick!}
								end;

						if not saveCmd & command.fFreeOnCompletion then
							FreeIfObject(command);
					end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.PollEvent (allowApplicationToSleep: BOOLEAN);

		label
			1000;

		var
			fi: FailInfo;
			theEvent: EventRecord;
			aWindow: TWindow;
			commandToPerform: TCommand;
			waitTicks: LONGINT;
			idledBeforeEventCall: BOOLEAN;

		procedure HdlPollEvt (error: integer; message: LONGINT);

		begin
		{$IFC qDebug}
			Writeln;										{ add a blank line after all the messages}
{														 from Failure}
		{$ENDC}
			gEventLevel := gEventLevel - 1;
			if gEventLevel = 0 then
				begin
					if error <> noErr then
						begin
							UnloadAllSegments;
							ShowError(error, message);
						end;

					HiliteMenu(0);								{ Make sure menus get straightened out. }
					InvalidateMenus;

					goto 1000;									{ Keep the application running. }
				end;
		end;

	begin
		gEventLevel := gEventLevel + 1;

	{$IFC qDebug}
		if gTarget = nil then
			Writeln('Serious Error!!! in TApplication.PollEvent: target = NIL');
	{$ENDC}

		CatchFailures(fi, HdlPollEvt);

	{ IF we have any queued commands that have not otherwise been taken care of, now is the time. }

		commandToPerform := GetNextCommand;
		if commandToPerform <> nil then
			PerformCommand(commandToPerform)
		else
			begin
		{ If we're running with WaitNextEvent then if there are no events pending we should}
{		idle before calling WaitNextEvent.	This is because we may not come back from WaitNextEvent}
{		for an indeterminate period of time.  By idling we make sure the menu bar is correct and}
{		give the app a chance to reset the idle frequency and cursor region.}

				if (qNeedsWaitNextEvent | gConfiguration.hasWaitNextEvent) & (allowApplicationToSleep & (fTicksTilNextIdle > 0)) & (not EventAvail(gMainEventMask, theEvent)) & (gIdlePhase = idleBegin) then
					begin
						Idle(gIdlePhase);
						gIdlePhase := idleContinue;
						idledBeforeEventCall := TRUE;
					end
				else
					idledBeforeEventCall := FALSE;

		{ If the cursor region is invalid, force it's recalculation before going to WNE. It won't be}
{		calculated from idle in the WNE case unless gAlwaysTrackCursor is true.}
				if (qNeedsWaitNextEvent | gConfiguration.hasWaitNextEvent) & (EmptyRgn(gCursorRgn)) then
					begin
						if TrackCursor then
							;
					end;

				if allowApplicationToSleep then
					waitTicks := fTicksTilNextIdle
				else
					waitTicks := 0;

				HiliteMenu(0);

				if GetEvent(gMainEventMask, waitTicks, gCursorRgn, theEvent) then
					begin
						if gIdlePhase <> idleBegin then
							begin
								Idle(idleEnd);
								gIdlePhase := idleBegin;
							end;
						HandleEvent(theEvent);
			{$IFC qDebug}
						gErrorParm3 := '?????'; 					{ to prevent anyone from using old values }
			{$ENDC}
					end

				else if not idledBeforeEventCall | (fTicksTilNextIdle = 0) then { idle if we Neeeed to! }
					begin
						Idle(gIdlePhase);
						gIdlePhase := idleContinue;
					end;
			end;

 { The desk scrap may have been changed by use of Cmd-X or Cmd-C in}
{  desk accessories.}
		if gSysWindowActive then
			begin
				CheckDeskScrap;
				InvalidateFocus;
			end;

		Success(fi);
		gEventLevel := gEventLevel - 1;

		if gEventLevel = 0 then
			gInhibitNestedHandling := FALSE;				{ All clear }

1000:													{ Failure re-entry point }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.PostCommand (command: TCommand);

	begin
		fCommandQueue.Insert(command);						{ inserts command ordered the list }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.PostHandleEvent (var theEventInfo: EventInfo);

		var
			sysWindowAct: BOOLEAN;
			perm: BOOLEAN;

	begin
		if theEventInfo.affectsMenus then
			InvalidateMenus;

		perm := PermAllocation(FALSE);
	{$IFC qDebug}
		if perm then
			ProgramBreak('The permanent flag was left TRUE.');
	{$ENDC}

	{ See if a system window has been activated or deactivated. }
		sysWindowAct := IsDeskAccessory(FrontWindow);

		if sysWindowAct <> gSysWindowActive then
			begin
				gSysWindowActive := sysWindowAct;

				if gSysWindowActive then						{ deactivating to sys window }
					begin
						AboutToLoseControl(TRUE);
						InvalidateMenuBar;
					end
				else											{ coming back from sys window }
					RegainControl(TRUE);
			end;

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAFinder}

	function TApplication.PrintDocument (anAppFile: AppFile): BOOLEAN;

		var
			aDocument: TDocument;
			aPrintHandler: TPrintHandler;
			proceed: BOOLEAN;
			fi: FailInfo;

		procedure HdlPrintDoc (error: integer; message: LONGINT);

		begin
			FreeIfObject(aDocument);
			aDocument := nil;
		end;

	begin
		aDocument := nil;
		CatchFailures(fi, HdlPrintDoc);

		aDocument := DoMakeDocument(KindOfDocument(cFinderPrint, @anAppFile));
		aDocument.ReadFromFile(anAppFile, kForPrinting);
		aDocument.DoMakeViews(kForPrinting);

	{ Note that if we are finder printing, this segment will be resident }
		UnloadAllSegments;

		aPrintHandler := aDocument.fDocPrintHandler;
		if aPrintHandler <> nil then
			begin
				proceed := aPrintHandler.SetupForFinder;
				if proceed & (aPrintHandler.Print(cFinderPrint, proceed) <> nil) then
		{$IFC qDebug}
					ProgramBreak('TApplication.PrintDocument: Print return a real command.');
			{$ENDC}
{	PSC Warning: Floating Semicolon	}
			end
		else
			begin
				proceed := TRUE;								{ might as well try the next one }
		{$IFC qDebug}
				ProgramBreak('TApplication.PrintDocument: The documents fDocPrintHandler is NIL.');
		{$ENDC}
			end;

		UnloadAllSegments;
		Success(fi);

		FreeIfObject(aDocument);
		aDocument := nil;

		UnloadAllSegments;
		PrintDocument := proceed;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClipboard}

	procedure TApplication.ReadFromDeskScrap;

		label
			1000;

		var
			aViewForClipboard: TView;
			fi: FailInfo;

		procedure HdlMakeViewForAlienClipbd (error: OSErr; message: LONGINT);

		begin

			aViewForClipboard := gClipOrphanage;
			if message = 0 then
				message := msgImportClipFailed;
			ShowError(error, message);
			goto 1000;
		end;

	begin
		CatchFailures(fi, HdlMakeViewForAlienClipbd);
		aViewForClipboard := MakeViewForAlienClipboard;
		FailNil(aViewForClipboard);
		Success(fi);
1000:
		ClaimClipboard(aViewForClipboard);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.RegainControl (checkClipboard: BOOLEAN);

	begin
		ActivateBusyCursor(TRUE);
		if checkClipboard then
			CheckDeskScrap;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MADebug}
{ Debugging procedure: given an EventRecord, prints out information about the event. }

	procedure TApplication.ReportEvent (var theEvent: EventRecord);

		var
			ch: integer;
			cap: integer;
			aString: Str255;
			mods: string[10];
			aWMgrWindow: WindowPtr;

	begin
		with theEvent do
			begin
				WRITE('t = ', when);
				mods := '          ';
		{ 1234567890 }
				;

				if BAND(modifiers, controlKey) <> 0 then
					mods[2] := 'C';
				if BAND(modifiers, optionKey) <> 0 then
					mods[3] := 'O';
				if BAND(modifiers, alphaLock) <> 0 then
					mods[4] := 'L';
				if BAND(modifiers, shiftKey) <> 0 then
					mods[5] := 'S';
				if BAND(modifiers, cmdKey) <> 0 then
					mods[6] := 'C';
				if BAND(modifiers, btnState) <> 0 then
					mods[7] := 'M';
				if what = activateEvt then
					if BAND(modifiers, activeFlag) <> 0 then
						mods[8] := 'A'
					else
						mods[8] := 'D';
				WRITE(mods);

				case what of
					nullEvent: 
						Writeln('nullEvent   ');
					mouseDown, mouseUp: 
						begin
							if what = mouseDown then
								WRITE('mouseDown   ')
							else
								WRITE('mouseUp     ');
							WRITE('@ (', where.h : 1, ', ', where.v : 1, ')');
							case FindWindow(where, aWMgrWindow) of
								inMenuBar: 
									aString := 'inMenuBar';
								inSysWindow: 
									aString := 'inSysWindow';
								inDrag: 
									aString := 'inDrag';
								inGrow: 
									aString := 'inGrow';
								inGoAway: 
									aString := 'inGoAway';
								inContent: 
									aString := 'inContent';
								inZoomIn: 
									aString := 'inZoomIn';
								inZoomOut: 
									aString := 'inZoomOut';
								otherwise
									aString := 'Mouse clicked in an unknown place.'
							end;
							Writeln(' ' : 5, aString);
						end;
					keyDown, autoKey, keyUp: 
						begin
							if what = keyDown then
								WRITE('keyDown     ')
							else if what = autoKey then
								WRITE('autoKey     ')
							else
								WRITE('keyUp       ');

							ch := BAND(message, charCodeMask);
							cap := BSR(message, 8);

							if (ch >= $20) & (ch <= $D8) & (ch <> $7F) then
								WRITE('"', chr(ch), '"')
							else
								WRITE('   ');

							Writeln('(', ch : 1, '/', cap : 1, ')');
						end;
					updateEvt, activateEvt: 
						begin
							if what = updateEvt then
								WRITE('updateEvt   ')
							else
								WRITE('activateEvt ');

							aString := WindowPeek(message)^.titleHandle^^;
							Writeln('"', aString, '"');
						end;
					diskEvt: 
						Writeln('diskEvt     ', 'd = ', LoWord(message) : 1, ' e = ', HiWord(message) : 1);
					networkEvt: 
						begin
							WRITE('networkEvt  ');
							WritePtr(message);
							Writeln;
						end;
					driverEvt: 
						begin
							WrLblHexLongInt('driverEvt   , message', message);
							Writeln;
						end;
					app1Evt: 
						begin
							WrLblHexLongInt('app1Evt     , message', message);
							Writeln;
						end;
					app2Evt: 
						begin
							WrLblHexLongInt('app2Evt     , message', message);
							Writeln;
						end;
					app3Evt: 
						begin
							WrLblHexLongInt('app3Evt     , message', message);
							Writeln;
						end;
					app4Evt: 
						begin
							case BSR(BAND(message, $FF000000), 24) of
								kSuspendOrResume: 
									if Odd(message) then
										WRITE('resume      ')
									else
										WRITE('suspend     ');
								kMouseMovedMessage: 
									WRITE('mouse moved ');
								otherwise
									WRITE('app4Evt     ');
							end;
							WrLblHexLongInt(', message', message);
							Writeln;
						end;
					otherwise
						begin
							Writeln('??? unknown = ', what : 1, '   ');
							WriteHexLongInt(message);
						end;
				end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}
									{ must be in the main segment }

	procedure TApplication.Run;

		var
			findSeg: integer;

	begin
		UnloadAllSegments;
		FailSpaceIsLow; 									{ make sure we have enough memory to}
{														 continue}
		gInitialized := TRUE;								{ was set FALSE in InitToolBox }

		if gFinderPrinting then
			begin
				findSeg := GetSegNumber(@FinderSegProc);

				UnloadAllSegments;
				SetResidentSegment(findSeg, TRUE);

				HandleFinderRequest;

				SetResidentSegment(findSeg, FALSE);
				UnloadAllSegments;

				gEventLevel := 0;								{ Indicate outermost level }
				Close;											{ Close is always called when quitting app }
			end
		else
			begin
				LaunchClipboard;

				UnloadAllSegments;
				HandleFinderRequest;

				UnloadAllSegments;
				gEventLevel := 0;								{ Indicate outermost level }
				MainEventLoop;

				AboutToLoseControl(TRUE);
			end;

	{$IFC qDebug}
	{ See if previous max. resource usage has been exceeded by the termi-}
{	nation code and resources.}
		CheckRsrcUsage;
	{$ENDC}

	{ We must call CleanupMacApp here; if we wait to fall thru to the end of the}
{	main program, A5 has been invalidated and we can't refer to any globals.}
		CleanupMacApp;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.SelectWMgrWindow (aWMgrWindow: WindowPtr);

	begin
		SelectWindow(aWMgrWindow);							{ Simply call the toolbox to select it. }
		gLastClickPart := inDesk;							{ Make sure previous mouse clicks are not }
	{ are not considered part of a multi-click. }
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClipboard}

	procedure TApplication.SetClipView (clipView: TView);

		var
			theSuperView: TView;

		procedure RemoveView (aView: TView);

		begin
			theSuperView.RemoveSubView(aView);
		end;

	begin
		if gClipWindow <> nil then
			begin
				if gClipWindow.CountSubViews > 0 then
					theSuperView := TView(gClipWindow.fSubViews.First)
				else
					theSuperView := gClipWindow;
				theSuperView.EachSubView(RemoveView);
				theSuperView.AddSubView(clipView);
				clipView.fSuperView := theSuperView;
				clipView.SuperViewChangedSize(gZeroVPt, kDontInvalidate);
				clipView.RevealTop(kDontRedraw);
				gClipWindow.ForceRedraw;
				gClipWindow.SetTarget(gClipWindow);
				gClipWrittenToDeskScrap := clipView = gClipOrphanage;
			end
		else
			begin
		{$IFC qDebug}
				ProgramBreak('SetClipView in absence of gClipWindow');
		{$ENDC}
			end;

		clipView.ViewEnable(FALSE, kDontRedraw);			{Ignore clicks while in clipboard views}
		gClipView := clipView;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.SetTarget (newTarget: TEvtHandler);

	begin
	{$Ifc qDebug}
		if newTarget = nil then
			ProgramBreak('In TApplication.SetTarget  you''re setting the global target to nil!');
	{$Endc}
		if newTarget <> gTarget then
			begin
				gTarget.InstallSelection(TRUE, FALSE);
				newTarget.InstallSelection(FALSE, TRUE);
				gTarget := newTarget;
				fTicksTilNextIdle := 0; 						{ Make sure we idle ASAP because there's a}
{														 new target.}
				InvalidateCursorRgn;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.SetUndoText (cmdDone: BOOLEAN; aCmdNumber: CmdNumber);

		var
			newMenuState: integer;
			undoName: Str255;
			cmdName: Str255;
			preCmdName: integer;
			constChars: integer;

	begin
		if (gUndoState <> cmdDone) | (gUndoCmd <> aCmdNumber) then
			begin
				if aCmdNumber = cCantUndo then
					newMenuState := bzCantUndo
				else if cmdDone then
					newMenuState := bzUndo
				else
					newMenuState := bzRedo;

				GetIndString(undoName, kIDBuzzString, newMenuState);
				if ParseTitleTemplate(undoName, preCmdName, constChars) then
					begin
						if (aCmdNumber = cNoCommand) | (aCmdNumber = cCantUndo) then
							cmdName := ''
						else
							CmdToName(aCmdNumber, cmdName);
						if SubstituteInTitle(undoName, cmdName, preCmdName, constChars) then
							;
					end;

				SetCmdName(cUndo, undoName);

				gUndoState := cmdDone;
				gUndoCmd := aCmdNumber;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.SetupTheMenus;

		procedure DoSetup;

			var
				appleMenu: MenuHandle;
				undoState: BOOLEAN;
				undoCmd: CmdNumber;
				aWindow: TWindow;
				lastCommand: TCommand;
				lowSpace: BOOLEAN;

		begin
			if not InModalMenuState then
				begin
			{$IFC qInspector}
					lowSpace := MemSpaceIsLow;
			{$EndC}

					aWindow := GetActiveWindow;
					gGotClipType := FALSE;

					gTarget.DoSetupMenus;						{ Setup menus relevent to target chain }

			{ Set up the menu commands that are not dependent on the target chain }

					undoState := kShowCantUndo; 				{ Set the Undo menu defaults. }
					undoCmd := cCantUndo;
					if gSysWindowActive then
						begin
							undoState := kShowUndo;
							undoCmd := cNoCommand;
							Enable(cUndo, TRUE);
							Enable(cCut, TRUE);
							Enable(cCopy, TRUE);
							Enable(cPaste, TRUE);
							Enable(cClear, TRUE);
						end
					else
						begin
							lastCommand := gTarget.GetLastCommand;
							if lastCommand <> nil then
								with lastCommand do
									if fCanUndo then
										begin
											if fCmdDone then
												undoState := kShowUndo
											else
												undoState := kShowRedo;
											undoCmd := fCmdNumber;

			  { Enable Undo only if the last command was not document-specific}
{			   or the document changed is the current document.}
											Enable(cUndo, (fChangedDocument = nil) | ((aWindow <> nil) & (fChangedDocument = aWindow.fDocument)));
										end;
						end;
					SetUndoText(undoState, undoCmd);

			{!!! we should really just make a call to the debugger/inspector here and give}
{			them a shot at setting these up instead}
			{$IFC qDebug}
					EnableCheck(cExperimenting, TRUE, gExperimenting);
					EnableCheck(cReportEvt, TRUE, gReportEvt);
					EnableCheck(cDebugPrinting, TRUE, gDebugPrinting);
					EnableCheck(cReportMenuChoices, TRUE, gReportMenuChoices);
					EnableCheck(cIntenseDebugging, TRUE, gIntenseDebugging);
					Enable(cIdentifySoftware, TRUE);
					Enable(cEnterMacAppDebugger, TRUE);

					if aWindow <> nil then
						begin
							Enable(cModalToggle, TRUE);
							SetMenuState(cModalToggle, kDebugBuzzStrings, bzMakeModal, bzMakeModeless, aWindow.fIsModal);
							Enable(cRefreshFrontWindow, TRUE);
							Enable(cDoFirstClick, TRUE);
							SetMenuState(cDoFirstClick, kDebugBuzzStrings, bzDoFirstClick, bzDontDoFirstClick, aWindow.fDoFirstClick);
						end;

					if qNeedsROM128k | gConfiguration.hasROM128k then
						begin
							Enable(cSetSysJust, TRUE);
							SetMenuState(cSetSysJust, kDebugBuzzStrings, bzSetRightSysJust, bzSetLeftSysJust, GetActualJustification(teJustSystem) <> teJustLeft);
						end;

					EnableCheck(cTraceSetupMenus, TRUE, gTraceSetupMenus);
					EnableCheck(cTraceIdle, TRUE, gTraceIdle);

					Enable(cDebugWind, TRUE);
			{$ENDC}

			{$IFC qInspector}
					Enable(cNewInspectorWindow, not lowSpace);
			{$ENDC}

					if not gSysWindowActive then
						Enable(cPaste, gGotClipType);
				end;

			appleMenu := MAGetMenu(mApple);
			with appleMenu^^ do
				if Odd(enableFlags) = InModalState then
					begin
						enableFlags := BXOR(enableFlags, 1);
						InvalidateMenuBar;
					end;

		end;

	begin
		if MenusHavePendingUpdate | MenuBarHasPendingUpdate then
			PerformMenuSetup(DoSetup);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAOpen}

	procedure TApplication.SFGetParms (itsCmdNumber: CmdNumber; var dlgID: integer; var where: Point; var fileFilter, dlgHook, filterProc: ProcPtr; typeList: TypeListHandle);

		var
			dlogTemplate: DialogTHndl;
			dialogRect: Rect;

	begin
		dlgID := getDlgID;

	{ compute the top-left location of the dialog }
		dlogTemplate := DialogTHndl(GetResource('DLOG', dlgID));
		if dlogTemplate <> nil then
			begin
				dialogRect := dlogTemplate^^.boundsRect;
				CenterRectOnScreen(dialogRect, TRUE, TRUE, TRUE);
				where := dialogRect.topLeft;
			end
		else
			SetPt(where, 100, 100);

		fileFilter := nil;
		dlgHook := nil;
		filterProc := nil;
		SetHandleSize(Handle(typeList), 4);
		FailMemError;
		typeList^^[1] := gMainFileType;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAError}

	procedure TApplication.ShowError (error: OSErr; message: LONGINT);

	begin
		ErrorAlert(error, message);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.SpaceIsLow;

		var
			now: LONGINT;

	begin
		if gEventLevel = 1 then 							{ Don't unload segs if nested event}
{														 handling}
			UnloadAllSegments;

	{ Show 'space is low' alert only after ever gLowSpaceInterval ticks. }
		if (gLowSpaceInterval > 0) & (not gInBackground) then
			begin
				now := TickCount;
				if now > gNextSpaceMsg then
					begin
						gInhibitNestedHandling := TRUE; 			{ Don't tell em again from the alert }
						StdAlert(phSpaceIsLow);
						gNextSpaceMsg := now + gLowSpaceInterval;
					end;
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAClipboard}

	procedure TApplication.SwapClipViews;

		var
			tempClipView: TView;

	begin
		tempClipView := gClipUndoView;
		gClipUndoView := gClipView;

		if tempClipView <> nil then
			SetClipView(tempClipView)						{ Installs old Undo clipboard as current}
{														 clipboard}

		else
			begin
 {$IFC qDebug}
				ProgramBreak('SwapClipViews finds undo clipboard was NIL')
        {$ENDC}
			end;
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.TrackCursor: BOOLEAN;

		var
			globalMouse: Point;
			localMouse: Point;
			cursorIsSet: BOOLEAN;
			aWMgrWindow: WindowPtr;
			cursorWindow: TWindow;
			cursorView: TView;
			windowVPt: VPoint;
			windowBounds: Rect;
			r: Rect;
			haveCursorRgn: BOOLEAN;
			theActiveWindow: TWindow;
			oldPort: GrafPtr;

		function GetDesktopRect: Rect;
	{ Returns the rgnBBox of the region representing the entire desktop (including menubar). }

		begin
		{$IFC qDebug}
			UseTempRgn('TApplication.TrackCursor, GetDesktopRect');
		{$ENDC}
			if qNeedsColorQD | gConfiguration.hasColorQD then { gTempRgn := main screen rect }
				RectRgn(gTempRgn, GetMainDevice^^.gdRect)
			else
				RectRgn(gTempRgn, screenBits.bounds);
			UnionRgn(GetGrayRgn, gTempRgn, gTempRgn);		{ gTempRgn := grayRgn + gTempRgn }
			GetDesktopRect := gTempRgn^^.rgnBBox;			{ return bounding box }
		{$IFC qDebug}
			DoneWithTempRgn;
		{$ENDC}
		end;

		procedure CalcNotClaimedRgn;
	{ Make the region wide open less the active window. And Less Any first click windows or DA's}

			procedure DoToWindow (theWMgrWindow: WindowPtr);

				var
					aWindow: TWindow;

			begin
				aWindow := WMgrToWindow(theWMgrWindow);
				if (aWindow <> nil) & (aWindow.fDoFirstClick | aWindow.fIsActive) & aWindow.IsShown then
					DiffRgn(gCursorRgn, WindowPeek(theWMgrWindow)^.contRgn, gCursorRgn);
			end;

		begin
			if cursorWindow <> nil then
				with globalMouse do
					SetRectRgn(gCursorRgn, h, v, h + 1, v + 1)
			else
				begin
					r := GetDesktopRect;
					RectRgn(gCursorRgn, r);
					EachWMgrWindowDo(DoToWindow);
			{ make sure mouse's current location is included }
			{$IFC qDebug}
					UseTempRgn('TApplication.TrackCursor, CalcNotClaimedRgn');
			{$ENDC}
					with globalMouse do
						SetRectRgn(gTempRgn, h, v, h + 1, v + 1);
					UnionRgn(gTempRgn, gCursorRgn, gCursorRgn);
			{$IFC qDebug}
					DoneWithTempRgn;
			{$ENDC}
				end;
		end;

	begin
		TrackCursor := FALSE;

		if gInBackground then
			EXIT(TrackCursor);

		GetMouse(globalMouse);
		LocalToGlobal(globalMouse);

		if PtInRgn(globalMouse, gCursorRgn) then
			begin
		{$IFC qDebug}
				if gIntenseDebugging & gTraceIdle then
					Writeln('cursor is in cursor region');
		{$ENDC}
				if not gAlwaysTrackCursor then
					EXIT(TrackCursor);
			end;

		InvalidateCursorRgn;
		haveCursorRgn := FALSE;
		cursorIsSet := FALSE;

 { Find out if the cursor is in a window.  If it is the window must be the}
{  front window or must handle first clicks.}
{  ??? Shouldn't the cursor testing be handed off to the window!!!}

		theActiveWindow := GetActiveWindow;

		if (FindWindow(globalMouse, aWMgrWindow) = inContent) then
			begin
				GetPort(oldPort);
				SetPort(aWMgrWindow);
				localMouse := globalMouse;
				GlobalToLocal(localMouse);
				SetPort(oldPort);

				cursorWindow := WMgrToWindow(aWMgrWindow);
				if (not PtInRgn(localMouse, aWMgrWindow^.visRgn)) | ((cursorWindow <> nil) & (cursorWindow <> theActiveWindow) & (not cursorWindow.fDoFirstClick)) then
					cursorWindow := nil;
			end
		else
			cursorWindow := nil;

		if cursorWindow <> nil then
			begin
				cursorWindow.GetGlobalBounds(windowBounds);
				windowVPt.h := globalMouse.h - windowBounds.left;
				windowVPt.v := globalMouse.v - windowBounds.top;
				cursorView := cursorWindow.HandleCursor(windowVPt, gCursorRgn);
				if cursorView <> nil then
					begin
						cursorIsSet := TRUE;

						if not EmptyRgn(gCursorRgn) then
							begin
								haveCursorRgn := TRUE;

				{ Intersect with viewed rect }
								if qDebug then
									cursorView.AssumeFocused;

				{ Intersect with visible region }
								SectRgn(thePort^.visRgn, gCursorRgn, gCursorRgn);
								SectRgn(thePort^.clipRgn, gCursorRgn, gCursorRgn);

				{ Convert gCursorRgn from view coords to global coords }
								with thePort^.portRect do
									OffsetRgn(gCursorRgn, windowBounds.left - left, windowBounds.top - top);
							end;
					end;
			end;

		if not haveCursorRgn then
			CalcNotClaimedRgn;

	{$IFC qDebug}
		if gIntenseDebugging & gTraceIdle then
			if gCursorRgn = nil then
				Writeln('gCursorRgn is NIL')
			else
				begin
					HLock(Handle(gCursorRgn));
					WrLblRect('gCursorRgn', gCursorRgn^^.rgnBBox);
					Writeln;
					HUnlock(Handle(gCursorRgn));
				end;
	{$ENDC}

		if not cursorIsSet then
			SetCursor(arrow);
		TrackCursor := cursorIsSet;

		if not PtInRgn(globalMouse, gCursorRgn) then
			begin
				if qDebug then
					begin
						Writeln('Whoops, cursor region was not correctly calculated.');
						WrLblPt('global cursor', globalMouse);
						WrLblRect('  gCursorRgn^^.rgnBBox', gCursorRgn^^.rgnBBox);
						Writeln;
						ProgramBreak('The cursor is not in the cursor region at end of TApplication.TrackCursor!');
					end;
			end;

	end;

{--------------------------------------------------------------------------------------------------}
{$S MADoCommand}

	function TApplication.TrackMouse (globalMouse, hysteresis: Point; theCommand: TCommand): TCommand;

		var
			tracker: TCommand;
			view: TView;
			scroller: TScroller;
			gotATracker: BOOLEAN;
			theQDMouse: Point;
			theMouse: VPoint;
			anchorPoint: VPoint;
			previousPoint: VPoint;
			peekEvent: EventRecord;
			movedOnce: BOOLEAN;
			amtMoved: VPoint;
			didMove: BOOLEAN;
			delta: VPoint;
			mouseInScroller: VPoint;
			didScroll: BOOLEAN;
			currTranslation: VPoint;
			viewExtent: VRect;
			autoscrollLimit: VRect;
			focusedOnDesktop: BOOLEAN;
			desktopPort: CGrafPort;
			savedPort: GrafPtr;

		procedure CleanUpFocus;

		begin
			if focusedOnDesktop then
				begin
					if qNeedsColorQD | gConfiguration.hasColorQD then
						CloseCPort(@desktopPort)
					else
						ClosePort(@desktopPort);
					SetPort(savedPort);
					focusedOnDesktop := FALSE;
				end;
		end;

		procedure SetupFocus;

		begin
			if view <> nil then
				begin
					if focusedOnDesktop then
						CleanUpFocus;

					if view.Focus then
						begin
							GetFocus(gSaveFocusRec);
							if scroller <> nil then
								begin
									scroller.GetExtent(autoscrollLimit);
									currTranslation := scroller.fTranslation;
								end;
						end

					else
						begin
 {$IFC qDebug}
							ProgramBreak('TApplication.TrackMouse: Unable to focus view.')
                {$ENDC}
						end;
				end
			else
				begin										{ focus on the desktop }
					if not focusedOnDesktop then
						begin
							GetPort(savedPort); 					{ In case we exit still focusedOnDeskTop }
							if qNeedsColorQD | gConfiguration.hasColorQD then
								OpenCPort(@desktopPort)
							else
								OpenPort(@desktopPort);
							focusedOnDesktop := TRUE;
						end;

					CopyRgn(GetGrayRgn, desktopPort.visRgn);
					desktopPort.portRect := desktopPort.visRgn^^.rgnBBox;
					InvalidateFocus;
					GetFocus(gSaveFocusRec);
				end;
		end;

		procedure DoFocus;

		begin
		{$Push}
			if (scroller <> nil) & not EqualVPt(currTranslation, scroller.fTranslation) then
		{$Pop}
				SetupFocus
			else
				SetFocus(gSaveFocusRec);
		end;

		procedure InstallTracker (newTracker: TCommand);

		begin
			tracker := newTracker;
			gotATracker := (tracker <> nil);
			if gotATracker then
				begin
					view := tracker.fView;
					scroller := tracker.fScroller;
					if view <> nil then
						view.GetExtent(viewExtent);
					SetupFocus;
				end;
		end;

		procedure FeedbackOnce (turnItOn, mouseDidMove: BOOLEAN);

		begin
			if gotATracker then
				begin
					PenNormal;
					PenMode(PatXOR);
					tracker.TrackFeedback(anchorPoint, previousPoint, turnItOn, mouseDidMove);
				end;
		end;

		procedure ConstrainOnce;							{ ??? fold this into TrackOnce ??? }

		begin
			if gotATracker then
				begin
					if tracker.fViewConstrain & (view <> nil) then
						PinVRect(viewExtent, theMouse);
					if tracker.fConstrainsMouse then
						tracker.TrackConstrain(anchorPoint, previousPoint, theMouse);
				end;
		end;

		procedure TrackOnce (aTrackPhase: TrackPhase; didMouseMove: BOOLEAN);

			var
				newTracker: TCommand;

		begin
		{$IFC qDebug}
			if tracker = nil then
				begin
					ProgramBreak('In TApplication.TrackMouse: tracker = NIL');
					tracker := nil;
					gotATracker := FALSE;
				end;
		{$ENDC}

			if gotATracker then
				begin
					newTracker := tracker.TrackMouse(aTrackPhase, anchorPoint, previousPoint, theMouse, didMouseMove);
					if newTracker <> tracker then
						begin
							FreeIfObject(tracker);
							tracker := nil;

							InstallTracker(newTracker);
						end
					else if (newTracker <> nil) & (newTracker.fView <> view) then
						InstallTracker(newTracker);
				end;
		end;

	begin
		focusedOnDesktop := FALSE;
		InstallTracker(theCommand);

		theQDMouse := globalMouse;
		if view <> nil then
			begin
				GlobalToLocal(theQDMouse);
				view.QDToViewPt(theQDMouse, theMouse);
			end
		else
			PtToVPt(theQDMouse, theMouse);
		anchorPoint := theMouse;
		previousPoint := theMouse;

		ConstrainOnce;

		anchorPoint := theMouse;
		previousPoint := theMouse;							{ in case Constrain changed the localPoint;}
{														 guarantee that all 3 are the same on}
{														 TrackPress}

		TrackOnce(trackPress, TRUE);
		previousPoint := theMouse;							{ in case TrackMouse changed nextPoint }
		FeedbackOnce(TRUE, TRUE);

		movedOnce := FALSE;

		while gotATracker & not tracker.IsDoneTracking do
			begin
				DoFocus;
				GetMouse(theQDMouse);
				if view <> nil then
					view.QDToViewPt(theQDMouse, theMouse)
				else
					PtToVPt(theQDMouse, theMouse);

				if not movedOnce then
					begin
						ConstrainOnce;								{ ensure that we are playing on a level}
{														 field.}
						amtMoved := theMouse;
						SubVPt(anchorPoint, amtMoved);
						if (Abs(amtMoved.h) >= hysteresis.h) | (Abs(amtMoved.v) >= hysteresis.v) then
							movedOnce := TRUE;
					end;

				delta := gZeroVPt;
				if movedOnce | tracker.fTrackNonMovement then
					begin

			{ ??? Problems with this:}
{			delta might be non-zero but scrolling can't take place}
{			because it is pinned at the end of the view}
{			also might want some slop before scrolling ???}

						if (scroller <> nil) & (view <> nil) then
							begin
								mouseInScroller := theMouse;
								view.LocalToWindow(mouseInScroller);
								scroller.WindowToLocal(mouseInScroller);
								if not PtInVRect(mouseInScroller, autoscrollLimit) then
									begin
										scroller.AutoScroll(mouseInScroller, delta); { Get the amount to autoscroll, if any }
										AddVPt(delta, theMouse);
									end;
							end;

						ConstrainOnce;
					end;

				didScroll := not EqualVPt(delta, gZeroVPt);
				didMove := not EqualVPt(previousPoint, theMouse);

				FeedbackOnce(FALSE, didMove | didScroll);

				if didScroll then
					begin
						tracker.AutoScroll(delta.h, delta.v);	{ OK, now actually do the scrolling }
						if view <> nil then
							view.Update;						{ Keep synchronized.  ScrollDraw only invalidated }
						SetupFocus; 								{ the focus changed }
					end;

				TrackOnce(trackMove, didMove);					{ ??? add OR didscroll ??? }

				previousPoint := theMouse;
				FeedbackOnce(TRUE, didMove | didScroll);
			end;

		DoFocus;

		if not movedOnce then
			theMouse := previousPoint						{ normally same as original mouse down; we}
{														 don't use anchorPoint in case someone has}
{														 changed that -- it is more likely that an}
{														 app would change anchorPoint than}
{														 previousPoint}

		else if EventAvail(mUpMask + mDownMask, peekEvent) then
			begin
				theQDMouse := peekEvent.where;
				if view <> nil then
					begin
						GlobalToLocal(theQDMouse);
						view.QDToViewPt(theQDMouse, theMouse);
					end
				else
					PtToVPt(theQDMouse, theMouse);
				ConstrainOnce;
			end;
	{ ELSE we use the last known mouse position }

		FeedbackOnce(FALSE, TRUE);
		TrackOnce(trackRelease, TRUE);

		CleanUpFocus;

		TrackMouse := tracker;

	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	procedure TApplication.UpdateAllWindows;

		const
			systemEventMask = app4Mask; 				{ maybe this will be defined in the}
{														 interfaces someday}

		var
			anEvent: EventRecord;

	begin
		while GetEvent(updateMask + activMask + systemEventMask, 0, nil, anEvent) do { SystemEvents}
{			  aren't queued}
			HandleEvent(anEvent);
	end;

{--------------------------------------------------------------------------------------------------}
{$S MAApplicationRes}

	function TApplication.WMgrToWindow (aWMgrWindow: WindowPtr): TWindow;

	begin
		if (aWMgrWindow <> nil) & (not IsDeskAccessory(aWMgrWindow)) & IsObject(GetWRefCon(aWMgrWindow)) then 	{ Make an IsObject test too because some slimedog may have created a window in our}
{	world and the refcon wouldn't be an object.  Since this is the only place in}
{	MacApp that we get asked to do something to a ToolBox structure where we don't _know_}
{	that we created the structure we need to be especially careful here.  ??? Perhaps in the}
{	future we should use a dictionary to make the windowPtr to TWindow association for us.}
			WMgrToWindow := TWindow(GetWRefCon(aWMgrWindow))
		else
			WMgrToWindow := nil;
	end;


end.