/* Copyright  1986-1990 Apple Computer, Inc.  All rights reserved. */
/* Default resources that can be included in your application if desired */

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#if qTemplateViews
resource 'view' (kDefaultWindowID,
#if qNames
"kDefaultWindowID",
#endif
	purgeable) {
	{
		root, 'WIND', { 50, 20 }, { 260, 430 }, sizeVariable, sizeVariable, shown, enabled,
		Window		{ "", zoomDocProc, goAwayBox, resizable, modeless,
					ignoreFirstClick,
					freeOnClosing, disposeOnFree, closesDocument, openWithDocument, dontAdaptToScreen,
					stagger, forceOnScreen, dontCenter, 'DFLT', "" };

		'WIND', 'SCLR',	{ 0, 0 }, { 260-kSBarSizeMinus1, 430-kSBarSizeMinus1 },
		sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller	{ "", vertScrollBar, horzScrollBar, 0, 0, 16, 16,
					vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCLR',IncludeViews	{ kDefaultViewID }
	}
};

resource 'view' (kDefaultViewID,
#if qNames
"kDefaultViewID",
#endif
	purgeable) {
	{
		root, 'DFLT', { 0, 0 }, { 134, 414 }, sizeFixed, sizeFixed, shown, enabled,
		DefaultView		{""}				// A ClassName can be put in this string
											// or do a RegisterStdType to point to
											// something to create for a "Default View"
	}
};
#endif

resource 'WIND' (kDefaultWindowID,
#if qNames
"kDefaultWindowID",
#endif
	purgeable) {
	{50, 40, 250, 436},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	""
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	MultiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	534 * 1024,
	246 * 1024
#else
	384 * 1024,													// try to leave enough room for printing
	96 * 1024
#endif
};

resource 'DITL' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{160, 182, 180, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{8, 70, 152, 316},
		StaticText {
			disabled,
			"^0"												// The ^0 will be dynamically replaced with CurApName
			"\n\nThis program was written "
			"with MacApp  1985-1990 Apple Computer, Inc."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

resource 'ALRT' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	{90, 100, 280, 412},
	phAboutApp,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
};


resource 'cmnu' (mApple,
#if qNames
"mApple",
#endif
nonpurgeable) {
	mApple,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{
	"About ^0", noIcon, noKey, noMark, plain, cAboutApp;		// The ^0 will be dynamically replaced with CurApName
	"-",		 noIcon, noKey, noMark, plain, nocommand
	}
};

resource 'cmnu' (mFile,
#if qNames
"mFile",
#endif
nonpurgeable) {
	mFile,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"File",
	{
	"New",				noIcon, "N",	noMark, plain, cNew;
	"Open",			noIcon, "O",	noMark, plain, cOpen;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Close",			noIcon, "W",	noMark, plain, cClose;
	"Save",				noIcon, "S",	noMark, plain, cSave;
	"Save As",			noIcon, noKey,	noMark, plain, cSaveAs;
	"Save a Copy In",	noIcon, noKey,	noMark, plain, cSaveCopy;
	"Revert",			noIcon, noKey,	noMark, plain, cRevert;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Page Setup",		noIcon, noKey,	noMark, plain, cPageSetup;
	"Print One",		noIcon, noKey,	noMark, plain, cPrintOne;
	"Print",			noIcon, "P",	noMark, plain, cPrint;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Quit",				noIcon, "Q",	noMark, plain, cQuit
	}
};

resource 'cmnu' (mEdit,
#if qNames
"mEdit",
#endif
nonpurgeable) {
	mEdit,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{
	"Undo",				noIcon, "Z",	noMark, plain, cUndo;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Cut",				noIcon, "X",	noMark, plain, cCut;
	"Copy",				noIcon, "C",	noMark, plain, cCopy;
	"Paste",			noIcon, "V",	noMark, plain, cPaste;
	"Clear",			noIcon, noKey,	noMark, plain, cClear;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Select All",		noIcon, "A",	noMark, plain, cSelectAll;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Show Clipboard",	noIcon, noKey,	noMark, plain, cShowClipboard
	}
};

resource 'cmnu' (mBuzzwords,
#if qNames
"Buzzwords",
#endif
nonpurgeable
) {
	mBuzzwords,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Buzzwords",
	{
	"Typing",				noIcon, noKey, noMark, plain, cTyping;
	"Page Setup Change",	noIcon, noKey, noMark, plain, cChangePrinterStyle
	}
};

resource 'MBAR' (kMBarDisplayed,
#if qNames
"kMBarDisplayed",
#endif
nonpurgeable) {

	{mApple; mFile; mEdit}
};

resource 'ICN#' (128,
#if qNames
"Application",
#endif
purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"00 00 00 00 00 02 7E 00 00 04 81 00 00 09 00 80 00 12 60 40 00 23 90 20 00 7C FF 1E"
		$"00 C4 60 0E 01 82 00 0E 03 01 00 0E 06 00 C0 0E 0C 00 3F CE 18 00 00 3E 30 00 00 0E"
		$"60 00 00 00 C0 00 15 02 60 00 40 81 30 00 00 42 18 00 10 24 0C 01 40 10 06 0A 2A 8A"
		$"03 00 10 05 01 81 00 02 00 C0 80 05 00 60 21 02 00 30 0A A5 00 18 00 0A 00 0C 08 05"
		$"00 06 10 00 00 03 20 00 00 01 C0 00 00 00 80",
		/* [2] */
		$"00 00 00 00 00 03 FE 00 00 07 FF 00 00 0F FF 80 00 1F FF C0 00 3F FF E0 00 7F FF FE"
		$"00 FF FF FE 01 FF FF FE 03 FF FF FE 07 FF FF FE 0F FF FF FE 1F FF FF FE 3F FF FF FE"
		$"7F FF FF FC FF FF FF FE 7F FF FF FF 3F FF FF FE 1F FF FF FC 0F FF FF F0 07 FF FF FF"
		$"03 FF FF FF 01 FF FF FF 00 FF FF FF 00 7F FF FF 00 3F FE FF 00 1F FC 0F 00 0F F8 07"
		$"00 07 F0 00 00 03 E0 00 00 01 C0 00 00 00 80"
	}
};

type 'MApp' as 'STR ';
resource 'MApp' (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"Application created by MacApp"
};

resource 'FREF' (128,
#if qNames
"Application",
#endif
	purgeable) {
	'APPL',
	0,
	""
};

resource 'BNDL' (128,
#if qNames
"Bundle",
#endif
	purgeable) {
	'MApp',
	0,
		{
		'ICN#',
			{
			0, 128,
			},
		'FREF',
			{
			0, 128,
			}
		}
};


// Version for the "package"
RESOURCE 'vers' (2,
#if qNames
	"Package Version",
#endif
	purgeable) {
	0x02,
	0x01,
	final,
	0x00,
	verUs,
	$$Shell("MAShortVersion"),
	$$Shell("MALongVersion")
};

// Version for the "application or file"
RESOURCE 'vers' (1,
#if qNames
	"Application Version",
#endif
	purgeable) {
	0x01,
	0x00,
	development,
	0x01,
	verUs,
	"1.0 d1",
	"1.0 d1, Application created by MacApp"
};



resource 'STR#' (kDefaultCredits,
#if qNames
	"kDefaultCredits",
#endif
	purgeable) {
	 {
	"The great people behind MacApp";

	"Engineers past and present";
	"Peter Alley";
	"Curt Bianchi";
	"Mary Boetcher";
	"Ken Doyle";
	"Steve Friedrich";
	"David Goldsmith";
	"Barry Haynes";
	"Chris Knepper";
	"Lonnie Millett";
	"Deb Orton";
	"Larry Rosenstein";
	"Larry Tesler";
	"Scott Wallace";
	"Russ Wetmore";

	"Testers past and present";
	"Dan Allen";
	"John Beswetherick";
	"Cliff Greyson";
	"Richard Kimberly";
	"Kuldip Nijjar";
	"Richard Rodseth";

	"Writers past and present";
	"Dave Bice";
	"Mikel Evins";
	"Bill Harris";
	"Marq Laube";
	"John Perry";
	"Don Reed";
	"Jon Simonoff";
	"Jon Singer";
	"Alan Spragens";
	"Andy Swartz";

	"Technical support past and present";
	"Darin Adler";
	"Mark Bennett";
	"Rick Blair";
	"Clarus the DogCow (Moof!)";
	"Bo3b Johnson";
	"Keith Rollin";
	"Andrew Shebanow";

	"Configuration Management";
	"Gary Davis";
	"Ming Low";

	"Product Managers past and present";
	"Harvey Alcabes";
	"Steve Burbeck";

	"Managers";
	"David Goldsmith (yes, he was a manager too!)";
	"Phac LeTuan";
	"Ron Metzker";
	"Jim Thomas";

	"Evangelizers";
	"Scott Knaster";
	"Jon Magill";
	"Gregg Williams";

	"MacApp Developers Association";
	"Bill Anderson";
	"Howard Katz";
	"Carl Nelson";
	"(206) 252-6946";

	"Other great people";
	"Rob Chandhok & John Pane @ Carnegie Mellon University";
	"Dan Cochran";
	"Eileen Crombie";
	"Patricia Eastman";
	"Ann Greyson";
	"Michael Hinkson";
	"Mark Lentczner";
	"Eileen Mayes";
	"Mom and Dad";
	"Kurt Schmucker";
	"Harry Yee";
	"Geri Younggren";
	"You, the billions and billions of MacApp programmers";

	"THE MacApp teachers";
	"Neal Goldstein";
	"Neil Rhodes";
	"Dave Wilson";

	"And because he insisted on being included";
	"Eagle I. Berns"

	 }
};
