{$P}
{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ UMacApp.TPrintHandler.p }
{ Copyright  1985-1990 by Apple Computer, Inc.  All rights reserved. }

{--------------------------------------------------------------------------------------------------}
{$S MAPrintingRes}

PROCEDURE TPrintHandler.IPrintHandler(itsView: TView);

	BEGIN
	fView := itsView;
	fDocument := NIL;
	IEvtHandler(NIL);
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

FUNCTION TPrintHandler.BreakFollowing(vhs: VHSelect; prevBreak: VCoordinate;
									  VAR automatic: BOOLEAN): VCoordinate;

	BEGIN
	{$IFC qDebug}
	ProgramBreak('BreakFollowing called for non-subclassed Printhandler');
	{$ENDC}
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAFields}

PROCEDURE TPrintHandler.Fields(PROCEDURE DoToField(fieldName: Str255; fieldAddr: Ptr;
												   fieldType: INTEGER));

	BEGIN
	DoToField('TPrintHandler', NIL, bClass);
	DoToField('fView', @fView, bObject);
	DoToField('fDocument', @fDocument, bObject);
	DoToField('fDeviceRes', @fDeviceRes, bPoint);
	DoToField('fViewPerPage', @fViewPerPage, bVPoint);
	DoToField('fFocusedPage', @fFocusedPage, bInteger);
	INHERITED Fields(DoToField);
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

PROCEDURE TPrintHandler.CalcPageStrips(VAR pageStrips: Point);

	BEGIN
	{$IFC qDebug}
	ProgramBreak('CalcPageStrips called for non-subclassed Printhandler');
	{$ENDC}
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

PROCEDURE TPrintHandler.CalcViewPerPage(VAR amtPerPage: VPoint);

	BEGIN
	{$IFC qDebug}
	ProgramBreak('CalcViewPerPage called for non-subclassed Printhandler');
	{$ENDC}
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

PROCEDURE TPrintHandler.CheckPrinter;					{See if there are changed
														 printer-configuration parameters which
														 need to be absorbed, and if so, absorb
														 them}

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAPrintingRes}

PROCEDURE TPrintHandler.DrawPrintFeedback(area: Rect);
{Draw page-breaks, page-numbers, etc.}

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAPrintingRes}

PROCEDURE TPrintHandler.DrawPageBreak(vhs: VHSelect; whichBreak: INTEGER; loc: VCoordinate;
									  automatic: BOOLEAN);

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAPrintingRes}

PROCEDURE TPrintHandler.FocusOnInterior;

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAInspector}

PROCEDURE TPrintHandler.GetInspectorName(VAR inspectorName: Str255); OVERRIDE;

	VAR
		hexString:			Str255;

	BEGIN
	IF SELF = gNullPrintHandler THEN
		inspectorName := 'gNullPrintHandler'
	ELSE IF SELF = gPrintHandler THEN
		inspectorName := 'gPrintHandler'
	ELSE IF IsObject(fView) THEN
		BEGIN
		PointerToHex(fView, hexString, 8);
		inspectorName := CONCAT('for view ', hexString);
		END;
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

PROCEDURE TPrintHandler.LocatePageInterior(pageNumber: INTEGER; VAR loc: Point);

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

FUNCTION TPrintHandler.MaxPageNumber: INTEGER;

	BEGIN
	MaxPageNumber := 0;
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAPrint}

FUNCTION TPrintHandler.Print(itsCmdNumber: CmdNumber; VAR proceed: BOOLEAN): TCommand;

	BEGIN
	proceed := TRUE;
	Print := NIL;
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANonRes}

PROCEDURE TPrintHandler.PrinterChanged;

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAFinder}											{??? Signal error ???}

FUNCTION TPrintHandler.SetupForFinder: BOOLEAN;

	BEGIN
	{$IFC qDebug}
	WriteLn('SetupForFinder called for a view that can''t');
	{$ENDC}
	SetupForFinder := FALSE;
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

PROCEDURE TPrintHandler.RedoPageBreaks;

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MAPrintingRes}

PROCEDURE TPrintHandler.Reset;

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S PrintOpen}

PROCEDURE TPrintHandler.SetDefaultPrintInfo;
{ Meant to be overridden in a subclass that really prints }

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

PROCEDURE TPrintHandler.SetPageInterior(pageNumber: INTEGER);

	BEGIN
	END;

{--------------------------------------------------------------------------------------------------}
{$S MANever}

PROCEDURE TPrintHandler.SetPageOffset(coord: VPoint);

	BEGIN
	END;
