/* Copyright  1986-1990 Apple Computer, Inc.  All rights reserved. */

/*  Auto-Include the requirements for this source */

#ifndef __CMDO.R__
#include "cmdo.r"
#endif

#ifndef __PICT.R__
#include "Pict.r"
#endif


resource 'cmdo' (128, "MABuild") {
	{
		295,			/* Height of dialog */
		"Make MacApp program up-to-date by rebuilding everything that is out-of-date.",
		{
			notDependent {}, RegularEntry {
				"Application:",
				{20, 15, 36, 105},
				{20, 105, 36, 330},
				"",
				keepCase,
				"",
				"This is the name of your application." },
			Or { {1} }, DoItButton {},
			notDependent {}, TriStateButtons {
				"", { {60,20,76,155}, "AutoBuild", "-NoAutoBuild", "", "-AutoBuild",
					"Auto-build the MacApp libraries (and any others). MABuild defaults "
					"to -NoAutoBuild." } },
			notDependent {}, TriStateButtons {
				"", { {76,20,92,155}, "Show Progress", "-NoPP", "", "-PP",
					"Have all tools show progress. MABuild defaults "
					"to -NoPP." } },
			notDependent {}, TriStateButtons {
				"", { {92,20,108,155}, "Run", "-NoRun", "", "-Run",
					"Run after build. MABuild defaults "
					"to -NoRun." } },
			notDependent {}, TriStateButtons {
				"", { {108,20,124,155}, "Save Windows", "-NoSave", "", "-Save",
					"Auto-save all open windows before starting build. MABuild defaults "
					"to -NoSave." } },
			notDependent {}, TriStateButtons {
				"", { {124,20,140,155}, "SeparateObjects", "-NoSeparateObjects", "", "-SeparateObjects",
					"Keep separate object folders for each build variation. MABuild defaults "
					"to -SeparateObjects." } },
			notDependent {}, TriStateButtons {
				"", { {140,20,156,155}, "Show Times", "-NoT", "", "-T",
					"Have all tools show elapsed time. MABuild defaults "
					"to -NoT." } },
			notDependent {}, TextBox {
				black,
				{52,15,164,160},
				"Common Options" },

			notDependent {}, RadioButtons {
				{
					{76,175,92,325}, "Std Debugging", "", set,
						"Use the standard debugging set. This implicitly sets BottleNeck, "
						"Inspector, Names, Perform, Range/Overflow Check, Trace, and UnInit.",
					{92,175,108,325}, "Std Non-Debugging", "-NoDebug", notSet,
						"Use the standard non-debugging set. This implicitly clears BottleNeck, "
						"Inspector, Names, Perform, Range/Overflow Check, Trace, and UnInit.",
					{108,175,124,325}, "Custom", "", notSet,
						"Choose this if you want a non-standard [non-]debugging set. The "
						"\"Debug Options\" button will become enabled, and you'll be able to "
						"choose the features you want."
				}},
			notDependent {}, CheckOption {
				notSet, {140,175,156,325}, "Use SADE symbols",
					"-Sym",
				"Generate SADE symbols."},
			notDependent {}, TextBox {
				black,
				{68,170,164,330},
				"Debugging Options" },
			notDependent {}, Box {
				gray, {132, 175,133, 325}},

			Or {{(3<<12) + 10}}, NestedDialog {
				2,
				{20, 338, 40, 466},
				"Debug Options",
				"This leads to the custom debugging options. If this button is grayed out, "
				"you can activate it by clicking on \"Custom\" radio button under "
				"\"Debugging Options\"" },
			notDependent {}, NestedDialog {
				3,
				{50, 338, 70, 466},
				"System Options",
				"This leads to options that control the type of system for which the "
				"application will be built." },
			notDependent {}, NestedDialog {
				4,
				{80, 338, 100, 466},
				"More Options",
				"This leads to the less often used options." },
			notDependent {}, NestedDialog {
				5,
				{110, 338, 130, 466},
				"Compiler Options",
				"Assign options for the various tools." },
			notDependent {}, NestedDialog {
				6,
				{140, 338, 160, 466},
				"Defines/Aliases",
				"Set compiler defines and directory aliases." },

			notDependent {}, Box {
				gray, {7,5,190,475} },
			notDependent {}, Box {
				black, {11,9,186,471} },
			notDependent {}, Box {
				black, {10,8,187,472} },

		/*	notDependent {}, PictOrIcon {
				Picture,
				128,
				{12, 10, 60, 209}
			}, */
			notDependent {}, VersionDialog {
				VersionString {"1.0b10"},
				"MABuild 1.0b10\n"
				$$Shell("MALongVersion") "\n"
				"  (Blood, sweat, and tears by Keith Rollin)",
				noDialog },
		},

		295,
		"Set the debugging options.",
		{
			notDependent {}, RadioButtons {
				{
					{30,60,46,230}, "Use Debugging Gear", "", set,
					"Turn on debugging and install debugging gear",
					{30,250,46,429}, "Turn off Debugging Gear", "-NoDebug", notSet,
					"Turn off debugging",
				}},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {50,60,66,230},  "No BottleNeck",
					"-NoBottleNeck",
				"Don't bottleneck method calls through the dispatcher"},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {66,60,82,230},  "No Inspector",
					"-NoInspector",
				"Don't include inspector in debugging gear"},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {82,60,98,230},  "No Names",
					"-NoNames",
				"Don't include embedded debugging symbols"},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {98,60,114,230},  "No Performance Tools",
					"-NoPerform",
				"Don't include performance monitor code"},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {114,60,130,230},  "No Range/Overflow Checking",
					"-NoRangeCheck",
				"Don't force Range/Overflow checking"},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {130,60,146,230},  "No Tracing",
					"-NoTrace",
				"Don't include tracing facilities in debugging gear"},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {146,60,162,230},  "No Initialization",
					"-NoUnInit",
				"Don't force initialization of uninitialized storage"},
			Or {{(1<<12) + 1}}, CheckOption {
				notSet, {162,60,178,230},  "unused",
					"",
				"Don't include writeLn window in debugging gear"},

			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {50,250,66,420},  "BottleNeck",
					"-BottleNeck",
				"Bottleneck method calls through the dispatcher"},
			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {66,250,82,420},  "Inspector",
					"-Inspector",
				"Include inspector"},
			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {82,250,98,420},  "Names",
					"-Names",
				"Include embedded debugging symbols"},
			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {98,250,114,420},  "Performance Tools",
					"-Perform",
				"Include performance monitor code"},
			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {114,250,130,420},  "Range/Overflow Checking",
					"-RangeCheck",
				"Force Range/Overflow checking"},
			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {130,250,146,420},  "Tracing",
					"-Trace",
				"Include tracing facilities in debugging gear"},
			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {146,250,162,420},  "Initialization",
					"-UnInit",
				"Force initialization of uninitialized storage"},
			Or {{-((1<<12) + 1)}}, CheckOption {
				notSet, {162,250,178,420},  "",
					"",
				"Include writeLn window in debugging gear"},

			notDependent {}, NestedDialog {
				7,
				{160, 400, 180, 465},
				"Help",
				"Get help on what this stupid dialog box is all about." },

			notDependent {}, Box {
				black, {27,50,180,430} },
			notDependent {}, Box {
				black, {27,240,180,241} },
			notDependent {}, Box {
				black, {48,50,49,430} },
		},

		280,
		"Set options that determine the system for which this application is built.",
		{
			notDependent {}, RadioButtons {
				{
					{38,20,54,150}, "No Dependancy", "-NoNeedsROM128K", notSet,
						"Don't require a certain ROM",
					{54,20,70,150}, "Needs 128K ROM", "", set,
						"Build to require ROM 128K or better",
				}},
			notDependent {}, TextBox {
				black,
				{30,15,78,155},
				"ROM Options" },

			notDependent {}, RadioButtons {
				{
					{38,170,54,300}, "No Dependancy", "", set,
						"Don't require a certain System",
					{54,170,70,300}, "Needs Sys 6.0+", "-NeedsSystem6", notSet,
						"Build to require System 6.0 or better",
				}},
			notDependent {}, TextBox {
				black,
				{30,165,78,305},
				"System Options" },

			notDependent {}, RadioButtons {
				{
					{38,320,54,450}, "No Dependancy", "", set,
						"Don't require Color QuickDraw",
					{54,320,70,450}, "Needs Color QD", "-NeedsColorQD", notSet,
						"Build to require Color QuickDraw",
				}},
			notDependent {}, TextBox {
				black,
				{30,315,78,455},
				"QuickDraw Options" },

			notDependent {}, RadioButtons {
				{
					{108,20,124,150}, "No Dependancy", "", set,
						"Don't require a certain CPU",
					{124,20,140,150}, "Needs MC68020", "-NeedsMC68020", notSet,
						"Build to require a 68020",
					{140,20,156,150}, "Needs MC68030", "-NeedsMC68030", notSet,
						"Build to require a 68030"
				}},
			notDependent {}, TextBox {
				black,
				{100,15,164,155},
				"CPU Options" },

			notDependent {}, RadioButtons {
				{
					{108,170,124,300}, "No Dependancy", "", set,
						"Don't require an FPU",
					{124,170,140,300}, "Needs FPU", "-NeedsFPU", notSet,
						"Require an FPU"
				}},
			notDependent {}, TextBox {
				black,
				{100,165,164,305},
				"FPU Options" }
		},

		280,
		"Set the less commonly used options.",
		{
			notDependent {}, TriStateButtons {
				"", { {30,95,46,230}, "Align", "-NoAlign", "", "-Align",
					"Longword align all code and data for speed. MABuild defaults "
					"to -Align." } },
			notDependent {}, TriStateButtons {
				"", { {46,95,62,230}, "Execute", "-NoExecute", "", "-Execute",
					"Execute the results of Make. MABuild defaults "
					"to -Execute." } },
			notDependent {}, TriStateButtons {
				"", { {62,95,78,230}, "ExpandEnvVars", "-NoExpandEnvVars", "", "-ExpandEnvVars",
					"Expand environment vars in AppName.makeit. MABuild defaults "
					"to -NoExpandEnvVars." } },
			notDependent {}, TriStateButtons {
				"", { {78,95,94,230}, "Fail", "-NoFail", "", "-Fail",
					"Stop executing after first failure. MABuild defaults "
					"to -NoFail." } },
			notDependent {}, TriStateButtons {
				"", { {94,95,110,230}, "MacApp", "-NoMacApp", "", "-MacApp",
					"Build for use with MacApp. MABuild defaults "
					"to -MacApp." } },
			notDependent {}, TriStateButtons {
				"", { {110,95,126,230}, "StatusOnly", "-NoStatusOnly", "", "-StatusOnly",
					"Write results of Make to StdOut. MABuild defaults "
					"to -NoStatusOnly." } },
			notDependent {}, TriStateButtons {
				"", { {126,95,142,230}, "UserAutoBuild", "-NoUserAutoBuild", "", "-UserAutoBuild",
					"Auto-build user specified libraries {MAUserAutoBuild}. MABuild defaults "
					"to -UserAutoBuild." } },
					
			notDependent {}, TriStateButtons {
				"", { {30,250,46,400}, "TemplateViews", "-NoTemplateViews", "", "-TemplateViews",
					"Include code to create views from templates. MABuild defaults "
					"to -TemplateViews." } },
			
			notDependent {}, TriStateButtons {
				"", { {46,250,62,400}, "Linkmap", "-NoLinkMap", "", "-LinkMap",
					"Generate a linkmap. MABuild defaults "
					"to -NoLinkMap." } },
			
			notDependent {}, TriStateButtons {
				"", { {62,250,78,400}, "Link Cross Ref", "-NoLinkXRef", "", "-LinkXRef",
					"Generate a link cross reference. MABuild defaults "
					"to -NoLinkXRef." } },
			
			notDependent {}, TextBox {
				gray, {22, 90, 150, 405}, "The Rest of the Options" },
			notDependent {}, Box {
				gray, {30, 240, 142, 241} }
		},

		295,
		"Set the Pass-through options.",
		{
			notDependent {}, RegularEntry {
				"Asm:",
				{25, 10, 41, 60},
				{25, 60, 41, 220},
				"-case on",
				ignoreCase,
				"-Asm",
				"Passthrough options to Assembler." },
			notDependent {}, RegularEntry {
				"C:",
				{50, 10, 66, 60},
				{50, 60, 66, 220},
				"",
				ignoreCase,
				"-C",
				"Passthrough options to C compiler." },
			notDependent {}, RegularEntry {
				"C++:",
				{75, 10, 91, 60},
				{75, 60, 91, 220},
				"",
				ignoreCase,
				"-CPlus",
				"Passthrough options to C++ compiler." },
			notDependent {}, RegularEntry {
				"Lib:",
				{100, 10, 116, 60},
				{100, 60, 116, 220},
				"",
				ignoreCase,
				"-Lib",
				"Passthrough options to Librarian." },
			notDependent {}, RegularEntry {
				"Link:",
				{125, 10, 141, 60},
				{125, 60, 141, 220},
				"",
				ignoreCase,
				"-Link",
				"Passthrough options to Linker." },

			notDependent {}, RegularEntry {
				"Make:",
				{150, 10, 166, 60},
				{150, 60, 166, 220},
				"-w",
				ignoreCase,
				"-Make",
				"Passthrough options to Make." },
			notDependent {}, RegularEntry {
				"Pascal:",
				{25, 240, 41, 310},
				{25, 310, 41, 460},
				"",
				ignoreCase,
				"-Pascal",
				"Passthrough options to Pascal compiler." },
			notDependent {}, RegularEntry {
				"Rez:",
				{50, 240, 66, 310},
				{50, 310, 66, 460},
				"",
				ignoreCase,
				"-Rez",
				"Passthrough options to Resource compiler." },
			notDependent {}, RegularEntry {
				"PostRez:",
				{75, 240, 91, 310},
				{75, 310, 91, 460},
				"",
				ignoreCase,
				"-PostRez",
				"Passthrough options to PostRez tool." },
			notDependent {}, CheckOption {
				NotSet, {118,305,134,460}, "Passthru -E to Make",
					"-E",
				"Passthru -E to Make; rebuild everything regardless of dates" },
			notDependent {}, CheckOption {
				NotSet, {134,305,150,460}, "Passthru -R to Make",
					"-R",
				"Passthru -E to Make; write roots of dependency graph to output" },
			notDependent {}, CheckOption {
				NotSet, {150,305,166,460}, "Passthru -S to Make",
					"-S",
				"Passthru -E to Make; write structure of target dependencies to output" }
		},

		295,
		"Set the compiler defines and directory aliases.",
		{
			notDependent {}, MultiRegularEntry {
				"Defines:",
				{20,7,35,125},
				{20,130,90,465},
				{},
				"-d",
				"Set compile time variable name in all compilers. Use the form: "
				"name[=(TRUE|FALSE)]" },
			notDependent {}, MultiRegularEntry {
				"Directory Aliases:",
				{100,7,115,125},
				{100,130,180,465},
				{
					/*"NmDbInUnPeRaWrTrTe 'Debug Files'",
					"NmDbInUnPeRaWrTrTeSm 'SADE Debug Files'",
					"Te 'Non-Debug Files'",
					"TeSm 'SADE Non-Debug Files'"*/
				},
				"-RenameFlag",
				"Enter a Directory Alias. For example, if you needed to alias the \".SADE "
				" Debug Files\" folder, you would enter \"NmDbInUnPeRaWrTrTeSm 'SADE "
				"Debug Files'\"" },
		},
		
		295,
		"Debugging Dialog Box Help",
		{
			notDependent {}, TextTitle {
				plain, {15,10,30,470}, systemFont, systemSize,
				"Normally, when you build with debugging on, the following build"
			},
			notDependent {}, TextTitle {
				plain, {30,10,45,470}, systemFont, systemSize,
				"options are also turned on: BottleNeck, Inspector, Names, Perform,"
			},
			notDependent {}, TextTitle {
				plain, {45,10,60,470}, systemFont, systemSize,
				"Range/Overflow Check, Trace, and UnInit. Alternatively, when"
			},
			notDependent {}, TextTitle {
				plain, {60,10,75,470}, systemFont, systemSize,
				"debugging is turned off, these options are likewise turned off."
			}
		}
	}
};

resource 'PICT' (128, purgeable) {
	{3, 66, 51, 265},
	VersionTwo {
		{	/* array OpCodes: 5 elements */
			/* [1] */
			HeaderOp {
				Version2,
				0x420000,
				0x30000,
				0x1090000,
				0x330000,
				0
			},
			/* [2] */
			DefHilite {

			},
			/* [3] */
			Clip {
				{0, 56, 699, 632},
				$""
			},
			/* [4] */
			PackBitsRgn {
				200,
				{3, 66, 51, 265},
				0,
				unpacked,
				0,
				0x480000,
				0x480000,
				chunky,
				8,
				1,
				8,
				0,
				7952,
				0x877,
				-32768,
				{	/* array ColorSpec: 256 elements */
					/* [1] */
					-32768, 65535, 65535, 65535,
					/* [2] */
					-32768, 0, 26880, 65280,
					/* [3] */
					-32768, 0, 25344, 65280,
					/* [4] */
					-32768, 0, 23808, 65280,
					/* [5] */
					-32768, 0, 22016, 65280,
					/* [6] */
					-32768, 0, 20480, 65280,
					/* [7] */
					-32768, 0, 18944, 65280,
					/* [8] */
					-32768, 0, 17152, 65280,
					/* [9] */
					-32768, 0, 15616, 65280,
					/* [10] */
					-32768, 0, 13824, 65280,
					/* [11] */
					-32768, 0, 12288, 65280,
					/* [12] */
					-32768, 0, 10752, 65280,
					/* [13] */
					-32768, 0, 8960, 65280,
					/* [14] */
					-32768, 0, 7424, 65280,
					/* [15] */
					-32768, 0, 5888, 65280,
					/* [16] */
					-32768, 0, 4096, 65280,
					/* [17] */
					-32768, 0, 2560, 65280,
					/* [18] */
					-32768, 0, 768, 65280,
					/* [19] */
					-32768, 1536, 0, 65280,
					/* [20] */
					-32768, 3072, 0, 65280,
					/* [21] */
					-32768, 4864, 0, 65280,
					/* [22] */
					-32768, 6400, 0, 65280,
					/* [23] */
					-32768, 7936, 0, 65280,
					/* [24] */
					-32768, 9728, 0, 65280,
					/* [25] */
					-32768, 11264, 0, 65280,
					/* [26] */
					-32768, 13056, 0, 65280,
					/* [27] */
					-32768, 14592, 0, 65280,
					/* [28] */
					-32768, 16128, 0, 65280,
					/* [29] */
					-32768, 17920, 0, 65280,
					/* [30] */
					-32768, 19456, 0, 65280,
					/* [31] */
					-32768, 20992, 0, 65280,
					/* [32] */
					-32768, 22784, 0, 65280,
					/* [33] */
					-32768, 24320, 0, 65280,
					/* [34] */
					-32768, 26112, 0, 65280,
					/* [35] */
					-32768, 27648, 0, 65280,
					/* [36] */
					-32768, 29184, 0, 65280,
					/* [37] */
					-32768, 30976, 0, 65280,
					/* [38] */
					-32768, 32512, 0, 65280,
					/* [39] */
					-32768, 34048, 0, 65280,
					/* [40] */
					-32768, 35840, 0, 65280,
					/* [41] */
					-32768, 37376, 0, 65280,
					/* [42] */
					-32768, 39168, 0, 65280,
					/* [43] */
					-32768, 40704, 0, 65280,
					/* [44] */
					-32768, 42240, 0, 65280,
					/* [45] */
					-32768, 44032, 0, 65280,
					/* [46] */
					-32768, 45568, 0, 65280,
					/* [47] */
					-32768, 47104, 0, 65280,
					/* [48] */
					-32768, 48896, 0, 65280,
					/* [49] */
					-32768, 50432, 0, 65280,
					/* [50] */
					-32768, 52224, 0, 65280,
					/* [51] */
					-32768, 53760, 0, 65280,
					/* [52] */
					-32768, 55296, 0, 65280,
					/* [53] */
					-32768, 57088, 0, 65280,
					/* [54] */
					-32768, 58624, 0, 65280,
					/* [55] */
					-32768, 60160, 0, 65280,
					/* [56] */
					-32768, 61952, 0, 65280,
					/* [57] */
					-32768, 63488, 0, 65280,
					/* [58] */
					-32768, 65280, 0, 65280,
					/* [59] */
					-32768, 65280, 0, 63488,
					/* [60] */
					-32768, 65280, 0, 61952,
					/* [61] */
					-32768, 65280, 0, 60160,
					/* [62] */
					-32768, 65280, 0, 58624,
					/* [63] */
					-32768, 65280, 0, 57088,
					/* [64] */
					-32768, 65280, 0, 55296,
					/* [65] */
					-32768, 65280, 0, 53760,
					/* [66] */
					-32768, 65280, 0, 52224,
					/* [67] */
					-32768, 65280, 0, 50432,
					/* [68] */
					-32768, 65280, 0, 48896,
					/* [69] */
					-32768, 65280, 0, 47104,
					/* [70] */
					-32768, 65280, 0, 45568,
					/* [71] */
					-32768, 65280, 0, 44032,
					/* [72] */
					-32768, 65280, 0, 42240,
					/* [73] */
					-32768, 65280, 0, 40704,
					/* [74] */
					-32768, 65280, 0, 39168,
					/* [75] */
					-32768, 65280, 0, 37376,
					/* [76] */
					-32768, 65280, 0, 35840,
					/* [77] */
					-32768, 65280, 0, 34048,
					/* [78] */
					-32768, 65280, 0, 32512,
					/* [79] */
					-32768, 65280, 0, 30976,
					/* [80] */
					-32768, 65280, 0, 29184,
					/* [81] */
					-32768, 65280, 0, 27648,
					/* [82] */
					-32768, 65280, 0, 26112,
					/* [83] */
					-32768, 65280, 0, 24320,
					/* [84] */
					-32768, 65280, 0, 22784,
					/* [85] */
					-32768, 65280, 0, 20992,
					/* [86] */
					-32768, 65280, 0, 19456,
					/* [87] */
					-32768, 65280, 0, 17920,
					/* [88] */
					-32768, 65280, 0, 16128,
					/* [89] */
					-32768, 65280, 0, 14592,
					/* [90] */
					-32768, 65280, 0, 13056,
					/* [91] */
					-32768, 65280, 0, 11264,
					/* [92] */
					-32768, 65280, 0, 9728,
					/* [93] */
					-32768, 65280, 0, 7936,
					/* [94] */
					-32768, 65280, 0, 6400,
					/* [95] */
					-32768, 65280, 0, 4864,
					/* [96] */
					-32768, 65280, 0, 3072,
					/* [97] */
					-32768, 65280, 0, 1536,
					/* [98] */
					-32768, 65280, 0, 0,
					/* [99] */
					-32768, 65280, 1536, 0,
					/* [100] */
					-32768, 65280, 3072, 0,
					/* [101] */
					-32768, 65280, 4864, 0,
					/* [102] */
					-32768, 65280, 6400, 0,
					/* [103] */
					-32768, 65280, 7936, 0,
					/* [104] */
					-32768, 65280, 9728, 0,
					/* [105] */
					-32768, 65280, 11264, 0,
					/* [106] */
					-32768, 65280, 13056, 0,
					/* [107] */
					-32768, 65280, 14592, 0,
					/* [108] */
					-32768, 65280, 16128, 0,
					/* [109] */
					-32768, 65280, 17920, 0,
					/* [110] */
					-32768, 65280, 19456, 0,
					/* [111] */
					-32768, 65280, 20992, 0,
					/* [112] */
					-32768, 65280, 22784, 0,
					/* [113] */
					-32768, 65280, 24320, 0,
					/* [114] */
					-32768, 65280, 26112, 0,
					/* [115] */
					-32768, 65280, 27648, 0,
					/* [116] */
					-32768, 65280, 29184, 0,
					/* [117] */
					-32768, 65280, 30976, 0,
					/* [118] */
					-32768, 65280, 32512, 0,
					/* [119] */
					-32768, 65280, 34048, 0,
					/* [120] */
					-32768, 65280, 35840, 0,
					/* [121] */
					-32768, 65280, 37376, 0,
					/* [122] */
					-32768, 65280, 39168, 0,
					/* [123] */
					-32768, 65280, 40704, 0,
					/* [124] */
					-32768, 65280, 42240, 0,
					/* [125] */
					-32768, 65280, 44032, 0,
					/* [126] */
					-32768, 65280, 45568, 0,
					/* [127] */
					-32768, 65280, 47104, 0,
					/* [128] */
					-32768, 65280, 48896, 0,
					/* [129] */
					-32768, 65280, 50432, 0,
					/* [130] */
					-32768, 65280, 52224, 0,
					/* [131] */
					-32768, 65280, 53760, 0,
					/* [132] */
					-32768, 65280, 55296, 0,
					/* [133] */
					-32768, 65280, 57088, 0,
					/* [134] */
					-32768, 65280, 58624, 0,
					/* [135] */
					-32768, 65280, 60160, 0,
					/* [136] */
					-32768, 65280, 61952, 0,
					/* [137] */
					-32768, 65280, 63488, 0,
					/* [138] */
					-32768, 65280, 65280, 0,
					/* [139] */
					-32768, 63488, 65280, 0,
					/* [140] */
					-32768, 61952, 65280, 0,
					/* [141] */
					-32768, 60160, 65280, 0,
					/* [142] */
					-32768, 58624, 65280, 0,
					/* [143] */
					-32768, 57088, 65280, 0,
					/* [144] */
					-32768, 55296, 65280, 0,
					/* [145] */
					-32768, 53760, 65280, 0,
					/* [146] */
					-32768, 52224, 65280, 0,
					/* [147] */
					-32768, 50432, 65280, 0,
					/* [148] */
					-32768, 48896, 65280, 0,
					/* [149] */
					-32768, 47104, 65280, 0,
					/* [150] */
					-32768, 45568, 65280, 0,
					/* [151] */
					-32768, 44032, 65280, 0,
					/* [152] */
					-32768, 42240, 65280, 0,
					/* [153] */
					-32768, 40704, 65280, 0,
					/* [154] */
					-32768, 39168, 65280, 0,
					/* [155] */
					-32768, 37376, 65280, 0,
					/* [156] */
					-32768, 35840, 65280, 0,
					/* [157] */
					-32768, 34048, 65280, 0,
					/* [158] */
					-32768, 32512, 65280, 0,
					/* [159] */
					-32768, 30976, 65280, 0,
					/* [160] */
					-32768, 29184, 65280, 0,
					/* [161] */
					-32768, 27648, 65280, 0,
					/* [162] */
					-32768, 26112, 65280, 0,
					/* [163] */
					-32768, 24320, 65280, 0,
					/* [164] */
					-32768, 22784, 65280, 0,
					/* [165] */
					-32768, 20992, 65280, 0,
					/* [166] */
					-32768, 19456, 65280, 0,
					/* [167] */
					-32768, 17920, 65280, 0,
					/* [168] */
					-32768, 16128, 65280, 0,
					/* [169] */
					-32768, 14592, 65280, 0,
					/* [170] */
					-32768, 13056, 65280, 0,
					/* [171] */
					-32768, 11264, 65280, 0,
					/* [172] */
					-32768, 9728, 65280, 0,
					/* [173] */
					-32768, 7936, 65280, 0,
					/* [174] */
					-32768, 6400, 65280, 0,
					/* [175] */
					-32768, 4864, 65280, 0,
					/* [176] */
					-32768, 3072, 65280, 0,
					/* [177] */
					-32768, 1536, 65280, 0,
					/* [178] */
					-32768, 0, 65280, 0,
					/* [179] */
					-32768, 0, 65280, 1536,
					/* [180] */
					-32768, 0, 65280, 3072,
					/* [181] */
					-32768, 0, 65280, 4864,
					/* [182] */
					-32768, 0, 65280, 6400,
					/* [183] */
					-32768, 0, 65280, 7936,
					/* [184] */
					-32768, 0, 65280, 9728,
					/* [185] */
					-32768, 0, 65280, 11264,
					/* [186] */
					-32768, 0, 65280, 13056,
					/* [187] */
					-32768, 0, 65280, 14592,
					/* [188] */
					-32768, 0, 65280, 16128,
					/* [189] */
					-32768, 0, 65280, 17920,
					/* [190] */
					-32768, 0, 65280, 19456,
					/* [191] */
					-32768, 0, 65280, 20992,
					/* [192] */
					-32768, 0, 65280, 22784,
					/* [193] */
					-32768, 0, 65280, 24320,
					/* [194] */
					-32768, 0, 65280, 26112,
					/* [195] */
					-32768, 0, 65280, 27648,
					/* [196] */
					-32768, 0, 65280, 29184,
					/* [197] */
					-32768, 0, 65280, 30976,
					/* [198] */
					-32768, 0, 65280, 32512,
					/* [199] */
					-32768, 0, 65280, 34048,
					/* [200] */
					-32768, 0, 65280, 35840,
					/* [201] */
					-32768, 0, 65280, 37376,
					/* [202] */
					-32768, 0, 65280, 39168,
					/* [203] */
					-32768, 0, 65280, 40704,
					/* [204] */
					-32768, 0, 65280, 42240,
					/* [205] */
					-32768, 0, 65280, 44032,
					/* [206] */
					-32768, 0, 65280, 45568,
					/* [207] */
					-32768, 0, 65280, 47104,
					/* [208] */
					-32768, 0, 65280, 48896,
					/* [209] */
					-32768, 0, 65280, 50432,
					/* [210] */
					-32768, 0, 65280, 52224,
					/* [211] */
					-32768, 0, 65280, 53760,
					/* [212] */
					-32768, 0, 65280, 55296,
					/* [213] */
					-32768, 0, 65280, 57088,
					/* [214] */
					-32768, 0, 65280, 58624,
					/* [215] */
					-32768, 0, 65280, 60160,
					/* [216] */
					-32768, 0, 65280, 61952,
					/* [217] */
					-32768, 0, 65280, 63488,
					/* [218] */
					-32768, 0, 65280, 65280,
					/* [219] */
					-32768, 0, 63488, 65280,
					/* [220] */
					-32768, 0, 61952, 65280,
					/* [221] */
					-32768, 0, 60160, 65280,
					/* [222] */
					-32768, 0, 58624, 65280,
					/* [223] */
					-32768, 0, 57088, 65280,
					/* [224] */
					-32768, 0, 55296, 65280,
					/* [225] */
					-32768, 0, 53760, 65280,
					/* [226] */
					-32768, 0, 52224, 65280,
					/* [227] */
					-32768, 0, 50432, 65280,
					/* [228] */
					-32768, 0, 48896, 65280,
					/* [229] */
					-32768, 0, 47104, 65280,
					/* [230] */
					-32768, 0, 45568, 65280,
					/* [231] */
					-32768, 0, 44032, 65280,
					/* [232] */
					-32768, 0, 42240, 65280,
					/* [233] */
					-32768, 0, 40704, 65280,
					/* [234] */
					-32768, 0, 39168, 65280,
					/* [235] */
					-32768, 0, 37376, 65280,
					/* [236] */
					-32768, 0, 35840, 65280,
					/* [237] */
					-32768, 0, 34048, 65280,
					/* [238] */
					-32768, 0, 32512, 65280,
					/* [239] */
					-32768, 0, 30976, 65280,
					/* [240] */
					-32768, 0, 29184, 65280,
					/* [241] */
					-32768, 61440, 61440, 61440,
					/* [242] */
					-32768, 57344, 57344, 57344,
					/* [243] */
					-32768, 53248, 53248, 53248,
					/* [244] */
					-32768, 49152, 49152, 49152,
					/* [245] */
					-32768, 45056, 45056, 45056,
					/* [246] */
					-32768, 40960, 40960, 40960,
					/* [247] */
					-32768, 36864, 36864, 36864,
					/* [248] */
					-32768, 32768, 32768, 32768,
					/* [249] */
					-32768, 28672, 28672, 28672,
					/* [250] */
					-32768, 24576, 24576, 24576,
					/* [251] */
					-32768, 20480, 20480, 20480,
					/* [252] */
					-32768, 16384, 16384, 16384,
					/* [253] */
					-32768, 12288, 12288, 12288,
					/* [254] */
					-32768, 8192, 8192, 8192,
					/* [255] */
					-32768, 4096, 4096, 4096,
					/* [256] */
					-32768, 0, 0, 0
				},
				{3, 66, 51, 265},
				{3, 66, 51, 265},
				srcCopy,
				{3, 66, 51, 265},
				$"",
				$"10 81 00 C9 00 FB 01 02 00 01 01 FD 00 02 01 01 B7 12 81 00 C7 00 01 0A 0A FE 00 FE 0A 01 00 00"
				$"FE 0A 00 0D 0D 81 00 C7 00 01 13 13 FE 00 F9 13 00 FB 13 81 00 C7 00 01 1C 1C FE 00 08 1C 1C 00"
				$"1C 1C 00 1C 1C E1 1B F7 01 F1 00 F7 01 BE 00 01 01 01 B0 00 01 26 26 FE 00 01 26 26 FD 00 02 26"
				$"26 FD 1B F7 03 F1 00 F7 03 BE 00 01 03 03 B0 00 01 2F 2F FE 00 01 2F 2F FD 00 02 2F 2F FF 1D 01"
				$"00 00 F8 05 F2 00 F9 05 BC 00 FE 05 B1 00 01 38 38 FE 00 01 38 38 FD 00 02 38 38 C6 11 01 00 00"
				$"F8 07 F2 00 F9 07 BC 00 FE 07 A4 00 00 FF 11 01 00 00 F7 09 F4 00 F8 09 BD 00 FC 09 A5 00 00 FB"
				$"11 01 00 00 F7 0B F4 00 F8 0B BD 00 FC 0B A5 00 00 A7 11 01 00 00 F6 0D F6 00 F7 0D BE 00 FA 0D"
				$"A6 00 00 D0 11 01 00 00 F6 0F F6 00 F7 0F BE 00 FA 0F A6 00 00 FB 29 01 00 00 F5 11 F8 00 F6 11"
				$"F3 00 F7 01 F1 00 F5 01 F3 00 F8 11 F0 00 FB 01 FD 00 FB 01 F3 00 FB 01 FD 00 FB 01 E6 00 00 EB"
				$"2A 01 00 00 F5 13 F8 00 F6 13 F5 00 F4 04 F4 00 F2 04 F4 00 F8 13 F2 00 F9 03 FE 00 F8 03 F6 00"
				$"FA 03 01 00 00 F7 03 E8 00 00 C1 2D 01 00 00 F4 15 FA 00 F5 15 F7 00 FA 06 FE 00 FB 06 F7 00 FA"
				$"06 FE 00 F9 06 F6 00 FE 15 00 00 FA 15 F5 00 E9 05 FB 00 E9 05 EA 00 00 FF 2D 01 00 00 F4 17 FA"
				$"00 F5 17 F8 00 FA 09 FD 00 FB 09 F8 00 FA 09 FC 00 FA 09 F6 00 FE 17 00 00 FA 17 F5 00 E8 06 FC"
				$"00 E8 06 EB 00 00 F8 3D 01 00 00 FD 19 00 00 F8 19 FC 00 FD 19 00 00 F9 19 F9 00 F9 0C FD 00 FB"
				$"0C F9 00 FA 0C FA 00 FB 0C F7 00 FE 19 FE 00 FA 19 F4 00 F7 08 FB 00 F9 08 FB 00 F7 08 FB 00 F9"
				$"08 EC 00 00 A2 3D 01 00 00 FD 1B 00 00 F8 1B FC 00 FD 1B 00 00 F9 1B F9 00 FA 0E FC 00 FB 0E F9"
				$"00 FB 0E F8 00 FC 0E F7 00 FE 1B FE 00 FA 1B F4 00 F8 0A F9 00 F9 0A FC 00 F8 0A F9 00 F9 0A ED"
				$"00 00 21 3F 01 00 00 FD 1D 01 00 00 F8 1D FE 00 FD 1D 01 00 00 F9 1D F9 00 FB 11 FB 00 FB 11 FA"
				$"00 FA 11 F7 00 FD 11 F8 00 FE 1D FC 00 FA 1D F5 00 F9 0C F7 00 FA 0C FC 00 F9 0C F7 00 FA 0C ED"
				$"00 00 F9 40 01 00 00 FD 1F 01 00 00 F8 1F FE 00 FD 1F 01 00 00 F9 1F F8 00 FD 14 FB 00 FA 14 FA"
				$"00 FA 14 F6 00 01 14 14 F7 00 FE 1F FC 00 FA 1F F5 00 F9 0D F7 00 F9 0D FD 00 F9 0D F7 00 F9 0D"
				$"EE 00 00 F4 35 01 00 00 FD 21 FE 00 F8 21 00 00 FD 21 FE 00 F9 21 EF 00 F9 16 FB 00 F9 16 EB 00"
				$"FE 21 FA 00 FA 21 F6 00 F9 0F F7 00 F9 0F FD 00 F9 0F F7 00 F9 0F EE 00 00 FF 35 01 00 00 FD 23"
				$"FE 00 F8 23 00 00 FD 23 FE 00 F9 23 F0 00 F8 19 FB 00 F9 19 EB 00 FE 23 FA 00 FA 23 F6 00 F9 11"
				$"F7 00 F9 11 FD 00 F9 11 F7 00 F9 11 EE 00 00 23 31 01 00 00 FD 25 FD 00 F5 25 FD 00 F9 25 F1 00"
				$"F7 1C FB 00 F9 1C EC 00 FE 25 F8 00 FA 25 F7 00 F9 13 F7 00 F9 13 FD 00 F9 13 F7 00 F9 13 EE 00"
				$"00 F8 35 01 00 00 FD 27 FD 00 F5 27 FD 00 F9 27 F3 00 FC 1E 00 00 FB 1E FB 00 F9 1E EC 00 FE 27"
				$"F8 00 FA 27 F7 00 F9 15 F7 00 F9 15 FD 00 F9 15 F7 00 F9 15 EE 00 00 FF 32 01 00 00 FD 29 FC 00"
				$"F7 29 FC 00 F9 29 F5 00 FB 21 01 00 00 FB 21 FB 00 F9 21 ED 00 EC 29 F8 00 F9 16 F7 00 F9 16 FD"
				$"00 F9 16 F7 00 F9 16 EE 00 00 F7 31 01 00 00 FD 2B FC 00 F7 2B FC 00 F9 2B F6 00 FB 24 FE 00 FB"
				$"24 FB 00 F9 24 ED 00 EC 2B F8 00 F9 18 F7 00 F9 18 FD 00 F9 18 F7 00 F9 18 EE 00 00 9B 35 01 00"
				$"00 FD 2D FB 00 F9 2D FB 00 F9 2D F7 00 FB 26 FD 00 FB 26 FB 00 F8 26 EF 00 FE 2D F5 00 F9 2D F9"
				$"00 F9 1A F7 00 F9 1A FD 00 F9 1A F7 00 F9 1A EE 00 00 F5 35 01 00 00 FD 2F FB 00 F9 2F FB 00 F9"
				$"2F F8 00 FB 29 FC 00 FB 29 FB 00 F8 29 EF 00 FE 2F F5 00 F9 2F F9 00 F9 1C F7 00 F9 1C FD 00 F9"
				$"1C F7 00 F9 1C EE 00 00 FD 35 01 00 00 FD 31 FA 00 FB 31 FA 00 F9 31 F9 00 FB 2C FB 00 FB 2C FA"
				$"00 F8 2C F1 00 FE 31 F3 00 F9 31 FA 00 F9 1D F7 00 FA 1D FC 00 F9 1D F7 00 FA 1D ED 00 00 F6 35"
				$"01 00 00 FD 33 FA 00 FB 33 FA 00 F9 33 F9 00 FB 2E FB 00 FB 2E FA 00 F8 2E F1 00 FE 33 F3 00 F9"
				$"33 FA 00 F9 1F F7 00 FA 1F FC 00 F9 1F F7 00 FA 1F ED 00 00 98 3D 01 00 00 FD 35 F9 00 FD 35 F9"
				$"00 F9 35 F9 00 FB 31 FC 00 FA 31 FE 00 00 31 FD 00 F8 31 F7 00 00 31 FE 00 FE 35 F1 00 F9 35 FB"
				$"00 F9 21 F8 00 FA 21 FB 00 F9 21 F8 00 FA 21 EC 00 00 2B 3F 01 00 00 FD 37 F9 00 FD 37 F9 00 F9"
				$"37 F9 00 FA 34 FE 00 F9 34 03 00 00 34 34 FD 00 F7 34 F9 00 01 34 34 FE 00 FE 37 F1 00 F9 37 FB"
				$"00 F9 23 F9 00 F9 23 FB 00 F9 23 F9 00 F9 23 EC 00 00 F9 32 01 00 00 FD 39 F8 00 01 39 39 F8 00"
				$"F9 39 F9 00 EB 36 FC 00 EF 36 FE 00 FE 39 EF 00 F8 39 FD 00 F8 25 FB 00 F9 25 FA 00 F8 25 FB 00"
				$"F9 25 EB 00 00 FF 32 01 00 00 FD 3B F8 00 01 3B 3B F8 00 F9 3B F9 00 EC 39 FA 00 F1 39 FD 00 FE"
				$"3B EF 00 F8 3B FD 00 F7 26 FD 00 F9 26 F9 00 F7 26 FD 00 F9 26 EA 00 00 FF 27 F9 3D F1 00 F5 3D"
				$"FA 00 F7 3C FE 00 FB 3C F7 00 F4 3C FE 00 F9 3D F5 00 F3 3D 01 00 00 ED 28 F7 00 ED 28 E8 00 00"
				$"6E 27 F9 3F F1 00 F5 3F F9 00 F9 3E FD 00 FC 3E F4 00 F7 3E FD 00 F9 3F F5 00 F3 3F 01 00 00 EF"
				$"2A F5 00 EF 2A E6 00 00 F5 0C 85 00 F9 2C EB 00 F9 2C DC 00 00 FF 0C 85 00 F9 2D EB 00 F9 2D DC"
				$"00 00 30 0C 85 00 F9 2F EB 00 F9 2F DC 00 00 78 0C 85 00 F9 31 EB 00 F9 31 DC 00 00 F1 0C 85 00"
				$"F9 33 EB 00 F9 33 DC 00 00 50 0C 85 00 F9 35 EB 00 F9 35 DC 00 00 FF 0C 85 00 F9 36 EB 00 F9 36"
				$"DC 00 00 F2 0C 85 00 F9 38 EB 00 F9 38 DC 00 00 64 0C 85 00 F9 3A EB 00 F9 3A DC 00 00 46 0C 85"
				$"00 F9 3C EB 00 F9 3C DC 00 00 80 0C 87 00 F5 3D EF 00 F5 3D DE 00 00 FF 0C 87 00 F5 3F EF 00 F5"
				$"3F DE 00 00 6E"
			},
			/* [5] */
			OpEndPic {

			}
		}
	}
};

