(***********************)
(* methods for TMyList *)
(***********************)
	
{$S AWriteFile}
FUNCTION TMyList.ReturnBytes: LONGINT;

	VAR
		bytesToStoreList: INTEGER;

	PROCEDURE CalculateBytes(theItem: TItem);
	
		BEGIN
			bytesToStoreList:= bytesToStoreList + theItem.ReturnBytes;
		END;	{CalculateBytes}

	BEGIN
		bytesToStoreList:= 0;
		SELF.Each(CalculateBytes);
		ReturnBytes:= bytesToStoreList;
	END;	{TMyList.ReturnBytes}


(*****************************)
(* methods for TMyMethodList *)
(*****************************)

{$S ARes}
FUNCTION TMyMethodList.FindFieldsMethod: TMethodItem;

	VAR
		aMethodItem: TMethodItem;

	BEGIN
		aMethodItem:= NIL;
		IF SELF.GetSize > 0 THEN
			BEGIN
				aMethodItem:= TMethodItem(SELF.Last);
				IF aMethodItem.GetTheItem <> 'Fields' THEN
					aMethodItem:= NIL;
			END;
		FindFieldsMethod:= aMethodItem;
	END;	{TMyMethodList.FindFieldsMethod}
	
{$S ARes}
PROCEDURE TMyMethodList.InsertLast(item: TObject); OVERRIDE;

	VAR
		possibleFieldsMethodItem: TMethodItem;

	BEGIN
		possibleFieldsMethodItem:= SELF.FindFieldsMethod;
		IF possibleFieldsMethodItem <> NIL THEN
			BEGIN
				SELF.AtDelete(SELF.GetSize);
				INHERITED InsertLast(item);
				INHERITED InsertLast(possibleFieldsMethodItem);
			END
		ELSE
			INHERITED InsertLast(item);
	END;	{TMyMethodList.InsertLast}
	
{$S ARes}
FUNCTION TMyMethodList.GetNumRealMethods: integer;

	VAR
		TempNumMethods: integer;
		
	PROCEDURE AddUpRealMethods(theMethodItem: TMethodItem);
	
		BEGIN
			TempNumMethods:= TempNumMethods + theMethodItem.GetNumRealMethods;
		END;

	BEGIN
		TempNumMethods:= 0;
		SELF.Each(AddUpRealMethods);
		GetNumRealMethods:= TempNumMethods;
	END;	{TMyMethodList.GetNumRealMethods}

	
(***********************************)
(* methods for TCRCCardApplication *)
(***********************************)
{$S AInit}
PROCEDURE TCRCCardsApplication.ICRCCardsApplication(designFileType: OSType);

	CONST
		kTabASCIICode = 9;
		
	VAR
		aSimpleCardView: TSimpleView;
		aEditView: TEditView;
		aDesignView: TDesignView;
		aTextListView: TMyTextListView;
		aParenStaticTextView: TParenStaticText;
		aTEView: TMyTEView;
		aStringHandle: StringHandle;
		aNewFieldButton: TNewFieldButton; 
		aNewMethodButton: TNewMethodButton;
		aNewCollaboratorButton: TNewCollaboratorButton;
		aCardWindow: TCardWindow;
		aFieldTextListView: TFieldTextListView;
		aMethodTextListView: TMethodTextListView;
		aCollaboratorTextListView: TCollaboratorTextListView;
		aPopText: TPopText;
		
	BEGIN
		IApplication(designFileType);
		IF gDeadStripSuppression THEN
			BEGIN
				NEW(aSimpleCardView);
				NEW(aEditView);
				NEW(aDesignView);
				NEW(aTextListView);
				NEW(aParenStaticTextView);
				NEW(aTEView);
				NEW(aNewFieldButton);
				NEW(aNewMethodButton);
				NEW(aNewCollaboratorButton);
				NEW(aCardWindow);
				NEW(aFieldTextListView);
				NEW(aMethodTextListView);
				NEW(aCollaboratorTextListView);
				NEW(aPopText);
			END;
		
		aStringHandle:= GetString(kEndOfLineID);
		FailResError;
		gEndOfLineStr:= aStringHandle^^;
		gOneTabStr:= char(kTabASCIICode);
		
	END;   {TCRCCardsApplication.ICRCCardsApplication}

{$S AOpen}
FUNCTION  TCRCCardsApplication.DoMakeDocument(itsCmdNumber: CmdNumber):TDocument; OVERRIDE;

	VAR 
		aDesignDocument:	TDesignDocument;

	BEGIN
		NEW(aDesignDocument);
		FailNil(aDesignDocument);
		aDesignDocument.IDesignDocument;
		DoMakeDocument := aDesignDocument;
	END;   {TCRCCardsApplication.DoMakeDocument}