Unit UCRCCards;

INTERFACE

USES
	UMacApp,
	ToolUtils,
	Resources,
	Packages,
	UPrinting,
	UTEView,
	UDialog,
	UGridView,
	UPopText,
	UItem,
	UCard,
	UDesignDocument,
	UMyViews,
	UMyCommands,
	UTextHandler;
	
CONST
	kBlankLine = '-';  {This causes a seperator line in a menu}
	kClassPrefix = 'T';
	kFieldPrefix = 'f';
	kGetAccessorPrefix = 'Get';
	kSetAccessorPrefix = 'Set';
	kFileType = 'desg';
	kSignature = 'crcc';
	kMPWFileType = 'TEXT';
	kMPWSignature = 'MPS ';
	kStringSize = SIZEOF(str255);
	kNoCards = 0;
	kCardNotFound = 0;
	kNoItems = 0;
	kDesignWindowID = 1000;
		kDesignViewResID = 'dsgn';
	kEditViewID = 1001;
		kFieldViewResID = 'feld';
		kMethodViewResID = 'meth';
		kCollaboratorViewResID = 'coll';
	kSimpleViewID = 1002;
		kSimpleViewResID = 'scrd';
		kClassNameViewID = 'ctxt';
		kSuperNameViewID = 'stxt';
		kIconViewID = 'icon';
	kMPWTEViewID = 1003;
		kMPWTEViewIdentifier = 'TEVW';
	kFieldEditID = 1005;
		kEditItemView = 'Iedt';
		kNameField = 'Inme';
		kTypeField = 'Ityp';
	kCollaboratorEditID = 1005;	
	kBeginning = 0;
	kEnd = maxInt;
	kOneClick = 1;
	kTwoClicks = 2;
	
	{editView text list view identifiers}
	kEditViewNameID = 'card';
	kFieldListID = 'feld';
	kMethodListID = 'meth';
	kCollaboratorListID = 'coll';
	
	{editView items identifiers}
	kClassEntryID = 'ctxt';
	kSuperClassEntryID = 'stxt';
	kFieldEntryID = 'ftxt';
	kCollaboratorEntryID = 'ltxt';
	kFieldTypeEntryID = 'ttxt';
	kMethodEntryID = 'mtxt';
	
	{editView button identifiers}
	kFieldButtonID = 'fbtn';
	kMethodButtonID = 'mbtn';
	kCollaboratorButtonID = 'cbtn';
	
	{miscellaneous other views}
	kTypeClusterID = 'clus';
	kItemTypeMenuID = 'tmnu';
	kSuperClassTypeMenuID = 'smnu';
	kOVERRIDEBoxID = 'over';
	kFieldEntryNameID = 'tnme';
	kFieldTypeEntryNameID = 'ttyp';
	
	{edit mode constants for the edit cluster}
	kBlankMode = 0;
	kFieldsMode = 1;
	kMethodsMode  = 2;
	kCollaboratorsMode = 3;
	
	{commands}
	cNewCardCmd = 1001;
	cDeleteCardCmd = 1002;
	cEditCardCmd = 1003;
	cWriteCodeCmd = 1004;
	cDelFieldCmd = 1005;
	cDelMethodCmd = 1006;
	cDelCollaboratorCmd = 1007;
	cAddFieldCmd = 1008;
	cAddMethodCmd = 1009;
	cAddCollaboratorCmd = 1010;
	cMoveViewCmd = 1011;
	cInPascalCmd = 1012;
	cInCPPCmd = 1013;
	cChangeFieldCmd = 1014;
	cChangeMethodCmd = 1015;
	cChangeCollaboratorCmd = 1016;
	cGetNewPreferencesCmd = 1017;
	cChangeNameCmd = 1018;
	cChangeSuperClassCmd = 1019;
	
	kOneItem = 1;
	kNoItemSelected = 0;
	kNoChanges = 0;
	kPrintInfoRsrcType	= 'PRNT';
	kPrintInfoRsrcID	= 1;
	
	kEmptyString = '';
	kUseImmediateSuperView = TRUE;
	kStartingClass = 'TClassName';
	kStartingSuperClass = 'TObject';
	kEndOfLineID = 1010;
	kHeadingID = 1020;
	kTypeDefID = 1030;
	kFieldsInterfaceID = 1040;
	kMethodsInterfaceID = 1050;
	kCollaboratorsInterfaceID = 1060;
	kEndOfTypeDefID = 1070;
	kStdMethID = 1080;
	kOverrideMethID = 1090;
	kGetAccessorID = 1100;
	kSetAccessorID = 1110;
	kImplementationID = 1120;
	kUnitEndStr = 1130;
	kImplementationNoteID = 1140;
	kImplIncFilesID = 1145;
	kGetAccessorImplementationID = 1150;
	kStdMethodImplementationID = 1160;
	kFieldsMethodDecStr = 1170;
	kFieldsMethodImpStr1 = 1180;
	kFieldsMethodImpStr2 = 1185;
	kFieldsMethodImpStr3 = 1190;
	kFieldsMethodCodeLineStr = 1200;
	kIncludeStatementID = 1210;
	kFieldItemDeclarationStrID = 1220;
	kCollaboratordeclarationStrID = 1230;
	kImplementationFileNameID	= 1240;
	kInterfaceFileNameID = 1250;
	kLFAndIndentStr = 1260;
	kSetAccessorImplementationID = 1270;
	kFieldItemImplDeclarationStrID = 1280;
	kStdImplMethID = 1290;
	kOverrideImplMethID = 1300;
	kImplFieldsMethodDecStr = 1310;
	kImplGetAccessorID = 1320;
	kImplSetAccessorID = 1330;
	kImplCollaboratorDeclarationStrID = 1340;
	kInlineGetAccessorID = 1350;
	kInlineSetAccessorID = 1360;
	kFwdClassDeclID = 1370;
	
	kDontExtendSel = FALSE;
	kHiLite = TRUE;
	kDim = TRUE;
	kDontSelect = FALSE;
	kImediateSuperView = TRUE;
	kIsSelected = TRUE;
	kConstrainDrags = TRUE;
	kDragging = TRUE;
	kOVERRIDE = TRUE;
	kUseMinimalMargins = TRUE;

	
TYPE
	TMyList = OBJECT(TList)
		FUNCTION TMyList.ReturnBytes: LONGINT;
	END;
	
	TMyMethodList = OBJECT(TMyList)
		FUNCTION TMyMethodList.FindFieldsMethod: TMethodItem;
		PROCEDURE TMyMethodList.InsertLast(item: TObject); OVERRIDE;
		FUNCTION TMyMethodList.GetNumRealMethods: integer;
	END;
	
	TCRCCardsApplication = OBJECT(TApplication)
		PROCEDURE TCRCCardsApplication.ICRCCardsApplication(designFileType: OSType);
		FUNCTION TCRCCardsApplication.DoMakeDocument(itsCmdNumber: CmdNumber): TDocument; OVERRIDE;
	END;

VAR
	gEndOfLineStr: str255;
	gOneTabStr: str255;
	
IMPLEMENTATION

{$I UCRCCards.inc1.p}			(* the list, view, text list view and application stuff *)

END.