/* Copyright  1988-1991 Apple Computer, Inc.  All rights reserved. */

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#if qTemplateViews
#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif
#endif

#ifndef __BalloonTypes__
#include "BalloonTypes.r"
#endif

#if qDebug
include "Debug.rsrc";
#endif
include "MacApp.rsrc";
include "Dialog.rsrc";

include "FloatWindow.rsrc";
#define kWindoidWDEF			48				// the default windoid WDEF proc ID
#define kWindoidHilite			 1				// add this to kWindoidWDEF if the title bar can be unhilited
#define kWindoidTallTitleBar	 2				// add this to kWindoidWDEF if the title bar has a title
#define kWindoidNotResizable	 4				// add this to kWindoidWDEF if the windoid is NOT resizable
#define kWindoidZoomable		 8				// add this to kWindoidWDEF if the windoid is zoomable

include $$Shell("ObjApp")"DemoDialogs" 'CODE';

/* Resource IDs */

#define kTestIcon			1000
#define kTestPopup			 235
#define kBaudPopup			 236
#define kParityPopup		 237
#define	kPopup			 	238

// to support the TextStyle popup
#define kTextStylePopup		 239
#define kFontHier			 230
#define kStyleHier			 231
#define kSizeHier			 232

#define kTestPicture		1000
#define kTestStrings		1000
#define kCalcPicture		1009

#define mDialogs			4		//	ID of the "Dialogs" menu

/* Command numbers */

#define cProcedureViews		1001
#define cTemplateViews		1002
#define cMonthlyDialog		1003
#define cSaveDialog			1004
#define	cMarkDialog			1005
#define cPageSetupDialog	1006
#define cHomeBrewControls	1007
#define cTabbingTest		1008
#define cCalculator			1009
#define cScrollingTest		1011
#define cFormatDialog		1012
#define cModelessMarkDialog	1013
#define cMessageWindoid		1014
#define cAdornment			1015
#define cPopupExample		1100
#define cCluster			1101
#define cTextStyleChanged	1102
#define cResetTextStyle		1103

resource 'seg!' (256, purgeable) {
	{
		"GOpen";
		"GClose";
		"GNonRes";
		"GSelCommand";
		"GDoCommand"
	}
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,				
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	500 * 1024,
	400 * 1024
#else
	290 * 1024,
	218 * 1024
#endif
};

resource 'DITL' (phAboutApp, purgeable) {
	 {
/* [1] */	{160, 182, 180, 262}, Button { enabled, "OK" };
/* [2] */	{8, 70, 152, 316}, StaticText { disabled, 
	"This program has several examples of MacApp dialogs." 
	"\n\nThis program was written "
	"with MacApp  1985-1991 Apple Computer, Inc."};
/* [3] */	{10, 20, 42, 52}, Icon { disabled, 1 }
	}
};

resource 'ALRT' (1000, purgeable) {
	{44, 48, 130, 358},
	1000,
	{
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1
	}
#if SystemSevenOrLater
	,
	alertPositionMainScreen
#endif
};

include "Defaults.rsrc"  'ALRT' (phAboutApp);	// Grab the default about box

include "Defaults.rsrc" 'CMNU' (mApple);		// Grab the default Apple menu

resource 'CMNU' (mFile,
#if qNames
"mFile",
#endif
nonpurgeable) {
	mFile,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"File",
	{
	"Close",			noIcon, "W",	noMark, plain, cClose;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Page Setup",		noIcon, noKey,	noMark, plain, cPageSetup;
	"Print One",		noIcon, noKey,	noMark, plain, cPrintOne;
	"Print",			noIcon, "P",	noMark, plain, cPrint;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Quit",				noIcon, "Q",	noMark, plain, cQuit
	}
};

include "Defaults.rsrc" 'CMNU' (mEdit);		// Grab the default Edit menus

resource 'CMNU' (mDialogs,
#if qNames
"mDialogs",
#endif
nonpurgeable) {
	mDialogs,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Dialogs",
	 {
/* [1] */	"Views by Procedures",		noIcon, noKey, noMark, plain, cProcedureViews;
/* [2] */	"Views by Templates",		noIcon, noKey, noMark, plain, cTemplateViews;
/* [3] */	"Side-by-Side Scrolling",	noIcon, noKey, noMark, plain, cScrollingTest;
/* [4] */	"Monthly Values Dialog",	noIcon, noKey, noMark, plain, cMonthlyDialog;
/* [5] */	"Save Dialog",				noIcon, noKey, noMark, plain, cSaveDialog;
/* [6] */	"Mark Dialog",				noIcon, noKey, nomark, plain, cMarkDialog;
/* [7] */	"Modeless Mark Dialog",		noIcon, noKey, nomark, plain, cModelessMarkDialog;
/* [8] */	"Message Windoid",			noIcon, noKey, nomark, plain, cMessageWindoid;
/* [9] */	"Adorners & Balloons",		noIcon, noKey, nomark, plain, cAdornment;
/* [10] */	"Page Setup Dialog",		noIcon, noKey, nomark, plain, cPageSetupDialog;
/* [11] */	"Format Dialog",			noIcon, noKey, nomark, plain, cFormatDialog;
/* [12] */	"Home Brew Controls",		noIcon, noKey, nomark, plain, cHomeBrewControls;
/* [13] */	"Tabbing Test",				noIcon, noKey, nomark, plain, cTabbingTest;
/* [14] */	"Calculator Test",			noIcon, noKey, noMark, plain, cCalculator
	}
};

include "Defaults.rsrc" 'CMNU' (mBuzzwords);	// Get the default buzzwords menu

resource 'CMNU' (kTestPopup) {
	kTestPopup,
	textMenuProc,
	allEnabled,
	enabled,
	"Popup:",
	{
/* [1] */	"Item 1", 	noIcon, "", "", plain, nocommand;
/* [2] */	"Item 2", 	noIcon, "", "", plain, nocommand;
/* [3] */	"Item 3", 	noIcon, "", "", plain, nocommand;
/* [4] */	"Item 4", 	noIcon, "", "", plain, nocommand;
/* [5] */	"Item 5", 	noIcon, "", "", plain, nocommand;
/* [6] */	"Item 6", 	noIcon, "", "", plain, nocommand;
/* [7] */	"Item 7", 	noIcon, "", "", plain, nocommand;
/* [8] */	"Item 8", 	noIcon, "", "", plain, nocommand
	}
};

resource 'mctb' (kTestPopup) { {
		kTestPopup, 0,
		{
		0x9999, 0x0000, 0x9999;			/* title color */
		0xFFFF, 0x6666, 0x0000;			/* "menu bar" color */
		0x0000, 0x6666, 0xFFFF;			/* default item color */
		0xFFFF, 0xFFFF, 0x0000			/* default menu background color */
		};

		kTestPopup, 3,
		{
		0xFFFF, 0x0000, 0x0000;			/* mark color */
		0xFFFF, 0x0000, 0x0000;			/* name color */
		0xFFFF, 0x0000, 0x0000;			/* command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* NFG!!! */
		}
} };

resource 'CMNU' (kBaudPopup) {
	kBaudPopup,
	textMenuProc,
	allEnabled,
	enabled,
	"Baud:",
	{
/* [1] */	"110", 	noIcon, "", "", plain, nocommand;
/* [2] */	"300", 	noIcon, "", "", plain, nocommand;
/* [3] */	"600", 	noIcon, "", "", plain, nocommand;
/* [4] */	"1200", 	noIcon, "", "", plain, nocommand
	}
};

resource 'CMNU' (kParityPopup) {
	kParityPopup,
	textMenuProc,
	allEnabled,
	enabled,
	"Parity:",
	{
/* [1] */	"Even", 	noIcon, "", "", plain, nocommand;
/* [2] */	"Odd", 	noIcon, "", "", plain, nocommand;
/* [3] */	"No", 	noIcon, "", "", plain, nocommand
	}
};

resource 'CMNU' (kPopup) {
	kPopup,
	textMenuProc,
	allEnabled,
	enabled,
	"Popup:",
	{
/* [1] */	"Plain", 	noIcon, noKey, noMark, plain, nocommand;
/* [2] */	"Bold", 	noIcon, noKey, noMark, bold, nocommand;
/* [3] */	"Italic", 	noIcon, noKey, noMark, italic, nocommand;
/* [4] */	"Underline", 	noIcon, noKey, noMark, underline, nocommand;
/* [5] */	"Outline", 	noIcon, noKey, noMark, outline, nocommand;
/* [6] */	"Shadow", 	noIcon, noKey, noMark, shadow, nocommand;
/* [7] */	"Condense", 	noIcon, noKey, noMark, condense, nocommand;
/* [8] */	"Extend", 	noIcon, noKey, noMark, extend, nocommand
	}
};

resource 'CMNU' (kTextStylePopup) {
	kTextStylePopup,
	textMenuProc,
	AllItems,	/* Disable dashed line */
	enabled,
	"Fonts:",
	{
/* [1] */	"Reset", 	noIcon, noKey, noMark, plain, cResetTextStyle;
/* [1] */	"Font:", 	noIcon, kHierarchicalMenu, "\0D230", plain, cTextStyleChanged;
/* [2] */	"Style:", 	noIcon, kHierarchicalMenu, "\0D231", plain, cTextStyleChanged;
/* [3] */	"Size:", 	noIcon, kHierarchicalMenu, "\0D232", plain, cTextStyleChanged
	}
};

resource 'CMNU' (kFontHier, "Font:") {
	kFontHier,
	textMenuProc,
	AllItems,
	enabled,
	"Font:",
	{
/* [1] */	"Chicago", 	noIcon, noKey, noMark, plain, cTextStyleChanged;
/* [2] */	"Geneva", 	noIcon, noKey, noMark, plain, cTextStyleChanged;
/* [3] */	"Helvetica", 	noIcon, noKey, noMark, plain, cTextStyleChanged
	}
};

resource 'CMNU' (kStyleHier, "Style:") {
	kStyleHier,
	textMenuProc,
	AllItems,
	enabled,
	"Just:",
	{
/* [1] */	"Plain", 	noIcon, noKey, noMark, plain, cTextStyleChanged;
/* [2] */	"Bold", 	noIcon, noKey, noMark, plain, cTextStyleChanged;
/* [3] */	"Italic", 	noIcon, noKey, noMark, plain, cTextStyleChanged;
/* [4] */	"Outline", 	noIcon, noKey, noMark, plain, cTextStyleChanged
	}
};

resource 'CMNU' (kSizeHier, "Size:") {
	kSizeHier,
	textMenuProc,
	AllItems,
	enabled,
	"Size:",
	{
/* [1] */	"9", 	noIcon, noKey, noMark, plain, cTextStyleChanged;
/* [2] */	"10", 	noIcon, noKey, noMark, plain, cTextStyleChanged;
/* [3] */	"12", 	noIcon, noKey, noMark, plain, cTextStyleChanged
	}
};

resource 'MBAR' (kMBarDisplayed,
#if qNames
"kMBarDisplayed",
#endif
nonpurgeable) {
	{mApple; mFile; mEdit; mDialogs} 
};

resource 'MBAR' (kMBarHierarchical,
#if qNames
"kMBarHierarchical",
#endif
nonpurgeable) {
	{ kFontHier, kSizeHier, kStyleHier, kTestPopup, kBaudPopup, kParityPopup, kPopup, kTextStylePopup } 
};

resource 'STR#' (kTestStrings, purgeable) { {
	"Scroll me vertically\n\n(P.S. This should read 'PARAM0': ^0\nThis should read 'PARAM1': ^1\nThis should read 'PARAM0': ^0)";
	"A static string"
} };

/************************************************************************************/
/*	Views by procedure																*/
/************************************************************************************/
resource 'WIND' (cProcedureViews, purgeable) {
	{50, 20, 310, 450}, zoomDocProc, invisible, goAway, 0x0, "Views by Procedure"
#if SystemSevenOrLater
	, centerMainScreen
#endif
};

/************************************************************************************/
/*	Views by template																*/
/************************************************************************************/
resource 'view' (cCluster, purgeable) {
	{
		root, 'TCls', {0, 0}, { 190, 150 }, sizeFixed, sizeFixed, shown, disabled,
		Cluster {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			"A Cluster!" };

		'TCls', 'PRad', { 20, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "Plain" };

		'TCls', 'BRad', { 40, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, bold, 12, black, "",
			off, "Bold" };

		'TCls', 'IRad', { 60, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, italic, 12, black, "",
			on, "Italic" };

		'TCls', 'URad', { 80, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, underline, 12, black, "",
			off, "Underline" };

		'TCls', 'ORad', { 100, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, outline, 12, black, "",
			off, "Outline" };

		'TCls', 'SRad', { 120, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, shadow, 12, black, "",
			off, "Shadow" };

		'TCls', 'CRad', { 140, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, condense, 12, black, "",
			off, "Condense" };

		'TCls', 'ERad', { 160, 10 }, { 20, 130 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, extend, 12, black, "",
			off, "Extend" };
	}
};


resource 'view' (cTemplateViews, purgeable) {
	{
		root, 'WIND', { 50, 20 }, { 260, 430 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				zoomDocProc, goAwayBox, resizable, modeless, doFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, stagger, forceOnScreen, dontCenter, 'DLOG',
				"Views by Template" };

		'WIND', 'SCLR',	{ 0, 0 }, { 260-kSBarSizeMinus1, 430-kSBarSizeMinus1 },
		sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller {
			"",
				vertScrollBar, horzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCLR', 'DLOG',	{ 0, 0 }, { 900, 480 },
		sizeFixed, sizeFixed, shown, enabled,
		DialogView { "TTestDialogView", noID, noID };

		'DLOG', IncludeViewsAt { cCluster, { 340, 100 } };

		'DLOG', noID, { 100, 50 }, { 150, 300 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, italic, 12, {0, 0, 0xFFFF}, "a",
			justCenter, "Scroll me vertically\n\n(P.S. This should read 'PARAM0': ^0\nThis should read 'PARAM1': ^1\nThis should read 'PARAM0': ^0)" };

		'DLOG', noID, { 540, 100 }, { 20, 100 }, sizeFixed, sizeFixed, shown, enabled,
		CheckBox {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, applFont12,
			off, "Check Box" };

		'DLOG', noID,	{ 540, 270 }, { 28, 100 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				adnRRect, {3, 3}, sizeable, notDimmed, notHilited, doesntDismiss,
				{ 4, 4, 4, 4 }, plain, 10, {0, 0, 0}, "a",
			"Push Button" };

		'DLOG', noID, { 570, 130 }, { 35, 35 }, sizeFixed, sizeFixed, shown, enabled,
		Icon {
			"",
				adnFrame+adnShadow, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				{ 1, 1, 1, 1 }, systemFont,
			preferColor, kTestIcon };

		'DLOG', noID, { 660, 100 }, { 0x18C-0xF0+16, 0x12C-0x8F+16 },
		sizeFixed, sizeFixed, shown, enabled,
		Picture {
			"",
				adnRRect+adnShadow, {2, 2}, sizeable, notDimmed, notHilited, doesntDismiss,
				{ 8, 8, 8, 8 }, systemFont,
			kTestPicture };

		'DLOG', noID, { 620, 20 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, plain, 12, {0xFFFF, 0, 0}, "",
			justCenter, "A static string" };

		'DLOG', noID, { 620, 140 }, { 22, 100 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				{3, 3, 3, 3}, applFont12,
			justRight, "EditText",
			255, ArrowsAndBackspace }
	}
};

/*	The popup example is separate from the rest of the views so that we avoid		*/
/*	creating it if the machine doesn't support popup menus.							*/

resource 'view' (cPopupExample, purgeable) {
	{
		root, noID, { 589, 290 }, { 22, 120 }, sizeFixed, sizeFixed, shown, enabled,
		Popup {
			"",
				noAdornment, notSizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			kTestPopup, 2, 50 },
		root, noID, { 624, 290 }, { 22, 120 }, sizeFixed, sizeFixed, shown, enabled,
		Popup {
			"",
				noAdornment, notSizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			kBaudPopup, 1, 50 },
		root, noID, { 659, 290 }, { 22, 120 }, sizeFixed, sizeFixed, shown, enabled,
		Popup {
			"",
				noAdornment, notSizeable, notDimmed, notHilited, doesntDismiss,
				noInset, applFont9,
			kParityPopup, 1, 50 }
	}
};

/************************************************************************************/
/*	Scrolling test dialog															*/
/************************************************************************************/
resource 'view' (cScrollingTest, purgeable) {
	{
		root, 'WIND', { 50, 20 }, { 320, 450 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				zoomDocProc, goAwayBox, notresizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, stagger, forceOnScreen, dontCenter, 'NUM1',
				"Side-by-Side Scrolling" };

		/* Top Left Pane */

		'WIND', 'BOR1',	{ 7, 7 }, { 128, 208 },
		sizeFixed, sizeFixed, shown, disabled,
		Control {
			"TBorderView",
				adnNone , { 1, 1 } , sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'BOR1', 'FRA1',	{ 3, 3 }, { 122, 202 },
		sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnFrame , { 1, 1 } , sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'FRA1', 'SCL1',	{ 1, 1 }, { 120, 200-kSBarSizeMinus1 },
		sizeFixed, sizeFixed, shown, enabled,
		Scroller {
			"",
				vertScrollBar, nohorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCL1', 'NUM1', { 0, 0 }, { 160000, 1000 },
		sizeFixed, sizeFixed, shown, enabled,
		View { "TNumbersView" };

		/* Top Right Pane */

		'WIND', 'BOR2',	{ 7, 227 }, { 128, 208 },
		sizeFixed, sizeFixed, shown, disabled,
 		Control {
			"TBorderView",
				adnNone , { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'BOR2', 'FRA2',	{ 3, 3 }, { 122, 202 },
		sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnFrame , { 1, 1 } , sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'FRA2', 'SCL2',	{ 1 , 1 }, { 120, 200-kSBarSizeMinus1 },
		sizeFixed, sizeFixed, shown, enabled,
		Scroller {
			"",
				vertScrollBar, nohorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCL2', 'NUM2', { 0, 0 }, { 120, 200 },
		sizeVariable, sizeFixed, shown, enabled,
		View { "TNumbersView" };

				
		/* Bottom Left Pane */

		'WIND', 'BOR3',	{ 147, 7 }, { 128, 208 },
		sizeFixed, sizeFixed, shown, disabled,
		Control {
			"TBorderView",
				adnNone , { 1, 1 } , sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'BOR3', 'FRA3',	{ 3, 3 }, { 122, 202 },
		sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnFrame , { 1, 1 } , sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'FRA3', 'SCL3',	{ 1, 1 }, { 120, 200-kSBarSizeMinus1 },
		sizeFixed, sizeFixed, shown, enabled,
		Scroller {
			"",
				vertScrollBar, nohorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCL3', 'TEV3', { 0, 0 }, { 116, 1020 }, sizeVariable, sizePage, shown, enabled,
		TEView {
			"",
				withStyle, autoWrap, acceptChanges, freeText, cTyping, unlimited,
				{ 8, 10, 0, 10 }, justSystem, applFont12 };

		/* Bottom Right Pane */

		'WIND', 'BOR4',	{ 147, 227 }, { 128, 208 },
		sizeFixed, sizeFixed, shown, disabled,
 		Control {
			"TBorderView",
				adnNone , { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'BOR4', 'FRA4',	{ 3, 3 }, { 122, 202 },
		sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnFrame , { 1, 1 } , sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'FRA4', 'SCL4',	{ 1 , 1 }, { 120, 200-kSBarSizeMinus1 },
		sizeFixed, sizeFixed, shown, enabled,
		Scroller {
			"",
				vertScrollBar, nohorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCL4', 'TEV4', { 0, 0 }, { 116, 1020 }, sizeVariable, sizePage, shown, enabled,
		TEView {
			"",
				withStyle, autoWrap, acceptChanges, freeText, cTyping, unlimited,
				{ 8, 10, 0, 10 }, justSystem, applFont12 };
	}
};



/************************************************************************************/
/*	Monthly values dialog															*/
/************************************************************************************/
resource 'view' (cMonthlyDialog, purgeable) {
	{
		root, 'WIND', { 50, 20 }, { 260, 430 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				zoomDocProc, goAwayBox, resizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				AdaptToScreen, stagger, forceOnScreen, dontCenter, 'jan ',
				"Monthly Values" };

		'WIND', 'SCLR',	{ 0, 0 }, { 260-kSBarSizeMinus1, 430-kSBarSizeMinus1 },
		sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller {
			"",
				vertScrollBar, horzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCLR', 'DLOG',	{ 0, 0 }, { 1000, 500 }, sizeFixed, sizeFixed, shown, enabled,
		DialogView {
			"TMonthlyDialog",
				noID, noID };

		'DLOG', noID, { 10, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "January" };

		'DLOG', 'jan ', { 9, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 40, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "February" };

		'DLOG', 'feb ', { 39, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 70, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont, justSystem, "March" };

		'DLOG', 'mar ', { 69, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 100, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "April" };

		'DLOG', 'apr ', { 99, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 130, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "May" };

		'DLOG', 'may ', { 129, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 160, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "June" };

		'DLOG', 'jun ', { 159, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 190, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "July" };

		'DLOG', 'jul ', { 189, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 220, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "August" };

		'DLOG', 'aug ', { 219, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 250, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "September" };

		'DLOG', 'sep ', { 249, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 280, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "October" };

		'DLOG', 'oct ', { 279, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 310, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "November" };

		'DLOG', 'nov ', { 309, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 };

		'DLOG', noID, { 340, 10 }, { 20, 100 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "December" };

		'DLOG', 'dec ', { 339, 120 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, applFont12,
			justRight, "",
			5, arrowsAndBackspace,
			0, 0, 32767 }

	}
};


/************************************************************************************/
/*	The "Save" dialog																*/
/************************************************************************************/
resource 'view' (cSaveDialog, purgeable) {
	{
		root, 'WIND', { 100, 110 }, { 120, 292 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				dBoxProc, noGoAwayBox, notResizable, modal, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, dontStagger, forceOnScreen, centerHorizontally,
				'DLOG', "Save Dialog" };

		'WIND', 'DLOG',	{ 0, 0 }, { 120, 292 }, sizeFixed, sizeFixed, shown, enabled,
		DialogView {
			"",
				'yes ', 'cncl' };

		'DLOG', 'yes ',	{ 56, 23 }, { 26, 82 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				adnRRect, {3, 3}, sizeable, notDimmed, notHilited, dismisses,
				{ 4, 4, 4, 4 }, systemFont,
			"Yes" };

		'DLOG', 'no  ',	{ 86, 195 }, { 18, 74 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				noAdornment, sizeable, notDimmed, notHilited, dismisses,
				noInset, systemFont,
			"No" };

		'DLOG', 'cncl',	{ 86, 25 }, { 18, 74 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				noAdornment, sizeable, notDimmed, notHilited, dismisses,
				noInset, systemFont,
			"Cancel" };

		'DLOG', noID, { 12, 20 }, { 33, 257 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Save changes to Untitled-1 before closing?" }
	}
};


/************************************************************************************/
/*	The "Mark" Dialog																*/
/************************************************************************************/
resource 'view' (cMarkDialog, purgeable) {
	{
		root, 'WIND', { 72, 64 }, { 92, 364 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				dBoxProc, noGoAwayBox, notResizable, modal, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, dontStagger, forceOnScreen, centerHorizontally, 'mark',
				"Mark Dialog" };

		'WIND', 'DLOG',	{ 0, 0 }, { 1000, 500 }, sizeFixed, sizeFixed, shown, enabled,
		DialogView {
			"",
				'ok  ', 'cncl' };

		'DLOG', 'ok  ',	{ 60, 48 }, { 28, 81 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				adnRRect, {3, 3}, sizeable, notDimmed, notHilited, dismisses,
				{ 4, 4, 4, 4 }, systemFont,
			"OK" };

		'DLOG', 'cncl',	{ 64, 231 }, { 20, 73 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				noAdornment, sizeable, notDimmed, notHilited, dismisses,
				noInset, systemFont,
			"Cancel" };

		'DLOG', noID, { 8, 8 }, { 16, 344 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Mark the selection with what name?" };

		'DLOG', 'mark', { 29, 7 }, { 22, 346 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "",
			255, arrowsAndBackspace }
	}
};

/************************************************************************************/
/*	The Modeless "Mark" Dialog														*/
/************************************************************************************/
resource 'view' (cModelessMarkDialog, purgeable) {
	{
		root, 'WIND', { 72, 64 }, { 92, 364 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				zoomDocProc, goAwayBox, notResizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, dontStagger, forceOnScreen, centerHorizontally, 'mark',
				"Modeless Mark Dialog" };

		'WIND', 'DLOG',	{ 0, 0 }, { 1000, 500 }, sizeFixed, sizeFixed, shown, enabled,
		DialogView {
			"TModelessMarkDialog",
				'ok  ', 'cncl' };

		'DLOG', 'ok  ',	{ 60, 48 }, { 28, 81 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				adnRRect, {3, 3}, sizeable, notDimmed, notHilited, dismisses,
				{ 4, 4, 4, 4 }, systemFont,
			"OK" };

		'DLOG', 'cncl',	{ 64, 231 }, { 20, 73 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				noAdornment, sizeable, notDimmed, notHilited, dismisses,
				noInset, systemFont,
			"Cancel" };

		'DLOG', noID, { 8, 8 }, { 16, 344 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Mark the selection with what name?" };

		'DLOG', 'mark', { 29, 7 }, { 22, 346 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "",
			255, arrowsAndBackspace }
	}
};

/************************************************************************************/
/*	The Message Box Windoid															*/
/************************************************************************************/
resource 'view' (cMessageWindoid, purgeable) {
	{
		root, 'WIND', { 72, 64 }, { 55, 364 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"TFloatWindow",
				kWindoidWDEF, goAwayBox, notResizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, dontStagger, forceOnScreen, centerHorizontally, 'mark',
				"Message Windoid" };

		'WIND', noID, { 8, 8 }, { 16, 344 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Message Box:" };

		'WIND', 'mark', { 29, 7 }, { 22, 350 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "",
			255, arrowsAndBackspace }
	}
};

/************************************************************************************/
/*	Adornment & Balloon Help														*/
/************************************************************************************/
resource 'view' (cAdornment, purgeable) {
	{
		root, 'WIND', { 40, 40 }, { 260, 430 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				zoomDocProc, goAwayBox, resizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, dontStagger, forceOnScreen, centerHorizontally, noid,
				"Adorned views with balloon help" };

		'WIND', 'SCLR',	{ 0, 0 }, { 260-kSBarSizeMinus1, 430-kSBarSizeMinus1 },
		sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller {
			"",
				vertScrollBar, horzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCLR', 'BGND',	{ 0, 0 }, { 300, 480 },
		sizeFixed, sizeFixed, shown, enabled,
		View { "" };

		'BGND', 'ADN1',	{ 20, 20 }, { 200, 100 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				adnFrame+adnShadow, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'ADN1', 'ADN2',	{ 30, 25 }, { 50, 50 }, sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'ADN1', 'ADN3',	{ 100, 25 }, { 50, 50 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

	}
};

/* Balloon Help for view 'ADN1' */
resource 'hrct' (128) 
{
	HelpMgrVersion,
	hmDefaultOptions,
	0, /* balloon definition function */
	5, /* variation code */
	{
		HMStringItem 
		{
			{ -1,0 }, /* tip location */
			{ 0,0,0,0 }, /* hot rectangle */
			"This view has frame and shadow adornment, and a plus cursor" 
		}
	}
};

/* Balloon Help for view 'ADN2' */
resource 'hrct' (129) 
{
	HelpMgrVersion,
	hmDefaultOptions,
	0, /* balloon definition function */
	5, /* variation code */
	{
		HMPictItem 
		{
			{ -1,0 }, /* tip location */
			{ 0,0,10,10 }, /* hot rectangle */
			1000 /* PICT id */
		}
	}
};

/* Balloon Help for view 'ADN3' */
resource 'hrct' (130) 
{
	HelpMgrVersion,
	hmDefaultOptions,
	0, /* balloon definition function */
	5, /* variation code */
	{
		HMStringItem 
		{
			{ -1,0 }, /* tip location */
			{ 0,0,0,0 }, /* hot rectangle */
			"This view has a shadow and an embossed frame adorner" 
		},
		HMPictItem 
		{
			{ 1,1 }, /* tip location */
			{ 0,0,10,10 }, /* hot rectangle */
			1002 /* PICT id */
		}
	}
};

/************************************************************************************/
/*	ImageWriter Page Setup Dialog													*/
/************************************************************************************/
resource 'view' (cPageSetupDialog, purgeable) {
	{
		root, 'WIND', { 30, 20 }, { 144, 472 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				dBoxProc, noGoAwayBox, notResizable, modal, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, dontStagger, forceOnScreen, centerHorizontally, 'DLOG',
				"Page Setup Dialog" };

		'WIND', 'DLOG',	{ 0, 0 }, { 144, 472 }, sizeFixed, sizeFixed, shown, enabled,
		DialogView {
			"TPageSetupDialog",
				'ok  ', 'cncl' };

		'DLOG', 'ok  ',	{ 0, 396 }, { 28, 68 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				adnRRect, {3, 3}, sizeable, notDimmed, notHilited, dismisses,
				{ 4, 4, 4, 4 }, systemFont,
			"OK" };

		'DLOG', 'cncl',	{ 40, 400 }, { 20, 60 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				noAdornment, sizeable, notDimmed, notHilited, dismisses,
				noInset, systemFont,
			"Cancel" };

		'DLOG', noID, { 4, 4 }, { 16, 380 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "ImageWriter" };

		'DLOG', noID, { 20, 4 }, { 3, 380 }, sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnLineTop+adnLineBottom, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont };

		'DLOG', noID, { 8, 300 }, { 12, 384-300 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, applFont9,
			justRight, "MacApp 3.0a2" };

		'DLOG', noID, { 24, 4 }, { 16, 58 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Paper:" };

		'DLOG', 'papC', { 24, 68 }, { 46, 320 }, sizeFixed, sizeFixed, shown, disabled,
		Cluster {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			"" };

		'papC', 'pap1', { 0, 0 }, { 16, 140 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			on, "US Letter" };

		'papC', 'pap2', { 0, 150 }, { 16, 165 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "A4 Letter" };

		'papC', 'pap3', { 15, 0 }, { 16, 140 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "US Legal" };

		'papC', 'pap4', { 15, 150 }, { 16, 165 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "International Fanfold" };

		'papC', 'pap5', { 30, 0 }, { 16, 140 }, sizeFixed, sizeFixed, shown, enabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "Computer Paper" };

		'papC', 'pap6', { 30, 150 }, { 16, 165 }, sizeFixed, sizeFixed, notShown, disabled,
		Radio {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "Invisible" };

		'DLOG', noID, { 74, 4 }, { 16, 84 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Orientation" };

		'DLOG', 'vert', { 93, 5 }, { 32, 32 }, sizeFixed, sizeFixed, shown, enabled,
		Icon {
			"TRadioIcon",
				noAdornment, sizeable, notDimmed, hilited, doesntDismiss,
				noInset, systemFont,
			dontPreferColor, 10060 };

		'DLOG', 'horz', { 93, 45 }, { 32, 32 }, sizeFixed, sizeFixed, shown, enabled,
		Icon {
			"TRadioIcon",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			dontPreferColor, 10061 };

		'DLOG', noID, { 74, 106 }, { 16, 113 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Special Effects:" };

		'DLOG', 'tall', { 74, 220 }, { 16, 108 }, sizeFixed, sizeFixed, shown, enabled,
		CheckBox {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "Tall Adjusted" };

		'DLOG', 'red ', { 89, 220 }, { 16, 122 }, sizeFixed, sizeFixed, shown, enabled,
		CheckBox {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "50 % Reduction" };

		'DLOG', 'gap ', { 104, 220 }, { 16, 181 }, sizeFixed, sizeFixed, shown, enabled,
		CheckBox {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "No Gap Between Pages" }
	}
};

/************************************************************************************/
/*	Format Dialog																	*/
/************************************************************************************/
resource 'view' (cFormatDialog, purgeable) {
	{
		root, 'WIND', { 68, 52 }, { 245-68, 435-52 }, sizeFixed, sizeFixed, shown, enabled,
		Window {
			"",
				dBoxProc, noGoAwayBox, notResizable, modal, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, dontStagger, forceOnScreen, centerHorizontally, 'size',
				"Format Dialog" };

		'WIND', 'DLOG',	{ 0, 0 }, { 245-68, 435-52 }, sizeSuperView, sizeSuperView, shown, enabled,
		DialogView {
			"",
				'ok  ', 'cncl' };

		'DLOG', 'ok  ',	{ 100, 264 }, { 28, 81 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				adnRRect, {3, 3}, sizeable, notDimmed, notHilited, dismisses,
				{ 4, 4, 4, 4 }, systemFont,
			"OK" };

		'DLOG', 'cncl',	{ 135, 268 }, { 20, 73 }, sizeFixed, sizeFixed, shown, enabled,
		Button {
			"",
				noAdornment, sizeable, notDimmed, notHilited, dismisses,
				noInset, systemFont,
			"Cancel" };

		'DLOG', noID, { 68, 253 }, { 17, 38 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Tabs:" };

		'DLOG', 'tabs', { 65, 295 }, { 22, 37 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "", 255, arrowsAndBackspace, 4, 0, 99 };

		'DLOG', 'inv ', { 42, 245 }, { 20, 127 }, sizeFixed, sizeFixed, shown, enabled,
		CheckBox {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			off, "Show Invisibles" };

		'DLOG', 'auto', { 25, 245 }, { 18, 123 }, sizeFixed, sizeFixed, shown, enabled,
		CheckBox {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			on, "Auto Indent" };

		'DLOG', noID, { 7, 15 }, { 18, 38 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Font" };

		'DLOG', noID, { 7, 184 }, { 18, 33 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			justSystem, "Size" };

		'DLOG', 'size', { 27, 180 }, { 22, 40 }, sizeFixed, sizeFixed, shown, enabled,
		NumberText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "", 255, arrowsAndBackspace, 9, 0, 255 };

		'DLOG', noID, { 28, 11 }, { 130, 159 }, sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss, noInset, systemFont };

		'DLOG', 'SCL1',	{ 29, 12 }, { 128, 142 },
		sizeFixed, sizeFixed, shown, enabled,
		Scroller {
			"",
				vertScrollBar, noHorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCL1', 'flst', { 0, 0 }, { 0, 142 },
		sizeVariable, sizeFixed, shown, enabled,
		TextListView {
			"TFontListView",
				0, 1, 16, 142, 0, 6, dontAdornRows, dontAdornCols, singleSelection, systemFont };

		'DLOG', noID, { 60, 180 }, { 98, 40 }, sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss, noInset, systemFont };

		'DLOG', 'SCL2',	{ 61, 181 }, { 96, 23 },
		sizeFixed, sizeFixed, shown, enabled,
		Scroller {
			"",
				vertScrollBar, noHorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCL2', 'slst', { 0, 0 }, { 0, 23 },
		sizeVariable, sizeFixed, shown, enabled,
		TextListView {
			"TSizeListView",
				0, 1, 16, 23, 0, 6, dontAdornRows, dontAdornCols, singleSelection, systemFont };

		'DLOG', noID, { 28, 233 }, { 128, 1 }, sizeFixed, sizeFixed, shown, disabled,
		Control {
			"",
				adnLineLeft, { 1, 1 }, sizeable, dimmed, notHilited, doesntDismiss, noInset, systemFont }
	}
};

/************************************************************************************/
/*	Homebrew Controls Dialog														*/
/************************************************************************************/
resource 'view' (cHomeBrewControls, purgeable) {
	{
		root, 'WIND', { 50, 20 }, { 260, 430 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				zoomDocProc, goAwayBox, resizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, stagger, forceOnScreen, dontCenter, noID,
				"Home Brew Controls" };

		'WIND', 'DLOG',	{ 0, 0 }, { 240, 430 }, sizeSuperView, sizeSuperView, shown, enabled,
		DialogView {
			"THomeBrewDialog",
				noID, noID };

		'DLOG', 'Conv', {100, 20}, { 90, 236 }, sizeFixed, sizeFixed, shown, disabled,
		Cluster {
			"TTemperatureConversionCluster",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			"Temperature Conversion" };

		'Conv', 'Cels', {20, 16}, { 60, 100 }, sizeFixed, sizeFixed, shown, disabled,
		Cluster {
			"TTemperatureCluster",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			"Celsius" };


		'Cels', 'arws', {30, 60}, {18, 11}, sizeFixed, sizeFixed, shown, enabled,
		Picture {
			"TArrowsControl",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			1001 };

		'Cels', 'Numb', { 30, 10 }, { 22, 40 }, sizeFixed, sizeFixed, shown, disabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				{2, 2, 2, 2}, applFont12,
			justRight, "",
			255, ArrowsAndBackspace,
			0, -40, 105 };

		'Conv', 'Fahr', {20, 120}, { 60, 100 }, sizeFixed, sizeFixed, shown, disabled,
		Cluster {
			"TTemperatureCluster",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			"Fahrenheit" };

		'Fahr', 'arws', {30, 60}, {18, 11}, sizeFixed, sizeFixed, shown, enabled,
		Picture {
			"TArrowsControl",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			1001 };

		'Fahr', 'Numb', { 30, 10 }, { 22, 40 }, sizeFixed, sizeFixed, shown, disabled,
		NumberText {
			"",
				adnFrame, {1, 1}, sizeable, notDimmed, notHilited, doesntDismiss,
				{2, 2, 2, 2}, applFont12,
			justRight, "",
			255, ArrowsAndBackspace,
			32, -40, 220 };

		'DLOG', 'sldr', {100, 300}, {106, 35}, sizeFixed, sizeFixed, shown, enabled,
		Picture {
			"TSlider",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			1003 };

		'DLOG', 'Scr1', { 20, 50 }, { 16, 300 }, sizeVariable, sizeVariable, shown, enabled,
		ScrollBar {
			"TScrollBar",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont, 0, -1000, 1000 };

	}
};


/************************************************************************************/
/*	Cluster Tabbing Test Dialog														*/
/************************************************************************************/
resource 'view' (cTabbingTest, purgeable) {
	{
		root, 'WIND', { 50, 20 }, { 260, 430 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				zoomDocProc, goAwayBox, resizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, stagger, forceOnScreen, dontCenter, 'edt1',
				"Tabbing Test" };

		'WIND', 'DLOG',	{ 0, 0 }, { 240, 430 }, sizeSuperView, sizeSuperView, shown, enabled,
/* !!!RCR - No dialog view in this one.
		DialogView {
			"",
				noId, noID };
*/
		View {
			""  };

		'DLOG', noID, { 10, 0 }, { 16, 430 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, applFont12,
			justCenter, "This dialog demonstrates tabbing" };

		'DLOG', 'edt1', { 40, 20 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "one",
			255, arrowsAndBackspace };

		'DLOG', 'edt2', { 70, 20 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "two",
			255, arrowsAndBackspace };

		'DLOG', 'cls1', { 100, 10 }, { 110, 190 }, sizeFixed, sizeFixed, shown, disabled,
		Cluster {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			"Cluster One" };

		'cls1', 'edt3', { 30, 10 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "three",
			255, arrowsAndBackspace };

		'cls1', 'edt4', { 70, 10 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justRight, "four",
			255, arrowsAndBackspace };

		'DLOG', 'cls2', { 30, 210 }, { 200, 190 }, sizeFixed, sizeFixed, shown, disabled,
		Cluster {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			"Cluster Two" };

		'cls2', 'edt5', { 30, 20 }, { 22, 150 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justCenter, "five",
			255, arrowsAndBackspace };

		'cls2', 'edt6', { 70, 20 }, { 100, 150 }, sizeFixed, sizeFixed, shown, enabled,
		EditText {
			"",
				adnFrame, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
				stdInset, systemFont,
			justSystem, "six",
			255, arrowsAndBackspace | carriageReturn }

	}
};


/************************************************************************************/
/*	Calculator clone dialog															*/
/************************************************************************************/
#define monaco9		plain,  9, {0, 0, 0}, "monaco"

resource 'view' (cCalculator, purgeable) {
	{
		root, 'WIND', { 60, 60 }, { 154, 112 }, sizeVariable, sizeVariable, shown, enabled,
		Window {
			"",
				rDocProc, goAwayBox, notResizable, modeless, ignoreFirstClick,
				freeOnClosing, disposeOnFree, closesDocument, openWithDocument,
				dontAdaptToScreen, stagger, forceOnScreen, dontCenter, 'DLOG',
				"Calculator" };

		'WIND', 'DLOG',	{ 0, 0 }, { 154, 112 }, sizeSuperView, sizeSuperView, shown, disabled,
		Picture {
			"TCalcDialog",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, systemFont,
			kCalcPicture };

		'DLOG', noID, { 6, 12 }, { 14, 88 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				noInset, bold+italic+condense, 9, { 0xFFFF, 0, 0 }, "monaco",
			justSystem, "MacApp-ulator" };

		'DLOG', 'SUMM', { 26, 12 }, { 18, 88 }, sizeFixed, sizeFixed, shown, disabled,
		StaticText {
			"TSumStaticText",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss,
				{ 2, 2, 2, 2 }, monaco9,
			justRight, "0" };

		'DLOG', 'keyC', { 50, 14 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key=', { 50, 36 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key/', { 50, 58 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key*', { 50, 80 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key7', { 70, 14 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key8', { 70, 36 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key9', { 70, 58 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key-', { 70, 80 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key4', { 90, 14 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key5', { 90, 36 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key6', { 90, 58 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key+', { 90, 80 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key1', { 110, 14 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key2', { 110, 36 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key3', { 110, 58 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'keyE', { 110, 80 }, { 36, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key0', { 130, 14 }, { 16, 41 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 };

		'DLOG', 'key.', { 130, 58 }, { 16, 19 }, sizeFixed, sizeFixed, shown, enabled,
		Control {
			"",
				noAdornment, sizeable, notDimmed, notHilited, doesntDismiss, noInset, monaco9 }
	}
};

type 'SS11' as 'STR ';
resource 'SS11' (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"Application created by MacApp"
};

resource 'BNDL' (128,
#if qNames
"Bundle",
#endif
	purgeable) {
	'SS11',
	0,
		{
		'ICN#',
			{
			0, 128,
			},
		'FREF',
			{
			0, 128,
			}
		}
};

include "Defaults.rsrc"  'STR#' (kDefaultCredits);		// Grab the default credits

// Get the default MacApp application icon and necessary bundling rsrcs
include "Defaults.rsrc"  'FREF' (128);
include "Defaults.rsrc"  'ICN#' (128);

// Get the default Version resources
include "Defaults.rsrc"  'vers' (1);		// Application or file specific
include "Defaults.rsrc"  'vers' (2);		// Overall package
