{$P}
{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UDemoDialogs.inc1.p }
{ Copyright  1988 - 1991 Apple Computer, Inc.	All rights reserved. }

USES
	ToolUtils, Fonts, Resources, Packages,
	Sane,
	UMemory, UScroller, UTabBehaviors, UViewServer;
	
{--------------------------------------------------------------------------------------------------}

CONST
	kNoOfLines			= 10000;
	kMaxScrollBar		= 1000;
	kTestIcon			= 1000;
	kTestAlert			= 1000;
	kTestPopup			= 235;
	kBaudPopup			= 236;
	kParityPopup		= 237;
	kPopup				= 238;
	
	kTextStylePopup		= 239;
	kFontHier			= 230;
	kStyleHier			= 231;
	kSizeHier			= 232;

	kTestPicture		= 1000;
	kTestStatic 		= 1000;
	kMaxPlaces			= 13;

	cFirstItem			= 1001;
	cProcedureViews 	= 1001;
	cTemplateViews		= 1002;
	cMonthlyDialog		= 1003;
	cSaveDialog 		= 1004;
	cMarkDialog 		= 1005;
	cPageSetupDialog	= 1006;
	cHomeBrewControls	= 1007;
	cTabbingTest		= 1008;
	cCalculator 		= 1009;
	cScrollingTest		= 1011;
	cFormatDialog		= 1012;
	cModelessMarkDialog = 1013;
	cMessageWindoid		= 1014;
	cAdornment			= 1015;
	cLastItem			= 1015;
	cPopupExample		= 1100;
	cTextStyleChanged	= 1102;
	cResetTextStyle		= 1103;

	mUpArrow			= 100;
	mDownArrow			= 101;
	mTemperatureChanged = 102;

TYPE
	FondHandle			= ^FondPointer;
	FondPointer 		= ^FondRecord;
	FondRecord			= RECORD
		familyStuff:		FamRec;
		noOfFonts:			INTEGER;
		fontStuff:			ARRAY [0..1000] OF
								RECORD
							size:				INTEGER;
							style:				INTEGER;
							resID:				INTEGER;
							END;
		END;

VAR
	gMonthlyValues: 	ARRAY [1..12] OF LONGINT;
	gMonthIDs:			ARRAY [1..12] OF IDType;
	
	gTargetFrameAdorner: TTargetFrameAdorner;

{******************************************************************************************}
{  T T e s t A p p l i c a t i o n				}
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S AInit}

PROCEDURE TTestApplication.ITestApplication(itsMainFileType: OSType);

	VAR
		i:					INTEGER;
		monthIDs:			PACKED ARRAY [1..48] OF CHAR;

	BEGIN
	IApplication(itsMainFileType);
	fLaunchWithNewDocument := FALSE;					{ Suppress the creation of a new document at
														 launch }

	FOR i := 1 TO 12 DO
		gMonthlyValues[i] := i * 100;
	monthIDs := 'jan feb mar apr may jun jul aug sep oct nov dec ';
	BlockMove(@monthIDs, @gMonthIDs, SIZEOF(gMonthIDs));

	New(gTargetFrameAdorner);
	gTargetFrameAdorner.IAdorner('TARG',FALSE);
	
	
	{ Suppress dead-stripping of the following classes }
	IF gDeadStripSuppression THEN
		BEGIN
		IF Member(TObject(NIL), TMonthlyDialog) THEN;
		IF Member(TObject(NIL), TArrowsControl) THEN;
		IF Member(TObject(NIL), TTemperatureCluster) THEN;
		IF Member(TObject(NIL), TTemperatureConversionCluster) THEN;
		IF Member(TObject(NIL), TSlider) THEN;
		IF Member(TObject(NIL), THomeBrewDialog) THEN;
		IF Member(TObject(NIL), TFontListView) THEN;
		IF Member(TObject(NIL), TSizeListView) THEN;
		IF Member(TObject(NIL), TRadioIcon) THEN;
		IF Member(TObject(NIL), TPageSetupDialog) THEN;
		IF Member(TObject(NIL), TSumStaticText) THEN;
		IF Member(TObject(NIL), TCalcDialog) THEN;
		IF Member(TObject(NIL), TBorderView) THEN;
		IF Member(TObject(NIL), TNumbersView) THEN;
		IF Member(TObject(NIL), TModelessMarkDialog) THEN;
		IF Member(TObject(NIL), TScrollBar) THEN;
		END;
	END;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

PROCEDURE TTestApplication.MakeProcedureViews(aCmdNumber: CmdNumber);

	VAR
		aTextStyle: 		TextStyle;
		i:					INTEGER;
		iStyle: 			StyleItem;
		oneStyle:			SET OF StyleItem;
		aColor: 			RGBColor;
		itsLocation:		VPoint;
		itsSize:			VPoint;
		ts: 				TextStyle;
		aWindow:			TWindow;
		aTestDialogView:	TTestDialogView;
		aCluster:			TCluster;
		aRadio: 			ARRAY [0..7] OF TRadio;
		aButton:			TButton;
		anIcon: 			TIcon;
		aCheckBox:			TCheckBox;
		aPopup: 			TPopup;
		aPicture:			TPicture;
		aStaticText:		TStaticText;
		anEditText: 		TEditText;

	BEGIN
	NEW(aTestDialogView);
	SetVPt(itsSize, 480, 1200);
	aTestDialogView.ITestDialogView(NIL, NIL, gZeroVPt, itsSize, SizeFixed, SizeFixed, kNoIdentifier,
							kNoIdentifier);
	MAParamText('^0', 'PARAM0');
	MAParamText('^1', 'PARAM1');
	
	aWindow := gViewServer.NewSimpleWindow(aCmdNumber, TRUE, TRUE, NIL, aTestDialogView);
	aWindow.fFreeOnClosing := TRUE;
	{ Only stagger the window if not on System 7, otherwise assume that the bit is set }
	{ in the window template in order to do the staggering. }
	IF (NOT (qNeedsSystem7 | (gConfiguration.systemVersion >= $700))) THEN
		aWindow.SimpleStagger(kStdStaggerAmount, kStdStaggerAmount, gStdStaggerCount);
	
	
	NEW(aStaticText);
	SetVPt(itsLocation, 50, 100);
	SetVPt(itsSize, 300, 150);
	aStaticText.IStaticText(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
							kTestStatic, 1);
	SetRGBColor(aColor, 0, 0, $FFFF);
	SetTextStyle(ts, applFont, [italic], 12, aColor);
	aStaticText.InstallTextStyle(ts, kDontRedraw);
	aStaticText.SetJustification(teCenter, kRedraw);
	
	NEW(aCluster);
	SetVPt(itsLocation, 100, 340);
	SetVPt(itsSize, 150, 190);
	aCluster.ICluster(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
					  kNoResource, 0);
	aCluster.SetLabel('A Cluster!', kRedraw);
	
	SetVPt(itsSize, 130, 20);
	oneStyle := []; 								{ no styles = plain }
	iStyle := bold;
	FOR i := 0 TO 7 DO
		BEGIN
		NEW(aRadio[i]);
		SetVPt(itsLocation, 10, (i + 1) * 20);
		aRadio[i].IRadio(aCluster, itsLocation, itsSize, sizeVariable, sizeVariable, '', i = 2);
		SetTextStyle(ts, systemFont, oneStyle, 12, gRGBBlack);
		aRadio[i].InstallTextStyle(ts, kDontRedraw);
		CASE i OF
			0:
				aRadio[i].SetText('Plain', kRedraw);
			1:
				aRadio[i].SetText('Bold', kRedraw);
			2:
				aRadio[i].SetText('Italic', kRedraw);
			3:
				aRadio[i].SetText('Underline', kRedraw);
			4:
				aRadio[i].SetText('Outline', kRedraw);
			5:
				aRadio[i].SetText('Shadow', kRedraw);
			6:
				aRadio[i].SetText('Condense', kRedraw);
			7:
				aRadio[i].SetText('Extend', kRedraw);
		END;
		oneStyle := [iStyle];
		iStyle := SUCC(iStyle);
		END;
	
	NEW(aCheckBox);
	SetVPt(itsLocation, 100, 540);
	SetVPt(itsSize, 100, 20);
	aCheckBox.ICheckBox(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
						'Check Box', FALSE);
	SetTextStyle(ts, applFont, [], 12, gRGBBlack);
	aCheckBox.InstallTextStyle(ts, kRedraw);
	
	NEW(aButton);
	SetVPt(itsLocation, 270, 540);
	SetVPt(itsSize, 100, 28);
	aButton.IButton(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
					'Push Button');
	SetTextStyle(ts, applFont, [], 10, gRGBBlack);
	aButton.InstallTextStyle(ts, kDontRedraw);
	aButton.fPenSize := Point($00030003);
	aButton.SetAdornment([adnRRect], kDontRedraw);
	aButton.Inset(4, 4, kRedraw);
	
	NEW(anIcon);
	SetVPt(itsLocation, 130, 570);
	SetVPt(itsSize, 35, 35);
	anIcon.IIcon(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kTestIcon,
				 kPreferColor);
	anIcon.SetAdornment(kFrame + [adnShadow], kDontRedraw);
	anIcon.ViewEnable(TRUE, kDontRedraw);
	anIcon.Inset(1, 1, kDontRedraw);
	
	NEW(aPopup);								{ test popup }
	SetVPt(itsLocation, 290, 589);
	SetVPt(itsSize, 120, 22);
	aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kTestPopup,
				  2, 50, 'Popup:', [], teJustLeft, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);								{ baud popup }
	SetVPt(itsLocation, 290, 624);
	SetVPt(itsSize, 120, 22);
	aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kBaudPopup,
				  1, 50, 'Baud:', [], teJustLeft, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);								{ parity popup }
	SetVPt(itsLocation, 290, 659);
	SetVPt(itsSize, 120, 22);
	aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
					kParityPopup, 1, 50, 'Parity:', [], teJustLeft, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);
	SetVPt(itsLocation, 2, 840);
	SetVPt(itsSize, 300, 22);
		aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kPopup, 
						2, 155, 'plain:', [], teJustLeft, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);
	SetVPt(itsLocation, 2, 870);
	SetVPt(itsSize, 300, 22);
		aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kPopup, 
						2, 155, 'bold:', [bold], teJustLeft, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);
	SetVPt(itsLocation, 2, 900);
	SetVPt(itsSize, 300, 22);
		aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kPopup, 
						2, 155, 'italic:', [italic], teJustLeft, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);
	SetVPt(itsLocation, 2, 930);
	SetVPt(itsSize, 300, 22);
		aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kPopup, 
						2, 155, 'outline:', [outline], teJustLeft, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);
	SetVPt(itsLocation, 2, 960);
	SetVPt(itsSize, 300, 22);
		aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kPopup, 
						2, 155, 'center just:', [], teJustCenter, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);
	SetVPt(itsLocation, 2, 990);
	SetVPt(itsSize, 300, 22);
		aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kPopup, 
						2, 155, 'right just:', [], teJustRight, kDontUseAddResMenu, '    ');
	
	NEW(aPopup);						{ text style popup }
	SetVPt(itsLocation, 20, 1020);
	SetVPt(itsSize, 180, 22);
	aPopup.IPopup(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable, kTextStylePopup,
						1, 75, 'TextStyle:', [], teJustLeft, kDontUseAddResMenu, '    ');
	aTestDialogView.fFontsPopup := aPopup;
	
	NEW(aStaticText);
	SetVPt(itsLocation, 220, 1020);
	SetVPt(itsSize, 100, 40);
	aStaticText.IStaticText(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
							kTestStatic, 2);
	aTestDialogView.fStatText := aStaticText;
	
	NEW(aPicture);
	SetVPt(itsLocation, 100, 660);
	SetVPt(itsSize, $18C - $F0 + 16, $12C - $8F + 16);
	aPicture.IPicture(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
					  kTestPicture);
	aPicture.fPenSize := Point($00020002);
	aPicture.SetAdornment([adnRRect, adnShadow], kDontRedraw);
	aPicture.ViewEnable(TRUE, kDontRedraw);
	aPicture.Inset(8, 8, kDontRedraw);
	
	NEW(aStaticText);
	SetVPt(itsLocation, 20, 620);
	SetVPt(itsSize, 100, 20);
	aStaticText.IStaticText(aTestDialogView, itsLocation, itsSize, sizeVariable, sizeVariable,
							kTestStatic, 2);
	SetRGBColor(aColor, $FFFF, 0, 0);
	aStaticText.InstallColor(aColor, kRedraw);
	
	NEW(anEditText);
	SetVPt(itsLocation, 140, 620);
	SetVPt(itsSize, 100, 22);
	anEditText.IEditText(aTestDialogView, itsLocation, itsSize, 255);
	SetTextStyle(ts, applFont, [], 12, gRGBBlack);
	anEditText.InstallTextStyle(ts, kDontRedraw);
	anEditText.SetJustification(teFlushRight, kDontRedraw);
	anEditText.SetText('EditText', kRedraw);
	
	{		 aTestDialogView.DoSelectEditText(anEditText, TRUE); * select text and scroll it into view }
	aWindow.Open;
	END;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

PROCEDURE TTestApplication.DoMenuCommand(aCmdNumber: CmdNumber); OVERRIDE;


	PROCEDURE MakeTemplateViews;

		VAR
			aWindow:			TWindow;
			aDialogView:		TDialogView;
			aPopup: 			TPopup;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		aDialogView := TDialogView(aWindow.FindSubView('DLOG'));
		aPopup := TPopup(gViewServer.DoCreateViews(NIL, aDialogView, cPopupExample, gZeroVPt));
		MAParamText('^0', 'PARAM0');
		MAParamText('^1', 'PARAM1');
		aWindow.Open;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeScrollingTest;

		VAR
			aWindow:			TWindow;
			minSize:			Point;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		SetPt(minSize, 315, 260);
		aWindow.SetResizeLimits(minSize, aWindow.fResizeLimits.botRight);
		aWindow.Open;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeMonthlyDialog;

		VAR
			aWindow:			TWindow;
			aMonthlyDialog: 	TMonthlyDialog;
			aTabber:			TViewTabber;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		aMonthlyDialog := TMonthlyDialog(aWindow.FindSubView('DLOG'));
		IF aMonthlyDialog <> NIL THEN
			aMonthlyDialog.StuffValues;

		{ Add a tabbing behavior to the window. This shows how to prevent cross-window tabbing
		when there are floating windows present }
		
		New(aTabber);
		aTabber.ITabber(TRUE);
		aWindow.AddBehavior(aTabber);
		
		aWindow.Open;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeSaveDialog;

		VAR
			aWindow:			TWindow;
			dismisser:			IDType;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		dismisser := TDialogView(aWindow.FindSubView('DLOG')).PoseModally;

{$IFC qDebug}
		IF dismisser = 'yes ' THEN
			WRITELN('The user said yes.')
		ELSE IF dismisser = 'no  ' THEN
			WRITELN('The user said no.')
		ELSE IF dismisser = 'cncl' THEN
			WRITELN('The user cancelled the dialog.')
		ELSE
			WRITELN('I don''t know how the user responded');
{$ENDC}
		aWindow.Close;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeMarkDialog;

		VAR
			aWindow:			TWindow;
			dismisser:			IDType;
{$IFC qDebug}
			theMark:			Str255;
{$ENDC}

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		dismisser := TDialogView(aWindow.FindSubView('DLOG')).PoseModally;
{$IFC qDebug}
		IF dismisser = 'ok  ' THEN
			BEGIN
			TEditText(aWindow.FindSubView('mark')).GetText(theMark);
			WRITELN('The mark is ''', theMark, '''.');
			END
		ELSE
			WRITELN('The dialog was cancelled.');
{$ENDC}
		aWindow.Close;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeDialog;

		VAR
			aWindow:			TWindow;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		aWindow.Open;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeAdornmentWindow;
	VAR
		aWindow:			TWindow;
		aSubView:			TView;
		anEmbossedFrame: 	TEmbossedFrame;

	BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		aSubView := aWindow.FindSubView('ADN1');
		aSubView.fHelpID := 128;
		aSubView.fCursorID := plusCursor;
		
		aSubView := aWindow.FindSubView('ADN2');
		aSubView.fHelpID := 129;
		aSubView.fHandlesCursor := FALSE;
		
		aSubView := aWindow.FindSubView('ADN3');
		aSubView.fHelpID := 130;

		IF qNeedsColorQD | gConfiguration.hasColorQD THEN
		BEGIN
			New(anEmbossedFrame);
			anEmbossedFrame.IAdorner('embo',kFreeOnDeletion);
			aSubView.AddAdorner(anEmbossedFrame,kHighestAdornPriority,FALSE);
		END;
		
		aWindow.Open;
	END;
	
	
{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeFormatDialog;

		VAR
			aWindow:			TWindow;
			theDialog:			TDialogView;
			dismisser:			IDType;

{--------------------------------------------------------------------------------------------------}

		PROCEDURE SetupTheFontView;

			VAR
				theFontListView:	TFontListView;
				theSizeListView:	TSizeListView;

			BEGIN
			theSizeListView := TSizeListView(theDialog.FindSubView('slst'));
			theSizeListView.fSelection := 0;
			theSizeListView.fSelectedSize := 9;
			theFontListView := TFontListView(theDialog.FindSubView('flst'));
			theFontListView.InitFontList;
			theFontListView.SelectItem(1, kDontExtend, kHighlight, kSelect);
			END;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		theDialog := TDialogView(aWindow.FindSubView('DLOG'));
		SetupTheFontView;

		dismisser := theDialog.PoseModally;
{$IFC qDebug}
		IF dismisser <> 'ok  ' THEN
			WRITELN('The dialog was cancelled.');
{$ENDC}
		aWindow.Close;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakePageSetupDialog;

		VAR
			aWindow:			TWindow;
			theDialog:			TPageSetupDialog;
			dismisser:			IDType;
			orientation:		VHSelect;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		theDialog := TPageSetupDialog(aWindow.FindSubView('DLOG'));
		orientation := v;
		theDialog.fOrientation := orientation;
		TRadioIcon(theDialog.FindSubView('vert')).HiliteState(orientation = v, kDontRedraw);
		TRadioIcon(theDialog.FindSubView('horz')).HiliteState(orientation = h, kDontRedraw);

		dismisser := theDialog.PoseModally;
{$IFC qDebug}
		IF dismisser = 'ok  ' THEN
			BEGIN
			END
		ELSE
			WRITELN('The dialog was cancelled.');
{$ENDC}
		aWindow.Close;
		END;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE MakeCalculator;

		VAR
			aWindow:			TWindow;
			aCalcDialog:		TCalcDialog;

		BEGIN
		aWindow := gViewServer.NewTemplateWindow(aCmdNumber, NIL);
		aCalcDialog := TCalcDialog(aWindow.FindSubView('DLOG'));
		aCalcDialog.ClearSum;
		aWindow.Open;
		END;

	BEGIN
	CASE aCmdNumber OF
		cProcedureViews:
			MakeProcedureViews(aCmdNumber);
		cTemplateViews:
			MakeTemplateViews;
		cScrollingTest:
			MakeScrollingTest;
		cMonthlyDialog:
			MakeMonthlyDialog;
		cSaveDialog:
			MakeSaveDialog;
		cMarkDialog:
			MakeMarkDialog;
		cModelessMarkDialog:
			MakeDialog;
		cMessageWindoid:
			MakeDialog;
		cAdornment:
			MakeAdornmentWindow;
		cFormatDialog:
			MakeFormatDialog;
		cPageSetupDialog:
			MakePageSetupDialog;
		cHomeBrewControls:
			MakeDialog;
		cTabbingTest:
			MakeDialog;
		cCalculator:
			MakeCalculator;
		OTHERWISE
			INHERITED DoMenuCommand(aCmdNumber);
	END;
	END;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

PROCEDURE TTestApplication.DoSetupMenus; OVERRIDE;

	VAR
		i:					INTEGER;

	BEGIN
	INHERITED DoSetupMenus;

	FOR i := cFirstItem TO cLastItem DO
		Enable(i, TRUE);
	END;

{--------------------------------------------------------------------------------------------------}
{******************************************************************************************}
{  TTestDialogView				}
{******************************************************************************************}
{$S ASelCommand}

PROCEDURE TTestDialogView.ITestDialogView(itsDocument: TDocument;
								  itsSuperView: TView;
								  itsLocation: VPoint;
								  itsSize: VPoint;
								  itsHSizeDet: SizeDeterminer;
								  itsVSizeDet: SizeDeterminer;
								  itsDefItemID: IDType;
								  itsCancelItemID: IDType);

	BEGIN
	IDialogView(itsDocument, itsSuperView, itsLocation, itsSize, itsHSizeDet, itsVSizeDet,
				itsDefItemID, itsCancelItemID);
	fFontsPopup := NIL;
	fStatText := NIL;
	END;

{--------------------------------------------------------------------------------------------------}
{$S ASelCommand}

PROCEDURE TTestDialogView.DoEvent(eventNumber: EvtNumber;
								source: TEvtHandler;
								event: TEvent); OVERRIDE;

	VAR
		menuID:			INTEGER;
		menuItem:		INTEGER;
		itemString:		Str255;
		itsTextStyle:	TextStyle;
		theNum:			LONGINT;
		itsMenuHandle:	MenuHandle;
		theRect:		VRect;
		theQDRect:		Rect;
		oldColor:		RGBColor;
		aCmdNumber:		CmdNumber;

	PROCEDURE EraseStatText;
	{ need to call this before calling TStaticText.ImageText since it calls MATextBox with kNoEraseFirst }

		BEGIN
		IF fStatText.Focus THEN ;
		fStatText.ControlArea(theRect);
		fStatText.ViewToQDRect(theRect, theQDRect);
		GetIfColor(oldColor);
		SetIfColor(itsTextStyle.tsColor);
		EraseRect(theQDRect);
		SetIfColor(oldColor);
		END;

	BEGIN
	IF (eventNumber = mPopupHit) & (source = fFontsPopup) THEN
		BEGIN
		aCmdNumber := TPopup(source).GetCurrentCommand;
		CASE aCmdNumber OF
			cResetTextStyle:
				BEGIN
				EraseStatText;
				fStatText.InstallTextStyle(gSystemStyle, kRedraw);
				END;
				
			cTextStyleChanged:										{ font popup was selected }
				BEGIN
				menuItem := fFontsPopup.GetCurrentItem;
				menuID := fFontsPopup.GetMenuID;
				itsMenuHandle := MAGetMenu(menuID);
				GetItem(itsMenuHandle, menuItem, itemString);
				itsTextStyle := fStatText.fTextStyle;
				IF menuID = kFontHier THEN							{ font menu was selected }
					BEGIN
					itsTextStyle.tsFont := GetFontNum(itemString);
					END
				ELSE IF menuID = kStyleHier THEN					{ style menu was selected }
					BEGIN
					IF itemString = 'Plain' THEN
						itsTextStyle.tsFace := []
					ELSE IF itemString = 'Bold' THEN
						itsTextStyle.tsFace := [Bold]
					ELSE IF itemString = 'Italic' THEN
						itsTextStyle.tsFace := [Italic]
					ELSE IF itemString = 'Outline' THEN
						itsTextStyle.tsFace := [Outline];
					END
				ELSE IF menuID = kSizeHier THEN						{ size menu was selected }
					BEGIN
					StringToNum(itemString, theNum);
					itsTextStyle.tsSize := theNum;
					END;
	
				EraseStatText;
				fStatText.InstallTextStyle(itsTextStyle, kRedraw);
				END;
		END;
		END;
	INHERITED DoEvent(eventNumber, source, event);
	END;

{******************************************************************************************}
{ Border View }
{******************************************************************************************}
{$S ARes}

PROCEDURE TBorderView.DoEvent(eventNumber: EvtNumber;
								source: TEvtHandler;
								event: TEvent); OVERRIDE;
BEGIN
	CASE eventNumber OF
		mBecameApplicationTarget: 
			BEGIN
				SELF.AddAdorner( gTargetFrameAdorner, kLowestAdornPriority - 15, kRedraw);	
			END;
			
		mResignedApplicationTarget:
			BEGIN
				SELF.DeleteAdorner( gTargetFrameAdorner, kRedraw);			
			END;
	OTHERWISE
		INHERITED DoEvent(eventNumber, source, event);
	END;
END;

{******************************************************************************************}
{ Target Frame Adorner }
{******************************************************************************************}
{$S ARes}

PROCEDURE TTargetFrameAdorner.DoHighlightSelection(itsView: TView; area: VRect; 
											fromHL, 
											toHL: HLState); OVERRIDE;
VAR adornExtent: VRect;
	qdArea: Rect;
BEGIN
	IF (toHL = hlOn) & itsView.Focus THEN BEGIN
		
		itsView.GetAdornExtent(adornExtent);
		itsView.ViewToQDRect(adornExtent,qdArea);
		PenSize(2,2);
		FrameRect(qdArea);
	END
	ELSE
		SELF.InvalidateAdorner(itsView);
END;

{$S ARes}
PROCEDURE TTargetFrameAdorner.InvalidateAdorner(itsView: TView);
VAR 
		adornArea:		VRect;
		QDArea:			Rect;
		tempRect:			Rect;
		anRGBGray:		RGBColor;
		outerRgn:			RgnHandle;
		innerRgn:				RgnHandle;
BEGIN
	itsView.GetAdornExtent(adornArea);
	itsView.ViewToQDRect(adornArea,QDArea);
	tempRect := QDArea;
	
	outerRgn := NewRgn;
	RectRgn ( outerRgn, QDArea );
	
	InsetRect ( QDArea, 3, 3 );
	innerRgn := NewRgn;
	RectRgn ( innerRgn, QDArea );
	
	DiffRgn ( outerRgn, innerRgn, outerRgn );
	
	DisposeRgn ( innerRgn );
	
	itsView.InvalidateRgn(outerRgn);		
	DisposeRgn ( outerRgn );
		
END;

{******************************************************************************************}
{  T N u m b e r s V i e w				  }
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S ARes}
FUNCTION TNumbersView.WantToBecomeTarget: BOOLEAN; OVERRIDE;
BEGIN
	WantToBecomeTarget := TRUE;
END;

{$S ARes}

PROCEDURE TNumbersView.Draw(area: VRect); OVERRIDE;

	VAR
		viewRect:			VRect;
		i, firstLine, lastLine: LONGINT;
		vPt:				VPoint;
		pt: 				Point;
		s:					Str255;

	BEGIN
	viewRect := area;
	viewRect.right := viewRect.right - 1;
	viewRect.bottom := viewRect.bottom - 1;
	firstLine := (viewRect.top DIV 16) + 1;
	lastLine := (viewRect.bottom DIV 16) + 1;
	SetPortTextStyle(gSystemStyle);
	FOR i := firstLine TO lastLine DO
		BEGIN
		SetVPt(vPt, 0, i * 16);
		pt := ViewToQDPt(vPt);
		MoveTo(pt.h, pt.v);
		NumToString(i, s);
		DrawString(s);
		END;

	INHERITED Draw(area);
	END;

{**************************************************************************************************}
{  T M o d e l e s s M a r k D i a l o g														   }
{**************************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TModelessMarkDialog.DoEvent(eventNumber: EvtNumber;
											source: TEvtHandler;
											event: TEvent); OVERRIDE;

	VAR
{$IFC qDebug}
		theMark:			Str255;
{$ENDC}
		aCloseWindowCommand: TCloseWindowCommand;

	BEGIN
	CASE eventNumber OF
		mDefaultKey,									{ This handles when user presses the
														 'return' key }
		mCancelKey, 									{ This handles when user presses the 'esc'
														 key }
		mButtonHit: 									{ This handles clicking in 'OK' or 'Cancel'
														 buttons }
			IF TView(source).fIdentifier = fDefaultItem THEN
				BEGIN
{$IFC qDebug}
				TEditText(FindSubView('mark')).GetText(theMark);
				WRITELN('The mark is ', theMark, '');
{$ENDC}
				{GetRootView.Close;}
				{!!!RCR This must be done asynchronously because TObject.Changed might
				reference SELF again after this update is handled, so we don't want to
				close the window, freeing all subviews, including the button that
				originated the update }
				
				New(aCloseWindowCommand);
				aCloseWindowCommand.ICloseWindowCommand(cClose,SELF.GetWindow);
				SELF.PostCommand(aCloseWindowCommand);
					
				END
			ELSE IF TView(source).fIdentifier = fCancelItem THEN
			BEGIN
				New(aCloseWindowCommand);
				aCloseWindowCommand.ICloseWindowCommand(cClose,SELF.GetWindow);
				SELF.PostCommand(aCloseWindowCommand);
			END;
		OTHERWISE
			INHERITED DoEvent(eventNumber,source,event);
	END;
	END;

{******************************************************************************************}
{  T M o n t h l y D i a l o g				 }
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}
{$S AClose}

PROCEDURE TMonthlyDialog.DismissDialog(dismisser: IDType); OVERRIDE;

	VAR
		i:					INTEGER;

	BEGIN
	FOR i := 1 TO 12 DO
		gMonthlyValues[i] := TNumberText(FindSubView(gMonthIDs[i])).GetValue;
	INHERITED DismissDialog(dismisser);
	END;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

PROCEDURE TMonthlyDialog.DoKeyCommand(event: TToolboxEvent); OVERRIDE;

	BEGIN
	{ If option-tab is pressed, deselect the current edit text and leave nothing selected.
	  This is for test purposes only.  It is not part of the Macintosh user interface. }
	IF (event.fCharacter = chTab) & (event.fOptionKey) THEN
		DoSelectEditText(NIL, FALSE)
	ELSE
		INHERITED DoKeyCommand(event);
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TMonthlyDialog.StuffValues;

	VAR
		i:					INTEGER;

	BEGIN
	FOR i := 1 TO 12 DO
		TNumberText(FindSubView(gMonthIDs[i])).SetValue(gMonthlyValues[i], kDontRedraw);
	END;

{******************************************************************************************}
{  T F o n t L i s t V i e w			   }
{******************************************************************************************}

{$S AOpen}

PROCEDURE TFontListView.InitFontList;

	VAR
		pFondIDs:			FontListPtr;
		i:					INTEGER;
		noOfFonds:			INTEGER;
		aString:			Str255;

	FUNCTION FondAfter(VAR fontName: Str255): INTEGER;
	{ Find the FOND whose name follows fontName alphabetically, and return its id and name }

		VAR
			theFondResource:	Handle;
			lastID: 			INTEGER;
			thisID: 			INTEGER;
			itsType:			ResType;
			index:				INTEGER;
			foundFOND:			BOOLEAN;
			lastName:			Str255;
			thisName:			Str255;

		BEGIN
		foundFOND := FALSE;
		lastName := '~~~~~~~~';
		FOR index := 1 TO noOfFonds DO
			BEGIN
			theFondResource := GetIndResource('FOND', index);
			GetResInfo(theFondResource, thisID, itsType, thisName);
			IF (thisName > fontName) & (thisName < lastName) THEN
				BEGIN
				lastID := thisID;
				lastName := thisName;
				foundFOND := TRUE;
				END;
			END;
		IF foundFOND THEN
			fontName := lastName
		ELSE											{ Skip duplicate FOND names }
			fontName := '';
		FondAfter := lastID;
		END;

	BEGIN
	fFontList := NIL;
	noOfFonds := CountResources('FOND');
	IF noOfFonds > kMaxFonds THEN
		noOfFonds := kMaxFonds;
	pFondIDs := FontListPtr(NewPermPtr(noOfFonds * 2));

	aString := ' ';
	FOR i := 1 TO noOfFonds DO
		BEGIN											{ put each FOND's id in the list }
		pFondIDs^[i] := FondAfter(aString); 			{ in alphabetical order }
		IF length(aString) = 0 THEN 					{ we finished early }
			BEGIN
			noOfFonds := i - 1;
			LEAVE;
			END;
		END;

	fFontList := pFondIDs;
	InsRowLast(noOfFonds, 16);
	END;

{--------------------------------------------------------------------------------------------------}

{$S AClose}

PROCEDURE TFontListView.Free; OVERRIDE;

	BEGIN
	Ptr(fFontList) := DisposeIfPtr(fFontList);

	INHERITED Free;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TFontListView.GetItemText(anItem: INTEGER;
									VAR aString: Str255); OVERRIDE;

	VAR
		theFondResource:	Handle;
		itsID:				INTEGER;
		itsType:			ResType;

	BEGIN
	theFondResource := GetResource('FOND', fFontList^[anItem]);
	GetResInfo(theFondResource, itsID, itsType, aString);
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TFontListView.SelectItem(anItem: INTEGER;
								   extendSelection, highlight, select: BOOLEAN); OVERRIDE;

	VAR
		aView:				TView;

	BEGIN
	INHERITED SelectItem(anItem, extendSelection, highlight, select);

	IF select THEN
		BEGIN
		aView := GetWindow.FindSubView('slst');
		FailNIL(aView);
		TSizeListView(aView).InstallFontFamily(fFontList^[anItem]);
		END;
	END;

{******************************************************************************************}
{  T S i z e L i s t V i e w			   }
{******************************************************************************************}

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TSizeListView.GetItemText(anItem: INTEGER;
									VAR aString: Str255); OVERRIDE;

	VAR
		noOfSizes:			INTEGER;
		theFond:			FondHandle;
		i:					INTEGER;

	BEGIN
	theFond := FondHandle(GetResource('FOND', fFondID));
	noOfSizes := 0;
	FOR i := 0 TO theFond^^.noOfFonts DO
		BEGIN
		IF theFond^^.fontStuff[i].style = 0 THEN
			noOfSizes := noOfSizes + 1;
		IF noOfSizes = anItem THEN
			BEGIN
			NumToString(theFond^^.fontStuff[i].size, aString);
			EXIT(GetItemText);
			END;
		END;
	aString := '';
	END;

{--------------------------------------------------------------------------------------------------}

{$S AOpen}

PROCEDURE TSizeListView.InstallFontFamily(theFondID: INTEGER);

	VAR
		theFond:			FondHandle;
		noOfSizes:			INTEGER;
		i:					INTEGER;
		sizeToSelect:		INTEGER;

	BEGIN
	theFond := FondHandle(GetResource('FOND', theFondID));
	noOfSizes := 0;
	sizeToSelect := 0;
	FOR i := 0 TO theFond^^.noOfFonts DO
		IF theFond^^.fontStuff[i].style = 0 THEN
			BEGIN
			noOfSizes := noOfSizes + 1;
			IF theFond^^.fontStuff[i].size = fSelectedSize THEN
				sizeToSelect := noOfSizes;
			END;
	fFondID := theFondID;
	SetNumberOfItems(noOfSizes);
	SelectItem(sizeToSelect, kDontExtend, kDontHighlight, kSelect);
	ForceRedraw;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TSizeListView.SelectItem(anItem: INTEGER;
								   extendSelection, highlight, select: BOOLEAN); OVERRIDE;

	VAR
		aString:			Str255;
		theSizeView:		TNumberText;
		fontSize:			LONGINT;

	BEGIN
	INHERITED SelectItem(anItem, extendSelection, highlight, select);

	IF select AND (anItem <> 0) THEN
		BEGIN
		GetItemText(anItem, aString);
		theSizeView := TNumberText(GetWindow.FindSubView('size'));
		theSizeView.SetText(aString, kRedraw);
		theSizeView.SetSelection(0, MAXINT, kRedraw);
		StringToNum(aString, fontSize);
		fSelectedSize := fontSize;
		END;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TSizeListView.SetNumberOfItems(aNumber: INTEGER);

	BEGIN
	SelectItem(0, kDontExtend, kHighlight, kSelect);

	IF fNumOfRows > aNumber THEN
		BEGIN
		DelItemFirst(fNumOfRows - aNumber);
		END
	ELSE IF fNumOfRows < aNumber THEN
		BEGIN
		InsItemFirst(aNumber - fNumOfRows);
		END;
	END;

{******************************************************************************************}
{  T P a g e S e t u p D i a l o g				}
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TPageSetupDialog.DoEvent(eventNumber: EvtNumber;
										source: TEvtHandler;
										event: TEvent); OVERRIDE;

	VAR
		newOrientation: 	VHSelect;
		tallAdjCheckBox:	TCheckBox;

	BEGIN
	CASE eventNumber OF
		mIconHit:
			BEGIN
			IF TView(source).fIdentifier = 'vert' THEN
				newOrientation := v
			ELSE
				newOrientation := h;
			IF newOrientation <> fOrientation THEN
				BEGIN
				TRadioIcon(FindSubView('vert')).HiliteState(newOrientation = v, kRedraw);
				TRadioIcon(FindSubView('horz')).HiliteState(newOrientation = h, kRedraw);
				tallAdjCheckBox := TCheckBox(FindSubView('tall'));
				tallAdjCheckBox.DimState(newOrientation = h, kRedraw);
				tallAdjCheckBox.SetState(FALSE, kRedraw);
				fOrientation := newOrientation;
				END;
			END;
		OTHERWISE
			INHERITED DoEvent(eventNumber,source,event);
	END;
	END;

{******************************************************************************************}
{  T R a d i o I c o n				   }
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S ADoCommand}

PROCEDURE TRadioIcon.TrackMouse(aTrackPhase: TrackPhase;
								VAR anchorPoint, previousPoint, nextPoint: VPoint;
								mouseDidMove: BOOLEAN); OVERRIDE;

	BEGIN
	IF aTrackPhase = TrackPress THEN
		SELF.HandleEvent(mIconHit, SELF, NIL);
	END;

{******************************************************************************************}
{  T H o m e B r e w D i a l o g			  }
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{--------------------------------------------------------------------------------------------------}
{$S ARes}

PROCEDURE THomeBrewDialog.DoSetCursor(localPoint: VPoint;
									 cursorRgn: RgnHandle); OVERRIDE;

	VAR
		theCursor:			CursHandle;
		qdExtent:			Rect;

	BEGIN
	theCursor := GetCursor(crossCursor);
	SetCursor(theCursor^^);
	GetQDExtent(qdExtent);
	RectRgn(cursorRgn, qdExtent);
	END;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

FUNCTION THomeBrewDialog.HandleCursor(theMouse: VPoint;
									  cursorRgn: RgnHandle): TView; OVERRIDE;

	BEGIN
	IF Focus THEN 
	BEGIN
		DoSetCursor(theMouse, cursorRgn);
		HandleCursor := SELF;
	END
	ELSE
		HandleCursor := NIL;
	END;

{******************************************************************************************}
{  T A r r o w s C o n t r o l				 }
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S AOpen}

PROCEDURE TArrowsControl.IRes(itsDocument: TDocument;
							  itsSuperView: TView;
							  VAR itsParams: Ptr); OVERRIDE;

	BEGIN
	INHERITED IRes(itsDocument, itsSuperView, itsParams);
	fLastChange := 0;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TArrowsControl.TrackMouse(aTrackPhase: TrackPhase;
									VAR anchorPoint, previousPoint, nextPoint: VPoint;
									mouseDidMove: BOOLEAN); OVERRIDE;

	BEGIN
	IF TickCount >= fLastChange + 5 THEN
		BEGIN
		fLastChange := TickCount;
		IF aTrackPhase = TrackPress THEN
			fLastChange := fLastChange + 10;

		IF ContainsMouse(nextPoint) THEN
			IF nextPoint.v <= fSize.v DIV 2 THEN
				SELF.HandleEvent(mUpArrow, SELF, NIL)
			ELSE
				SELF.HandleEvent(mDownArrow, SELF, NIL);
		END;
	END;

{******************************************************************************************}
{  TTemperatureCluster				  }
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TTemperatureCluster.DoEvent(eventNumber: EvtNumber;
											source: TEvtHandler;
											event: TEvent); OVERRIDE;

	VAR
		theNumberText:		TNumberText;
		theNumber:			LONGINT;

	BEGIN
	CASE eventNumber OF
		mUpArrow, mDownArrow:
			BEGIN
				theNumberText := TNumberText(FindSubView('Numb'));
				theNumber := theNumberText.GetValue;
				IF eventNumber = mUpArrow THEN
					theNumber := theNumber + 1
				ELSE
					theNumber := theNumber - 1;
				theNumberText.SetValue(theNumber, kRedraw);
	
				SELF.HandleEvent(mTemperatureChanged, SELF, NIL);
			END;
		OTHERWISE
			INHERITED DoEvent(eventNumber,source,event);
	END;
	END;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

FUNCTION TTemperatureCluster.GetValue: LONGINT;

	VAR
		numberText: 		TNumberText;

	BEGIN
	numberText := TNumberText(SELF.FindSubView('Numb'));
	GetValue := numberText.GetValue;
	END;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

PROCEDURE TTemperatureCluster.SetValue(newValue: LONGINT;
									   redraw: BOOLEAN);

	VAR
		numberText: 		TNumberText;

	BEGIN
	numberText := TNumberText(SELF.FindSubView('Numb'));
	numberText.SetValue(newValue, redraw);
	END;

{******************************************************************************************}
{  TTemperatureConversionCluster	}
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TTemperatureConversionCluster.DoEvent(eventNumber: EvtNumber;
											source: TEvtHandler;
											event: TEvent); OVERRIDE;

VAR
	Celsius, Fahrenheit: TTemperatureCluster;

BEGIN
	IF eventNumber = mTemperatureChanged THEN
		BEGIN
			Celsius := TTemperatureCluster(FindSubView('Cels'));
			Fahrenheit := TTemperatureCluster(FindSubView('Fahr'));
			IF source = Celsius THEN
				Fahrenheit.SetValue(TRUNC(Celsius.GetValue * 1.8 + 32), kRedraw)
			ELSE 
				IF source = Fahrenheit THEN
					Celsius.SetValue(TRUNC((Fahrenheit.GetValue - 32) / 1.8), kRedraw)
		END
	ELSE
		INHERITED DoEvent(eventNumber, source, event);
END;

{******************************************************************************************}
{  T S l i d e r				  }
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S AOpen}

PROCEDURE TSlider.IRes(itsDocument: TDocument;
					   itsSuperView: TView;
					   VAR itsParams: Ptr); OVERRIDE;

	VAR
		knobPicture:		PicHandle;
		knobRect:			Rect;

	BEGIN
	INHERITED IRes(NIL, itsSuperView, itsParams);
	knobPicture := GetPicture(1002);
	fKnobPicture := knobPicture;
	WITH knobPicture^^.picFrame DO
		BEGIN
		SetPt(knobRect.topLeft, fSize.h - (right - left), fSize.v - 16);
		knobRect.right := knobRect.left + right - left;
		knobRect.bottom := knobRect.top + bottom - top;
		END;
	fMaxTop := knobRect.top;
	fMinTop := knobRect.top - 84;
	fKnobRect := knobRect;
	fValue := 0;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

FUNCTION TSlider.ContainsMouse(theMouse: VPoint): BOOLEAN; OVERRIDE;

	VAR
		knobRect:			Rect;

	BEGIN
	GetKnobRect(knobRect);
	ContainsMouse := PtInRect(VPtToPt(theMouse), knobRect);
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TSlider.Draw(area: VRect); OVERRIDE;

	BEGIN
	INHERITED Draw(area);								{ This draws everything but the knob }
	DrawKnob;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TSlider.DrawKnob;

	VAR
		knobRect:			Rect;

	BEGIN
	GetKnobRect(knobRect);
	LoadResource(Handle(fKnobPicture)); 				{ In case it was purged from memory }
	DrawPicture(fKnobPicture, knobRect);
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TSlider.GetKnobRect(VAR knobRect: Rect);

	BEGIN
	knobRect := fKnobRect;
	OffsetRect(knobRect, 0, - (fValue * 12));
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TSlider.TrackMouse(aTrackPhase: TrackPhase;
							 VAR anchorPoint, previousPoint, nextPoint: VPoint;
							 mouseDidMove: BOOLEAN); OVERRIDE;

	VAR
		oldRect:			Rect;
		newRect:			Rect;
		difference: 		Rect;
		VDifference:		VRect;
		savedClip:			RgnHandle;
		base:				INTEGER;
		offset: 			INTEGER;

	BEGIN
	GetKnobRect(oldRect);
	newRect := oldRect;

	{ Compute rectangle of knob's current position }
	offset := Min(Max(previousPoint.v - anchorPoint.v, fMinTop - newRect.top), fMaxTop -
				  newRect.top);
	OffsetRect(oldRect, 0, offset);

	{ Compute rectangle of knob's new position }
	offset := Min(Max(nextPoint.v - anchorPoint.v, fMinTop - newRect.top), fMaxTop - newRect.top);
	OffsetRect(newRect, 0, offset);

	{ If the mouse was release, pin the knob to a value and set slider's value }
	IF aTrackPhase = TrackRelease THEN
		BEGIN
		base := fSize.v - 16 - newRect.top;
		offset := base - ((base + 6) DIV 12 * 12);
		OffsetRect(newRect, 0, offset);
		fValue := (fSize.v - 16 - newRect.top) DIV 12;
		END;

	{ To redraw minimal amount, compute difference between old and new positions }
	difference := oldRect;
	IF oldRect.top > newRect.top THEN
		difference.top := Max(oldRect.top, newRect.bottom)
	ELSE
		difference.bottom := Min(oldRect.bottom, newRect.top);

	savedClip := MakeNewRgn;
	GetClip(savedClip);

	ClipRect(difference);
	QDToViewRect(difference,VDifference);
	INHERITED Draw(VDifference);

	SetClip(savedClip);
	DisposeRgn(savedClip);

	LoadResource(Handle(fKnobPicture)); 				{ In case it was purged from memory }
	DrawPicture(fKnobPicture, newRect);
	END;

{******************************************************************************************}
{  T S u m S t a t i c T e x t				 }
{******************************************************************************************}

{$S ARes}

PROCEDURE TSumStaticText.Draw(area: VRect); OVERRIDE;

	VAR
		theRect:			Rect;

	BEGIN
	{ Make sure the gray background gets completely erased }
	GetQDExtent(theRect);
	InsetRect(theRect, fPenSize.h, fPenSize.v);
	EraseRect(theRect);
	INHERITED Draw(area);
	END;

{******************************************************************************************}
{  T C a l c D i a l o g				}
{******************************************************************************************}
{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TCalcDialog.DoEvent(eventNumber: EvtNumber;
									source: TEvtHandler;
									event: TEvent); OVERRIDE;

VAR
	origID: 			IDType;

BEGIN
	CASE eventNumber OF
		mOKHit:
			BEGIN
				IF Member(source, TView) THEN
				BEGIN
					origID := TView(source).fIdentifier;
					CASE origID[4] OF
						'C':
							ClearSum;
						'=', 'E':
							TotalSum(noOperator);
						'/':
							TotalSum(divOperator);
						'*':
							TotalSum(mulOperator);
						'-':
							TotalSum(subOperator);
						'+':
							TotalSum(addOperator);
						OTHERWISE
							NewDigit(origID[4]);
					END;
				END;
			END;
		OTHERWISE
			INHERITED DoEvent(eventNumber, source, event);
	END;
END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TCalcDialog.DoKeyCommand(event: TToolboxEvent); OVERRIDE;

	VAR
		validKeyStroke: BOOLEAN;
		theID: IDType;
		theView: TView;

	BEGIN
	validKeyStroke := TRUE;
	
	{ Determine the ID to find the view which will be used as the originator of the keystroke }
	CASE event.fKeyCode OF
		kClearVirtualCode:
			theID := 'keyC';
		OTHERWISE
			CASE event.fCharacter OF
				'0'..'9', '.', '+', '-', '*', '/', '=':
					BEGIN
					theID := 'key ';
					theID[4] := event.fCharacter;
					END;
				chEnter, chReturn:
					theID := 'keyE';
				OTHERWISE
					BEGIN
				validKeyStroke := FALSE;
					SysBeep(1);
					END;
			END;
	END;

	IF validKeyStroke THEN
		BEGIN
		theView := FindSubView(theID);
		IF theView <> NIL THEN
			TControl(theView).Flash;
		SELF.HandleEvent(mOKHit, theView, NIL);
		END;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TCalcDialog.ClearSum;

	BEGIN
	fArgument := 0;
	fSum := 0;
	fOperator := noOperator;
	fDecimalPoint := FALSE;
	fRestart := TRUE;
	TStaticText(FindSubView('SUMM')).SetText('0', TRUE);
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

FUNCTION TCalcDialog.FetchValue: Extended;

	VAR
		theStr: 			Str255;

	BEGIN
	TStaticText(FindSubView('SUMM')).GetText(theStr);
	FetchValue := Str2Num(theStr);
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TCalcDialog.SetValue;

	VAR
		thePos: 			INTEGER;
		theStr: 			Str255;
		theForm:			DecForm;
		anExtended: 		Extended;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE Truncate;

		VAR
			theChar:			CHAR;

		BEGIN
		IF length(theStr) > 1 THEN
			BEGIN
			theChar := theStr[length(theStr)];
			IF (theChar = '0') | (theChar = '.') THEN
				Delete(theStr, length(theStr), 1);
			IF theChar = '0' THEN
				Truncate;
			END;
		END;

	BEGIN
	theForm.style := FixedDecimal;
	theForm.Digits := 2 * kMaxPlaces;
	anExtended := fSum;
	Num2Str(theForm, anExtended, DecStr(theStr));
	thePos := POS('.', theStr);
	IF thePos <> 0 THEN
		Truncate;
	IF (thePos > kMaxPlaces) | ((thePos <> 0) & (POS('000000', theStr) = thePos + 1)) THEN
		BEGIN
		theForm.style := FloatDecimal;
		theForm.Digits := 2;
		anExtended := fSum;
		Num2Str(theForm, anExtended, DecStr(theStr));
		END;
	IF length(theStr) > kMaxPlaces THEN
		theStr[0] := CHR(kMaxPlaces);
	TStaticText(FindSubView('SUMM')).SetText(theStr, TRUE);
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TCalcDialog.TotalSum(newOperator: CalcOperator);

	BEGIN
	fArgument := FetchValue;
	CASE fOperator OF
		noOperator:
			fSum := fArgument;
		divOperator:
			fSum := fSum / fArgument;
		mulOperator:
			fSum := fSum * fArgument;
		subOperator:
			fSum := fSum - fArgument;
		addOperator:
			fSum := fSum + fArgument;
	END;
	SetValue;
	fRestart := TRUE;
	fArgument := fSum;
	fOperator := newOperator;
	END;

{--------------------------------------------------------------------------------------------------}

{$S ARes}

PROCEDURE TCalcDialog.NewDigit(theNumber: CHAR);

	VAR
		theText:			TStaticText;
		theStr: 			Str255;

{--------------------------------------------------------------------------------------------------}

	PROCEDURE SetIt;

		BEGIN
		theStr[length(theStr) + 1] := theNumber;
		theStr[0] := CHR(length(theStr) + 1);
		theText.SetText(theStr, TRUE);
		END;

	BEGIN
	theText := TStaticText(FindSubView('SUMM'));
	IF fRestart THEN
		theStr := ''
	ELSE
		theText.GetText(theStr);
	IF length(theStr) < kMaxPlaces THEN
		BEGIN
		fRestart := FALSE;
		IF (theNumber = '.') AND NOT fDecimalPoint THEN
			BEGIN
			fDecimalPoint := TRUE;
			SetIt;
			END
		ELSE
			SetIt;
		END;
	END;

{--------------------------------------------------------------------------------------------------}

{$S AFields}

PROCEDURE TCalcDialog.Fields(obj: TObject); OVERRIDE;

	BEGIN
	WITH obj DO
		BEGIN
		DoToField(AtStr('TCalcDialog'), NIL, bClass);
		DoToField(AtStr('fSum'), @fSum, bExtended);
		DoToField(AtStr('fArgument'), @fArgument, bExtended);
		DoToField(AtStr('fOperator'), @fOperator, bInteger);
		DoToField(AtStr('fDecimalPoint'), @fDecimalPoint, bBoolean);
		DoToField(AtStr('fRestart'), @fRestart, bBoolean);
		END;

	INHERITED Fields(obj);
	END;

{--------------------------------------------------------------------------------------------------}
{$S ARes}

PROCEDURE TEmbossedFrame.Draw (itsView: TView; area: VRect );	OVERRIDE;
	VAR
		saveColor:			RGBColor;
		savePenState:	PenState;
		adornArea:		VRect;
		QDArea:			Rect;
		tempRect:			Rect;
		anRGBGray:		RGBColor;
		outerRgn:			RgnHandle;
		innerRgn:				RgnHandle;
		
	BEGIN
		{  Save off the current pen state and the foreground color											}
		GetPenState ( savePenState );
		GetIfColor ( saveColor );
		PenNormal;
		itsView.GetAdornExtent(area);
		itsView.ViewToQDRect(area,QDArea);
		tempRect := QDArea;
		
		{  Build the region to use for filling, first create the outer region							}
		InsetRect ( QDArea, 1, 1 );
		outerRgn := NewRgn;
		RectRgn ( outerRgn, QDArea );
		
		{  Create the inner region																											}
		InsetRect ( QDArea, 6, 6 );
		innerRgn := NewRgn;
		RectRgn ( innerRgn, QDArea );
		
		{  Finally subtract the inner from the outer region															}
		DiffRgn ( outerRgn, innerRgn, outerRgn );
		
		{  Get rid of the inner region																										}
		DisposeRgn ( innerRgn );
		
		{  Set the foreground color to the global face color, this allows the user to 		}
		{ change the color of the face																										}
		SetIfColor ( gRGBLtGray );
		PaintRgn ( outerRgn );
		
		{  Get rid of the outer region																									}
		DisposeRgn ( outerRgn );
		
		{  Draw the inside black frame																									}
		SetIfColor ( gRGBBlack );
		InsetRect ( QDArea, 1, 1 );
		FrameRect ( QDArea );
				
		{  Draw the shadows																													}
		WITH tempRect DO
			BEGIN
				{  Draw the outer gray shadow																						}
				SetIfColor ( gRGBGray );
				MoveTo ( left + 1 , bottom - 1 );		{(h, v)}
				LineTo ( right - 1, bottom - 1  ); 		{(h, v)}
				LineTo ( right - 1, top + 1 ); 				{(h, v)}				

				{  Draw the inner gray shadow																						}
				SetIfColor ( gRGBGray );
				MoveTo ( left + 7 , bottom - 8 );		{(h, v)}
				LineTo ( left + 7, top + 7 ); 				{(h, v)}
				LineTo ( right - 8, top + 7 ); 				{(h, v)}				
			END;
				
		{  Restore the foreground color and the pen																		}
		SetIFColor ( saveColor );
		SetPenState ( savePenState );
	END;	
