{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ Copyright  1988 - 1991 by Apple Computer, Inc. All rights reserved. }

UNIT UDemoDialogs;

	INTERFACE

		USES
		Types, MacAppTypes, Memory, UPascalObject, UObject, UList, AppleEvents, UEvent, UCommand, Editions, Scrap, Dialogs
		 , UEvtHandler, UApplication, UDocument, Balloons, UAdorners, UView, UWindow, UBehavior, UViewBehavior, UPrintHandler, UFailure,
		 UGeometry, OSUtils, UMacAppUniversal, UMacAppUtilities, Menus, UMenuMgr, UPatch, UMacAppGlobals,

		{  Building Blocks }
		PrintTraps, UPrinting, UGridView, UTEView, UControl, UDialog, UPopup;
	

		CONST

			{ Command numbers }
			cMakePicture		= 1000;

			kSignature			= 'SS11';				{ Application signature }
			kFileType			= 'SF11';				{ File-type code used for document files
														 created by this application }
			kTestWindowID		= 1001; 				{ This is passed to NewSimpleWindow as the
														 resource ID of the the WIND Resource which
														 defines the window for this application's
														 documents }

			kMaxFonds			= 100;					{ Max number of FONDs the FontList holds }

		TYPE
			CalcOperator		= (noOperator, divOperator, mulOperator, subOperator, addOperator);

			FontList			= ARRAY [1..kMaxFonds] OF INTEGER; { FOND resource IDs }
			FontListPtr 		= ^FontList;

			
			TTestApplication	= OBJECT (TApplication)

				PROCEDURE TTestApplication.ITestApplication(itsMainFileType: OSType);
				{ Initializes the application and globals. }

				PROCEDURE TTestApplication.MakeProcedureViews(aCmdNumber: CmdNumber);

				PROCEDURE TTestApplication.DoMenuCommand(aCmdNumber: CmdNumber); OVERRIDE;

				PROCEDURE TTestApplication.DoSetupMenus; OVERRIDE;

				END;

			TTestDialogView		= OBJECT (TDialogView)
				fFontsPopup:	TPopup;
				fStatText:		TStaticText;
				PROCEDURE TTestDialogView.ITestDialogView(itsDocument: TDocument;
												  itsSuperView: TView;
												  itsLocation: VPoint;
												  itsSize: VPoint;
												  itsHSizeDet: SizeDeterminer;
												  itsVSizeDet: SizeDeterminer;
												  itsDefItemID: IDType;
												  itsCancelItemID: IDType);

				PROCEDURE TTestDialogView.DoEvent(eventNumber: EvtNumber;
												source: TEvtHandler;
												event: TEvent); OVERRIDE;

				END;

			TNumbersView		= OBJECT (TView)

				FUNCTION  TNumbersView.WantToBecomeTarget: BOOLEAN; OVERRIDE;
				PROCEDURE TNumbersView.Draw(area: VRect); OVERRIDE;

				END;
				
			TMonthlyDialog		= OBJECT (TDialogView)

				PROCEDURE TMonthlyDialog.DoKeyCommand(event: TToolboxEvent); OVERRIDE;

				PROCEDURE TMonthlyDialog.DismissDialog(dismisser: IDType); OVERRIDE;

				PROCEDURE TMonthlyDialog.StuffValues;

				END;

			TModelessMarkDialog = OBJECT (TDialogView)

				PROCEDURE TModelessMarkDialog.DoEvent(eventNumber: EvtNumber;
												source: TEvtHandler;
												event: TEvent); OVERRIDE;

				END;

			TFontListView		= OBJECT (TTextListView)

				fFontList:			FontListPtr;		{ font resource ids }

				PROCEDURE TFontListView.InitFontList;
				{ Build an array of ids of font resources whose names are in alphabetical order }

				PROCEDURE TFontListView.Free; OVERRIDE;
				{ Make sure the font list gets freed }

				PROCEDURE TFontListView.GetItemText(anItem: INTEGER;
													VAR aString: Str255); OVERRIDE;

				PROCEDURE TFontListView.SelectItem(anItem: INTEGER;
												   extendSelection, highlight,
					select: BOOLEAN); OVERRIDE;

				END;

			TSizeListView		= OBJECT (TTextListView)

				fSelection: 		INTEGER;
				fSelectedSize:		INTEGER;
				fFondID:			INTEGER;

				PROCEDURE TSizeListView.GetItemText(anItem: INTEGER;
													VAR aString: Str255); OVERRIDE;

				PROCEDURE TSizeListView.InstallFontFamily(theFondID: INTEGER);

				PROCEDURE TSizeListView.SelectItem(anItem: INTEGER;
												   extendSelection, highlight,
					select: BOOLEAN); OVERRIDE;

				PROCEDURE TSizeListView.SetNumberOfItems(aNumber: INTEGER);

				END;

			TPageSetupDialog	= OBJECT (TDialogView)

				fOrientation:		VHSelect;

				PROCEDURE TPageSetupDialog.DoEvent(eventNumber: EvtNumber;
												source: TEvtHandler;
												event: TEvent); OVERRIDE;

				END;

			TRadioIcon			= OBJECT (TIcon)

				PROCEDURE TRadioIcon.TrackMouse(aTrackPhase: TrackPhase;
												VAR anchorPoint, previousPoint, nextPoint: VPoint;
												mouseDidMove: BOOLEAN); OVERRIDE;

				END;

			THomeBrewDialog 	= OBJECT (TDialogView)

				PROCEDURE THomeBrewDialog.DoSetCursor(localPoint: VPoint;
													 cursorRgn: RgnHandle); OVERRIDE;

				FUNCTION THomeBrewDialog.HandleCursor(theMouse: VPoint;
													  cursorRgn: RgnHandle): TView; OVERRIDE;

				END;

			TArrowsControl		= OBJECT (TPicture)

				fLastChange:		LONGINT;			{ tick count of last call to DoChoice }

				PROCEDURE TArrowsControl.IRes(itsDocument: TDocument;
											  itsSuperView: TView;
											  VAR itsParams: Ptr); OVERRIDE;

				PROCEDURE TArrowsControl.TrackMouse(aTrackPhase: TrackPhase;
													VAR anchorPoint, previousPoint,
													nextPoint: VPoint;
													mouseDidMove: BOOLEAN); OVERRIDE;

				END;

			TTemperatureCluster = OBJECT (TCluster)

				PROCEDURE TTemperatureCluster.DoEvent(eventNumber: EvtNumber;
												source: TEvtHandler;
												event: TEvent); OVERRIDE;
				FUNCTION TTemperatureCluster.GetValue: LONGINT;
				PROCEDURE TTemperatureCluster.SetValue(newValue: LONGINT;
													   redraw: BOOLEAN);

				END;

			TTemperatureConversionCluster = OBJECT (TCluster)

				PROCEDURE TTemperatureConversionCluster.DoEvent(eventNumber: EvtNumber;
												source: TEvtHandler;
												event: TEvent); OVERRIDE;

				END;

			TSlider 			= OBJECT (TPicture)

				fValue: 			INTEGER;
				fKnobPicture:		PicHandle;
				fKnobRect:			Rect;
				fMinTop:			INTEGER;
				fMaxTop:			INTEGER;

				PROCEDURE TSlider.IRes(itsDocument: TDocument;
									   itsSuperView: TView;
									   VAR itsParams: Ptr); OVERRIDE;

				FUNCTION TSlider.ContainsMouse(theMouse: VPoint): BOOLEAN; OVERRIDE;

				PROCEDURE TSlider.Draw(area: VRect); OVERRIDE;

				PROCEDURE TSlider.DrawKnob;

				PROCEDURE TSlider.GetKnobRect(VAR knobRect: Rect);

				PROCEDURE TSlider.TrackMouse(aTrackPhase: TrackPhase;
											 VAR anchorPoint, previousPoint, nextPoint: VPoint;
											 mouseDidMove: BOOLEAN); OVERRIDE;

				END;

			TSumStaticText		= OBJECT (TStaticText)

				PROCEDURE TSumStaticText.Draw(area: VRect); OVERRIDE;

				END;

			TCalcDialog 		= OBJECT (TPicture)

				fSum:				Extended;
				fArgument:			Extended;
				fOperator:			CalcOperator;
				fDecimalPoint:		BOOLEAN;
				fRestart:			BOOLEAN;

				PROCEDURE TCalcDialog.DoEvent(eventNumber: EvtNumber;
												source: TEvtHandler;
												event: TEvent); OVERRIDE;

				PROCEDURE TCalcDialog.DoKeyCommand(event: TToolboxEvent); OVERRIDE;

				PROCEDURE TCalcDialog.ClearSum;

				FUNCTION TCalcDialog.FetchValue: Extended;

				PROCEDURE TCalcDialog.SetValue;

				PROCEDURE TCalcDialog.TotalSum(newOperator: CalcOperator);

				PROCEDURE TCalcDialog.NewDigit(theNumber: CHAR);

				PROCEDURE TCalcDialog.Fields(obj: TObject); OVERRIDE;
				END;

			TBorderView = OBJECT(TControl)
				PROCEDURE TBorderView.DoEvent(eventNumber: EvtNumber;
												source: TEvtHandler;
												event: TEvent); OVERRIDE;
			END;

			TTargetFrameAdorner 		= OBJECT (TAdorner)
				PROCEDURE TTargetFrameAdorner.DoHighlightSelection(itsView: TView; area: VRect; 
															fromHL, 
															toHL: HLState); OVERRIDE;
				PROCEDURE TTargetFrameAdorner.InvalidateAdorner(itsVIew: TView); OVERRIDE;
			END;
			
			TEmbossedFrame 		= OBJECT (TAdorner)
				PROCEDURE TEmbossedFrame.Draw(itsView: TView;
												area : VRect); OVERRIDE;
			END;
			
	IMPLEMENTATION

		{$I UDemoDialogs.inc1.p}

END.
