/* Copyright  1986-1991 Apple Computer, Inc.  All rights reserved. */

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#if qTemplateViews
#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif
#endif

#if qDebug
include "Debug.rsrc";
#endif
include "MacApp.rsrc";
include "Printing.rsrc";

include "FloatWindow.rsrc";
#define kWindoidWDEF			48				// the default windoid WDEF proc ID
#define kWindoidHilite			 1				// add this to kWindoidWDEF if the title bar can be unhilited
#define kWindoidTallTitleBar	 2				// add this to kWindoidWDEF if the title bar has a title
#define kWindoidNotResizable	 4				// add this to kWindoidWDEF if the windoid is NOT resizable
#define kWindoidZoomable		 8				// add this to kWindoidWDEF if the windoid is zoomable

include $$Shell("ObjApp")"DrawShapes" 'CODE';

/* Resource ids */
#define kShapeWindowRSRCID		1005			/* The main document window */
#define kShapeViewRSRCID		1006			/* the shape view resource */
#define kToolsPaletteRSRCID		1007			// the floating window tools palette
#define kPatternsPaletteRSRCID	1008			// the floating window patterns palette
#define kColorMenuBar			 131			/* Menu bar for a color system */
#define kNonColorMenuBar		 132			/* Menu bar for a black & white system */
#define kRainbowArrow			 140
#define kPickerPrompt			 256			/* 'STR ' resource for Color Picker */

#define mGoodies				   4			/* the goodies menu */
#define mTools					   5			/* The Tools menu resource id */
#define mPatterns				   6			/* The Patterns menu resource id */
#define mColor					   7			/* The Color menu resource id */
#define mMoreDebug				   8			/* Menu number for the 'More Debug' menu */

/* Command numbers */
#define cArrow					1100
#define cBox					1101
#define cCircle					1102
#define cHBox					1103

#define cPatterns				1300			/* The 'Patterns' menu */

#define cPickColor				1005			/* Command to bring up Color Picker */

#define cNewShape				1010			/* Command to draw a new shape */
#define cMoveShape				1011			/* Command to move one or more shapes */
#define cChangeShade			1012			/* Buzz command for "Undo Shade Change" */
#define cChangeColor			1013			/* Buzz command for "Undo Color Change" */
#define cChangeTool				1014			/* Buzz command for "Undo Tool Change" */

#define cPasteReplacesSelection	 118			/* Three commands in the 'More Debug' menu */
#define cRecalcExtent			 119
#define cConstrainDrags 		 120
#define cBetterFeedback			 121


/* view constants */
#define kMaxCoord				30000			/* largest possible QuickDraw view coordinate
												(QuickDraw maximum minus slop for size of screen) */
#define kToolsPaletteWidth			41			// Width of the tools palette
#define kToolsPaletteHeight			160			// height of the tools palette 

#define kPatternsAcross				4			// how many patterns across
#define kPatternsDown 				10			// how many patterns down
#define kTotalPatterns				kPatternsAcross * kPatternsDown

#define kWPatternsCell 				18			// Width of patterns Cell
#define kHPatternsCell 				14			// Height of patterns Cell
#define kHorizontalFrames		kPatternsDown - 1		
#define kVerticalFrames			kPatternsAcross - 1		

// Width of the Patterns palette
#define kWPatternsChoice				kWPatternsCell * kPatternsAcross + kVerticalFrames
// height of the Patterns palette
#define kHPatternsChoice				kHPatternsCell * kPatternsDown + kHorizontalFrames

#define kSignature		'SS05'					// Application signature

resource 'DITL' (phAboutApp, purgeable) {
	 {
/* [ 1] */	{160, 182, 180, 262},
			Button {
				enabled,
				"OK"
			};
/* [ 2] */	{10, 75, 150, 320},
			StaticText {
				disabled,
					"This sample program demonstrates many features of MacApp.\n\n"
					"This program was written with MacApp  1985-1990 Apple Computer, Inc."
			};
/* [ 3] */	{10, 20, 42, 52},
			Icon {
				disabled,
				1
			}
	}
};

include "Defaults.rsrc"  'ALRT' (phAboutApp);	// Grab the default about box

#if qTemplateViews

// This guy is used with template views (this is the recommended approach)
resource 'view' (kShapeWindowRSRCID, purgeable) { {
	root, 'WIND', { 50, 40 }, { 200, 396 }, sizeVariable, sizeVariable, shown, enabled,
	Window {
		"",
			zoomDocProc, goAwayBox, resizable, modeless, ignoreFirstClick, freeOnClosing,
			disposeOnFree, closesDocument, openWithDocument, dontAdaptToScreen, stagger,
			forceOnScreen, dontCenter, 'SHAP', "<<<>>>" };

	'WIND', 'PLTT', { 0, 0 }, { 0, kToolsPaletteWidth }, sizeSuperview, sizeFixed, shown, enabled,
	view { "TToolsPalette" };
	
	'WIND', 'SCLR',	{ 0, kToolsPaletteWidth }, { 200-kSBarSizeMinus1, 396-kSBarSizeMinus1-kToolsPaletteWidth },
	sizeRelSuperView, sizeRelSuperView, shown, enabled,
	Scroller {
		"",
			vertScrollBar, horzScrollBar, 0, 0, 16, 16,
			noVertConstrain, noHorzConstrain, { 0, 0, 0, 0 } };

	'SCLR', IncludeViewsAt { kShapeViewRSRCID, { 0, 0 } };
} };

resource 'view' (kShapeViewRSRCID, purgeable) { {
	root, 'SHAP', { 0, 0 }, { kMaxCoord, kMaxCoord }, sizeFillPages, sizeFillPages, shown, enabled,
	view { "TShapeView" };
} };

resource 'view' (kToolsPaletteRSRCID, purgeable) { {
	root, 'TWND', { 80, 80 }, { kToolsPaletteHeight, kToolsPaletteWidth }, sizeFixed, sizeFixed, shown, enabled,
	Window {
		"TFloatWindow",
			kWindoidWDEF + kWindoidNotResizable, goAwayBox, notResizable, modeless, ignoreFirstClick, dontfreeOnClosing,
			dontdisposeOnFree, doesntCloseDocument, dontOpenWithDocument, dontAdaptToScreen, dontStagger,
			forceOnScreen, dontCenter, noid, "" };

	'TWND', 'TPLT', { 0, 0 }, { kToolsPaletteHeight, kToolsPaletteWidth }, sizeFixed, sizeFixed, shown, enabled,
	view { "TToolsPalette" };
} };

resource 'view' (kPatternsPaletteRSRCID, purgeable) { {
	root, 'PWND', { 80, 80 }, { kHPatternsChoice, kWPatternsChoice }, sizeFixed, sizeFixed, shown, enabled,
	Window {
		"TFloatWindow",
			kWindoidWDEF + kWindoidNotResizable, goAwayBox, notResizable, modeless, ignoreFirstClick, dontfreeOnClosing,
			dontdisposeOnFree, doesntCloseDocument, dontOpenWithDocument, dontAdaptToScreen, dontStagger,
			forceOnScreen, dontCenter, noid, "" };

	'PWND', 'PPLT', { 0, 0 }, { kHPatternsChoice, kWPatternsChoice }, sizeFixed, sizeFixed, shown, enabled,
	view { "TPatternsPalette" };
} };

#else

// This guy is used when the template stuff isn't (buttemplate views are recommended, see above)
resource 'WIND' (kShapeWindowRSRCID, purgeable) {
	{50, 40, 250, 436},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	""
};

#endif

include "Defaults.rsrc" 'SIZE' (-1);		// Grab the default SIZE resource

/*	Quitting and saving files is the most memory intensive part of this program.
	In addition to the resident segments, these segments are needed. */

resource 'seg!' (256, purgeable) {
	{
		"GTerminate";
		"GWriteFile";
		"GClipboard";
		"GDoCommand";
		"GClose";
		"GNonRes";
		"GSelCommand";
		"GFile";
	}
};

resource 'STR ' (kPickerPrompt) {
	"Pick a color, any color"
};

include "Defaults.rsrc" 'CMNU' (mApple);		// Grab the default Apple/File menus
include "Defaults.rsrc" 'CMNU' (mFile);

resource 'CMNU' (mEdit,
#if qNames
"mEdit",
#endif
nonpurgeable) {
	mEdit,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Edit",
	 {	/* array: 9 elements */
/* [1] */ "Undo",			noIcon, "Z",	noMark, plain, cUndo;
/* [2] */ "-",				noIcon, noKey,	noMark, plain, nocommand;
/* [3] */ "Cut",			noIcon, "X",	noMark, plain, cCut;
/* [4] */ "Copy",			noIcon, "C",	noMark, plain, cCopy;
/* [5] */ "Paste",			noIcon, "V",	noMark, plain, cPaste;
/* [6] */ "Clear",			noIcon, noKey,	noMark, plain, cClear;
/* [7] */ "Select All",		noIcon, "A",	noMark, plain, cSelectAll;
/* [8] */ "-",				noIcon, noKey,	noMark, plain, nocommand;
/* [9] */ "Show Clipboard",	noIcon, noKey,	noMark, plain, cShowClipboard
	}
};

resource 'CMNU' (mGoodies,
#if qNames
"mGoodies",
#endif
nonpurgeable) {
	mGoodies,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Goodies",
	{
/* [1] */ "Show Page Breaks",
								noIcon, noKey, noMark, plain, cShowBreaks;
/* [2] */ "-",					noIcon, noKey,	noMark, plain, nocommand;
/* [3] */ "Better feedback desired",
								noIcon, noKey, noMark, plain, cBetterFeedback
	}
};

resource 'CMNU' (mTools,
#if qNames
"mTools",
#endif
nonpurgeable) {
	mTools,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Tools",
	 {
/* [1] */	"Arrow",		noIcon, noKey, noMark, plain, cArrow;
/* [2] */	"Box",	noIcon, noKey, noMark, plain, cBox;
/* [3] */	"Circle",	noIcon, noKey, noMark, plain, cCircle;
/* [4] */	"Heavy Box",	noIcon, noKey, noMark, plain, cHBox
	 }
};

resource 'CMNU' (mPatterns,
#if qNames
"mPatterns",
#endif
nonpurgeable) {
	mPatterns,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Patterns",
	{ "Patterns", noIcon, noKey, noMark, plain, cPatterns }
};

resource 'CMNU' (mColor,
#if qNames
"mColor",
#endif
nonpurgeable) {
	mColor,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Colors",
	{	/* array: 9 elements */
/* [1] */	"Green",			noIcon, noKey, noMark, plain, noCommand;
/* [2] */	"Yellow",			noIcon, noKey, noMark, plain, noCommand;
/* [3] */	"Orange",			noIcon, noKey, noMark, plain, noCommand;
/* [4] */	"Red",				noIcon, noKey, noMark, plain, noCommand;
/* [5] */	"Purple",			noIcon, noKey, noMark, plain, noCommand;
/* [6] */	"Blue",				noIcon, noKey, noMark, plain, noCommand;
/* [7] */	"Black",			noIcon, noKey, noMark, plain, noCommand;
/* [8] */	"-",				noIcon, noKey, noMark, plain, noCommand;
/* [9] */	"Pick a Color",	noIcon, noKey, noMark, plain, cPickColor
	}
};

resource 'CMNU' (mMoreDebug,
#if qNames
"mMoreDebug",
#endif
nonpurgeable) {
	mMoreDebug,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"More Debug",
	 {	/* array: 3 elements */
/* [1] */ "Paste Replaces Selection",
								noIcon, noKey, noMark, plain, cPasteReplacesSelection;
/* [2] */ "Recompute view extent",
								noIcon, noKey, noMark, plain, cRecalcExtent;
/* [3] */ "Constrain dragging to view borders",
								noIcon, noKey, noMark, plain, cConstrainDrags
	}
};

resource 'mctb' (mColor) {
	{
	/* Green */
	mColor, 1,
		{
		0x0000, 0xDB00, 0x0000;			/* Mark color */
		0x0000, 0xDB00, 0x0000;			/* Name color */
		0x0000, 0xDB00, 0x0000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Yellow */
	mColor, 2,
		{
		0xFFFF, 0xDB00, 0x0000;			/* Mark color */
		0xFFFF, 0xDB00, 0x0000;			/* Name color */
		0xFFFF, 0xDB00, 0x0000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Orange */
	mColor, 3,
		{
		0xFFFF, 0x4700, 0x0000;			/* Mark color */
		0xFFFF, 0x4700, 0x0000;			/* Name color */
		0xFFFF, 0x4700, 0x0000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Red */
	mColor, 4,
		{
		0xDB00, 0x0000, 0x0000;			/* Mark color */
		0xDB00, 0x0000, 0x0000;			/* Name color */
		0xDB00, 0x0000, 0x0000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Purple */
	mColor, 5,
		{
		0x9200, 0x0000, 0xB000;			/* Mark color */
		0x9200, 0x0000, 0xB000;			/* Name color */
		0x9200, 0x0000, 0xB000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Blue */
	mColor, 6,
		{
		0x0000, 0x0000, 0xFFFF;			/* Mark color */
		0x0000, 0x0000, 0xFFFF;			/* Name color */
		0x0000, 0x0000, 0xFFFF;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		};
	/* Black */
	mColor, 7,
		{
		0x0000, 0x0000, 0x0000;			/* Mark color */
		0x0000, 0x0000, 0x0000;			/* Name color */
		0x0000, 0x0000, 0x0000;			/* Command Key color */
		0xFFFF, 0xFFFF, 0xFFFF			/* Background color */
		}
	}
};

resource 'CMNU' (mBuzzwords,
#if qNames
"Buzzwords",
#endif
nonpurgeable
) {
	mBuzzwords,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Buzzwords",
	 {	/* array: 5 elements */
/* [1] */	"Drawing",				noIcon, noKey, noMark, plain, cNewShape;
/* [2] */	"Move",					noIcon, noKey, noMark, plain, cMoveShape;
/* [3] */	"Page Setup Change",	noIcon, noKey, noMark, plain, cChangePrinterStyle;
/* [4] */	"Shade Change",			noIcon, noKey, noMark, plain, cChangeShade;
/* [5] */	"Color Change",			noIcon, noKey, noMark, plain, cChangeColor;
/* [6] */	"Tool Change",			noIcon, noKey, noMark, plain, cChangeTool
	}
};

/* Menu bar for a color system */
resource 'MBAR' (kColorMenuBar,
#if qNames
"kColorMenuBar",
#endif
nonpurgeable) {
	{mApple; mFile; mEdit; mTools; mPatterns; mColor; mGoodies}
};

/* Menu bar for a non-color system */
resource 'MBAR' (kNonColorMenuBar,
#if qNames
"kNonColorMenuBar",
#endif
nonpurgeable) {
	{mApple; mFile; mEdit; mTools; mPatterns; mGoodies}
};

resource 'MBAR' (kMBarNotDisplayed,
#if qNames
"kMBarNotDisplayed",
#endif
nonpurgeable) {
	{mMoreDebug}
};

/* The color "rainbow" arrow cursor */
data 'crsr' (kRainbowArrow, "Rainbow Arrow") {
	$"8001 0000 0062 0000 0096 0000 0000 0000"        /* ....b......... */
	$"0000 0000 0000 4000 6000 7000 7800 7C00"        /* ......@.`.p.x.|. */
	$"7E00 7F00 7F80 7C00 6C00 4600 0600 0300"        /* ~....|.l.F..... */
	$"0100 0000 C000 E000 F000 F800 FC00 FE00"        /* ............... */
	$"FF00 FF80 FFC0 FFE0 FE00 EF00 CF00 8780"        /* ........... */
	$"0780 0380 0001 0001 0000 0000 0000 0000"        /* .............. */
	$"0000 0000 0000 8008 0000 0000 0010 0010"        /* ............... */
	$"0000 0000 0000 0000 0048 0000 0048 0000"        /* .........H...H.. */
	$"0000 0004 0000 0000 0000 0000 0000 0116"        /* ................ */
	$"0000 0000 0000 0000 0000 0000 0000 0100"        /* ................ */
	$"0000 0000 0000 0110 0000 0000 0000 0121"        /* ...............! */
	$"0000 0000 0000 0222 2000 0000 0000 0233"        /* ......." ......3 */
	$"3200 0000 0000 0333 3330 0000 0000 0344"        /* 2......330.....D */
	$"4445 0000 0000 0444 4445 5000 0000 0444"        /* DE.....DDEP....D */
	$"5500 0000 0000 0550 6600 0000 0000 0500"        /* U......Pf....... */
	$"0660 0000 0000 0000 0660 0000 0000 0000"        /* .`.......`...... */
	$"0066 0000 0000 0000 0066 0000 0000 0000"        /* .f.......f...... */
	$"0000 0000 0000 0000 0000 0000 0006 0000"        /* ................ */
	$"FFFF FFFF FFFF 0001 0000 DB00 0000 0002"        /* ................ */
	$"FFFF DB00 0000 0003 FFFF 4F00 0000 0004"        /* ..........O..... */
	$"DB00 0000 0000 0005 9200 0000 B000 0006"        /* .............. */
	$"0000 0000 FFFF"                                 /* ...... */
};

include "Defaults.rsrc"  'STR#' (kDefaultCredits);		// Grab the default credits

// Get the default MacApp application icon and necessary bundling rsrcs
resource 'BNDL' (128,
#if qNames
"DrawShapes",
#endif
	purgeable) {
	kSignature,
	0,
	{
		'ICN#',
		{
			0, 128,
		},
		'FREF',
		{
			0, 128,
		}
	}
};

type kSignature as 'STR ';
resource kSignature (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"DrawShapes 3.0a2 Apple Computer, Inc. 1988-1991"
};

// Get the default MacApp application icon and file reference
include "Defaults.rsrc"  'ICN#' (128);
include "Defaults.rsrc"  'FREF' (128);

// Get the default Version resources
include "Defaults.rsrc"  'vers' (1);		// Application or file specific
include "Defaults.rsrc"  'vers' (2);		// Overall package

resource 'PAT#' (128, "Patterns", purgeable) {
	{	/* array PatArray: 40 elements */
		/* [1] */
		$"",
		/* [2] */
		$"8000 0000 08",
		/* [3] */
		$"8800 2200 8800 22",
		/* [4] */
		$"8888 2222 8888 2222",
		/* [5] */
		$"88AA 22AA 88AA 22AA",
		/* [6] */
		$"CCAA 33AA CCAA 33AA",
		/* [7] */
		$"EEAA BBAA EEAA BBAA",
		/* [8] */
		$"EEBB BBEE EEBB BBEE",
		/* [9] */
		$"FFBB FFEE FFBB FFEE",
		/* [10] */
		$"FFBB FFFF FFBB FFFF",
		/* [11] */
		$"8010 0220 0108 4004",
		/* [12] */
		$"FFFF FFFF FFFF FFFF",
		/* [13] */
		$"8822 8822 8822 8822",
		/* [14] */
		$"1122 4488 1122 4488",
		/* [15] */
		$"C480 0C68 4302 3026",
		/* [16] */
		$"B130 031B D8C0 0C8D",
		/* [17] */
		$"AA00 AA00 AA00 AA",
		/* [18] */
		$"8822 5522 8822 5522",
		/* [19] */
		$"8855 2255 8855 2255",
		/* [20] */
		$"77DD 77DD 77DD 77DD",
		/* [21] */
		$"80",
		/* [22] */
		$"AA55 AA55 AA55 AA55",
		/* [23] */
		$"0384 4830 0C02 0101",
		/* [24] */
		$"8244 3944 8201 0101",
		/* [25] */
		$"8814 2241 8841 2214",
		/* [26] */
		$"8080 413E 0808 14E3",
		/* [27] */
		$"2204 8C74 2217 9810",
		/* [28] */
		$"BE80 8808 EB08 8880",
		/* [29] */
		$"25C8 3289 6424 4C92",
		/* [30] */
		$"A29C 41BE 2AC9 14EB",
		/* [31] */
		$"40A0 0000 040A",
		/* [32] */
		$"8040 2000 0204 08",
		/* [33] */
		$"AA00 8000 8800 80",
		/* [34] */
		$"FF80 8080 8080 8080",
		/* [35] */
		$"081C 22C1 8001 0204",
		/* [36] */
		$"FF80 8080 FF08 0808",
		/* [37] */
		$"F874 2247 8F17 2271",
		/* [38] */
		$"BF00 BFBF B0B0 B0B0",
		/* [39] */
		$"FF7F BE5D A241 80",
		/* [40] */
		$"FAF5 FAF5 A050 A050"
	}
};

