// MacAppTypes.h
// Copyright 1984-1991 Apple Computer, Inc.All rights reserved.

#ifndef __MACAPPTYPES__
#define __MACAPPTYPES__
 
#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __PASCALDEFS__
#include <PascalDefs.h>
#endif

// This unit implements a set of simple type declarations.

// If for some reason these compiler variables are undefined then set them to the highest
// form:    -NoDebug -System7

#if !defined(qModelFarCode)
#	define qModelFarCode   FALSE
#endif

#if !defined(qModelFarData)
#	define qModelFarData   FALSE
#endif

#if !defined(qDebug)
#	define qDebug   FALSE
#endif

#if !defined(qDebugTheDebugger)
#	define qDebugTheDebugger   FALSE
#endif

#if !defined(qInspector)
#	define qInspector   FALSE
#endif

#if !defined(qMacApp)
#	define qMacApp   TRUE
#endif

#if !defined(qNames)
#	define qNames   FALSE
#endif

#if !defined(qNeedsColorQD)
#	define qNeedsColorQD   FALSE
#endif

#if !defined(qNeedsFPU)
#	define qNeedsFPU   FALSE
#endif

#if !defined(qNeedsMC68020)
#	define qNeedsMC68020   FALSE
#endif

#if !defined(qNeedsMC68030)
#	define qNeedsMC68030   FALSE
#endif

#if !defined(qPerform)
#	define qPerform   FALSE
#endif

#if !defined(qRangeCheck)
#	define qRangeCheck   FALSE
#endif

#if !defined(qUnInit)
#	define qUnInit   FALSE
#endif

#if !defined(qTemplateViews)
#	define qTemplateViews   TRUE
#endif

#if !defined(qTrace)
#	define qTrace   FALSE
#endif

#if !defined(qNeedsSystem7 )
#	define qNeedsSystem7   TRUE
#endif

#if !defined(qNeedsAppleEventMgr)
#	define qNeedsAppleEventMgr   TRUE
#endif

#if !defined(qNeedsEditionMgr)
#	define qNeedsEditionMgr   TRUE
#endif

#if !defined(qNeedsHelpMgr)
#	define qNeedsHelpMgr   TRUE
#endif

#if !defined(qNeedsAliasMgr)
#	define qNeedsAliasMgr   TRUE
#endif

#if !defined(qNeedsFolderMgr)
#	define qNeedsFolderMgr   TRUE
#endif

#if !defined(qNeedsProcessMgr)
#	define qNeedsProcessMgr   TRUE
#endif

#if !defined(qExperimentalAndUnsupported)
#	define qExperimentalAndUnsupported   FALSE
#endif

//------------------------------------------------------------------------------------------------
// The following macros make dealing with Pascal compatible sets (bitmaps basically)
// a little less painful.

#define ASSETELEM(integral) (1 << (integral))

#define IN(set, elem) ((set) & (elem) ? true : false)

// Does A contains B?
// C = A XOR B identifies which bits are set in A or B but
//   not both i.e. identifies bits with different values.
// C AND B, out of the bits with differents values, which ones are set in C.
//   If this is true for any bits, then A does not contain B.

#define CONTAINS(container, containee) ((container) & ((container) ^ (containee)) ? false : true)

#define UNION(set1, set2) ((set1) | (set2))

#define INTERSECTION(set1, set2) ((set1) & (set2))


//----------------------------------------------------------------------------------------
// ASCII Character Constants
//----------------------------------------------------------------------------------------
const short chBackspace = 8;					//  ASCII code for Backspace character  
const short chClear = 27;						//  ASCII code for Clear key (aka ESC)  
const short chDown = 31;						//  ASCII code for down arrow  
const short chEnd = 4;							//  ASCII code for the End key  
const short chEnter = 3;						//  ASCII code for Enter character  
const short chEscape = 27;						//  ASCII code for Escape (aka Clear) key  
const short chFunction = 16;					//  ASCII code for any function key  
const short chFwdDelete = 127;					//  ASCII code for forward delete  
const short chHelp = 5;							//  ASCII code for Help key  
const short chHome = 1;							//  ASCII code for the Home key  
const short chLeft = 28;						//  ASCII code for left arrow  
const short chPageDown = 12;					//  ASCII code for Page Down key  
const short chPageUp = 11;						//  ASCII code for Page Up key  
const short chReturn = 13;						//  ASCII code for Return character  
const short chRight = 29;						//  ASCII code for right arrow  
const short chSpace = 32;						//  ASCII code for Space character  
const short chTab = 9;							//  ASCII code for Tab character  
const short chUp = 30;							//  ASCII code for up arrow  

//----------------------------------------------------------------------------------------
// Virtual Key Code Constants
//----------------------------------------------------------------------------------------
const short kClearVirtualCode = 71;				//  Clear key virtual code  
const short kEscapeVirtualCode = 53;			//  Escape key virtual code  
const short kF10VirtualCode = 109;				//  F10 virtual key code  
const short kF11VirtualCode = 103;				//  F11 virtual key code  
const short kF12VirtualCode = 111;				//  F12 virtual key code  
const short kF13VirtualCode = 105;				//  F13 virtual key code  
const short kF14VirtualCode = 107;				//  F14 virtual key code  
const short kF15VirtualCode = 113;				//  F15 virtual key code  
const short kF1VirtualCode = 122;				//  F1 virtual key code  
const short kF2VirtualCode = 120;				//  F2 virtual key code  
const short kF3VirtualCode = 99;				//  F3 virtual key code  
const short kF4VirtualCode = 118;				//  F4 virtual key code  
const short kF5VirtualCode = 96;				//  F5 virtual key code  
const short kF6VirtualCode = 97;				//  F6 virtual key code  
const short kF7VirtualCode = 98;				//  F7 virtual key code  
const short kF8VirtualCode = 100;				//  F8 virtual key code  
const short kF9VirtualCode = 101;				//  F9 virtual key code  
const short kFwdDelVirtualCode = 117;			//  Forward Delete virtual code  

extern const char* kSysFontName;				//  GetFontNum converts this to zero.
extern const char* kApplFontName;				//  GetFontNum converts this to one.

const int kWordAlign = True;					//  Constant for OffsetPtr
const int kDontAlign = False;					//  Constant for OffsetPtr

extern const char* kHexDigits;					//  Digits in base 16

const short kNoFileRefnum = -(MaxInt - 1);
// an invalid file refnum; used to indicate an unopened file (actually interpreted by
// HFS as a volume number. If you have this many volumes you are sick indeed!

const short kNoStaticLink = -1;
// Pascal functions and procedures can take "procedure" parameters which are like C++
// function pointers with the additional capabilitly to access upscope variables.
// This is particularly convenient for "call back" type procedures because they are
// executed in their original scope. Well kids, C++ has no equivalent structure, so
// all of the interfaces that call for a "procedure" parameter have been translated
// to a function pointer and a static link (upscope variable accessor) in the C++
// headers. The static link can be used to pass any useful context information
// around, see the C++ examples. HOWEVER, when a static link is not used or
// required; C++ users must insert a non-NIL placeholder. The receiving code is in
// pascal and includes special detection of the case where NIL is passed for static
// link. When NIL is passed in, >>> NO <<< static link will be passed to the
// "procedure" parameter when it is called! You can imagine the ensuing heartache for
// well meaning C++ users as their stack gets tromped. The answer, my friends is to have
// C++ users pass kNoStaticLink when they don't wish to use the static link.

//----------------------------------------------------------------------------------------
// Field types for the Fields methods. These are understood by StdFieldToString.    
// Negative values are reserved for MacApp.
//----------------------------------------------------------------------------------------
const short bBoolean = -1;
const short bByte = -2;
const short bChar = -3;
const short bClass = -4;
const short bCmdNumber = -5;
const short bCntlAdornment = -6;
const short bControlHandle = -7;
const short bDouble = -8;						//    SANE Double
const short bExtended = -9;						//    SANE Extended
const short bFixed = -10;
const short bFontName = -11;
const short bGrafPtr = -12;
const short bHandle = -13;
const short bHexInteger = -14;
const short bHexLongInt = -15;
const short bHighByte = -16;
const short bHLState = -17;
const short bIDType = -18;
const short bInteger = -19;
const short bLongInt = -20;
const short bLowByte = -21;
const short bObject = -22;
const short bOSType = -23;
const short bPattern = -24;
const short bPoint = -25;
const short bPointer = -26;
const short bReal = -27;						//  Pascal Real
const short bRect = -28;
const short bResType = -29;
const short bRGBColor = -30;
const short bRgnHandle = -31;
const short bSingle = -32;						//  SANE Single
const short bSizeDeterminer = -33;
const short bString = -34;
const short bStringHandle = -35;
const short bStyle = -36;
const short bTEHandle = -37;
const short bTitle = -38;
const short bVCoordinate = -39;
const short bVPoint = -40;
const short bVHSelect = -41;
const short bVRect = -42;
const short bWindowPtr = -43;
const short bTextStyle = -44;
const short bConfigRec = -45;
const short bScrapStuff = -46;
const short bQDProcs = -47;
const short bCQDProcs = -48;
const short bSectionRecord = -49;

//----------------------------------------------------------------------------------------
// Constants used by StdFieldToCount to determine number of fields in compound type   
//----------------------------------------------------------------------------------------
const short kTextStyleFields = 4;
const short kQDProcsFields = 14;
const short kCQDProcsFields = 20;
const short kScrapStuffFields = 5;
const short kConfigRecFields = 27;
const short kSectionRecordFields = 11;

const short kMANameSize = 255;					// Maximum size string supported for
                                                // an MAName

const int kAutoWrap = True;						// Want to AutoWrap (for MATextBox)
const int kNoAutoWrap = !kAutoWrap;				// Don't want to AutoWrap (for MATextBox) 
const int kEraseFirst = True;					// Want to erase first (for MATextBox) 
const int kNoEraseFirst = !kEraseFirst;			// Don't want to erase first (for
                                                // MATextBox)
const int kSpaceForCaret = True;				// Want to leave space for an insertion
                                                // caret(forMATextBox)

const int kNoSpaceForCaret = !kSpaceForCaret;	// Don't want to leave space for an
                                                // insertioncaret(forMATextBox)


//----------------------------------------------------------------------------------------
//  The following constants are instructions used in the various inline functions.
//----------------------------------------------------------------------------------------
#define		kMoveLImmed			0x2EBC				// MOVE.L of immediate data to (SP)  
#define		kMoveBAbsolute		0x1EB8				// MOVE.B of absolute Address data to
                                                    // (SP)   
#define		kMoveWAbsolute		0x3EB8				// MOVE.W of absolute Address data to
                                                    // (SP)   
#define		kMoveLAbsolute		0x2EB8				// MOVE.L of absolute Address data to
                                                    // (SP)   

//----------------------------------------------------------------------------------------
//  H I G H L I G H T I N G  
//----------------------------------------------------------------------------------------
const short hlOff = 1;							// the selection is to be unhighlighted
const short hlDim = 2;							// the selection is to be dimly
                                                // highlighted   
const short hlOn = 4;							// the selection is to be fully
                                                // highlighted   

//----------------------------------------------------------------------------------------
// these constants can be used to test for combinations of fromHL+toHL, when you do not
// care which is from and which is to
//----------------------------------------------------------------------------------------
const short hlOffDim = hlOff + hlDim;
const short hlDimOff = hlOffDim;
const short hlDimOn = hlDim + hlOn;
const short hlOnDim = hlDimOn;
const short hlOffOn = hlOff + hlOn;
const short hlOnOff = hlOffOn;

//----------------------------------------------------------------------------------------
// CHANGE NOTIFICATION AND EVENT/COMMAND NUMBERS  
//----------------------------------------------------------------------------------------
const short kNoChange = -1;

// Special command codes  

const short cNoEvent = 0;						// <!> Event number representing no event
const short cNoCommand = cNoEvent;				// <!> Command number representing no
                                                // command   
const short cCantUndo = -1;						// <!> Passed to TApplication.SetUndoText
                                                // to indicate that the command cannot be
                                                // undone.


//----------------------------------------------------------------------------------------
// Declarations of pointers to commonly used types.  
//----------------------------------------------------------------------------------------
typedef short* IntegerPtr;
typedef IntegerPtr* IntegerHandle;

typedef long* LongIntPtr;
typedef LongIntPtr* LongIntHandle;

typedef Handle* HandlePtr;
typedef HandlePtr* HandleHandle;

typedef Boolean* BooleanPtr;
typedef BooleanPtr* BooleanHandle;

typedef SignedByte* SignedBytePtr;
typedef SignedBytePtr* SignedByteHandle;

typedef Str255* String255Ptr;
typedef String255Ptr* String255Handle;

typedef char String8[9];

typedef Str255 MAName;
// A Name in MacApp. ClassNames, MethodNames, IVar Names, ProcNames, etc. ??? Should we
// punt on stringlength and only define pointers to these strings?

typedef MAName* MANamePtr;

typedef MANamePtr* MANameHandle;

typedef ResType IDType;
// MacApp uses four byte "signatures" in several places. They are a handy way to have a
// partially human readable quantity that only takes up a long.

typedef OSType TypeList[8000];
//  Actually, variable length

typedef TypeList* TypeListPtr;

typedef TypeListPtr* TypeListHandle;

//----------------------------------------------------------------------------------------
// Enumeration for specifying standard adornments. These are used to operate on Pascal
// sets, thus the setting of explicit values for each identifier in the enumeration.
//----------------------------------------------------------------------------------------
enum AdornPieces
{
	adnLineTop = 	0x01,			// Draw a line at the top of the extent
	adnLineLeft = 	0x02,			// Draw a line on the left side of the extent
	adnLineBottom =	0x04,			// Draw a line on the bottom side of the extent
	adnLineRight = 	0x08,			// Draw a line on the right side of the extent
	adnDummy = 		0x10,			// Place filler
	adnOval = 		0x20,			// Do a FrameOval using the extent
	adnRRect = 		0x40,			// Do a (16,16) FrameRoundRect using the extent
	adnShadow = 	0x80			// Draw drop shadows against framed selections
};

typedef char CntlAdornment;


typedef long EvtNumber;

typedef EvtNumber CmdNumber;
// CmdNumbers tell MacApp what verb is intended after mapping from menu/item.

enum TrackPhase
{
	trackBegin,
	trackContinue,
	trackEnd
};

// !!! 2.0 compatibility sop.
#define trackPress trackBegin
#define trackMove trackContinue
#define trackRelease trackEnd

//----------------------------------------------------------------------------------------
// Some handy inline utility functions
//----------------------------------------------------------------------------------------

inline Boolean odd(long value)
{
	return (value & 0x00000001);
}

inline Boolean odd(short value)
{
	return (value & 0x0001);
}


inline Boolean odd(Ptr value)
{
	return ((long)value & 0x00000001);
}


struct ConfigRecord
{												// ??? should this be PACKED ??? if so,
                                                // how will this affect C++ users?
	// Values from SysEnvirons (Version 1)
	short environsVersion;
	short machineType;
	short systemVersion;
	short processor;
	Boolean hasFPU;
	Boolean hasColorQD;
	short keyboardType;
	short atDrvrVersNum;
	short sysVRefNum;
	long teVersion;								// TextEdit version
	// Derived values
	Boolean hasROM128K;							// ROM 128K - OR - Better
	Boolean hasHFS;

	Boolean hasHierarchicalMenus;
	Boolean hasScriptManager;
	Boolean hasStyleTextEdit;
	Boolean hasSoundManager;
	Boolean hasWaitNextEvent;
	Boolean hasSCSI;
	Boolean hasDesktopBus;
	Boolean hasAUX;
	Boolean hasTempMem;							// TRUE if Process Manager temp memory is
                                                // avail
	Boolean has32BitQD;							// TRUE if 32 bit Quickdraw is installed
	Boolean hasAppleEventMgr;					// TRUE if running under System 7.0
	Boolean hasEditionMgr;						// TRUE if running under System 7.0
	Boolean hasHelpMgr;							// TRUE if running under System 7.0
	Boolean hasAliasMgr;						// TRUE if running under System 7.0
	Boolean hasFolderMgr;						// TRUE if running under System 7.0
	Boolean hasProcessMgr;						// TRUE if running under System 7.0
	Boolean hasPopupCDEF;						// TRUE if running under System 7.0
};


// H I G H L I G H T I N G
typedef char HLState;

//----------------------------------------------------------------------------------------
// Macro for suppressing dead-stripping
//----------------------------------------------------------------------------------------

#define DontDeadStrip(class) \
	{ short i = 0; if (i == 1) { class* dummy = new class; }}


#endif


