// PascalDefs.h
// Copyright 1984-1991 Apple Computer, Inc.All rights reserved.

#ifndef __PASCALDEFS__
#define __PASCALDEFS__

const int False = 0;
const int True = 1;

//----------------------------------------------------------------------------------------
// Pascal predefines the following constants.
//----------------------------------------------------------------------------------------
const int MaxInt = 32767;
const int MAXINT = MaxInt;
const long MaxLongInt = 2147483647;
const long MAXLONGINT = MaxLongInt;


//----------------------------------------------------------------------------------------
// These routines are used mainly by header files that were converted to C++ using
// p2CPlus. A function exists here if an equivalent primitive function exists in Object
// Pascal and can be called from the CONST section of an Object Pascal program. The names
// are ugly so as not to conflict with any programmer defined C++ functions.
//----------------------------------------------------------------------------------------

inline double __Pascal_Abs__ (double a) { return a < 0.0 ? -a : a; }
inline int __Pascal_Abs__ (int a) { return a < 0 ? -a : a; }

inline double __Pascal_Sqr__ (double a) { return a * a; }
inline int __Pascal_Sqr__ (int a) { return a * a; }

inline int __Pascal_Odd__ (long a) { return a & 0x0001; }
inline int __Pascal_Odd__ (int a) { return a & 0x0001; }

inline int __Pascal_Ord__ (char *a) { return *a; }
inline int __Pascal_Ord4__ (char *a) { return *a;}

inline char __Pascal_Chr__ (int a) { return a; }

inline int __Pascal_Trunc__ (double a) { return a; }

inline int __Pascal_Round__ (double a) { return a + 0.5; }

#endif