// UGrabberTracker.h
// Copyright 1984-1991 Apple Computer, Inc.All rights reserved.

#ifndef __UGRABBERTRACKER__
#define __UGRABBERTRACKER__

#ifndef __PASCALDEFS__
#include <PascalDefs.h>
#endif

#ifndef __UGEOMETRY__
#include <UGeometry.h>
#endif

#ifndef __UCOMMAND__
#include <UCommand.h>
#endif


//----------------------------------------------------------------------------------------
// Constants
//----------------------------------------------------------------------------------------

const short kGrabberHand = 9;					// ID of the grabberhand cursor


//----------------------------------------------------------------------------------------
// External and forward class declarations
//----------------------------------------------------------------------------------------

class TDocument;
class TView;
class TScroller;


//----------------------------------------------------------------------------------------
// TGrabberTracker: Tracks a scrolling view with a MacPaint-like Grabber Hand
//----------------------------------------------------------------------------------------

class TGrabberTracker : public TNoChangesTracker
{
public:

	virtual pascal void IGrabberTracker(CmdNumber itsCmdNumber,
										TDocument* itsDocument,
										TView* itsView,
										TScroller* itsScroller,
										const VPoint& itsMouse);

	virtual pascal TTracker* TrackMouse(TrackPhase aTrackPhase,
										VPoint& anchorPoint,
										VPoint& previousPoint,
										VPoint& nextPoint,
										Boolean mouseDidMove);
	virtual pascal void TrackFeedback(TrackPhase aTrackPhase,
										const VPoint& anchorPoint,
										const VPoint& previousPoint,
										const VPoint& nextPoint,
										Boolean mouseDidMove,
										Boolean turnItOn);

	virtual pascal void AutoScroll(const VPoint& delta);
};


#endif


