// UInspector.h
// Copyright 1984-1991 Apple Computer, Inc. All rights reserved.

#ifndef __UINSPECTOR__
#define __UINSPECTOR__

#ifndef __PASCALDEFS__
#include "PascalDefs.h"
#endif

#ifndef __UOBJECT__
#include "UObject.h"
#endif


//----------------------------------------------------------------------------------------
// This unit implements two things: a set of lists of all objects in each class. and the
// inspector window (with its associated views.) The global routines below together make
// up the public interface to the inspector. The classes used are private to the unit and
// are declared in UInspector.inc1.p. Refer to that source code for more information on
// the implementation of this unit.
//----------------------------------------------------------------------------------------

extern pascal void InitUInspector();
	// Called during MacApp initialization. Initializes this unit.

extern pascal void AddObjectToInspector(TObject* theObject);
	// Called when a new object is created by New or cloning. Adds theObject to the list
    // of objects for its class.

extern pascal void RemoveObjectFromInspector(TObject* theObject);
	// Called when an object is freed. Removes theObject from the list of objects for its
    // class.

extern pascal void MakeInspector();
	// Called during MacApp initialization to make the Inspector document. Must be called
    // after creating gApplication.

extern pascal void MakeInspectorWindow();
	// Called to make a new Inspector window.

extern pascal Boolean AddNewObjectsToInspector(Boolean add);
	// Set to true (default) to automatically add all newly created objects to the
    // inspector. Function returns old setting.


#endif


