// ULoMem.h
// Copyright 1984-1991 Apple Computer, Inc. All rights reserved.

#ifndef __ULOMEM__
#define __ULOMEM__

#ifndef __PASCALDEFS__
#include <PascalDefs.h>
#endif

#ifndef __DEVICES__
#include <Devices.h>
#endif

#ifndef __SYSEQU__
#include <SysEqu.h>
#endif


//----------------------------------------------------------------------------------------
// This unit provides a friendly interface to low memory variables (see Inside Macintosh.)
// The global "routines" are, in fact, inline functions which directly access the low
// memory variables.   NOTE: + = ROM128K or newer
//----------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------
// This are needed for the non script manager case...
//----------------------------------------------------------------------------------------

const short kLMApFontID = 2436;					// Integer - Resource ID of application
                                                // font

const short kLMSysFontFam = 2982;				// + System font family ID or zero

const short kLMSysFontSize = 2984;				// + System font size (or zero for 12
                                                // point)

const short kLMTESysJust = TESysJust;			// + System font size (or zero for 12
                                                // point)


const short kLMHiliteMode = HiliteMode;			// Clr bit seven to make next QD Op use
                                                // selection color

const short kLMExTable = 0;						// Address of exception vector table


//----------------------------------------------------------------------------------------
// for ROMMapInsert
//----------------------------------------------------------------------------------------

const short kLMmapTrue = -1;

const short kLMmapFalse = 0;


//----------------------------------------------------------------------------------------
// for GetUTableBase
//----------------------------------------------------------------------------------------

typedef DCtlHandle UnitTable[129];

typedef UnitTable* UnitTablePtr;

typedef RgnHandle* RgnHandlePtr;


//----------------------------------------------------------------------------------------
// Assembly language inlines.
//----------------------------------------------------------------------------------------

pascal CursPtr GetTheCrsr() = {					/*  kMoveLImmed*/
							   0x2ebc,			/* 0x0*/ 0x0,/*  TheCrsr*/ 0x844};
/*  pointer to current cursor */
/*  MOVE.L #TheCrsr,(SP)  */

pascal RgnHandlePtr GetSaveVisRgnPtr() = {		/* 0x41f8*/
										  0x41f8,/* 0x9f2*/ 0x9f2,/* 0x2e88*/ 0x2e88};/*  Temporarily saved VisRegion during Update
												  cycle  */
/*  LEA $9f2, A0 MOVE.L A0,(SP)  */

pascal Ptr GetCurStackBase() = {				/*  kMoveLAbsolute*/
								0x2eb8,			/*  CurStackBase*/ 0x908};/*  Current stack base  */
/*  MOVE.L CurStackBase,(SP)  */

pascal short GetHwCfgFlags() = {				/*  kMoveWAbsolute*/
								0x3eb8,			/* 0xb22*/ 0xb22};/* + Hardware Configuration flags  */
/*  MOVE.W $B22,(SP)  */

pascal WindowPtr GetWindowList() = {			/*  kMoveLAbsolute*/
									0x2eb8,		/*  WindowList*/ 0x9d6};/*  Z-ordered linked list of windows  */
/*  MOVE.L #WindowList,(SP)  */

pascal short GetFSFCBLen() = {					/*  kMoveWAbsolute*/
							  0x3eb8,			/* 0x3f6*/ 0x3f6};/*  End of file system variables, >0=has HFS  */
/*  MOVE.W $3F6,(SP)  */

pascal short GetCurJTOffset() = {				/*  kMoveWAbsolute*/
								 0x3eb8,		/*  CurJTOffset*/ 0x934};/*  Offset from A5 to start of jump table  */
/*  MOVE.W CurJTOffset,(SP)  */

pascal short GetUnitNtryCnt() = {				/*  kMoveWAbsolute*/
								 0x3eb8,		/*  UnitNtryCnt*/ 0x1d2};/*  Number of entries in unit table  */
/*  MOVE.W UnitNtryCnt,(SP)  */

pascal UnitTablePtr GetUTableBase() = {			/*  kMoveLAbsolute*/
									   0x2eb8,	/*  UTableBase*/ 0x11c};/*  Start of unit table  */
/*  MOVE.L UTableBase,(SP)  */

pascal SignedByte GetCrsrBusy() = {				/*  kMoveBAbsolute*/
								   0x1eb8,		/*  CrsrBusy*/ 0x8cd};/*  Cursor locked out */
/*  MOVE.B CrsrBusy,(SP)  */

pascal Ptr GetROMMapInsert() = {				/*  kMoveLImmed*/
								0x2ebc,			/* 0x0*/ 0x0,/*  RomMapInsert*/ 0xb9e};/* + $FF=Look first in ROM resources file,
												  $00=Don't look in ROM  */
/*  MOVE.L #ROMMapInsert,(SP)  */

pascal Handle GetMenuList() = {					/*  kMoveLAbsolute*/
							   0x2eb8,			/* 0xa1c*/ 0xa1c};/*  Current menuBar list structure  */
/*  MOVE.L $A1C,(SP)  */

pascal Handle GetGZMoveHnd() = {				/*  kMoveLAbsolute*/
								0x2eb8,			/*  GZMoveHnd*/ 0x330};/*  moving handle for GrowZone  */
/*  MOVE.L GZMoveHnd,(SP)  */

pascal Handle GetGZRootHnd() = {				/*  kMoveLAbsolute*/
								0x2eb8,			/*  GZRootHnd*/ 0x328};/*  Block which must not be moved by GrowZone
												  function */
/*  MOVE.L GZRootHnd,(SP)  */

pascal Boolean GetResLoad() = {					/*  kMoveBAbsolute*/
							   0x1eb8,			/*  ResLoad*/ 0xa5e};
/*  MOVE.B ResLoad,(A7)  */
/*  Returns the ResLoad flag from low memory.True indicates that resources
  are loaded on GetResource.  */


#endif


