{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ UClipboardMgr.p }
{ Copyright  1984-1991 by Apple Computer Inc. All rights reserved. }
UNIT UClipboardMgr;

	INTERFACE

		USES
			{
			 List units defining any types or constants that are required for your interface
			section (e.g. MacAppTypes or QuickDraw)
			 Also list units defining the classes that you are subclassing from in the interface
			section.  DO NOT list units for classes that you are only referencing
			(e.g. instance vars, parameter types or function results).
			 Also list the units used by the above (in their interface section).
			}
			Types, MacAppTypes, Memory, UPascalObject, UObject, AppleEvents, UEvtHandler, Scrap;

		TYPE
			{
			 Declare as external the classes that you are only referencing
			(e.g. instance vars, parameter types or function results) that are not covered by
			the USES in the interface section.
			}
			TView				= OBJECT; EXTERNAL;
			TWindow 			= OBJECT; EXTERNAL;

			TClipboardMgr		= OBJECT (TEvtHandler)	{ This object is responsible for interaction
														 with the scrap manager}
				fOldScrapStuff: 	ScrapStuff; 		{ the last ScrapStuff record used in
														 tracking the scrap }

				fNewScrapStuff: 	ScrapStuff; 		{ the current ScrapStuff record used in
														 tracking the scrap }
				fPrefClipType:		ResType;
				fGotClipType:		BOOLEAN;			{ True if we can paste the data in the
														 clipboard }
				fClipClaimed:		BOOLEAN;			{ Used by PerformCommand & ClaimClipboard to
														 determine, if DoIt of a cut/copy cmd
														 fails, whether the Clipboard had already
														 been claimed by the new command or not }
				fClipOrphanage: 	TView;				{ A view to represent the Clipboard when the
														 application can't }

				fClipUndoView:		TView;				{ The view previously installed in the
														 Clipboard }

				fClipView:			TView;				{ The view currently installed in the
														 Clipboard }
				fClipWindow:		TWindow;			{ The window holding the Clipboard display }
				fClipWrittenToDeskScrap: BOOLEAN;		{ True if the clipboard view has been
														 written to the desk scrap. }

				PROCEDURE TClipboardMgr.Initialize;	OVERRIDE;

				PROCEDURE TClipboardMgr.IClipboardMgr;

				PROCEDURE TClipboardMgr.Close;

				PROCEDURE TClipboardMgr.Fields(obj: TObject); OVERRIDE;

				PROCEDURE TClipboardMgr.Launch;

				FUNCTION TClipboardMgr.GetDataToPaste(aDataHandle: Handle;
													  VAR dataType: ResType): LONGINT;
				{ Returns the number of bytes in the paste data. Will signal Failure if it gets an
				error. }

				FUNCTION TClipboardMgr.MakeClipboardWindow: TWindow;
				{ Called by to make the clipboard window. ClipView is the view to be initially installed in the clipboard--it is
				fClipOrphanage. }

				FUNCTION TClipboardMgr.MakeViewForAlienClipboard: TView;
				{ Calls the application's MakeViewForAlienClipboard.  If it returns a view then that
				view is returned to our caller else it returns fClipOrphanage, which is capable of displaying
				scrap of type TEXT or PICT. Override this to create a view to handle other types of scrap data. }

				FUNCTION TClipboardMgr.PutDeskScrapData(aResType: ResType;
														aDataHandle: Handle): OSerr;
				{ Call this from your TCommand method 'WriteToDeskScrap' (for a Command which changes the
				Clipboard) to write out data to the actual Desk Scrap. The return code from the Scrap
				Manager is returned as the function value -- will be noErr unless something went wrong.
				This procedure leaves aDataHandle UNLOCKED. Rather than calling this, you can call the
				ToolBox routine PutScrap yourself }

				PROCEDURE TClipboardMgr.AbandonUndoClipboard;
				{ Called when the undo clipboard is no longer needed. Calls
				fClipUndoView.FreeFromClipboard and sets fClipUndoView to NIL. }

				PROCEDURE TClipboardMgr.AboutToLoseControl(convertClipboard: BOOLEAN);

				PROCEDURE TClipboardMgr.AbsorbScrapStuff;
				{ Called to retrieve the current InfoScrap record from low memory. This will be used
				to determine if the scrap has changed. }

				PROCEDURE TClipboardMgr.CheckDeskScrap;
				{ Checks to see if the desk scrap has changed by calling AbsorbScrapStuff and
				comparing the current scrap change count with the previous change count. If the
				scrap has changed, then the current clipboard becomes the undo clipboard and
				ReadFromDeskScrap is called to read in the new desk scrap. }

				PROCEDURE TClipboardMgr.ClaimClipboard(clipView: TView);
				{ Makes clipView the new view displayed by the Clipboard. Typically called by a Cut
				or Copy command. }

				PROCEDURE TClipboardMgr.CanPaste(aClipType: ResType);
				{ Call this in your SetUpMenus code to register an ability to paste a particular type of
				Clipboard data }

				PROCEDURE TClipboardMgr.DoSetupMenus; OVERRIDE;
				{ Handles the show/hide clipboard command and enabling of paste }

				PROCEDURE TClipboardMgr.DoMenuCommand(aCmdNumber: CmdNumber); OVERRIDE;
				{ Handles the show/hide clipboard command }

				PROCEDURE TClipboardMgr.ReadFromDeskScrap;
				{ Called at launch and when the desk scrap changes. Calls
				MakeViewForAlienClipboard, then ClaimClipboard }

				PROCEDURE TClipboardMgr.RegainControl(checkClipboard: BOOLEAN);
				{ Called when switching in or when leaving a desk accessory }

				PROCEDURE TClipboardMgr.SetClipView(clipView: TView);
				{ Installs the given view into the clipboard window. }

				PROCEDURE TClipboardMgr.SwapClipViews;
				{ Swaps the undo clipboard view with the current clipboard view. Used during an Undo
				or Redo. }

				END;

		VAR
			{$Push} 									{$J+}
			gClipboardMgr:		TClipboardMgr;
			{$Pop}

		PROCEDURE InitUClipboardMgr;
		{ called to initialize the clipboard manager }
END.
