{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UDeskScrapView.p }
{ Copyright  1984-1991 by Apple Computer Inc.	All rights reserved. }

UNIT UDeskScrapView;

	INTERFACE

		USES
			{}
			Types, MacAppTypes, Memory, UPascalObject, UObject, AppleEvents, UEvtHandler, Balloons, UView;

		TYPE

			TDocument			= OBJECT; EXTERNAL;

			TDeskScrapView		= OBJECT (TView)		{ The default view in the Clipboard, able to
														 display only standard text and pictures. }
				fHavePicture:		BOOLEAN;			{ are we holding a PICT }
				fHaveText:			BOOLEAN;			{ is there any TEXT }
				fScrapCount:		INTEGER;			{ scrapCount of the scrap represented by
														 this view.}

				fDataHandle:		Handle; 			{ if non-NIL, will be either a PicHandle to
														 my picture or a Handle to my Text }

				PROCEDURE TDeskScrapView.Initialize; OVERRIDE;
				{ Puts a newly created TDeskScrapView into a known state. Subclasses should
				override it and call INHERITED. Typically used to put the object into a state where
				it can be safely FREED. }

				PROCEDURE TDeskScrapView.IDeskScrapView;
				{ Initialize the deskscrap view procedurally. }

				PROCEDURE TDeskScrapView.IRes(itsDocument: TDocument;
											  itsSuperView: TView;
											  VAR itsParams: Ptr); OVERRIDE;
				{ Initialize the deskscrap view from a resource template. }

				PROCEDURE TDeskScrapView.Free; OVERRIDE;
				{ Does nothing, don't ever want to free the ClipOrphange. }

				PROCEDURE TDeskScrapView.CheckScrapContents;
				{ Checks the contents of the deskscrap. }

				PROCEDURE TDeskScrapView.CalcMinSize(VAR minSize: VPoint); OVERRIDE;
				{ Responsible for calculating the correct size for the deskscrap view. }

				PROCEDURE TDeskScrapView.Draw(area: VRect); OVERRIDE;
				{ handles the drawing of the contents of the deskscrap, which by default is either a
				PICT or text. }

				PROCEDURE TDeskScrapView.SuperViewChangedSize(delta: VPoint;
															  invalidate: BOOLEAN); OVERRIDE;
				{ If our superview changes size then call AdjustSize & ForceRedraw. }

				PROCEDURE TDeskScrapView.WriteToDeskScrap; OVERRIDE;
				{ This view represents data that is already written to the deskscrap, so this does
				nothing. }

				{ Inspecting }
				PROCEDURE TDeskScrapView.GetInspectorName(VAR inspectorName: Str255); OVERRIDE;
				{ Used by the Inspector to get the name of this class. }

				PROCEDURE TDeskScrapView.Fields(obj: TObject); OVERRIDE;
				{ Used by the Inspector and the Debugger to display the contents of this class's
				fields. }

				END;

		VAR
			{$Push} 									{$J+}
			gVarClipPicSize:	BOOLEAN;				{ if TRUE, Pictures in the Clipboard are
														 treated as variable size, depending on the
														 window size; if FALSE (default), then
														 pictures in the Clipboard are drawn and
														 pasted ??? actual size }
			{$Pop}
END.
