{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UEvent.p }
{ Copyright  1984-1991 by Apple Computer Inc.	All rights reserved. }

UNIT UEvent;

	INTERFACE

		USES
			{}
			Types, MacAppTypes, Memory, UPascalObject, UObject, AppleEvents;

		CONST
			kPriorityLowest 	= 127;					{ Low priority commands are considered last
														 }
			kPriorityLow		= kPriorityLowest - 32; { Low priority commands are considered last
														 }
			kPriorityNormal 	= 64;					{ Normal priority assigned to commands by
														 default }
			kPriorityHigh		= kPriorityNormal - 32; { High priority commands take precedence }
			kPriorityHighest	= 0;					{ High priority commands take precedence }

		TYPE

			EventPriority 		= kPriorityHighest..kPriorityLowest; { Event priorities }

			TEvtHandler 		= OBJECT; EXTERNAL;

			TEvent				= OBJECT(TObject)
			
				fID:	EvtNumber;		{ Can be a many-to-one mapping of fID
											to TEvent }

				fSource:	TEvtHandler;
				fHandler:	TEvtHandler;		{ The handler for this event. }
				fAffectsMenus:		BOOLEAN;	{ True means the menus must be setup after
													the event }
				fPriority:			EventPriority;	{ How this event should be prioritized if
														 it has do compete on a prioritized basis
														 for execution. kNormalPriority is the
														 Default. Most programs won't have to mess
														 with this. }
				
				PROCEDURE TEvent.Initialize; OVERRIDE;
				PROCEDURE TEvent.IEvent(itsEventNumber: EvtNumber;
										itsSource: TEvtHandler;
										itsHandler: TEvtHandler);
				FUNCTION TEvent.ShouldFreeOnCompletion: BOOLEAN;
				FUNCTION TEvent.IsReadyToExecute: BOOLEAN;
				FUNCTION TEvent.IsRecurring: BOOLEAN;
				
				FUNCTION  TEvent.GetHandler: TEvtHandler;
				PROCEDURE TEvent.Process;
				PROCEDURE TEvent.ReportEvent;
				PROCEDURE TEvent.Fields(obj: TObject); OVERRIDE;
				
			END;
			
			TToolboxEvent				= OBJECT (TEvent) 		{ stores more information about the
															  event in an unpacked form }
				fEventRecord:		EventRecord;		{ The original packed ToolBox event record }
				fBtnState:			BOOLEAN;			{ bits found in the modifiers field of an
														 EventRecord }
				fCmdKey:			BOOLEAN;			{ Was Command key depressed? }
				fShiftKey:			BOOLEAN;			{ Was Shift key depressed? }
				fAlphaLock: 		BOOLEAN;			{ Was Alpha Lock depressed? }
				fOptionKey: 		BOOLEAN;			{ Was Option key depressed? }
				fControlKey:		BOOLEAN;			{ Was Control key depressed? }
				fAutoKey:			BOOLEAN;			{ TRUE if this was an auto key event }
				fCharacter: 		Char;				{ IF a key event the char that the event
														 translates to !!! what about 16 bit chars?
														 }
				fKeyCode:			INTEGER;			{ IF a key event the virtual key code that
														 the event translates to }

				fClickCount:		INTEGER;			{ 0 = event was not a mouse down; 1-N = # of
														 multiple clicks }

				PROCEDURE TToolboxEvent.IToolboxEvent(itsHandler: TEvtHandler);
				PROCEDURE TToolboxEvent.ReportEvent; OVERRIDE;
				PROCEDURE TToolboxEvent.Fields(obj: TObject); OVERRIDE;
				PROCEDURE TToolboxEvent.HaveEvent(theEvent: EventRecord);
				END;
END.
