{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UFloatWindow.p }
{ Copyright  1989-1991 by Apple Computer Inc. All rights reserved. }

{[f-]}
(*
				T H E O R Y   O F	O P E R A T I O N

UFloatWindow a number of services to support floating windows, including the TFloatWindow base class
which provides floating window capabilities to MacApp windows. Floating windows are distinguished
from other windows in the application heap by the value of the windowKind field of the windowPeek
record. The windowKind values 128-999 are reserved by MacApp. For now, windowKind values of 128
are used to indicate that a window is a floating window.

To use this unit, call InitUFloatWindow from your main program (i.e. M<your>Application.p)
after calling InitUMacApp. This routine ensures that the class TFloatWindow isn't dead-stripped
by the linker, sets gUFloatWindowInitialized to TRUE, and installs patches to the Window Manager
which provide floating window services. N.B.: The MacApp team wishes to thank the HyperCard team for
the use of their window manager patches to support floating window operation.

We don't need to ensure that the window manager patches are removed when the application terminates
because we use the UPatch mechanism to patch the traps and on the way out, CleanUpMacApp calls
UnpatchAll which unpatches all traps patched with UPatch. This is important in non-MultiFinder worlds
(MultiFinder automatically removes the application patches in MF worlds when the application either
quits or is switched out in a context switch).

To create a floating window:
 For template views, it's business as usual: specify the name of the window class, "TFloatWindow",
in the window's view description resource and call NewTemplateWindow as usual.
 For non-template views, call this unit's NewFloatPaletteWindow, instead of NewPaletteWindow; call
this unit's NewFloatSimpleWindow, instead of NewSimpleWindow; and call this unit's NewFloatTWindow,
instead of NewTWindow.

*)
{[f+]}

UNIT UFloatWindow;

	INTERFACE

		USES
			{}
			Types, MacAppTypes, Memory, UPascalObject, UObject, AppleEvents, UEvtHandler, Balloons, UView, 
			UEvent, UCommand, UWindow;

		TYPE

			TDocument			= OBJECT; EXTERNAL;

			TFloatWindow		= OBJECT (TWindow)

				PROCEDURE TFloatWindow.IFloatWindow(itsDocument: TDocument;
													itsWMgrWindow: WindowPtr;
													canResize, canClose, disposeOnFree: BOOLEAN);

				PROCEDURE TFloatWindow.IRes(itsDocument: TDocument;
											itsSuperView: TView;
											VAR itsParams: Ptr); OVERRIDE;

				FUNCTION TFloatWindow.GetBehindWindowPtr: WindowPtr; OVERRIDE;
				{ returns WindowPtr(-1) }
				
				FUNCTION TFloatWindow.GetNextHandler: TEvtHandler; OVERRIDE;
				{!!!}
				
				END;

			{ === Unit initialization === }

		PROCEDURE InitUFloatWindow;

		{ === Miscellaneous public utility routines === }

		PROCEDURE MAClipAbove(window: WindowPtr);

		PROCEDURE SendSystemWindowsToBack;

		{ === public global variables === }

		VAR
			{$Push} 									{$J+}
			gUFloatWindowInitialized: BOOLEAN;
			{$Pop}
END.
