{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{UInspector.p}
{Copyright  1987-1991 by Apple Computer, Inc.	All rights reserved.}

{
This unit implements two things: a set of lists of all objects in each class. and
the inspector window (with its associated views.) The global routines below
together make up the public interface to the inspector. The classes used are
private to the unit and are declared in UInspector.inc1.p. Refer to that source
code for more information on the implementation of this unit.
}

UNIT UInspector;

	INTERFACE

		USES
			{}
			Types, MacAppTypes,
			{}
			Memory, UPascalObject, UObject;

		PROCEDURE InitUInspector;
		{ Called during MacApp initialization.	Initializes this unit.}

		PROCEDURE AddObjectToInspector(theObject: TObject);
		{ Called when a new object is created by New or cloning. Adds theObject to the list of
		objects for its class. }

		PROCEDURE RemoveObjectFromInspector(theObject: TObject);
	   { Called when an object is freed. Removes theObject from the list of objects for its class. }

		PROCEDURE MakeInspector;
		{ Called during MacApp initialization to make the Inspector document. Must be called after
		creating gApplication.}

		PROCEDURE MakeInspectorWindow;
		{ Called to make a new Inspector window.}

		FUNCTION AddNewObjectsToInspector(add: BOOLEAN): BOOLEAN;
		{ Set to true (default) to automatically add all newly created objects to the inspector.
		Function returns old setting. }

	IMPLEMENTATION

{$I UInspector.inc1.p}

END.
