{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}

{------------------------------------------------------------------------------
Simple framework for an MPW tool.

NOTE - tools cannot currently be built with -debug Sorry!
------------------------------------------------------------------------------}
UNIT UMPWTool;

	INTERFACE

		USES
			{  requirements for this unit's interface. }
			Types, MacAppTypes,
			{}
			Memory, UPascalObject, UObject;

		CONST
			Version 			= '1.0';				{ Current version}
			kErrorMarker		= '### ';

			{ Keyword IDs.	Negative numbers reserved for the framework }
			kwP 				= - 1;
			kwNoP				= - 2;
			kwT 				= - 3;
			kwNoT				= - 4;
			kwHelp				= - 5;

		TYPE
			TAssociation		= OBJECT; EXTERNAL;

			TMPWTool			= OBJECT (TObject)
				fKeyWordList:		TAssociation;		{ keywords to this command }
				fProgName:			Str255; 			{ Program's file name}
				fInterrupted:		Boolean;			{ True ==> interrupted (Cmd "." pressed)}
				fCursorCount:		integer;			{ for our spinning cursor}
				fRetCode:			(RC_Normal, RC_ParmErrs, RC_DontMatch, RC_Abort); {Return codes}
				fProgress:			Boolean;			{ true for progress request }
				fTime:				Boolean;			{ true for elapsed time request }
				fStartTicks:		Longint;			{ tickcount at start of tool }
				fStartDateTime: 	Longint;			{ Date/Time at start of tool }
				fArgVIndex: 		integer;

				PROCEDURE TMPWTool.Initialize; OVERRIDE;
				{ Puts a newly created TMPWTool into a known state. Subclasses should
				override it and call INHERITED. Typically used to put the object into a state where
				it can be safely FREED. }

				PROCEDURE TMPWTool.ITool;
				PROCEDURE TMPWTool.InstallKeyWord(keyword: Str255; kw: integer);
				FUNCTION TMPWTool.LookupKeyword(keyword: Str255; VAR kw: integer): Boolean;
				PROCEDURE TMPWTool.InstallKeyWords;
				PROCEDURE TMPWTool.DoProcessFileArg(arg: Str255);
				PROCEDURE TMPWTool.DoProcessOptionArg(kw: integer);
				PROCEDURE TMPWTool.DoShowUsage;
				PROCEDURE TMPWTool.DoStartProgress;
				PROCEDURE TMPWTool.DoToolAction;
				FUNCTION TMPWTool.GetNextArg: Str255;
				PROCEDURE TMPWTool.ProcessArg(arg: Str255);
				PROCEDURE TMPWTool.Run;
				PROCEDURE TMPWTool.Stop(msg: Str255);
				PROCEDURE TMPWTool.SyntaxError(suffix: Str255);
				END;

		PROCEDURE InitUMPWTool;

		VAR
			gTool:				TMPWTool;				{ The tool }
			gProgName:			Str255; 				{ Program's file name}

	IMPLEMENTATION

{$I UMPWTool.inc1.p}

END.
