{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57,n+]}
{ UMacAppGlobals.p }
{ Copyright  1984-1991 by Apple Computer Inc.	All rights reserved. }

UNIT UMacAppGlobals;

	INTERFACE

		USES
			{
			 List units defining any types or constants that are required for your interface
			section (e.g. MacAppTypes or QuickDraw)
			 Also list units defining the classes that you are subclassing from in the interface
			section.  DO NOT list units for classes that you are only referencing
			(e.g. instance vars, parameter types or function results).
			 Also list the units used by the above (in their interface section).
			}
			Types, MacAppTypes, Memory, UPascalObject, UObject, UPatch, UFailure, Dialogs;

		CONST
			{ M E N U S }
			kMBarDisplayed		= 128;					{ Default 'MBAR' id of the menus that are
														 read in and installed in menu bar }
			kMBarNotDisplayed	= 129;					{ Default 'MBAR' id of the menus that are
														 read in but not installed }
			kMBarHierarchical	= 130;					{ Default 'MBAR' id of the menus that pop up
														 when a menu item is choosen }

			kMBarDebug			= 900;					{ Default 'MBAR' id of the Debug menus }
			kMBarDebugHierarchical = 901;				{ Default 'MBAR' id of the Debug Hierarchial
														 menus }

			{ C O M M A N D S }

			{ Negative numbers and positive numbers up to 999 are reserved by MacApp }
			{ Predefined command numbers ??? Renumber these more logically ??? }
			{ Not all of these are caught by MacApp.
			"<!>" means MacApp catches it.
			"<&>" means TEView catches it.
			"<->" means the application must catch it if it is used as a
			command number in any menu."


			{ Apple-menu commands }

			cAboutApp			= 1;					{ <!> "About <appname>" }

			{ File-menu filing commands }

			cNew				= 10;					{ <!> "New" (??? reserve a range of NEW
														 commands ???) }
			cNewLast			= 19;
			cOpen				= 20;					{ <!> "Open " (??? reserve a range of OPEN
														 commands ???) }
			cOpenLast			= 29;

			cSave				= 30;					{ <!> "Save" }
			cClose				= 31;					{ <!> "Close" }
			cSaveAs 			= 32;					{ <!> "Save as" }
			cSaveCopy			= 33;					{ <!> "Save a Copy in " }
			cRevert 			= 34;					{ <!> "Revert" (to previous version) }
			cShowClipboard		= 35;					{ <!> "Show Clipboard"/"Hide Clipboard" }
			cQuit				= 36;					{ <!> "Quit" }

			{ Edit-menu commands }

			{ For the following command numbers, we must guarantee that
			<command number> - cEditBase = <appropriate number to pass to
			SystemEdit>.  This relationship is enforced in
			TApplication.IApplication. }
			cEditBase			= 101;					{ start of standard editing commands }
			cUndo				= 101;					{ <!> "Undo <command>"/"Redo <command>" }
			cEditSep			= 102;					{ line separating UNDO from CUT }
			cCut				= 103;					{ <&> "Cut" }
			cCopy				= 104;					{ <&> "Copy" }
			cPaste				= 105;					{ <&> "Paste" }
			cClear				= 106;					{ <-> "Clear" }
			cEditLast			= cClear;

			cSelectAll			= 110;					{ <&> "Select All" }

			cTyping 			= 120;					{ for use in a TTypingCommand }
			cMouseCommand		= 121;					{ generic mouse command }

			cStyleChange		= 130;					{ "Menu" command for style change }
			cRememberStyle		= 131;					{ "Menu" command for remembering present
														 style }

			{ Finder pseudo-commands }

			cFinderNew			= 40;					{ <!> The user selected the tool icon in the
														 Finder and chose "Open" }
			cFinderPrint		= 41;					{ <!> The user selected document icons in
														 the Finder and chose "Print" }
			cFinderOpen 		= 42;					{ <!> The user selected document icons in
														 the Finder and chose "Open" }
			cFinderQuit 		= 43;					{ <!> The user selected "ShutDown" and the
														 the Finder sends a 'quit' AppleEvent'}

			{---------------- EDITION MANAGER AppleEvent COMMAND CONSTANTS ----------------}
			cSectionRead		= 50;					{ subscribers should read themselves afresh
														 from disk }
			cSectionWrite		= 51;					{ publishers should write themselves to an
														 edition file }
			cSectionScroll		= 52;					{ the user selects Open Publisher for a
														 subscriber }
			cSectionCancel		= 53;					{ cancel this section in a document }

			{ File-menu printing commands  }

			cPrFileBase 		= 176;					{ Command numbers between cPrFileBase and
														 cPrFileMax are reserved for printing. }
			cPrFileMax			= 195;

			cPageSetup			= 176;					{ <!> "Page Setup" }
			cPrintOne			= 177;					{ <!> "Print One" }
			cPrint				= 178;					{ <!> "Print" }
			cPrintToFile		= 179;					{ <!> "Print to file" }

			cPrintSpoolFile 	= 190;					{ <-> "Print spooled file" }

			cPrViewBase 		= 201;					{ Command numbers between cPrViewBase and
														 cPrViewMax are printing commands applied
														 to a displayed view in the fTarget chain }
			cPrViewMax			= 250;

			cShowBorders		= 199;					{ <!> Toggle. "Show view borders"--also
														 usable outside Debug menu }

			{ Zooming commands }						{ Not being used at present }

			cReduce50			= 301;					{ <-> "Reduce 50%" }
			cReduceToFit		= 302;					{ <-> "Reduce to Fit" }
			cShowFullSize		= 303;					{ <-> "Show Full Size" }

			{ Control tracking }
			cTrackingControl	= 400;

			{ Debug-menu commands.	Flag toggled by "cFoo" is called "gFoo" for any
			"Foo" }

			cExperimenting		= 901;					{ <!> Toggle. "Enable experimental features"
														 }
			cReportMenuChoices	= 902;					{ <!> Toggle. "Trace menu commands"--
														 WriteLn menu choices }
			cIntenseDebugging	= 904;					{ <!> Toggle. "Intense Debugging" }
			cTraceSetupMenus	= 905;					{ <!> Toggle. "Allow Trace of Menu Setups"
														 if gTrace is also on }
			cTraceIdle			= 906;					{ <!> Toggle. "Allow Trace during Idle" if
														 gTrace is also on }
			cDebugPrinting		= 912;					{ <!> Toggle. "Debug Printing" }
			cReportEvt			= 914;					{ <!> Toggle. "Report Events"--WriteLn
														 events received from queue }
			cDoFirstClick		= 915;					{ <!> Toggle. "'Do First Click' for this
														 window" }
			cVarClipPicSize 	= 916;					{ <!> Toggle. "Scale Pictures in Clipboard
														 to Window" }
			cRefreshFrontWindow = 917;					{ <!> Action. "Refresh Front Window" }
			cNewInspectorWindow = 918;					{ <!> Action. "Open new inspector window" }
			cModalToggle		= 919;					{ <!> Toggle. "Make front window
														 modal/modeless"}
			cDebugWind			= 913;					{ <!> Action. "Show Debug Window" }
			cEnterMacAppDebugger = 920; 				{ <!> Action. "Enter the MacApp Debugger" }

			cSetSysJust 		= 921;					{ <!> Action. "Switch system justification"
														 }
			cDebugFont			= 922;
			cDebugSize			= 923;
			cToggleFlag 		= 924;					{ Hierarchial Flags menu }

			{ M A C A P P	B U Z Z - S T R I N G	R E S O U R C E }
			kIDBuzzString		= 250;					{ std list of buzzwords stored as 'STR#'
														 resources. This string list is reserved
														 for MacApp; you should choose a different
														 resource ID for your strings. }

			{ Indices for strings in the buzz-string resource }
			bzSaveAs			= 1;					{ 'Save This Document As:' }
			bzSaveCopy			= 2;					{ 'Save a Copy In:' }
			bzShowClip			= 3;					{ 'Show Clipboard' }
			bzHideClip			= 4;					{ 'Hide Cllpboard' }
			bzUndo				= 5;					{ 'Undo x' }
			bzRedo				= 6;					{ 'Redo x' }
			bzCantDraw			= 7;					{ 'Unable to draw contents of window' }
			bzUntitled			= 8;					{ name of untitled document; if blank then
														 this is taken from the window title
														 template; if this includes the string
														 '<<<>>>' then MacApp will substitute a
														 number for the string (e.g., if the buzz
														 string contains 'Untitled-<<<>>>' then
														 untitled windows will be named
														 'Untitled-1', Untitled-2,  }
			bzClosing			= 9;					{ 'closing' }
			bzQuitting			= 10;					{ 'quitting' }
			bzCantUndo			= 11;					{ 'Cant Undo' }
			bzSaveAnyways		= 12;					{ 'save' }
			bzRevertAnyways 	= 13;					{ 'revert' }
			bzHideBorders		= 14;					{ 'Hide Borders' }
			bzShowBorders		= 15;					{ 'Show Borders' }
			bzSubscriberOptions = 16;					{ 'Subscriber Options' }
			bzPublisherOptions	= 17;					{ 'Publisher Options' }

			{ D E B U G   B U Z Z - S T R I N G   R E S O U R C E }
			kDebugBuzzStrings	= 251;					{ Debug buzzwords STR# resource }
			bzMakeModal 		= 1;					{ 'Make Front Window Modal' }
			bzMakeModeless		= 2;					{ 'Make Front Window Modeless' }
			bzDoFirstClick		= 3;					{ 'Do First Click For This Window' }
			bzDontDoFirstClick	= 4;					{ 'Don't Do First Click For This Window' }
			bzSetRightSysJust	= 5;					{ Set system to right justification }
			bzSetLeftSysJust	= 6;					{ Set system to left justification }

			{ R E S O U R C E	I D S }
			{ Negative numbers and numbers up to 127 are reserved by Apple }
			{ Positive numbers from 128 up to 999 are reserved by MacApp }
			kDefaultCredits 	= 1001; 				{ People responsible for the application }
			kIDClipWindow		= 200;					{ window displaying the Clipboard }
			kScrollBarId		= 202;					{ for when we create scrollers from
														 resources }
			kDebugParamsID		= 300;					{ debug window }

			kAEDispatchTable	= 400;					{ AppleEvents dispatch table }

			{ V I E W	I D E N T I F I E R S }
			{ These follow the same reservation rules as resource types }

			kDefaultWindowID	= 1001; 				{ Window view resource installed by default
														 in TDocument }
			kDefaultViewID		= 1002; 				{ View resource installed by default in
														 TDocument }
			kIDDefaultView		= 'DFLT';				{ View ID of default view }
			kIDClipView 		= 'CLIP';				{ identifier of the clipboard "orhanage" }

			{ O B J E C T  S I G N A T U R E S }
			{ These follow the same reservation rules as resource types }
			{ The signature is used to search the signature table and create
			an object "by signature"  If the signature's entry in the table has
			been updated with a new class then an object of that class will be created. }

			kStdDocument		= 'docu';
			kStdTracker 		= 'trak';
			kStdList			= 'list';

			kStdButton			= 'butn';
			kStdCheckBox		= 'chkb';
			kStdCluster 		= 'clus';
			kStdControl 		= 'cntl';
			kStdDefaultView 	= 'dflt';
			kStdDialogView		= 'dlog';
			kStdEditText		= 'edit';
			kStdGridView		= 'grid';
			kStdIcon			= 'icon';
			kStdNumberText		= 'nmbr';
			kStdPattern 		= 'patn';
			kStdPicture 		= 'pict';
			kStdPopup			= 'popp';
			kStdRadio			= 'radb';
			kStdScroller		= 'scrl';
			kStdSScrollBar		= 'sbar';
			kStdStaticText		= 'stat';
			kStdTEView			= 'tevw';
			kStdTextGridView	= 'txtg';
			kStdTextListView	= 'lstg';
			kStdView			= 'view';
			kStdWindow			= 'wind';

			{ C H O I C E S }

			{ Negative numbers and positive numbers up to 999 are reserved by MacApp }
			mOKHit				= 1;
			mCancelHit			= 2;
			mButtonHit			= 3;
			mCheckBoxHit		= 4;
			mClusterHit 		= 5;
			mEditTextHit		= 6;
			mIconHit			= 7;
			mListItemHit		= 8;
			mListScrollBarHit	= 9;
			mPictureHit 		= 10;
			mPopupHit			= 11;
			mRadioHit			= 12;
			mStaticTextHit		= 13;
			mHScrollBarHit		= 14;
			mVScrollBarHit		= 15;
			mEditTabKey 		= 16;
			mEditReturnKey		= 17;
			mEditEnterKey		= 18;
			mPatternHit 		= 19;
			mControlHit 		= 20;
			mCancelKey			= 21;
			mDefaultKey 		= 22;
			mSmallIconHit		= 23;
			mBecameWindowTarget 		= 24;
			mResignedWindowTarget 		= 25;
			mBecameApplicationTarget 	= 26;
			mResignedApplicationTarget 	= 27;

			kNoIdentifier		= '    ';
			kNoTemplate 		= - 1;
			kNoResource 		= - 1;

			{ M I S C E L L A N E O U S }
			kStdMainFileType	= 'TEXT';				{ the file type identifier used by default }

			kYesButton			= 1;					{ the 'Yes' button in various dialogs }
			kNoButton			= 3;					{ the 'No' button in various dialogs }

			kLowSpaceInterval	= 2 * 60 * 60;			{ default low space msg interval (2 seconds)
														 }

			kStdScrollUnit		= 16;					{ default value of fScrollUnit used by
														 scrollers }

			kSBarSize			= 16;
			kSBarSizeMinus1 	= kSBarSize - 1;
			{ !!! Prefer the above names }
			kStdSzSBar			= 16;					{ width/height of a standard
														 vertical/horizontal scroll bar }
			kStdSzMinus1SBar	= kStdSzSBar - 1;

			kStdStaggerAmount	= 16;					{ standard # of pixels to stagger windows }

			kMaxIdleTime		= MAXLONGINT;			{ Default tick count sent to WaitNextEvent }

			{ Numbers to pass to SystemEdit }
			kSysUndo			= 0;
			kSysCut 			= 2;
			kSysCopy			= 3;
			kSysPaste			= 4;
			kSysClear			= 5;

			{$IFC qDebug}
			kRsrcCheckInterval	= 100;
			{$ENDC}

			kBuild				= TRUE; 				{ Pass to TWindow.BuildWindowRgns }
			kAllowApplicationToSleep = TRUE;			{ Pass to TApplication.PollEvent if the
														 application is allowed to sleep if there
														 are no events pending. }
			{ P R I N T I N G }
			kSquareDots 		= TRUE; 				{ Square dots in Printing }
			kFixedSize			= TRUE; 				{ Fixed Page Size in Printing }

			kPrintInfoSize		= 120;					{ size in bytes of printInfo record }

			{ size in bytes of the overhead for a resource file;
			kRsrcFileOverhead is added in TDocument.DoNeedDiskSpace if the
			document uses the rsrc fork.
			You should add kRsrcTypeOverhead for each unique type you use
			plus kRsrcOverhead for each resoruce you use
			plus the total bytes in all the resources
			plus the length of all the names for named resources. }
			kRsrcFileOverhead	= 256 + 				{ resource header & stuff }
								  30					{ fixed part of resource map } ;
			kRsrcTypeOverhead	= 8;					{ overhead for each resource type }
			kRsrcOverhead		= 16;					{ overhead for each resource }

			{ ??? }
			kViewRsrcExpandAmt	= $400; 				{ ??? Is 1K enough for expansion, or too
														 much maybe??? }

			{ debugging info }
			kDebugFont			=						{monaco} 4; { Font for Debug Window }
			kDebugSize			= 9;					{ Font size for Debug Window }

			{ argument of TDocument.DoMakeViews }
			kForDisplay 		= FALSE;
			kForPrinting		= NOT kForDisplay;

			{ arguments of TScroller.IScroller and TViewServer.NewPaletteWindow }
			kWantHScrollBar 	= TRUE;
			kWantVScrollBar 	= TRUE;

			{ arguments of TDocument.Save }
			kAskForFilename 	= TRUE;
			kMakingCopy 		= TRUE;
			kSwitchToTarget 	= NOT kMakingCopy;

			{ argument of TApplication.SetUndoText }
			kShowUndo			= TRUE;
			kShowRedo			= FALSE;
			kShowCantUndo		= kShowUndo;

			{ argument of TDocument.IDocument }
			kUsesDataFork		= TRUE;
			kUsesRsrcFork		= TRUE;
			kDataOpen			= TRUE;
			kRsrcOpen			= TRUE;

			{ argument of TDocument.OpenDocFile }
			kKeepingOpen		= TRUE;
			kReadingFile		= TRUE;

			kVisible			= TRUE;
			kInvisible			= FALSE;

			{ arguments to routines with a 'redraw' parameter }
			kRedraw 			= TRUE;
			kDontRedraw 		= FALSE;

			{ arguments to routines with an 'invalidate' parameter }
			kInvalidate 		= TRUE;
			kDontInvalidate 	= FALSE;

		TYPE
			{
			 Declare as external the classes that you are only referencing
			(e.g. instance vars, parameter types or function results) that are not covered by
			the USES in the interface section.
			}
			TView				= OBJECT; external;
			TWindow 			= OBJECT; external;
			TDocument			= OBJECT; external;
			TPrintHandler		= OBJECT; external;
			TDynamicArray		= OBJECT; external;

			{ Used by the signature mapper }
			SignatureRec		= RECORD
				itsSignature:		IDType;
				itsClassID: 		ObjClassID;
				END;
			SignatureRecPtr 	= ^SignatureRec;

{--------------------------------------------------------------------------------------------------}

		VAR
			{$Push} 									{$J+}
			gApplicationStyle:	TextStyle;				{ Application's default text style }

			gCouldPrint:		BOOLEAN;				{ whether Printer code is accessible to the
														 application }
			{$IFC qExperimentalAndUnsupported}
			gEnableDoubleBuffering: BOOLEAN;			{ TRUE to enable automatic double buffering
														 when drawing/scrolling views }
			{$EndC}

			gOldChooserFlag:	BOOLEAN;				{ The state of the chooser alert flag when
														 the application started up. }
			gSignatures:		TDynamicArray;			{ Standard object signatures and their
														 classIDs }

			gSystemStyle:		TextStyle;				{ System's default text style }
			gWorkPort:			WindowPtr;				{ Pointer to a window that is created during
														 initialization, but never shown or
														 enumerated. }

			gTempRgn:			RgnHandle;				{ gTempRgn is a temporary RgnHandle created
														 in InitUMacApp. When debugging: before
														 using gTempRgn, call UseTempRgn and when
														 done call DoneWithTempRgn; this ensures
														 that 2 routines do not try to use gTempRgn
														 and the same time }
			gTempRgn2:			RgnHandle;				{ gTempRgn is a temporary RgnHandle created
														 in InitUMacApp. When debugging: before
														 using gTempRgn, call UseTempRgn and when
														 done call DoneWithTempRgn; this ensures
														 that 2 routines do not try to use gTempRgn
														 and the same time }
			{$IFC qDebug}
			gBusyTempRgn:		BOOLEAN;				{ Is gTempRgn in use? }
			gUsedBy:			Str255; 				{ The routine using gTempRgn }
			gBusyTempRgn2:		BOOLEAN;				{ Is gTempRgn in use? }
			gUsedBy2:			Str255; 				{ The routine using gTempRgn }
			{$ENDC}

			{ These are really private but, they're here in case access is needed. }
			pCopyright: 		StringHandle;
			pETSPatch:			TrapPatch;				{ patch for ExitToShell }
			pFi:				FailInfo;				{ Outermost failure handler }
			{$Pop}

{--------------------------------------------------------------------------------------------------}

			{ D E B U G G I N G }

			{$IFC qDebug}

		PROCEDURE DoneWithTempRgn;
		{ Indicates that gTempRgn is no longer in use. Call this only if qDebug is true. }

		PROCEDURE DoneWithTempRgn2;
		{ Indicates that gTempRgn is no longer in use. Call this only if qDebug is true. }

		PROCEDURE EntDebugger(entering: BOOLEAN);
		{ Call to enter the MacApp Debugger }

		PROCEDURE UseTempRgn(byWhom: Str255);
		{ Call this when you are about to use gTempRgn and qDebug is true. Used with DoneWithTempRgn
		will prevent you from trying to use gTempRgn from two places at the same time. }

		PROCEDURE UseTempRgn2(byWhom: Str255);
		{ Call this when you are about to use gTempRgn and qDebug is true. Used with DoneWithTempRgn
		will prevent you from trying to use gTempRgn from two places at the same time. }
		{$ENDC qDebug}

		FUNCTION LookupSymbol(VAR sym: Str255): LONGINT;
		{ Call to see if anyone knows a reference for the given symbol }

		{ W I N D O W S }

		FUNCTION FreeIfWMgrWindow(w: WindowPtr; dispose: BOOLEAN): WindowPtr;
		{ Calls DisposeWindow if dispose is true, else calls CloseWindow. Does nothing if w
		is nil.
		Returns NIL for convenient assignment back to the reference passed in. }

		FUNCTION ParseTitleTemplate(VAR itsTemplate: Str255; VAR preDocname,
									constTitle: INTEGER): BOOLEAN;
		{ Used in TWindow.IWindow to parse the template for window titles. Returns TRUE if it changed
		the template. preDocname is start of document name in string; constChars is total #
		characters of window title that are constants. (These values are fixed regardless of the
		document name.) If preDocname is 0, then the entire title is constant. }

		FUNCTION SubstituteInTitle(VAR title: Str255; newStuff: Str255; preDocname,
								   constTitle: INTEGER): BOOLEAN;
		{ Substitutes newStuff into the template as parsed by ParseTitleTemplate; returns TRUE if a
		substitution was made. }

		{ O B J E C T	C R E A T I O N   U T I L I T I E S }

		PROCEDURE RegisterStdType(typeName: Str255; signature: IDType);
		{ Associates the given class with a signature. }

		FUNCTION GetClassIDFromSignature(signature: IDType): ObjClassID;
		{ Returns the classID associated with a given signature, or kNILClass }

		FUNCTION DetermineClassID(signature: IDType;
								className: MAName): ObjClassID;
		{ Returns the classID associated with the given class name, if className is not empty.
 		Returns the classID associated with the given signature, if className is empty }

		FUNCTION NewStdObject(signature: IDType): TObject;
		{ Returns the prototype object for the given signature. }

		FUNCTION NewObjectBySignature(signature: IDType;
										className: MAName) : TObject;
		{ Returns an instance of class "className" if className is non-empty.
		Returns the prototype object for the given signature if className is empty }

		{ M I S C E L L A N E O U S }

		PROCEDURE DoAlertKeyDown(theDialog: DialogPtr; itemNo: INTEGER);
		{ Given a dialog pointer and button item, simulate pressing the button }
		
		PROCEDURE DoInitUMacApp;
		{ Should be called only by InitUMacApp. It is here because this doesn't need }
		{ to be universal code but InitUMacApp does. }
		
		PROCEDURE GetAlertButtonTitle(theDialog: DialogPtr; itemNo: INTEGER; VAR theTitle: Str255);
		{ Given a dialog pointer and a button item, return the title of that button }
		
		FUNCTION CompareAlertKeysToItem(theDialog: DialogPtr; VAR theChars: Str31; VAR itemHit: INTEGER) : BOOLEAN;
		{ Compares the buffered multi-byte chars to the first character of each button title }
		{ 1st button in alert (by convention == "OK").  2nd button in alert }
		{ (by convention == "Cancel").	3rd button in alert (by convention == "No") }

		FUNCTION MacAppAlertFilter(theDialog: DialogPtr; VAR theEvent: EventRecord;
								   VAR itemHit: INTEGER): BOOLEAN;
		{ Default alert filter used throughout MacApp.	Lets you answer yes and no to dialogs with
		keystrokes. Handles "cmd-." and escape. If the alert has not been called in a failure sequence
		then the application also handles update and activate events and idles. }

		PROCEDURE ApplicationBeep;
		{ If gApplication is not NIL just calls gApplication.Beep else it does a SysBeep.
		Removes a circular reference for UFailure.}

		FUNCTION GetNewCenteredDialog(dialogID: INTEGER; dStorage: Ptr;
									  behind: WindowPtr): DialogPtr;
		{ The same as GetNewDialog except it centers the dialog on the screen and sets the cursor to
		an arrow. }

		PROCEDURE GetTextStyleFontInfo(theTextStyle: TextStyle; VAR theFontInfo: Fontinfo;
									   VAR theFontHeight: INTEGER);
		{ Returns the FontInfo record for the font/face/size specified in theTextStyle.  Uses
		a temporary port so you don't have to. Also returns the font's line height. }

		PROCEDURE ExitMacApp;
		{ Call this if for some reason you want to immediately exit the application. It calls
		gApplication.Terminate, cleans up some other internal stuff, and then calls ExitToShell.
		(Normally, you would not call this, because MacApp takes care of terminating the
		application.)}

		PROCEDURE InitUMacApp(callsToMoreMasters: INTEGER);
		{ Initialize the UMacApp unit call this in your program after calling: InitToolBox and
		ValidateConfiguration. }

		PROCEDURE InstallIfPrintHandler(aPrintHandler: TPrintHandler; aView: TView);
		{ Install a clone of aPrintHandler into the view if aPrintHandler is not the
		same as the null print handler. (Typically if printing is initialized.)  This
		lets us install a print handler if printing is being used in the application
		and do NOTHING if it is not. }

		FUNCTION MakeNewRgn: RgnHandle;
		{ Calls NewRgn, then FailNIL}

		PROCEDURE CleanupMacApp;
		{ Called as the final step of TApplication.Run }
END.
