{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57,n+]}
{ UMacAppUniversal.p }
{ Copyright  1984-1991  Apple Computer, Inc.  All rights reserved. }

UNIT UMacAppUniversal;

	INTERFACE

		USES Types, OSUtils, TextEdit, MacAppTypes;

		PROCEDURE BlockSet(destPtr: Ptr; byteCount: LONGINT; setVal: UNIV SignedByte);
		{ Sets a block of memory to a value.  }

		PROCEDURE CenterRectOnScreen(VAR aRect: Rect; horizontally, vertically, forDialog: BOOLEAN);
		{ Horizontally and/or vertically centers the given rectangle on the main screen. If forDialog
		is true then the rect is vertically centered closer to the top of the screen as for a modal
		dialog. }

		PROCEDURE ConcatNumber(aString: Str255; aNumber: LONGINT; VAR theResult: Str255);
		{ Returns aString appended with the string representation of aNumber }

		FUNCTION GetTrapType(theTrap: INTEGER): TrapType;
		{ Returns the trap's type (OSTrap or ToolTrap). }

		PROCEDURE InitToolBox;
		{ Essential toolbox and utility initialization. }

		FUNCTION ValidateConfiguration(configuration: ConfigRecord): BOOLEAN;
		{ FALSE if compiled configuration doesn't match runtime config }

		PROCEDURE DefineConfiguration(VAR configuration: ConfigRecord);
		{ Fills the configuration record for the host machine. }

		PROCEDURE PullApplicationToFront;
		{ Applications don't start as the frontmost layer under Process Manager. They come to the front
		after a few Event calls. If you have a splash screen at startup then you probably want to
		use this call. }

		PROCEDURE SetRGBColor(VAR RGB: RGBColor; aRed, aGreen, aBlue: INTEGER);
		{ Sets RGB to the given colors. }

		FUNCTION TrapExists(theTrap: INTEGER): BOOLEAN;
		{ Returns true if the given trap exists at run-time }

END.
