{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57,n+]}
{ UMacAppUtilities.p }
{ Copyright  1984-1991  Apple Computer, Inc.  All rights reserved. }
{
This unit implements a set of simple utility routines.
}

UNIT UMacAppUtilities;

	INTERFACE

		USES
			{
			 List units defining any types or constants that are required for your interface
			section (e.g. MacAppTypes or QuickDraw)
			 Also list units defining the classes that you are subclassing from in the interface
			section.  DO NOT list units for classes that you are only referencing
			(e.g. instance vars, parameter types or function results).
			 Also list the units used by the above (in their interface section).
			}
			Types, MacAppTypes, TextEdit, OSUtils, Editions;

		CONST
			kCopyright			=
					'MacApp 3.0a2 Copyright  1984-1991 Apple Computer, Inc.  All rights reserved.'
			;

		{ In the NON-debug case these are set to false and the code they condition will not be
		compiled }
			{$IFC NOT qDebug}
			gPreCondition		= FALSE;				{ true to do pre-condition processing }
			gPostCondition		= FALSE;				{ true to do post-condition processing }

			gExperimenting		= FALSE;
			gReportMenuChoices	= FALSE;
			gIntenseDebugging	= FALSE;
			gDebugPrinting		= FALSE;
			gReportEvt			= FALSE;

			gAssumeFocused		= FALSE;
			gShowInvalidations	= FALSE;
			gShowCursorRegion	= FALSE;
			gShowHelpRegion 	= FALSE;
			gShowSleepRegion	= FALSE;

			{$ENDC}

		VAR
			{$Push} 									{$J+}
			{$IFC qDebug}
			gPreCondition:		BOOLEAN;				{ true to do pre-condition processing }
			gPostCondition: 	BOOLEAN;				{ true to do post-condition processing }

			gAssumeFocused: 	BOOLEAN;				{ Actually do TView.AssumeFocused checking?
														 }
			gDebugPrinting: 	BOOLEAN;				{ simple toggle for debugging printing }
			gExperimenting: 	BOOLEAN;				{ simple toggle for enabling/disabling
														 experimental features }
			gIntenseDebugging:	BOOLEAN;				{ debugging toggle for intensive debugging }
			gReportEvt: 		BOOLEAN;				{ debugging toggle for reporting events }
			gReportMenuChoices: BOOLEAN;				{ debugging toggle for tracing cmds }
			gRsrcCheck: 		INTEGER;				{ debugging toggle for checking resource
														 usage }
			gShowCursorRegion:	BOOLEAN;				{ Graphically show cursor region?}
			gShowHelpRegion:	BOOLEAN;				{ Graphically show help region?}
			gShowInvalidations: BOOLEAN;				{ Graphically show invalidations? }
			gShowSleepRegion:	BOOLEAN;				{ Graphically show sleep region?}
			gTraceIdle: 		BOOLEAN;				{ allow tracing through idle }
			{$ENDC}

			gApplicationRefNum: INTEGER;				{ RefNum of the application's res file. }
			gConfiguration: 	ConfigRecord;			{ The _actual_ environment configuration }

			gBoolString:		ARRAY [BOOLEAN] OF STRING[5]; { Used to display boolean values. }
			{$Push} 									{$J+}
			gFieldToStrRtn: 	ProcPtr;				{ Routine that converts fields to strings. }
			gFieldToCountRtn:	ProcPtr;				{ Routine that counts fields in compound
														 types. }
			{$Pop}

			{$Push} 									{$J+}
			gToolBoxInitialized: BOOLEAN;				{ Indicates whether toolbox has been inited
														 }
			gUDialogInitialized: BOOLEAN;				{ Indicates whether UDialog has been inited
														 }
			gUGridViewInitialized: BOOLEAN; 			{ Indicates whether UGridView has been
														 inited }
			gUPrintingInitialized: BOOLEAN; 			{ Indicates whether UPrinting has been
														 inited }
			gUTEViewInitialized: BOOLEAN;				{ Indicates whether UTEView has been inited
														 }
			gStrippedAddress:	Ptr;					{ an address already stripped by
														 StripAddress }
			{$Pop}

			gDeadStripSuppression: BOOLEAN; 			{ Dynamically set to false. Condition the
														 execution of a New(aTFoo) to suppress the
														 dead-stripping of support for a TFoo }

			gMATextBoxTE:		TEHandle;				{ a working TEHandle for use exclusively by
														 MATextBox. Keeps us from having to
														 continually allocate and dispose a TE
														 (like TextBox does) }

			gTEDefaultWordBreak: ProcPtr;				{ The default word break routine used by TE.
														 NOTE that _this_ routine (alone) does not
														 take parameters using the Pascal calling
														 conventions as required by SetWordBreak
														 (Thank you TE!) and must be set in the TE
														 by munging (Rhymes with plunging) the
														 wordBreak field directly. }

			gOrthogonal:		ARRAY [VHSelect] OF VHSelect; { An Orthogonal set of VHSelects.
															   gOrthogonal[v] = h and
															   gOrthogonal[h] = v }

			{ Pascal doesn't have structured constants so }
			gZeroRect:			Rect;					{ SetRect(gZeroRect, 0, 0, 0, 0); }
			gZeroPt:			Point;					{ SetPt(gZeroPt, 0, 0); }
			gZeroVPt:			VPoint; 				{ SetVPt(gZeroVPt, 0, 0); }
			gZeroVRect: 		VRect;					{ SetVRect(gZeroVRect, 0, 0, 0, 0); }

			gRGBBlack,									{ RGB representation for black. }
			gRGBWhite,									{ RGB representation for white. }
			gRGBRed,									{ RGB representation for red. }
			gRGBGreen,									{ RGB representation for green. }
			gRGBBlue:			RGBColor;				{ RGB representation for blue. }
			{$Pop}

			{ S T A R T U P   U T I L I T I E S }

		{ M I S C E L L A N E O U S   U T I L I T I E S }

		{ >>> NOTE <<<

		Use the following accessors _wisely_ since they can play real havoc with inter-language
		portability. These routines used to begin with %_ but, that was dropped since it translates
		into the reserved __ in C++.

		}

		FUNCTION GetParmBlockPtr: LONGINT;
			INLINE $2E88;								{ MOVE.L A0,(A7) }
		{ Return the value of register A0.	Useful for getting the pointer
		to the parameter block from a VBL task or a completion routine. }

		FUNCTION GetA5: LONGINT;
			INLINE $2E8D;								{ MOVE.L A5,(A7) }
		{ Return the value of register A5. Useful for getting the immediate value
		of A5 which is not always the same as CurrentA5.  Generally a pointer to the program's
		global area and jump table. }

		FUNCTION GetCurStackFramePtr: Ptr;
			INLINE $2E8E;								{ MOVE.L A6,(A7) }
		{ Return the value of register A6.	Usually a pointer to the local stack
		frame.	Most often used to find out the caller's name when invoking a debugging routine. }

		FUNCTION GetCurStackTop: Ptr;
			INLINE $2E8F;								{ MOVE.L A7,(A7) }
		{ Return the value of register A7.	Usually the top of stack.  Useful
		for stack sniffing (not a crime). }

	  {--------------------------------------------------------------------------------------------}

		FUNCTION CompareMultiByteChars(first: Str31; second: Str31; caseSens: BOOLEAN): BOOLEAN;

		FUNCTION CompareStrings(first: Str255; second: Str255): INTEGER;
		{ Returns -1, 0, or 1 if first <, =, or > second. }

		PROCEDURE CopyStr255(VAR fmStr: Str255; toAddr: UNIV Ptr);
		{ Copies a string, copying ONLY what's necessary }

		PROCEDURE EachWMgrWindowDo(PROCEDURE DoToWMgrWindow(theWMgrWindow: WindowPtr));
		{ Calls DoToWMgrWindow for each window in the windowlist starting at FrontWindow.  }

		FUNCTION FindWindowBefore(theWindow: WindowPtr): WindowPtr;
		{ returns the window just before a given window. Returns nil if the given window is frontmost
		or not found. }

		FUNCTION PRStr(astr: Str255): Ptr;
			INLINE $2E9F;								{ Move.L (A7)+,(A7) }
		{ For Pascal compiler, which can't pass the address of a string in a packed record,
		even though it has to be byte-aligned by definition. Sure, maybe it's not word aligned, but for a
		BlockMove we don't care. When calling CopyStr255 where the destination is the address of a
		Str255 in a packed record, call it like this: CopyStr255(fromStr, PRStr(packedStr)); }

		FUNCTION AtStr(astr: Str255): StringPtr;
			INLINE $2E9F;								{ Move.L (A7)+,(A7) }
		{ Lets you take the address of a string constant so you can pass pointers with no stack copy.
		Use it like this: AtStr('Foo'); }

		FUNCTION AtMAName(astr: MAName): MANamePtr;
			INLINE $2E9F;								{ Move.L (A7)+,(A7) }
		{ Lets you take the address of a string constant so you can pass pointers with no stack copy.
		Use it like this: AtMAName('Bar'); }

		PROCEDURE DefaultSize(VAR theSize: INTEGER);
		{ If theSize is equal to the system font size then theSize is set to zero. Otherwise it is
		left unchanged. The purpose of this routine is to convert a font size to portable form,
		where a font size of zero is the portable equivalent to the system font size. }

		FUNCTION DisposeIfHandle(aHandle: UNIV Handle): Handle;
		{ Disposes the handle only if it is non-NIL.
		Returns NIL for convenient assignment back to the reference passed in. } { Preferred }

		FUNCTION DisposeIfPicHandle(aPicHandle: PicHandle): PicHandle;
		{ Disposes the PicHandle only if it is non-NIL.
		Returns NIL for convenient assignment back to the reference passed in. }

		FUNCTION DisposeIfPtr(aPtr: UNIV Ptr): Ptr;
		{ Disposes the pointer only if it is non-NIL.
		Returns NIL for convenient assignment back to the reference passed in. } { Preferred }

		FUNCTION DisposeIfRgnHandle(aRgnHandle: RgnHandle): RgnHandle;
		{ Disposes the RgnHandle only if it is non-NIL.
		Returns NIL for convenient assignment back to the reference passed in. }

		FUNCTION DisposeIfSectionHandle(aSectionHandle: SectionHandle): SectionHandle;
		{ Disposes the SectionHandle only if it is non-NIL.
		Returns NIL for convenient assignment back to the reference passed in. }

		FUNCTION EqualBlocks(first, second: UNIV Ptr; theSize: INTEGER): BOOLEAN;
		{ Returns true if the two blocks pointed at by first and second are equal over theSize
		bytes.}

		PROCEDURE FieldToString(fieldLabel: StringPtr; theData: Ptr; fieldType: INTEGER; PROCEDURE
								ProcessField(theLabel: StringPtr; theString: StringPtr;
											 theData: Ptr; theType: INTEGER));
		{ Calls the routine whose address is stored in gFieldToStrRtn. Its purpose is to take some
		data pointed to by theData, and whose type is indicated by field type, and convert that
		data into a string representation. By default, gFieldToStrRtn points to StdFieldToString. }

		PROCEDURE FieldToCount(VAR count: INTEGER; fieldType: INTEGER);
		{ Calls the routine whose address is stored in gFieldToCountRtn. Its purpose is to examine
		the type of the field and return in count the number of fields it contains if it is a
		compound type. By default, gFieldToCountRtn points to StdFieldToCount. }

		FUNCTION GetActualJustification(justification: INTEGER): INTEGER;
		{ If the justification passed in is teFlushDefault then returns teFlushLeft or teFlushRight
		depending on the setting of the system justification.  Other justifications are just passed
		through to the result. }

		PROCEDURE GetDeskTopRegion(deskTopRgn: RgnHandle);
		{ Sets deskTopRgn to the region representing the entire desktop, including
		the menu bar. Assumes the region handle is already allocated. }

		FUNCTION GetFontNum(fontName: Str255): INTEGER;
		{ Returns the font number corresponding to the given name. If fontName is equal to
		kSysFontName then zero is returned. If fontName is equal to kApplFontName then 1 is
		returned. Otherwise the Toolbox routine GetFNum is called to get the font number. }

		PROCEDURE GetIfColor(VAR aColor: RGBColor);
		{ Fetches current foreground color.  Works for both color and classic QD. }

		PROCEDURE GetIfBkColor(VAR aColor: RGBColor);
		{ Fetches current background color.  Works for both color and classic QD. }

		PROCEDURE GetPortTextStyle(VAR theTextStyle: TextStyle);
		{ Returns the textStyle representing the current state of thePort. }

		PROCEDURE GetPortFontInfo(fontNum: INTEGER; VAR fontName: Str255; VAR fontSize: INTEGER);
		{ Returns the font name corresponding to a given name, in portable format. i.e. if fontNum is
		the system font then kSysFontName is returned; if fontNum is the application font then
		kApplFontName is return; otherwise the Toolbox routine GetFontName is called to get the
		font name. Then, if fontNum is the system or application font, a 0 is returned if the size
		is the default size. }

		FUNCTION IntMultiply(x, y: INTEGER): LONGINT;
			INLINE $301F,								{ MOVE.W (A7)+,D0 }
				   $C1DF,								{ MULS.W (A7)+,D0 }
				   $2E80;								{ MOVE.L D0,(A0) }
		{ Multiplies two integers and returns a longint result. Note that the Pascal compiler will
		generate a 16-bit result if you say n := x * y, truncating the upper 16-bits. Furthermore,
		if either x or y is a longint then the compiler expands both operands to 32-bits and calls
		a 32-bit multiply subroutine. IntMultiply avoids these problems. }

		FUNCTION IsColorPort(port: GrafPtr): BOOLEAN;
		{ Returns TRUE if the GrafPort is a Color QD GrafPort }

		FUNCTION IsAResource(h: UNIV Handle): BOOLEAN;
		{ Returns true or false for resource-ness of h }

		FUNCTION IsHandle(h: UNIV Handle): BOOLEAN;
		{ Returns true or false for handlehood of h }

		FUNCTION IsHandleLocked(h: UNIV Handle): BOOLEAN;
		{ Returns lockState of h }

		{$IFC qDebug}

		FUNCTION IsHandlePurged(h: UNIV Handle): BOOLEAN;
		{ Returns purgeState of h }
		{$ElseC}

		FUNCTION IsHandlePurged(h: UNIV Handle): BOOLEAN;
			INLINE $205F,								{ MOVE.L (A7)+,A0 }
				   $4A90,								{ TST.L (A0) }
				   $57D7,								{ SEQ (A7) }
				   $4417;								{ NEG.B (A7)}
		{ Returns purgeState of h }
		{$EndC}

		FUNCTION GetWindowVariant(theWindow: WindowPtr): INTEGER;
		{ given a windowPtr, this routine returns its variant }

		FUNCTION LengthRect(r: Rect; vhs: VHSelect): INTEGER;
		{ If vhs is v, returns the length of r; else returns the width of r. }

		FUNCTION LockHandleHigh(h: Handle): SignedByte;
		{ Convenience function.  Moves a handle high (MoveHHi) and locks it (HLock).  The two
		operations are very frequently performed together thus, this procedure.  Ignores NIL
		handles. Returns the previous saved state of the handle from HGetState. }

		FUNCTION LongerSide(VAR r: Rect): VHSelect;
		{ Return an indication of which side is longer. }

		FUNCTION LongerVSide(VAR r: VRect): VHSelect;
		{ Return an indication of which side is longer. }

		PROCEDURE LIntToHex(decNumber: UNIV LONGINT; VAR hexNumber: String8; noOfDigits: INTEGER);
		{ LIntToHex converts decNumber to a hexidecimal string of noOfDigits length. }

		FUNCTION MAGetFontInfo(VAR theFontInfo: FontInfo): INTEGER;
		{ Returns the FontInfo record & line height of the font for the current port. }

		FUNCTION MAUseResFile(refNum: INTEGER): INTEGER;
		{ Like the ToolBox UseResFile but, it also returns the old CurResFile setting }

		PROCEDURE MATextBox(text: Ptr; itsLength: LONGINT; box: Rect; itsJust: INTEGER;
							autoWrap: BOOLEAN; wordBreak: ProcPtr; eraseFirst: BOOLEAN;
							spaceForCaret: BOOLEAN);
		{ Like the toolbox TextBox but, it also gives you control over whether the text should
		word-wrap with autoWrap, whether the box should be erased first with eraseFirst and, if
		word-wrap is specified, where the word breaks should be with wordBreak (pass NIL to use
		the default word-wrap routine in TE.  Since TextBox uses TE to image the text,
		spaceForCaret lets us adjust the drawn text by 1 pixel (the insertion caret) on the left and
		right.	If the text is editable or could become editable (as in TEditText) you probably want
		to leave space for a caret.  If the text is a title or something then you probably don't
		want to leave space for a caret.}

		PROCEDURE MADrawString(s: StringPtr; box: Rect; justification: INTEGER);
		{ A convenience routine.  Like the toolbox DrawString but, it uses a StringPtr to help
		reduce stack space requirements. And It also gives you control over
		the bounds into which the text will be drawn and draws it in the correct international
		direction.	This routine is _MUCH_ slower than DrawString. }

		FUNCTION Max(a, b: LONGINT): LONGINT;
			INLINE $201F,								{ MOVE.L (A7)+,D0 }
				   $2E9F,								{ MOVE.L (A7)+,(A7) }
				   $B097,								{ CMP.L (A7),D0 }
				   $6F02,								{ BGE.S *+4 }
				   $2E80;								{ MOVE.L D0,(A7) }
		{ Returns the maximum of a and b. }

		FUNCTION Min(a, b: LONGINT): LONGINT;
			INLINE $201F,								{ MOVE.L (A7)+,D0 }
				   $2E9F,								{ MOVE.L (A7)+,(A7) }
				   $B097,								{ CMP.L (A7),D0 }
				   $6C02,								{ BLE.S *+4 }
				   $2E80;								{ MOVE.L D0,(A7) }
		{ Returns the minimum of a and b. }

		FUNCTION MinMax(MinVal, expression, MaxVal: LONGINT): LONGINT;
		{ Returns the expression bounded by minimum and maximum }

		PROCEDURE NumberToHex(theNumber: UNIV LONGINT; VAR hexString: Str255; hexDigits: INTEGER);
		{ Converts theNumber to a hex string preceeded with '$'.}

		FUNCTION IsCommandKeyDown: BOOLEAN;
		{ returns TRUE if the Command key is down }

		FUNCTION IsControlKeyDown: BOOLEAN;
		{ returns TRUE if the Control key is down }

		FUNCTION IsOptionKeyDown: BOOLEAN;
		{ returns TRUE if the Option key is down }

		FUNCTION IsShiftKeyDown: BOOLEAN;
		{ returns TRUE if the Shift key is down }

		FUNCTION PinOnRect(theRect: Rect; thePt: Point): LONGINT;
		{ Like PinRect except that if thePt.h (or v) is >= theRect.right (bottom) it returns
		theRect.right (bottom). PinRect returns 1 less than that except if thePt is exactly on the
		edge of theRect.}

		PROCEDURE PinOnVRect(theRect: VRect; thePt: VPoint; VAR thePin: VPoint);
		{ Like PinRect except that if thePt.h (or v) is >= theRect.right (bottom) it returns
		theRect.right (bottom). PinRect returns 1 less than that except if thePt is exactly on the
		edge of theRect.}

		FUNCTION StripLong(address: UNIV Ptr): LONGINT;
		{ same function as the glue/trap stripAddress only the types are long and modified to bypass
		the inefficient MPW glue!!.  If inlines could reference relocatables it could even be inline. }

		PROCEDURE PointerToHex(theNumber: UNIV LONGINT; VAR hexString: Str255; hexDigits: INTEGER);
		{ If theNumber is zero, then hexString is set to 'Nil'. Else theNumber is converted to a hex
		string preceeded with '$'.}

		FUNCTION RectsNest(outer: Rect; inner: Rect): BOOLEAN;
		{ Determine if inner nests within outer. }

		FUNCTION VRectsNest(outer: VRect; inner: VRect): BOOLEAN;
		{ Determine if inner nests within outer for VCoordinates. }

		FUNCTION RoundUp(aNumber: LONGINT; aModulus: INTEGER): LONGINT;
		{ Rounds aNumber up so that it is evenly divisible by aModulus. }

		FUNCTION SetKeyScript(newKeyScript: INTEGER): INTEGER;
		{ If newKeyScript is different from the current key script, then the key script is set to
		newKeyScript. (The reason we don't want to set the key script to the same thing is that the
		Script Mgr. does a FlushEvents when it sets the key script.) }

		PROCEDURE SetIfColor(aColor: RGBColor);
		{ Sets foreground color.  Works for both color and classic QD. }

		PROCEDURE SetIfBkColor(aColor: RGBColor);
		{ Sets background color.  Works for both color and classic QD. }

		PROCEDURE SetPortTextStyle(theTextStyle: TextStyle);
		{ Sets the font style of the current port to the characteristics of theTextStyle. }

		PROCEDURE SetTextStyle(VAR theTextStyle: TextStyle; theFont: INTEGER; theStyle: Style;
							   theSize: INTEGER; theColor: RGBColor);
		{ Sets theTextStyle to the given characteristics }

		PROCEDURE StdFieldToString(fieldLabel: StringPtr; theData: Ptr; fieldType: INTEGER;
								   PROCEDURE ProcessField(theLabel: StringPtr; theString: StringPtr;
														  theData: Ptr; theType: INTEGER));
		{ This routine converts all field types defined by the constants in this unit. }

		PROCEDURE StdFieldToCount(VAR count: INTEGER; fieldType: INTEGER);
		{ This routine counts all field types defined by the constants in this unit. }

		FUNCTION UprChar(ch: CHAR): CHAR;
		{ Returns ch converted to upper case }

		PROCEDURE UprStr255(VAR s: Str255);
		{ Converts s to all upper case. }

		PROCEDURE UprMAName(VAR s: MAName);
		{ Converts s to all upper case. }

		FUNCTION LowerChar(ch: CHAR): CHAR;
		{ Returns ch converted to lower case }

		PROCEDURE LowerStr255(VAR s: Str255);
		{ Converts s to all lower case. }

		PROCEDURE UseSelectionColor;
		{ Call to make the next (and only the next) QD operation use the selection color. }

		PROCEDURE UseROMMap(resLoad: BOOLEAN);
		{ Call this before any Resource Manager call for which you might like to use ROM resources.
		Remember, if you pass FALSE to this then you should call SetResLoad(TRUE) afterwards. }

		PROCEDURE WithApplicationResFileDo(PROCEDURE DoWithResFile);
		{ Performs a proc with the application res file as the curResFile restoring the prev setting
		at completion. }

		{ F I L E	U T I L I T I E S }

		FUNCTION NumBlocks(numBytes: LONGINT; blkSize: LONGINT): LONGINT;
		{ Returns the number of blocks required to store numBytes, given that the block size is
		blkSize. }

		{ D E B U G G I N G   U T I L I T I E S }

		FUNCTION CanReadLn: BOOLEAN;
		{ returns TRUE if WritelnWindow is available and the display is not suppressed }

		FUNCTION CanWriteLn: BOOLEAN;
		{ returns TRUE if WritelnWindow is available }

		FUNCTION ReadInteger(prompt: Str255): INTEGER;
		{ Displays prompt and reads an integer from the debug window. }

		FUNCTION ReadYesNo(prompt: Str255): BOOLEAN;
		{ Displays prompt and accepts a 'y' or 'n' as input from the debug
		window. }

		FUNCTION VerboseIsHandle(h: UNIV Handle): BOOLEAN;
		{ Returns true if h is really a handle. If not then it prints diagnostic info about the
		alleged handle. }

		PROCEDURE WritePt(pt: Point);
		{ Writes the point in the debug window. }

		PROCEDURE WritePtr(val: UNIV LONGINT);
		{ Writes the pointer, in hex, in the debug window. }

		PROCEDURE WriteRect(r: Rect);
		{ Writes the rectangle in the debug window. }

		PROCEDURE WriteBoolean(b: BOOLEAN);
		{ Writes the boolean in the debug window. }

		PROCEDURE WriteVPt(pt: VPoint);
		{ Writes the VPoint in the debug window. }

		PROCEDURE WriteVRect(r: VRect);
		{ Writes the VRect in the debug window. }

		PROCEDURE WrLblPt(aLabel: Str255; pt: Point);
		{ Writes the label, ' = ', the point, to the debug window. }

		PROCEDURE WrLblPtr(aLabel: Str255; val: UNIV LONGINT);
		{ Writes the label, ' = ', the pointer in hex, to the debug window. }

		PROCEDURE WrLblRect(aLabel: Str255; r: Rect);
		{ Writes the label, ' = ', the rectangle, to the debug window. }

		PROCEDURE WrLblBoolean(aLabel: Str255; b: BOOLEAN);
		{ Writes the label, ' = ', the boolean, to the debug window. }

		PROCEDURE WrLblVPt(aLabel: Str255; pt: VPoint);
		{ Writes the label, ' = ', the VPoint in the debug window. }

		PROCEDURE WrLblVRect(aLabel: Str255; r: VRect);
		{ Writes the lable, ' = ', the VRect in the debug window. }

		PROCEDURE WriteSig(theID: IDType);
		{ Writes out an IDType signature. }

		PROCEDURE WrLblSig(theLabel: Str255; theID: IDType);
		{ Writes the label, ' =', theID in the debug window. }

		PROCEDURE WrLblHandleContents(aLabel: Str255; theHandle: UNIV Handle);
		{ Writes the label, ' =', theHandle in the debug window. }

		PROCEDURE WriteHandleContents(theHandle: UNIV Handle);
		{ Writes theHandle	in the debug window. }

		PROCEDURE WriteHexInt(theInt: INTEGER);
		{ Writes theInt  in the debug window. }

		PROCEDURE WrLblHexInt(theLabel: Str255; theInt: INTEGER);
		{ Writes the label, ' =', theInt in the debug window. }

		PROCEDURE WriteHexLongint(theLongint: LONGINT);
		{ Writes theLongint  in the debug window. }

		PROCEDURE WrLblHexLongint(theLabel: Str255; theLongint: LONGINT);
		{ Writes the label, ' =', theLongint in the debug window. }
END.
