{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}

{------------------------------------------------------------------------------
Simple framework for an pascal MPW tool.

NOTE - tools cannot currently be built with -debug Sorry!
------------------------------------------------------------------------------}
UNIT UPascalTool;

	INTERFACE

		USES
			{  requirements for this unit's interface. }
			Types, MacAppTypes,
			{}
			Memory, UPascalObject, UObject;

		CONST
			Version 			= '1.0';				{ Current version}
			kErrorMarker		= '### ';

			{ Keyword IDs.	Negative numbers reserved for the framework }
			kwP 				= - 1;
			kwNoP				= - 2;
			kwT 				= - 3;
			kwNoT				= - 4;
			kwHelp				= - 5;

		TYPE
			TAssociation		= OBJECT; EXTERNAL;

			TPascalTool			= OBJECT (TObject)
				fKeyWordList:		TAssociation;		{ keywords to this command }
				fProgName:			Str255; 			{ Program's file name}
				fInterrupted:		Boolean;			{ True ==> interrupted (Cmd "." pressed)}
				fCursorCount:		integer;			{ for our spinning cursor}
				fRetCode:			(RC_Normal, RC_ParmErrs, RC_DontMatch, RC_Abort); {Return codes}
				fProgress:			Boolean;			{ true for progress request }
				fTime:				Boolean;			{ true for elapsed time request }
				fStartTicks:		Longint;			{ tickcount at start of tool }
				fStartDateTime: 	Longint;			{ Date/Time at start of tool }
				fArgVIndex: 		integer;

				PROCEDURE TPascalTool.Initialize; OVERRIDE;
				{ Puts a newly created TPascalTool into a known state. Subclasses should
				override it and call INHERITED. Typically used to put the object into a state where
				it can be safely FREED. }

				PROCEDURE TPascalTool.IPascalTool;
				PROCEDURE TPascalTool.InstallKeyWord(keyword: Str255; kw: integer);
				FUNCTION TPascalTool.LookupKeyword(keyword: Str255; VAR kw: integer): Boolean;
				PROCEDURE TPascalTool.InstallKeyWords;
				PROCEDURE TPascalTool.DoProcessFileArg(arg: Str255);
				PROCEDURE TPascalTool.DoProcessOptionArg(kw: integer);
				PROCEDURE TPascalTool.DoShowUsage;
				PROCEDURE TPascalTool.DoStartProgress;
				PROCEDURE TPascalTool.DoToolAction;
				FUNCTION TPascalTool.GetNextArg: Str255;
				PROCEDURE TPascalTool.ProcessArg(arg: Str255);
				PROCEDURE TPascalTool.Run;
				PROCEDURE TPascalTool.Stop(msg: Str255);
				PROCEDURE TPascalTool.SyntaxError(suffix: Str255);
				END;

		PROCEDURE InitUPascalTool;

		VAR
			gPascalTool:		TPascalTool;			{ The tool }
			gProgName:			Str255; 				{ Program's file name}

	IMPLEMENTATION

{$I UPascalTool.inc1.p}

END.
