{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ UProjFileHandler.p }
{ Copyright  1984-1991 by Apple Computer Inc.	All rights reserved. }

UNIT UProjFileHandler;

	INTERFACE

		USES
			Types, MacAppTypes, Memory, UPascalObject, UObject, Files, UFileHandler;

		TYPE

			{ Projector ckid resource record. }
			ProjectorRecord 	= RECORD
				checksum:			LONGINT;
				locationID: 		LONGINT;
				version:			INTEGER;
				checkoutState:		INTEGER;
				branch: 			SignedByte;
				Modified:			SignedByte;
				unused: 			LONGINT;
				checkoutTime:		LONGINT;
				modDate:			LONGINT;
				etcetera:			LONGINT;
				END;

			ProjectorPtr		= ^ProjectorRecord;
			ProjectorHandle 	= ^ProjectorPtr;

			ProjectorStatus 	= (readOnly, readWrite, modReadOnly, notInProject);

			TFileBasedDocument	= OBJECT; external;
			TFile				= OBJECT; external;

			TProjFileHandler		= OBJECT (TFileHandler)

				fProjStatus:		ProjectorStatus;
				fWriteckid: 		BOOLEAN;			{ True if fFile status was modified }
				
				PROCEDURE TProjFileHandler.Initialize; OVERRIDE;

				PROCEDURE TProjFileHandler.IProjFileHandler(itsDocument: TFileBasedDocument; itsFile: TFile;
													itsFileType, itsCreator: OSType; usesDataFork,
													usesRsrcFork: BOOLEAN; keepsDataOpen,
													keepsRsrcOpen: BOOLEAN);
				{ Initialization method for TProjectorFile. }
				
				PROCEDURE TProjFileHandler.DoRead(forPrinting: BOOLEAN); OVERRIDE;
				{ Check for a CKID resource in the file and set fProjStatus accordingly }
				
				PROCEDURE TProjFileHandler.DoWrite(aFile: TFile; makingCopy: Boolean); OVERRIDE;
				{ If fWriteckid is TRUE, then write the projector status out as modified readonly }

				FUNCTION TProjFileHandler.GetProjectorStatus: ProjectorStatus;
				{ Return the projector read/write status of its file }

				PROCEDURE TProjFileHandler.ModifyReadOnly;
				{ Set the projector status of its file as modified read-only }

				PROCEDURE TProjFileHandler.Fields(obj: TObject); OVERRIDE;
				{ Called by the Inspector and the Debugger to display the contents of this class's
				fields. }

				END;
END.
