{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n+]}
{ USectionMgr.p }
{ Copyright  1984-1991 by Apple Computer Inc.	All rights reserved. }

UNIT USectionMgr;

	INTERFACE

		USES
			{}
			Types, MacAppTypes, Memory, UPascalObject, UObject, Events, AppleEvents, UEvtHandler,
			Balloons, UEvent, UView, UBehavior, UCommand, UList, Dialogs, Editions;

		TYPE

			TDocument			= OBJECT; EXTERNAL;
			TPublisher 			= OBJECT; EXTERNAL;
			TSection 			= OBJECT; EXTERNAL;
			TSubscriber 		= OBJECT; EXTERNAL;
			TView				= OBJECT; EXTERNAL;


			{---------------- TSection MANAGER ----------------}

			TSectionMgr		= OBJECT (TBehavior)		{ This object is responsible for interaction
														 with the Edition manager}

				PROCEDURE TSectionMgr.ISectionMgr;
				{ initialize }

				PROCEDURE TSectionMgr.DoAppleCommand(aCmdNumber: CmdNumber; message: AppleEvent;
													  reply: AppleEvent); OVERRIDE;
				{ responds to the edition manager apple events }

				PROCEDURE TSectionMgr.Fields(obj: TObject); OVERRIDE;
				{ Used by the Inspector and the Debugger to display the contents of this class's
				fields, in this case the global variables. }

				END;

			{---------------- EDITION MANAGER AppleEvent COMMAND CLASSES ----------------}

			TSectionCommand = OBJECT (TAppleCommand)
			{ an abstract superclass used as the base class for the edition manager apple event command
			classes }
		
				fSection:		TSection;			{ section object for this apple event command }
		
				PROCEDURE TSectionCommand.ISectionCommand(itsCmdNumber: CmdNumber;
														  itsDocument: TDocument;
														  itsView: TView;
														  itsSection: TSection);
				{ initialize this command }

				PROCEDURE TSectionCommand.InitFromAppleEvent(itsCmdNumber: CmdNumber;
														 itsDocument: TDocument;
														 itsView: TView;
														 itsMessage: AppleEvent;
														 itsReply: AppleEvent); OVERRIDE;
				{ initialize this command from the AppleEvent stream }

				FUNCTION TSectionCommand.GetSectionObject(aSectionHandle: SectionHandle): TSection;
				{ maps a section handle to a section object }

				END;

			{---------------------------------------------------------------------------------------}
			TSectionReadEventCmd = OBJECT (TSectionCommand)
			
				PROCEDURE TSectionReadEventCmd.ISectionReadEventCmd(itsCmdNumber: CmdNumber;
														  itsDocument: TDocument;
														  itsView: TView;
														  itsSubscriber: TSubscriber);
				{ initialize this command }

				PROCEDURE TSectionReadEventCmd.DoIt; OVERRIDE;
				{ call TSubscriber(fSection).Subscribe }
				END;

			{---------------------------------------------------------------------------------------}
			TSectionWriteEventCmd = OBJECT (TSectionCommand)

				PROCEDURE TSectionWriteEventCmd.ISectionWriteEventCmd(itsCmdNumber: CmdNumber;
														 itsDocument: TDocument;
														 itsView: TView;
														 itsPublisher: TPublisher);
				{ initialize this command }

				PROCEDURE TSectionWriteEventCmd.DoIt; OVERRIDE;
				{ call TPublisher(fSection).Publish }
				END;

			{---------------------------------------------------------------------------------------}
			TSectionScrollEventCmd = OBJECT (TSectionCommand)

				PROCEDURE TSectionScrollEventCmd.ISectionScrollEventCmd(itsCmdNumber: CmdNumber;
																		itsDocument: TDocument;
																		itsView: TView;
																		itsSection: TSection);
				{ initialize this command }

				PROCEDURE TSectionScrollEventCmd.DoIt; OVERRIDE;
				{ scrolls the document to the publisher }
				END;

			{---------------------------------------------------------------------------------------}
			TSectionCancelEventCmd = OBJECT (TSectionCommand)

				PROCEDURE TSectionCancelEventCmd.ISectionCancelEventCmd(itsCmdNumber: CmdNumber;
																		itsDocument: TDocument;
																		itsView: TView;
																		itsSection: TSection);
				{ initialize this command }

				PROCEDURE TSectionCancelEventCmd.DoIt; OVERRIDE;
				{ cancels this section }
				END;

			{---------------------------------------------------------------------------------------}

		PROCEDURE InitUSectionMgr;
		{ Initialize the section manager and attach it to the application. Note that the application 
		should already have been instantiated and initialized when this procedure is called. }
END.
