{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57/1$,n-]}
{ UTearOffMenuView.p }
{ Copyright  1989-1991 by Apple Computer Inc. All rights reserved. }

{[f-]}
(*
*)
{[f+]}

UNIT UTearOffMenuView;

	INTERFACE

		USES
			{
			 List units defining any types or constants that are required for your interface
			section (e.g. MacAppTypes or QuickDraw)
			 Also list units defining the classes that you are subclassing from in the interface
			section.  DO NOT list units for classes that you are only referencing
			(e.g. instance vars, parameter types or function results).
			 Also list the units used by the above (in their interface section).
			}
			Types, MacAppTypes, Memory, UPascalObject, UObject, AppleEvents, UEvtHandler, Balloons, UView, Menus,
			UMenuView, UEvent, UCommand;

		CONST
			kTearOffMargin		= 10;					{ the slop around the displayed menu within
														 which we don't tear-off; see Apple Human
														 Interface Guidelines p. 91; note: some
														 programs (eg. HyperCard) use a 15 pixel
														 slop value }
			kTearOffOffset		= 3;					{ pixel offset from pointer to gray rgn
														 being dragged around }

		TYPE

			{
			 Declare as external the classes that you are only referencing
			(e.g. instance vars, parameter types or function results) that are not covered by
			the USES in the interface section.
			}
			TWindow 			= OBJECT; EXTERNAL;

			TTearOffMenuView		= OBJECT; FORWARD;

			TShowTearOffWindowCmd = OBJECT (TNoChangesCommand)
			{ moves, shows and selects a TTearOffMenuView }

				fTearOffWindow: 	TWindow;

				fWhere: 			Point;

				PROCEDURE TShowTearOffWindowCmd.Initialize; OVERRIDE;
				{ Puts a newly created TShowTearOffWindowCmd into a known state. Subclasses should
				override it and call INHERITED. Typically used to put the object into a state where
				it can be safely FREED. }

				PROCEDURE TShowTearOffWindowCmd.IShowTearOffWindowCmd(tearOffWindow: TWindow;
																	  where: Point);

				PROCEDURE TShowTearOffWindowCmd.DoIt; OVERRIDE;

				PROCEDURE TShowTearOffWindowCmd.Fields(obj: TObject); OVERRIDE;
				END;

			TTearOffTracker 	= OBJECT (TTracker)
			{ abstract superclass providing basic tear-off menu tracking: tracks the grey outline of
			the menu around the screen }

				fTearOffMenu:		TTearOffMenuView;

				fTearOffWindowOutline: RgnHandle;

				fExitTracking:		BOOLEAN;

				fOrigin:			Point;

				PROCEDURE TTearOffTracker.Initialize; OVERRIDE;
				{ Puts a newly created TTearOffTracker into a known state. Subclasses should
				override it and call INHERITED. Typically used to put the object into a state where
				it can be safely FREED. }

				PROCEDURE TTearOffTracker.ITearOffTracker(hitPt: Point;
														  tearOffMenu: TTearOffMenuView);

				PROCEDURE TTearOffTracker.Free; OVERRIDE;

				PROCEDURE TTearOffTracker.DoIt; OVERRIDE;

				PROCEDURE TTearOffTracker.TrackFeedback(aTrackPhase: TrackPhase;
														anchorPoint: VPoint;
														previousPoint: VPoint;
														nextPoint: VPoint;
														mouseDidMove: BOOLEAN;
														turnItOn: BOOLEAN); OVERRIDE;

				FUNCTION TTearOffTracker.TrackMouse(aTrackPhase: TrackPhase;
													VAR anchorPoint: VPoint;
													VAR previousPoint: VPoint;
													VAR nextPoint: VPoint;
													mouseDidMove: BOOLEAN): TTracker; OVERRIDE;

				FUNCTION TTearOffTracker.IsDoneTracking: BOOLEAN; OVERRIDE;

				PROCEDURE TTearOffTracker.Fields(obj: TObject); OVERRIDE;

				END;

			TTearOffMenuView		= OBJECT (TMenuView)
			{ abstract superclass providing basic tear-off menu behavior }

				fTearOffTrackingRgn: RgnHandle;

				fTearOffTracker:	TTearOffTracker;

				fTearOffWindow: 	TWindow;

				PROCEDURE TTearOffMenuView.Initialize; OVERRIDE;
				{ Puts a newly created TTearOffMenuView into a known state. Subclasses should
				override it and call INHERITED. Typically used to put the object into a state where
				it can be safely FREED. }

				PROCEDURE TTearOffMenuView.ITearOffMenuView(rsrcID: INTEGER;
													menuWidth, menuHeight: INTEGER;
													tearOffWindow: TWindow);

				PROCEDURE TTearOffMenuView.InstallTearOffTracker;
				{ For the sake of efficiency when tracking a tear-off, we'll create the tear-off tracker and
				 keep it with us, so we don't need to allocate a new tracker every time we tear off a menu. If you
				 want a different tracker in your subclass of TTearOffMenuView, then override this method. }

				PROCEDURE TTearOffMenuView.Free; OVERRIDE;

				PROCEDURE TTearOffMenuView.HandleChooseMessage(message: INTEGER;
														   theMenu: MenuHandle;
														   VAR menuRect: Rect;
														   hitPt: Point;
														   VAR whichItem: INTEGER); OVERRIDE;
				{ initiates tracking if mouse is in fTearOffTrackingRgn }

				FUNCTION TTearOffMenuView.GetTearOffTrackingRgn(menuRect: Rect): RgnHandle;
				{ accessor for fTearOffTrackingRgn: a rgn that represents the desktop less the menu rect (with some buffer area
				around the menu rect). This is useful for testing whether tracking should occur because the mouse
				just might be in the menu bar (which isn't in the desktop & isn't in the menu rect) and so tracking
				should not occur while the mouse is in the menu bar (MenuSelect does that tracking just fine). }

				PROCEDURE TTearOffMenuView.Fields(obj: TObject); OVERRIDE;
				END;
END.
