/* Copyright  1986-1991 Apple Computer, Inc.  All rights reserved. */
/* Default resources that can be included in your application if desired */

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __SYSTYPES.R__
#include "SysTypes.r"
#endif

#ifndef __BalloonTypes__
#include "BalloonTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#if qTemplateViews
resource 'view' (kDefaultWindowID,
#if qNames
"kDefaultWindowID",
#endif
	purgeable) {
	{
		root, 'WIND', { 50, 20 }, { 260, 430 }, sizeVariable, sizeVariable, shown, enabled,
		Window		{ "", zoomDocProc, goAwayBox, resizable, modeless,
					ignoreFirstClick,
					freeOnClosing, disposeOnFree, closesDocument, openWithDocument, dontAdaptToScreen,
					stagger, forceOnScreen, dontCenter, 'DFLT', "" };

		'WIND', 'SCLR',	{ 0, 0 }, { 260-kSBarSizeMinus1, 430-kSBarSizeMinus1 },
		sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller	{ "", vertScrollBar, horzScrollBar, 0, 0, 16, 16,
					vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCLR',IncludeViews	{ kDefaultViewID }
	}
};

resource 'view' (kDefaultViewID,
#if qNames
"kDefaultViewID",
#endif
	purgeable) {
	{
		root, 'DFLT', { 0, 0 }, { 134, 414 }, sizeFixed, sizeFixed, shown, enabled,
		DefaultView		{""}				// A ClassName can be put in this string
											// or do a RegisterStdType to point to
											// something to create for a "Default View"
	}
};
#endif

resource 'WIND' (kDefaultWindowID,
#if qNames
"kDefaultWindowID",
#endif
	purgeable) {
	{50, 40, 250, 436},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	""
#if SystemSevenOrLater
	,
	staggerMainScreen
#endif
};

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,				
	reserved,
	reserved,
	reserved,
	reserved,
#if qDebug
	534 * 1024,
	246 * 1024
#else
	384 * 1024,													// try to leave enough room for printing
	96 * 1024
#endif
};

resource 'DITL' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{160, 182, 180, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{8, 70, 152, 316},
		StaticText {
			disabled,
			"^0"												// The ^0 will be dynamically replaced with CurApName
			"\n\nThis program was written "
			"with MacApp  1985-1990 Apple Computer, Inc."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

resource 'ALRT' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	{90, 100, 280, 412},
	phAboutApp,
	{
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	}
#if SystemSevenOrLater
	,
	alertPositionMainScreen
#endif
};


resource 'CMNU' (mApple,
#if qNames
"mApple",
#endif
nonpurgeable) {
	mApple,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{
	"About ^0", noIcon, noKey, noMark, plain, cAboutApp;		// The ^0 will be dynamically replaced with CurApName
	"-",		 noIcon, noKey, noMark, plain, nocommand
	}
};

resource 'CMNU' (mFile,
#if qNames
"mFile",
#endif
nonpurgeable) {
	mFile,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"File",
	{
	"New",				noIcon, "N",	noMark, plain, cNew;
	"Open",			noIcon, "O",	noMark, plain, cOpen;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Close",			noIcon, "W",	noMark, plain, cClose;
	"Save",				noIcon, "S",	noMark, plain, cSave;
	"Save As",			noIcon, noKey,	noMark, plain, cSaveAs;
	"Save a Copy In",	noIcon, noKey,	noMark, plain, cSaveCopy;
	"Revert",			noIcon, noKey,	noMark, plain, cRevert;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Page Setup",		noIcon, noKey,	noMark, plain, cPageSetup;
	"Print One",		noIcon, noKey,	noMark, plain, cPrintOne;
	"Print",			noIcon, "P",	noMark, plain, cPrint;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Quit",				noIcon, "Q",	noMark, plain, cQuit
	}
};

resource 'CMNU' (mEdit,
#if qNames
"mEdit",
#endif
nonpurgeable) {
	mEdit,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Edit",
	{
	"Undo",				noIcon, "Z",	noMark, plain, cUndo;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Cut",				noIcon, "X",	noMark, plain, cCut;
	"Copy",				noIcon, "C",	noMark, plain, cCopy;
	"Paste",			noIcon, "V",	noMark, plain, cPaste;
	"Clear",			noIcon, noKey,	noMark, plain, cClear;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Select All",		noIcon, "A",	noMark, plain, cSelectAll;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Show Clipboard",	noIcon, noKey,	noMark, plain, cShowClipboard
	}
};

resource 'CMNU' (mEditionMgrEdit,
#if qNames
"mEditionMgrEdit",
#endif
nonpurgeable) {
	mEditionMgrEdit,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Edit",
	{
	"Undo",				noIcon, "Z",	noMark, plain, cUndo;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Cut",				noIcon, "X",	noMark, plain, cCut;
	"Copy",				noIcon, "C",	noMark, plain, cCopy;
	"Paste",			noIcon, "V",	noMark, plain, cPaste;
	"Clear",			noIcon, noKey,	noMark, plain, cClear;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Create Publisher",noIcon, noKey,	noMark, plain, cCreatePublisher;
	"Subscribe to",	noIcon, noKey,	noMark, plain, cSubscribeTo;
	"Publisher Options",noIcon, noKey,	noMark, plain, cOptions;
	"Show Borders",		noIcon, noKey,	noMark, plain, cBorders;
	"Stop All Editions",noIcon, noKey,	noMark, plain, cStopAllEditions;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Select All",		noIcon, "A",	noMark, plain, cSelectAll;
	"-",				noIcon, noKey,	noMark, plain, nocommand;
	"Show Clipboard",	noIcon, noKey,	noMark, plain, cShowClipboard
	}
};

resource 'CMNU' (mBuzzwords,
#if qNames
"Buzzwords",
#endif
nonpurgeable
) {
	mBuzzwords,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Buzzwords",
	{
	"Typing",				noIcon, noKey, noMark, plain, cTyping;
	"Page Setup Change",	noIcon, noKey, noMark, plain, cChangePrinterStyle
	}
};

resource 'MBAR' (kMBarDisplayed,
#if qNames
"kMBarDisplayed",
#endif
nonpurgeable) {

	{mApple; mFile; mEdit}
};

resource 'hmnu' (mFile) 
{
	HelpMgrVersion,
	hmDefaultOptions,
	0, /* balloon definition function */
	0, /* variation code */
	/* Missing items */
	HMStringItem 
	{
		"Missing Item Enabled",
		"Missing Item Disabled",
		"Missing Item Checked",
		"Missing Item Marked",
	},
	/* Title and items */
	{	
		/* Title */
		HMStringItem 
		{
			"File Menu Enabled",
			"File Menu Disabled",
			"",
			"",
		},
		/* New Item */
		HMStringItem 
		{
			"File/New Enabled",
			"File/New Disabled",
			"",
			"",
		},
		/* Open Item */
		HMStringItem 
		{
			"File/Open Enabled",
			"File/Open Disabled",
			"",
			"",
		},
		/* Dashed line between Open and Close */
		HMSkipItem { },
		/* Close Item */
		HMStringItem 
		{
			"File/Close Enabled",
			"File/Close Disabled",
			"",
			"",
		},
		/* Save Item */
		HMStringItem 
		{
			"File/Save Enabled",
			"File/Save Disabled",
			"",
			"",
		},
		/* Save As Item */
		HMStringItem 
		{
			"File/Save As Enabled",
			"File/Save As Disabled",
			"",
			"",
		},
		/* Save a Copy In Item */
		HMStringItem 
		{
			"File/Save a Copy In Enabled",
			"File/Save a Copy In Disabled",
			"",
			"",
		},
		/* Revert Item */
		HMStringItem 
		{
			"File/Revert Enabled",
			"File/Revert Disabled",
			"",
			"",
		},
		/* Dashed line between Revert and Page Setup */
		HMSkipItem { },
		/* Page Setup */
		HMStringItem 
		{
			"File/Page Setup Enabled",
			"File/Page Setup Disabled",
			"",
			"",
		},
		/* Print One Item */
		HMStringItem 
		{
			"File/Print One Enabled",
			"File/Print One Disabled",
			"",
			"",
		},
		/* Print Item */
		HMStringItem 
		{
			"File/Print Enabled",
			"File/Print Disabled",
			"",
			"",
		},
		/* Dashed line between Print and Quit */
		HMSkipItem { },
		/* Quit Item */
		HMStringItem 
		{
			"File/Quit Enabled",
			"File/Quit Disabled",
			"",
			"",
		}
	}
};

resource 'hmnu' (mEdit) 
{
	HelpMgrVersion,
	hmDefaultOptions,
	0, /* balloon definition function */
	0, /* variation code */
	/* Missing items */
	HMStringItem 
	{
		"Missing Item Enabled",
		"Missing Item Disabled",
		"Missing Item Checked",
		"Missing Item Marked",
	},
	/* Title and items */
	{	
		/* Title */
		HMStringItem 
		{
			"Edit Menu Enabled",
			"Edit Menu Disabled",
			"",
			"",
		},
		/* Undo/Redo Item */
		HMStringItem 
		{
			"Edit/Undo/Redo Enabled",
			"Edit/Undo/Redo Disabled",
			"",
			"",
		},
		/* Dashed line between Undo and Cut */
		HMSkipItem { },
		/* Cut Item */
		HMStringItem 
		{
			"Edit/Cut Enabled",
			"Edit/Cut Disabled",
			"",
			"",
		},
		/* Copy Item */
		HMStringItem 
		{
			"Edit/Copy Enabled",
			"Edit/Copy Disabled",
			"",
			"",
		},
		/* Paste Item */
		HMStringItem 
		{
			"Edit/Paste Enabled",
			"Edit/Paste Disabled",
			"",
			"",
		},
		/* Clear Item */
		HMStringItem 
		{
			"Edit/Clear Enabled",
			"Edit/Clear Disabled",
			"",
			"",
		},
		/* Dashed line between Clear and Select All */
		HMSkipItem { },
		/* Select All Item */
		HMStringItem 
		{
			"Edit/Select All Enabled",
			"Edit/Select All Disabled",
			"",
			"",
		},
		/* Dashed line between Select All and Show Clipboard */
		HMSkipItem { },
		/* Show Clipboard Item */
		HMStringItem 
		{
			"Edit/Show-Hide Clipboard Enabled",
			"Edit/Show-Hide Clipboard Disabled",
			"",
			"",
		}
	}
};

resource 'ics8' (128,
#if qNames
"Application",
#endif
purgeable) {
	$"0000 0000 0000 0000 0000 FFFF 0000 0000 0000 0000 0000 0000 00FF 0808 FF00 0000"
	$"0000 0000 0000 0000 FF08 FF08 08FF FFFF 0000 0000 00FF FFFF 08FF FFFF FF08 FFFF"
	$"0000 0000 FFFF F5F5 FF08 0808 0808 FFFF 0000 00FF FFF5 F5F5 F5FF FFFF FFFF FFFF"
	$"0000 FFFF F5F5 F5F5 F5F5 F5F5 0000 FFFF 00FF FFF5 F5F5 F5F5 F5FA FAF5 F5FA 0000"
	$"FFFF F5F5 F5F5 F5F5 FAF5 F5FA F5F5 0000 FFFF F5F5 F5F5 F5FA F5FA F5F5 FAFA FA00"
	$"00FF FFF5 F5FA FAF5 FAFA FAFA F5FA FA00 0000 FFFF F5F5 F5FA F5F5 F5F5 F5FA FA00"
	$"0000 00FF FFF5 F5F5 FAFA FAFA FAFA FA00 0000 0000 FFFF F5F5 F5FA 0000 00FA FA00"
	$"0000 0000 00FF FFF5 FA00 0000 0000 0000 0000 0000 0000 FFFF"
};

resource 'ics#' (128,
#if qNames
"Application",
#endif
purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0030 0048 00A7 077B 0C83 187F 3003 6044 C090 C144 6452 3104 18AA 0C44 0680 03",
		/* [2] */
		$"00F8 01FC 03FF 07FF 0FFF 1FFF 3FFF 7FFC FFFE FFFE 7FFE 3FFE 1FFE 0FC6 0780 03"
	}
};

resource 'ICN#' (128,
#if qNames
"Application",
#endif
purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 3F00 0000 4080 0000 8040 0001 3020 0001 C810 000E 7F8F 0012 3007 0031 0007"
		$"0060 8007 00C0 6007 0180 1FE7 0300 001F 0600 0107 0C00 0080 1800 5440 3001 0220"
		$"6002 0110 C000 C088 6005 2040 3028 AA28 1800 4014 0C04 0008 0602 0014 0300 8008"
		$"0180 2A94 00C0 0028 0060 1014 0030 2000 0018 4000 000C 8000 0007 0000 0002",
		/* [2] */
		$"0000 3F00 0000 7F80 0000 FFC0 0001 FFE0 0001 FFF0 000F FFFF 001F FFFF 003F FFFF"
		$"007F FFFF 00FF FFFF 01FF FFFF 03FF FE1F 07FF FF07 0FFF FF80 1FFF FFC0 3FFF FFE0"
		$"7FFF FFF0 FFFF FFF8 7FFF FFF0 3FFF FFFC 1FFF FFFC 0FFF FFFC 07FF FFFC 03FF FFFC"
		$"01FF FFFC 00FF F87C 007F F01C 003F E000 001F C000 000F 8000 0007 0000 0002"
	}
};

resource 'icl8' (128,
#if qNames
"Application",
#endif
purgeable) {
	$"0000 0000 0000 0000 0000 0000 0000 0000 0000 FFFF FFFF FFFF 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 00FF 0808 0808 0808 FF00 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000 FF08 0808 0808 0808 08FF 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FF 0808 FFFF 0808 0808 0808 FF00 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 00FF FFFF F5F5 FF08 0808 0808 08FF 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FFFF FF08 08FF FFFF FFFF FFFF FF08 0808 FFFF FFFF"
	$"0000 0000 0000 0000 0000 00FF F5F5 FF08 0808 FFFF 0808 0808 0808 0808 08FF FFFF"
	$"0000 0000 0000 0000 0000 FFFF F5F5 F5FF 0808 0808 0808 0808 0808 0808 08FF FFFF"
	$"0000 0000 0000 0000 00FF FFF5 F5F5 F5F5 FF08 0808 0808 0808 0808 0808 08FF FFFF"
	$"0000 0000 0000 0000 FFFF F5F5 F5F5 F5F5 F5FF FF08 0808 0808 0808 0808 08FF FFFF"
	$"0000 0000 0000 00FF FFF5 F5F5 F5F5 F5F5 F5F5 F5FF FFFF FFFF FFFF FF08 08FF FFFF"
	$"0000 0000 0000 FFFF F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 FA00 0000 00FF FFFF FFFF"
	$"0000 0000 00FF FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FA 0000 0000 00FF FFFF"
	$"0000 0000 FFFF F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 FA00 0000 0000 0000"
	$"0000 00FF FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 FAFA FAFA FAFA F5F5 F5FA 0000 0000 0000"
	$"0000 FFFF F5F5 F5F5 F5F5 F5F5 F5F5 F5FA F5F5 F5F5 F5F5 FAF5 F5F5 FA00 0000 0000"
	$"00FF FFF5 F5F5 F5F5 F5F5 F5F5 F5F5 FAF5 F5F5 F5F5 F5F5 F5FA F5F5 F5FA 0000 0000"
	$"FFFF F5F5 F5F5 F5F5 F5F5 F5F5 F5FA F5F5 FAFA F5F5 F5F5 F5F5 FAF5 F5F5 FA00 0000"
	$"00FF FFF5 F5F5 F5F5 F5F5 F5F5 F5FA FAFA F5F5 FAF5 F5F5 F5F5 F5FA F5FA 0000 0000"
	$"0000 FFFF F5F5 F5F5 F5F5 FAFA FAF5 F5FA FAFA FAFA FAFA FAF5 F5F5 FAFA FAFA 0000"
	$"0000 00FF FFF5 F5F5 F5F5 F5F5 FAF5 F5F5 FAFA F5F5 F5F5 F5F5 F5F5 F5FA FAFA 0000"
	$"0000 0000 FFFF F5F5 F5F5 F5F5 F5FA F5F5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FA FAFA 0000"
	$"0000 0000 00FF FFF5 F5F5 F5F5 F5F5 FAF5 F5F5 F5F5 F5F5 F5F5 F5F5 F5FA FAFA 0000"
	$"0000 0000 0000 FFFF F5F5 F5F5 F5F5 F5FA FAF5 F5F5 F5F5 F5F5 F5F5 F5FA FAFA 0000"
	$"0000 0000 0000 00FF FFF5 F5F5 F5F5 F5F5 F5FA FAFA FAFA FAFA FAF5 F5FA FAFA 0000"
	$"0000 0000 0000 0000 FFFF F5F5 F5F5 F5F5 F5F5 F5F5 FA00 0000 00FA FAFA FAFA 0000"
	$"0000 0000 0000 0000 00FF FFF5 F5F5 F5F5 F5F5 F5FA 0000 0000 0000 00FA FAFA 0000"
	$"0000 0000 0000 0000 0000 FFFF F5F5 F5F5 F5F5 FA00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 00FF FFF5 F5F5 F5FA 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FFFF F5F5 FA00 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 00FF FFFA 0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 FF"
};

type 'MApp' as 'STR ';
resource 'MApp' (0,
#if qNames
"Signature",
#endif
	purgeable) {
	"Application created by MacApp"
};

resource 'FREF' (128,
#if qNames
"Application",
#endif
	purgeable) {
	'APPL',
	0,
	""
};

resource 'BNDL' (128,
#if qNames
"Bundle",
#endif
	purgeable) {
	'MApp',
	0,
		{
		'ICN#',
			{
			0, 128,
			},
		'FREF',
			{
			0, 128,
			}
		}
};


// Version for the "package"
RESOURCE 'vers' (2,
#if qNames
	"Package Version",
#endif
	purgeable) {
	0x03,
	0x00,
	alpha,
	0x02,
	verUs,
	$$Shell("MAShortVersion"),
	$$Shell("MALongVersion")
};

// Version for the "application or file"
RESOURCE 'vers' (1,
#if qNames
	"Application Version",
#endif
	purgeable) {
	0x01,
	0x00,
	development,
	0x01,
	verUs,
	"1.0 d1",
	"1.0 d1, Application created by MacApp"
};



resource 'STR#' (kDefaultCredits,
#if qNames
	"kDefaultCredits",
#endif
	purgeable) {
	 {
	"The great people behind MacApp";

	"Engineers past and present";
	"Peter Alley";
	"Curt Bianchi";
	"Mary Boetcher";
	"Mike Burbidge";
	"Ken Doyle";
	"Steve Friedrich";
	"David Goldsmith";
	"Barry Haynes";
	"Chris Knepper";
	"Lonnie Millett";
	"Deb Orton";
	"Richard Rodseth";
	"Larry Rosenstein";
	"Larry Tesler";
	"Scott Wallace";
	"Russ Wetmore";

	"Testers past and present";
	"Dan Allen";
	"John Beswetherick";
	"Cliff Greyson";
	"Bernadette Jolicoeur";
	"Richard Kimberly";
	"Kuldip Nijjar";
	"Richard Rodseth";
	"David Stafford";

	"Writers past and present";
	"Dave Bice";
	"Mikel Evins";
	"Bill Harris";
	"Marq Laube";
	"John Perry";
	"Don Reed";
	"Jon Simonoff";
	"Jon Singer";
	"Alan Spragens";
	"Andy Swartz";

	"Technical support past and present";
	"Darin Adler";
	"Mark Bennett";
	"Rick Blair";
	"Clarus the DogCow (Moof!)";
	"Bo3b Johnson";
	"Keith Rollin";
	"Andrew Shebanow";

	"Configuration Management";
	"Gary Davis";
	"Ming Low";

	"Product Managers past and present";
	"Harvey Alcabes";
	"Steve Burbeck";
	"Tom Chavez";

	"Managers";
	"David Goldsmith (yes, he was a manager too!)";
	"Phac LeTuan";
	"Ron Metzker";
	"Jim Thomas";

	"Evangelizers";
	"Scott Knaster";
	"Jon Magill";
	"Gregg Williams";

	"MacApp Developers Association";
	"Bill Anderson";
	"Howard Katz";
	"Carl Nelson";
	"(206) 252-6946";

	"Other great people";
	"Rob Chandhok & John Pane @ Carnegie Mellon University";
	"Dan Cochran";
	"Eileen Crombie";
	"Patricia Eastman";
	"Ann Greyson";
	"Michael Hinkson";
	"Mark Lentczner";
	"Eileen Mayes";
	"Mom and Dad";
	"Kurt Schmucker";
	"Harry Yee";
	"Geri Younggren";
	"You, the billions and billions of MacApp programmers";

	"THE MacApp teachers";
	"Neal Goldstein";
	"Neil Rhodes";
	"Dave Wilson";

	"And because he insisted on being included";
	"Eagle I. Berns"

	 }
};

