/*
	Dialog.r
	MacApp Resources for UDialog
	Copyright  1985 - 1990 Apple Computer, Inc.  All rights reserved.
*/

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif


#define		phInvalidValue			300
#define		kInvalidValueReasons	300
#define		kDialogTEViewID			300

#if !SystemSevenOrLater
include "Popup.rsrc" 'CDEF' (128);					// suck in the Popup CDEF for System 6 compatibility
#endif

#if qTemplateViews
resource 'view' (kDialogTEViewID,
#if qNames
	"kDialogTEViewID",
#endif
	purgeable)  { {
	root, noID, { 0, 0 }, { 0, 0 }, sizeRelSuperView, sizeVariable, shown, enabled,
	TEView {
		"TDialogTEView",
			withoutStyle, crOnly, acceptChanges, freeText, cTyping, unlimited,
			noInset, justSystem, systemFont };
} };
#endif


resource 'STR#' (kInvalidValueReasons,
#if qNames
	"kInvalidValueReasons",
#endif
	purgeable) {
	{	/* [1] */	"Invalid value";
		/* [2] */	"The value is less than the allowed minimum";
		/* [3] */	"The value is greater than the allowed maximum";
		/* [4] */	"The value contains non-numeric characters";
		/* [5] */	"The value contains too many characters";
	}
};

resource 'DITL' (phInvalidValue,
#if qNames
	"phInvalidValue",
#endif
	purgeable) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{90, 182, 110, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 80, 80, 270},
		StaticText {
			disabled,
			"^0; previous value substituted."
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

resource 'ALRT' (phInvalidValue,
#if qNames
	"phInvalidValue",
#endif
	purgeable) {
	{90, 100, 210, 412},
	phInvalidValue,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent;
		/* [2] */
		OK, visible, silent;
		/* [3] */
		OK, visible, silent;
		/* [4] */
		OK, visible, silent
	}
#if SystemSevenOrLater
	,
	alertPositionMainScreen
#endif
};

