/*
	MacApp.r
	MacApp Common Resources
	Copyright  1986-1990 Apple Computer, Inc.	All rights reserved.
*/

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

/* NOTE:

	By Toolbox convention, the OK button is item 1 and the Cancel button
		is item 2.
*/

#define		kBaseMacApp			129
#define		kReservedForCommands 130	/* room to reserve for TCommand allocations that should never fail */
#define		kScrollBarId		202
#define      kInspectorWindowType		900

resource 'aedt' (kAEDispatchTable) {{			// Minimum for AppleEvent aware application
	'aevt', 'oapp', cFinderNew;
	'aevt', 'odoc', cFinderOpen;
	'aevt', 'pdoc', cFinderPrint;
	'aevt', 'quit', cFinderQuit;
	}
};

resource 'STR#' (kIDBuzzString,
#if qNames
	"IDBuzzString",
#endif
	purgeable) {
	 {	/* [1] */	"Save this document as:";	/* Std File prompt */
		/* [2] */	"Save a copy in:";			/* Std File prompt */
		/* [3] */	"Show Clipboard";			/* used as menu command */
		/* [4] */	"Hide Clipboard";			/* used as menu command */
		/* [5] */	"Undo <<<>>>";				/* used as menu command */
		/* [6] */	"Redo <<<>>>";				/* used as menu command */
			/* for Undo and Redo, the <<<>>> string will be replaced
				by the name of the command */				
		/* [7] */	"Unable to display contents at the moment";
								/* used when Clipboard cannot be displayed */
		/* [8] */	"Untitled-<<<>>>";			/* name of an untitled document */
			/* the <<<>>> string will be replaced by a sequence number */
		/* [9] */	"closing";			/* see Alert 110: "Save changes before ___" */
		/* [10] */	"quitting"; 		/* see Alert 110: "Save changes before ___" */
		/* [11] */	"Cant Undo";					/* used as menu command */
		/* [12] */	"save"; 			/* see Alert 113: "Do you want to ___ anyway?" */
		/* [13] */	"revert";			/* see Alert 113: "Do you want to ___ anyway?" */
		/* [14] */	"Hide Borders";				/* used as a menu item */
		/* [15] */	"Show Borders";				/* used as a menu item */
		/* [16] */	"Subscriber Options";		/* used as a menu item */
		/* [17] */	"Publisher Options";		/* used as a menu item */
	}
};


#if qInspector && !qDebug
resource 'CMNU' (mDebug,
#if qNames
	"Inspector",
#endif
	nonpurgeable) {
	mDebug,
	textMenuProc,
	0x7FFFFFBF,
	enabled,
	"Inspector",
	{
	"New Inspector Window", 				noIcon, noKey,	noMark, plain,	cNewInspectorWindow
	}
};
#endif


/* ===========================	 Inspector Window	============================= */

#if qTemplateViews && qInspector
/* For building the view templates */
resource 'view' (kInspectorWindowType,
#if qNames
	"InspectorWindowType",
#endif
	purgeable) {
	{
	root, 'WIND', { 0, 0 }, { 252, 215 }, sizeVariable, sizeVariable, shown, enabled,
	Window		{ "TInspectWindow", zoomDocProc, goAwayBox, resizable,
				modeless, ignoreFirstClick,freeOnClosing, disposeOnFree, closesDocument,
				openWithDocument, dontAdaptToScreen, dontstagger, forceOnScreen,
				dontCenter, 'IVW3', "Inspector <<<>>>" };

				'WIND', 'SCL1', { 0, 0 }, { 12 * 7, 95 },
				sizeFixed, sizeFixed, shown, enabled,
		Scroller	{ "", vertScrollBar, noHorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

				'SCL1', 'IVW1', { 0, 0 }, { 0, 95 }, sizeVariable, sizeSuperView,
				shown, enabled,
		View	{ "TClassListView" };

				'WIND', 'SCL2', { 0, 111 }, { 12 * 7, 200-111 },
				sizeFixed, sizeRelSuperView, shown, enabled,
		Scroller	{ "", vertScrollBar, noHorzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

				'SCL2', 'IVW2', { 0, 0 }, { 0, 200 - 111 }, sizeVariable,
				sizeRelSuperView, shown, enabled,
		View	{ "TObjListView"  };

				'WIND', 'SCL3', { 12 * 7 + 1, 0 }, { (252-(12*7)), 200 },
				sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller	{ "", vertScrollBar, horzScrollBar, 0, 0, 16, 16,
				vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

				'SCL3', 'IVW3', { 0, 0 }, { 0, 600 }, sizeVariable,
				 sizeVariable, shown, enabled,
		View	{ "TObjectView" }

	}
};
#endif

#if !qTemplateViews && qInspector
/* This guy is used when the template stuff isn't */

resource 'WIND' (kInspectorWindowType,
#if qNames
	"InspectorWindowType",
#endif
	purgeable) {
	{0, 0, 250, 215},
	zoomDocProc,
	invisible,
	goAway,
	0x0,
	"Inspector <<<>>>",
	noAutoCenter
};
#endif

#if qTemplateViews
resource 'view' (kScrollBarId,
#if qNames
	"kScrollBarId",
#endif
	purgeable)  { {
	root, noID, { 0, 0 }, { 0, 0 }, sizeVariable, sizeVariable, shown, enabled,
	ScrollBar {
		"",
			adnLineLeft, { 1, 1 }, sizeable, notDimmed, notHilited, doesntDismiss,
			noInset, systemFont, 0, 0, 0 };
} };
#endif

#include "ErrorMgr.r"			// ??? should this be a separate compile?
#include "BusyCursor.r"			// ??? should this be a separate compile? Especially so
// it can be optional?
#include "Memory.r"				// ??? should this be a separate compile?
#include "DeskScrapView.r"				// ??? should this be a separate compile?
