/*
	Memory.r
	MacApp Memory management Resources
	Copyright  1986-1990 Apple Computer, Inc.	All rights reserved.
*/

/*  Auto-Include the requirements for this source */
#ifndef __TYPES.R__
#include "Types.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

/* memory stuff */
resource 'mem!' (kBaseMacApp,
#if qNames
	"BaseMacApp",
#endif
	purgeable) {
	4096,				// Add to temporary reserve
	4096,				// Add to permanent reserve
	8192				// Add to stack space (actually this first one sets the base stack requirement
						// to be the same as for a Macintosh Plus.
};

/* memory stuff */
resource 'mem!' (kReservedForCommands,
#if qNames
	"ReservedForCommands",
#endif
	purgeable) {
	128,				// Add to temporary reserve
	0,					// Add to permanent reserve
	0					// Add to stack space
};


resource 'seg!' (kBaseMacApp,
#if qNames
	"BaseMacApp",
#endif
	purgeable) {
	{	"Main";
		"MAMain";
		"GMain";
		"GRes";
		"GRes2";
		"GRes3";
		"GRes4";
		"ARes";
		"BBRes";
		"BBRes2";
		"%_MethTables";
		"GError";
		"STDCLIB";
		"PASLIB";
		"32-bit bootstrap";
#if qInspector && !qDebug
		"GDebug";
		"GInspector";
		"GWriteLn";
		"AFields";
		"BBFields";
		"GFields"
#endif
#if qPerform
		"GPerformanceTools";
#endif
	};
};

resource 'res!' (kBaseMacApp,
#if qNames
	"BaseMacApp",
#endif
	purgeable) {
	{	"Main";
		"MAMain";
		"GMain";
		"GRes";
		"GRes2";
		"GRes3";
		"GRes4";
		"ARes";
		"BBRes";
		"BBRes2";
		"%_MethTables";
		"GError";
		"STDCLIB";
		"PASLIB";
		"32-bit bootstrap";
#if qInspector && !qDebug
		"GDebug";
		"GInspector";
		"GWriteLn";
		"AFields";
		"BBFields";
		"GFields"
#endif
#if qPerform
		"GPerformanceTools";
#endif
	};
};

