{[a-,body+,h-,o=100,r+,rec+,t=4,u+,#+,j=20/57,n-]}

{------------------------------------------------------------------------------

FILE CreatorAndBundle.p
 Copyright Apple Computer, Inc. 1986 - 1991
 All rights reserved.

NAME
 CreatorAndBundle -- post process application for bundle resource

------------------------------------------------------------------------------}
PROGRAM CreatorAndBundle;

	USES
		{}
		Types, MacAppTypes, Memory, UPascalObject, UObject,

		{  Building Blocks }
		UPascalTool,

		{  Implementation use }
		UFailure, UList, UAssociation, TextEdit, OSUtils, Editions, UMacAppUtilities, CursorCtl, Signal,
		PasLibIntf, IntEnv, ToolUtils, Packages, Resources;

	TYPE

		TCreatorAndBundleTool = OBJECT (TPascalTool)

			fResFileName:		str255;

			PROCEDURE TCreatorAndBundleTool.ICreatorAndBundleTool;
			PROCEDURE TCreatorAndBundleTool.DoProcessFileArg(arg: str255); OVERRIDE;
			PROCEDURE TCreatorAndBundleTool.DoToolAction; OVERRIDE;
			PROCEDURE TCreatorAndBundleTool.DoAutoMagicCreatorAndBundle;

			END;

	VAR
		gCreatorAndBundleTool: TCreatorAndBundleTool;

{--------------------------------------------------------------------------------------------------}
		{$S TInit}

	PROCEDURE TCreatorAndBundleTool.ICreatorAndBundleTool;

		BEGIN
		IPascalTool;

		fResFileName := '';
		END;

{--------------------------------------------------------------------------------------------------}
	{$S TInit}

	PROCEDURE TCreatorAndBundleTool.DoProcessFileArg(arg: str255);

		BEGIN
		IF fResFileName <> '' THEN
			Stop('Sorry only smart enough to process one file')
		ELSE
			fResFileName := arg;
		END;

{--------------------------------------------------------------------------------------------------}
	{$S TRes}

	PROCEDURE TCreatorAndBundleTool.DoAutoMagicCreatorAndBundle;

		CONST
			bundleType			= 'BNDL';
			bundleID			= 128;

		TYPE
			OSTypePtr			= ^OSType;
			OSTypeHandle		= ^OSTypePtr;

		VAR
			theFInfo:			FInfo;
			theBundle:			OSTypeHandle;
			aName:				str255;

		BEGIN
		aName := fResFileName;
		FailOSErr(GetFInfo(aName, 0, theFInfo));
		theBundle := OSTypeHandle(Get1IndResource(bundleType, 1));
		IF theBundle <> NIL THEN
			BEGIN
			theFInfo.fdCreator := theBundle^^;
			theFInfo.fdFlags := BOR(theFInfo.fdFlags, fHasBundle);
			END
		ELSE
			BEGIN
			theFInfo.fdCreator := '????';
			theFInfo.fdFlags := BAND(theFInfo.fdFlags, BNOT(fHasBundle));
			END;
		FailOSErr(SetFInfo(aName, 0, theFInfo));
		END;

{--------------------------------------------------------------------------------------------------}
	{$S TRes}

	PROCEDURE TCreatorAndBundleTool.DoToolAction;

		VAR
			ref:				integer;
			aName:				str255;

		BEGIN
		IF fResFileName = '' THEN
			Stop('No filename specified');

		aName := fResFileName;

		SetResLoad(FALSE);								{ avoid preloads }
		ref := OpenResFile(aName);
		SetResLoad(TRUE);
		IF ref = - 1 THEN
			FailResError;

		DoAutoMagicCreatorAndBundle;

		CloseResFile(ref);
		FailResError;
		END;

	{$S TRes}

	BEGIN
	InitUPascalTool;

	New(gCreatorAndBundleTool);
	FailNil(gCreatorAndBundleTool);
	gCreatorAndBundleTool.ICreatorAndBundleTool;
	gCreatorAndBundleTool.Run;
	END.
